DROP TABLE IF EXISTS candidatos;
CREATE TABLE candidatos(id serial NOT NULL,soporte integer,item text,CONSTRAINT candidatos_pkey PRIMARY KEY (id)) 
WITHOUT OIDS;
ALTER TABLE candidatos OWNER TO upolaris;
DROP TABLE IF EXISTS log;
CREATE TABLE log(id serial NOT NULL,hostremoto text,auser text NOT NULL DEFAULT 'anonimo'::text,fecha date,hora time without time zone,metodo text NOT NULL DEFAULT 'GET'::text,
  peticion text,protocolo text,estado integer DEFAULT 400,bytes integer DEFAULT 0,referencia text,agenteu text,idpeticion integer,idreferencia integer,
  idagenteu integer,CONSTRAINT log_pkey PRIMARY KEY (id)) WITHOUT OIDS;
ALTER TABLE log OWNER TO upolaris;
DROP TABLE IF EXISTS sesioncomun;
CREATE TABLE sesioncomun(hostremoto text NOT NULL,fechahorainicio timestamp without time zone NOT NULL,fechahorafin timestamp without time zone,
  numsolicitudes integer DEFAULT 1,totalbytes integer DEFAULT 0,tiposficheros integer[],pagvisitadas integer[],nomtipofichero text[],
  nompagvisitadas text[],id serial NOT NULL,CONSTRAINT sesioncomun_pkey PRIMARY KEY (hostremoto, fechahorainicio)) WITHOUT OIDS;
ALTER TABLE sesioncomun OWNER TO upolaris;
DROP TABLE IF EXISTS sesionextendida;
CREATE TABLE sesionextendida(hostremoto text NOT NULL,agenteu text NOT NULL,fechahorainicio timestamp without time zone NOT NULL,fechahorafin timestamp without time zone,
  numsolicitudes integer DEFAULT 1,totalbytes integer DEFAULT 0,nomtipofichero text[],tiposficheros integer[],transacciones text[],id serial NOT NULL,
  nompagvisitadas text[],CONSTRAINT sesionextendida_pkey PRIMARY KEY (hostremoto, agenteu, fechahorainicio)) WITHOUT OIDS;
ALTER TABLE sesionextendida OWNER TO upolaris;
DROP TABLE IF EXISTS crawlers;
CREATE TABLE crawlers (id_crawler integer NOT NULL,nom_crawler character varying(100) NOT NULL,num_datos integer,PRIMARY KEY (id_crawler))WITHOUT OIDS;
ALTER TABLE crawlers OWNER TO upolaris;
DROP TABLE IF EXISTS enlaces;
CREATE TABLE enlaces (id_enlace integer NOT NULL,tipo_enlace character varying(3),origen integer,destino integer,id_crawler integer,PRIMARY KEY (id_enlace))
WITHOUT OIDS;
ALTER TABLE enlaces OWNER TO upolaris;
DROP TABLE IF EXISTS paginas;
CREATE TABLE paginas (id_pagina integer NOT NULL,url_pagina character varying(1000),numeracion_pagina character varying(500),nivel_pagina integer,
    enlaces_si integer,enlaces_ei integer,enlaces_se integer,enlaces_ee integer,id_crawler integer,id_nodo integer,PRIMARY KEY (id_pagina))
WITHOUT OIDS;
ALTER TABLE paginas OWNER TO upolaris;
DROP TABLE IF EXISTS codigo_http;
CREATE TABLE codigo_http(id serial NOT NULL,codigo text,descripcion text,tipo text,CONSTRAINT codigo_http_pkey PRIMARY KEY (id))WITH (OIDS=FALSE);
ALTER TABLE codigo_http OWNER TO upolaris;
DROP TABLE IF EXISTS codigos_utf8;CREATE TABLE codigos_utf8(caracter text,codigo_utf text,codigo_string text)WITH (OIDS=FALSE);
ALTER TABLE codigos_utf8 OWNER TO upolaris;
DROP TABLE IF EXISTS dias_semana;
CREATE TABLE dias_semana(id integer NOT NULL,nombre_dia text,CONSTRAINT dias_semana_pkey PRIMARY KEY (id))WITH (OIDS=FALSE);
ALTER TABLE dias_semana OWNER TO upolaris;
DROP TABLE IF EXISTS horas_dia;
CREATE TABLE horas_dia(id_hora integer NOT NULL,intervalo_hora_24 text,intervalo_hora_am text,CONSTRAINT horas_dia_pkey PRIMARY KEY (id_hora)) WITH (OIDS=FALSE);
ALTER TABLE horas_dia OWNER TO upolaris;
DROP TABLE IF EXISTS lista_so;
CREATE TABLE lista_so(so_string text NOT NULL,nombre_so text,CONSTRAINT lista_so_pkey PRIMARY KEY (so_string)) WITH (OIDS=FALSE);
ALTER TABLE lista_so OWNER TO upolaris;
DROP TABLE IF EXISTS motores_busqueda;
CREATE TABLE motores_busqueda(nombre_motor text NOT NULL,variable_busqueda text,motor_string text,CONSTRAINT motores_busqueda_pkey PRIMARY KEY (nombre_motor))WITH (OIDS=FALSE);
ALTER TABLE motores_busqueda OWNER TO upolaris;
DROP TABLE IF EXISTS tabla_dominios;
CREATE TABLE tabla_dominios(dominio text NOT NULL,"desc" text,CONSTRAINT tabla_dominios_pkey PRIMARY KEY (dominio)) WITH (OIDS=FALSE);
ALTER TABLE tabla_dominios OWNER TO upolaris;
DROP TABLE IF EXISTS tipo_archivo;
CREATE TABLE tipo_archivo(extension text NOT NULL,tipo text,descripcion text,CONSTRAINT tipo_archivo_pkey PRIMARY KEY (extension))WITH (OIDS=FALSE);
ALTER TABLE tipo_archivo OWNER TO upolaris;
DROP TABLE IF EXISTS ua_lista;
CREATE TABLE ua_lista(id integer NOT NULL,ua_nombre text,ua_string text,ua_tipo text,desc_tipo text,CONSTRAINT ua_browsers_ua_string_key UNIQUE (ua_string)) WITH (OIDS=FALSE);
ALTER TABLE ua_lista OWNER TO upolaris;
DROP TABLE IF EXISTS tabla_sesion;
	CREATE TABLE tabla_sesion
	(
		id integer NOT NULL,host text NOT NULL,fecha date NOT NULL,hora time without time zone NOT NULL,id_sesion integer,date_time timestamp without time zone,
		transferencia integer,status_code text,request_original text,request text,directorio text,archivo text,extension text,dia integer,solo_hora integer,
		tipoarchivo text,user_agent text,ua_tipo text,ua_so text,ua_browser text,ua_crawler text,ua_link text,ua_spam text,ua_downloading text,
		ua_proxy text,referente text DEFAULT '-',motor_busqueda text DEFAULT 'N/A',palabras_clave text DEFAULT '',sitios_referentes text DEFAULT 'N/A',dominio text DEFAULT 'N/A'

	);
CREATE OR REPLACE FUNCTION crear_acceso_estadisticas()
  RETURNS void AS
$BODY$
DECLARE
BEGIN
DROP TABLE IF EXISTS acceso_estadisticas;
DROP TABLE IF EXISTS acceso_extensiones;
DROP TABLE IF EXISTS acceso_tipoarchivo;
CREATE TABLE acceso_estadisticas(
request text,directorio text,archivo text,extension text,tipoarchivo text,hits integer DEFAULT 0,visitantes integer DEFAULT 0,
transferencia integer DEFAULT 0);
	INSERT INTO acceso_estadisticas(SELECT distinct request,directorio,archivo,extension,tipoarchivo,0,0,0 FROM tabla_sesion ORDER BY request);
	UPDATE acceso_estadisticas SET hits = (SELECT COUNT(tabla_sesion.request) FROM tabla_sesion WHERE tabla_sesion.request=acceso_estadisticas.request);	 
	UPDATE acceso_estadisticas SET visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion WHERE tabla_sesion.request=acceso_estadisticas.request);
	UPDATE acceso_estadisticas SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion WHERE tabla_sesion.request=acceso_estadisticas.request);
	CREATE TABLE acceso_extensiones
	(
		extension text,tipoarchivo text,descripcion text,hits integer DEFAULT 0,visitantes integer DEFAULT 0,transferencia integer DEFAULT 0
	);
	INSERT INTO acceso_extensiones(SELECT distinct extension,null,null,0,0,0 FROM tabla_sesion ORDER BY extension);
	UPDATE acceso_extensiones SET tipoarchivo=tipo_archivo.tipo FROM tipo_archivo
		WHERE acceso_extensiones.extension=tipo_archivo.extension;
	UPDATE acceso_extensiones SET tipoarchivo='Other' WHERE tipoarchivo IS NULL;
	UPDATE acceso_extensiones SET descripcion=tipo_archivo.descripcion FROM tipo_archivo
		WHERE acceso_extensiones.extension=tipo_archivo.extension;
	UPDATE acceso_extensiones SET descripcion='No description' WHERE descripcion IS NULL;
	UPDATE acceso_extensiones SET hits = (SELECT COUNT(tabla_sesion.extension) FROM tabla_sesion WHERE tabla_sesion.extension=acceso_extensiones.extension);	 
	UPDATE acceso_extensiones SET visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
		WHERE tabla_sesion.extension=acceso_extensiones.extension);
	UPDATE acceso_extensiones SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
		WHERE tabla_sesion.extension=acceso_extensiones.extension);
	CREATE TABLE acceso_tipoarchivo
	(
		tipoarchivo text,hits integer DEFAULT 0,visitantes integer DEFAULT 0,transferencia integer DEFAULT 0
	);
	INSERT INTO acceso_tipoarchivo(SELECT distinct tipoarchivo,0,0,0 FROM tabla_sesion ORDER BY tipoarchivo);
	UPDATE acceso_tipoarchivo SET hits = (SELECT COUNT(tabla_sesion.tipoarchivo) FROM tabla_sesion WHERE tabla_sesion.tipoarchivo=acceso_tipoarchivo.tipoarchivo);	 
	UPDATE acceso_tipoarchivo SET visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
							WHERE tabla_sesion.tipoarchivo=acceso_tipoarchivo.tipoarchivo);
	UPDATE acceso_tipoarchivo SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
							WHERE tabla_sesion.tipoarchivo=acceso_tipoarchivo.tipoarchivo);
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION crear_acceso_estadisticas() OWNER TO upolaris;
CREATE OR REPLACE FUNCTION crear_est_buscadores()
  RETURNS void AS
$BODY$
DECLARE
BEGIN
	DROP TABLE IF EXISTS est_buscadores;
	CREATE TABLE est_buscadores
	(
		buscador text,hits integer DEFAULT 0,visitantes integer DEFAULT 0,transferencia integer DEFAULT 0
	);
	INSERT INTO est_buscadores(SELECT distinct motor_busqueda,0,0,0 FROM tabla_sesion WHERE motor_busqueda <> 'N/A' ORDER BY motor_busqueda);
	UPDATE est_buscadores SET hits = (SELECT COUNT(tabla_sesion.motor_busqueda) FROM tabla_sesion WHERE tabla_sesion.motor_busqueda=est_buscadores.buscador);	 
	UPDATE est_buscadores SET visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
		WHERE tabla_sesion.motor_busqueda=est_buscadores.buscador);
	UPDATE est_buscadores SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
		WHERE tabla_sesion.motor_busqueda=est_buscadores.buscador);
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION crear_est_buscadores() OWNER TO upolaris;
CREATE OR REPLACE FUNCTION crear_est_dominios()
  RETURNS void AS
$BODY$
DECLARE
BEGIN
	DROP TABLE IF EXISTS est_dominios;
	CREATE TABLE est_dominios
	(
		dominio text,nombre text,hits integer DEFAULT 0,visitantes integer DEFAULT 0,transferencia integer DEFAULT 0
	);	
	INSERT INTO est_dominios(SELECT distinct dominio,null,0,0,0 FROM tabla_sesion WHERE dominio <> 'N/A' ORDER BY dominio);
	UPDATE est_dominios SET hits = (SELECT COUNT(tabla_sesion.dominio) FROM tabla_sesion WHERE tabla_sesion.dominio=est_dominios.dominio);	 
	UPDATE est_dominios SET visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
		WHERE tabla_sesion.dominio=est_dominios.dominio);
	UPDATE est_dominios SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
		WHERE tabla_sesion.dominio=est_dominios.dominio);
	UPDATE est_dominios SET nombre = tabla_dominios.desc FROM tabla_dominios
		WHERE est_dominios.dominio = tabla_dominios.dominio;	DELETE FROM est_dominios WHERE nombre IS NULL;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION crear_est_dominios() OWNER TO upolaris;
CREATE OR REPLACE FUNCTION crear_est_palabras()
  RETURNS void AS
$BODY$
DECLARE
BEGIN
	DROP TABLE IF EXISTS est_palabras;
	CREATE TABLE est_palabras
	(
		palabras text,hits integer DEFAULT 0,visitantes integer DEFAULT 0,transferencia integer DEFAULT 0,palabras2 text,dominio text
	);
	INSERT INTO est_palabras(SELECT distinct palabras_clave,0,0,0,null FROM tabla_sesion WHERE palabras_clave <> 'N/A' ORDER BY palabras_clave);
	UPDATE est_palabras SET hits = (SELECT COUNT(tabla_sesion.palabras_clave) FROM tabla_sesion WHERE tabla_sesion.palabras_clave=est_palabras.palabras);	 
	UPDATE est_palabras SET visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
		WHERE tabla_sesion.palabras_clave=est_palabras.palabras);
	UPDATE est_palabras SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
		WHERE tabla_sesion.palabras_clave=est_palabras.palabras);
	UPDATE est_palabras SET palabras2=palabras;
	UPDATE est_palabras SET palabras2 = replace(palabras2,'+',' ');
	UPDATE est_palabras SET palabras2 = replace(palabras2,'=','');
	UPDATE est_palabras SET palabras2 = replace(palabras2,upper(codigos_utf8.codigo_string),codigos_utf8.caracter) FROM codigos_utf8
		WHERE est_palabras.palabras2 ILIKE '%'||codigos_utf8.codigo_string||'%';
	UPDATE est_palabras SET palabras2 = replace(palabras,codigos_utf8.codigo_string,codigos_utf8.caracter) FROM codigos_utf8
		WHERE est_palabras.palabras2 ILIKE '%'||codigos_utf8.codigo_string||'%';
	DELETE FROM est_palabras WHERE palabras2 = '';
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION crear_est_palabras() OWNER TO upolaris;
CREATE OR REPLACE FUNCTION crear_est_sitios_referentes()
  RETURNS void AS
$BODY$
DECLARE
BEGIN
	DROP TABLE IF EXISTS est_sitios_referentes;
	CREATE TABLE est_sitios_referentes
	(
		sitio text,hits integer DEFAULT 0,visitantes integer DEFAULT 0,transferencia integer DEFAULT 0
	);
	INSERT INTO est_sitios_referentes(SELECT distinct sitios_referentes,0,0,0 FROM tabla_sesion WHERE sitios_referentes <> 'N/A' ORDER BY sitios_referentes);
	UPDATE est_sitios_referentes SET hits = (SELECT COUNT(tabla_sesion.sitios_referentes) FROM tabla_sesion WHERE tabla_sesion.sitios_referentes=est_sitios_referentes.sitio);	 
	UPDATE est_sitios_referentes SET visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
		WHERE tabla_sesion.sitios_referentes=est_sitios_referentes.sitio);
	UPDATE est_sitios_referentes SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
		WHERE tabla_sesion.sitios_referentes=est_sitios_referentes.sitio);
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION crear_est_sitios_referentes() OWNER TO upolaris;
CREATE OR REPLACE FUNCTION crear_estadisticas_codigoshttp()
  RETURNS void AS
$BODY$
DECLARE
BEGIN
	DROP TABLE IF EXISTS estadisticas_codigoshttp;
	CREATE TABLE estadisticas_codigoshttp
	(
		codigo_http text,descripcion text,tipo text,hits integer DEFAULT 0
	);
	INSERT INTO estadisticas_codigoshttp(SELECT distinct status_code,null,0 FROM tabla_sesion ORDER BY status_code);

	UPDATE estadisticas_codigoshttp SET descripcion = codigo_http.descripcion FROM codigo_http 
		WHERE codigo_http.codigo = estadisticas_codigoshttp.codigo_http;
	UPDATE estadisticas_codigoshttp SET tipo = codigo_http.tipo FROM codigo_http 
		WHERE codigo_http.codigo = estadisticas_codigoshttp.codigo_http;
	UPDATE estadisticas_codigoshttp SET hits = (SELECT COUNT(tabla_sesion.status_code) FROM tabla_sesion WHERE tabla_sesion.status_code=estadisticas_codigoshttp.codigo_http);
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION crear_estadisticas_codigoshttp() OWNER TO upolaris;
CREATE OR REPLACE FUNCTION crear_estadisticas_visitantes()
  RETURNS void AS
$BODY$
DECLARE
BEGIN
	DROP TABLE IF EXISTS estadisticas_visitantes;
	CREATE TABLE estadisticas_visitantes
	(
		host_remoto text,hits integer DEFAULT 0,visitantes integer DEFAULT 0,transferencia integer DEFAULT 0
	);
	INSERT INTO estadisticas_visitantes(SELECT distinct host,0,0,0 FROM tabla_sesion ORDER BY host);
	UPDATE estadisticas_visitantes SET hits = (SELECT COUNT(tabla_sesion.host) FROM tabla_sesion WHERE tabla_sesion.host=estadisticas_visitantes.host_remoto);	 
	UPDATE estadisticas_visitantes SET visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
		WHERE tabla_sesion.host=estadisticas_visitantes.host_remoto);
	UPDATE estadisticas_visitantes SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
		WHERE tabla_sesion.host=estadisticas_visitantes.host_remoto);
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION crear_estadisticas_visitantes() OWNER TO upolaris;
CREATE OR REPLACE FUNCTION crear_estadisticas_visitantes()
  RETURNS void AS
$BODY$
DECLARE
BEGIN
	DROP TABLE IF EXISTS estadisticas_visitantes;
	CREATE TABLE estadisticas_visitantes
	(
		host_remoto text,
		hits integer DEFAULT 0,
		visitantes integer DEFAULT 0,
		transferencia integer DEFAULT 0
	);
	INSERT INTO estadisticas_visitantes(SELECT distinct host,0,0,0 FROM tabla_sesion ORDER BY host);
	UPDATE estadisticas_visitantes SET hits = (SELECT COUNT(tabla_sesion.host) FROM tabla_sesion WHERE tabla_sesion.host=estadisticas_visitantes.host_remoto);	 
	UPDATE estadisticas_visitantes SET visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
		WHERE tabla_sesion.host=estadisticas_visitantes.host_remoto);
	UPDATE estadisticas_visitantes SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
		WHERE tabla_sesion.host=estadisticas_visitantes.host_remoto);
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION crear_estadisticas_visitantes() OWNER TO upolaris;
CREATE OR REPLACE FUNCTION crear_referentes_estadisticas()
  RETURNS void AS
$BODY$
DECLARE
BEGIN
	UPDATE tabla_sesion SET motor_busqueda=motores_busqueda.nombre_motor FROM motores_busqueda
			WHERE tabla_sesion.referente like '%'||motores_busqueda.motor_string||'%';
	UPDATE tabla_sesion SET palabras_clave = split_part(referente,'&q',2) WHERE motor_busqueda <> 'N/A' and palabras_clave ='';
	UPDATE tabla_sesion SET palabras_clave = split_part(referente,'?q',2) WHERE motor_busqueda <> 'N/A' and palabras_clave ='';
	UPDATE tabla_sesion SET palabras_clave = split_part(referente,'?p',2) WHERE motor_busqueda <> 'N/A' and palabras_clave ='';
	UPDATE tabla_sesion SET palabras_clave = split_part(referente,'&query',2) WHERE motor_busqueda <> 'N/A' and palabras_clave ='';
	UPDATE tabla_sesion SET palabras_clave = split_part(palabras_clave,'&',1);
	UPDATE tabla_sesion SET palabras_clave = 'N/A'  WHERE  palabras_clave ='';
	UPDATE tabla_sesion SET sitios_referentes = split_part(referente,'/',1)||'//'||split_part(referente,'/',2)||split_part(referente,'/',3) WHERE referente <> '-';
	UPDATE tabla_sesion SET dominio=substring(sitios_referentes from '%#".%#"%' for '#') WHERE referente <> '-';
	UPDATE tabla_sesion SET sitios_referentes = 'N/A' WHERE motor_busqueda <> 'N/A';
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION crear_referentes_estadisticas() OWNER TO upolaris;
CREATE OR REPLACE FUNCTION crear_resumen_sesion()
  RETURNS void AS
$BODY$
 DECLARE
BEGIN
	DROP TABLE IF EXISTS resumen_sesion;
	CREATE TABLE resumen_sesion
	(
		id integer,host text,tiempo_inicio timestamp without time zone,tiempo_fin timestamp without time zone,cantidad_peticiones integer,transferencia integer
	);
INSERT INTO resumen_sesion(SELECT id_sesion,host,min(date_time),max(date_time),count(id_sesion),sum(transferencia) FROM tabla_sesion group by id_sesion,host order by id_sesion);
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION crear_resumen_sesion() OWNER TO upolaris;
CREATE OR REPLACE FUNCTION crear_tabla_actividad_diaria()
  RETURNS void AS
$BODY$
DECLARE
BEGIN
	DROP TABLE IF EXISTS actividad_diaria;
	CREATE TABLE actividad_diaria
	(
		id_dia integer,dia text,hits integer DEFAULT 0,no_paginas_vistas integer DEFAULT 0,no_visitantes integer DEFAULT 0,transferencia integer DEFAULT 0
	);
	INSERT INTO actividad_diaria(SELECT id,nombre_dia,0,0,0,0 FROM dias_semana ORDER BY id);
	UPDATE actividad_diaria SET hits = (SELECT COUNT(tabla_sesion.dia) FROM tabla_sesion WHERE tabla_sesion.dia=actividad_diaria.id_dia);	
	UPDATE actividad_diaria SET no_paginas_vistas = (SELECT COUNT(tabla_sesion.dia) FROM tabla_sesion 
		WHERE tabla_sesion.dia=actividad_diaria.id_dia
		AND tabla_sesion.tipoarchivo = 'Web Page');
	UPDATE actividad_diaria SET no_visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
		WHERE tabla_sesion.dia=actividad_diaria.id_dia);
	UPDATE actividad_diaria SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
		WHERE tabla_sesion.dia=actividad_diaria.id_dia);
	UPDATE actividad_diaria SET transferencia = 0 WHERE transferencia IS NULL;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION crear_tabla_actividad_diaria() OWNER TO upolaris;
CREATE OR REPLACE FUNCTION crear_tabla_actividad_fecha()
  RETURNS void AS
$BODY$
DECLARE
BEGIN
	DROP TABLE IF EXISTS actividad_fecha;
	CREATE TABLE actividad_fecha
	(
		fecha date,
		hits integer DEFAULT 0,
		no_paginas_vistas integer DEFAULT 0,
		no_visitantes integer DEFAULT 0,
		transferencia integer DEFAULT 0
	);
	INSERT INTO actividad_fecha(SELECT distinct fecha,0,0,0,0 FROM tabla_sesion ORDER BY fecha);
	UPDATE actividad_fecha SET hits = (SELECT COUNT(tabla_sesion.fecha) FROM tabla_sesion WHERE tabla_sesion.fecha=actividad_fecha.fecha);
	UPDATE actividad_fecha SET no_paginas_vistas = (SELECT COUNT(tabla_sesion.fecha) FROM tabla_sesion 
		WHERE tabla_sesion.fecha=actividad_fecha.fecha
		AND tabla_sesion.tipoarchivo = 'Web Page');	
	UPDATE actividad_fecha SET no_visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
		WHERE tabla_sesion.fecha=actividad_fecha.fecha);
	UPDATE actividad_fecha SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
		WHERE tabla_sesion.fecha=actividad_fecha.fecha);
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION crear_tabla_actividad_fecha() OWNER TO upolaris;
CREATE OR REPLACE FUNCTION crear_tabla_actividad_hora()
  RETURNS void AS
$BODY$
DECLARE
 
BEGIN
	DROP TABLE IF EXISTS actividad_hora;
	CREATE TABLE actividad_hora
	(
		id_hora integer,hora_24 text,hora_am text,hits integer DEFAULT 0,no_paginas_vistas integer DEFAULT 0,no_visitantes integer DEFAULT 0,transferencia integer DEFAULT 0
	);
	INSERT INTO actividad_hora(SELECT id_hora,intervalo_hora_24,intervalo_hora_am,0,0,0,0 FROM horas_dia ORDER BY id_hora);
	UPDATE actividad_hora SET hits = (SELECT COUNT(tabla_sesion.solo_hora) FROM tabla_sesion WHERE tabla_sesion.solo_hora=actividad_hora.id_hora);
	UPDATE actividad_hora SET no_paginas_vistas = (SELECT COUNT(tabla_sesion.solo_hora) FROM tabla_sesion 
		WHERE tabla_sesion.solo_hora=actividad_hora.id_hora
		AND tabla_sesion.tipoarchivo = 'Web Page');
	UPDATE actividad_hora SET no_visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
		WHERE tabla_sesion.solo_hora=actividad_hora.id_hora);
	UPDATE actividad_hora SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
		WHERE tabla_sesion.solo_hora=actividad_hora.id_hora);
	UPDATE actividad_hora SET transferencia = 0 WHERE transferencia IS NULL;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION crear_tabla_actividad_hora() OWNER TO upolaris;
CREATE OR REPLACE FUNCTION crear_tabla_log_comonlf(campos text)
  RETURNS boolean AS
$BODY$DECLARE
	campos text;
BEGIN
	campos=$1;
	EXECUTE 'DROP TABLE IF EXISTS tabla_log_common_l_f';
	EXECUTE 'CREATE TABLE tabla_log_common_l_f (id serial NOT NULL PRIMARY KEY,'||campos||');';
RETURN TRUE;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION crear_tabla_log_comonlf(text) OWNER TO upolaris;
CREATE OR REPLACE FUNCTION crear_tabla_log_w3c(campos text)
  RETURNS boolean AS
$BODY$DECLARE
	campos text;
BEGIN
	campos=$1;
	EXECUTE 'DROP TABLE IF EXISTS tabla_log_w3c';
	EXECUTE 'CREATE TABLE tabla_log_w3c (id serial NOT NULL PRIMARY KEY,'||campos||');';
RETURN TRUE;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION crear_tabla_log_w3c(text) OWNER TO upolaris;
CREATE OR REPLACE FUNCTION crear_useragent_estadisticas()
  RETURNS void AS
$BODY$
DECLARE
 
BEGIN
	DROP TABLE IF EXISTS ua_tipos;
	DROP TABLE IF EXISTS ua_sistemas_operativos;
	DROP TABLE IF EXISTS ua_browsers;
	DROP TABLE IF EXISTS ua_crawlers;
	DROP TABLE IF EXISTS ua_links;
	DROP TABLE IF EXISTS ua_spams;
	DROP TABLE IF EXISTS ua_downloads;
	DROP TABLE IF EXISTS ua_proxys;
	CREATE TABLE ua_tipos
	(
		ua_tipo text,hits integer DEFAULT 0,visitantes integer DEFAULT 0,transferencia integer DEFAULT 0
	);
	INSERT INTO ua_tipos(SELECT distinct ua_tipo,0,0,0 FROM tabla_sesion ORDER BY ua_tipo);
	UPDATE ua_tipos SET hits = (SELECT COUNT(tabla_sesion.ua_tipo) FROM tabla_sesion WHERE tabla_sesion.ua_tipo=ua_tipos.ua_tipo);
	UPDATE ua_tipos SET visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
		wHERE tabla_sesion.ua_tipo=ua_tipos.ua_tipo);
	UPDATE ua_tipos SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
		WHERE tabla_sesion.ua_tipo=ua_tipos.ua_tipo);
	CREATE TABLE ua_sistemas_operativos
	(
		ua_so text,hits integer DEFAULT 0,visitantes integer DEFAULT 0,transferencia integer DEFAULT 0
	);
	INSERT INTO ua_sistemas_operativos(SELECT distinct ua_so,0,0,0 FROM tabla_sesion ORDER BY ua_so);
	UPDATE ua_sistemas_operativos SET hits = (SELECT COUNT(tabla_sesion.ua_so) FROM tabla_sesion 
		WHERE tabla_sesion.ua_so=ua_sistemas_operativos.ua_so);
	UPDATE ua_sistemas_operativos SET visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
		wHERE tabla_sesion.ua_so=ua_sistemas_operativos.ua_so);
	UPDATE ua_sistemas_operativos SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
		WHERE tabla_sesion.ua_so=ua_sistemas_operativos.ua_so);
	CREATE TABLE ua_browsers
	(
		ua_browser text,hits integer DEFAULT 0,visitantes integer DEFAULT 0,transferencia integer DEFAULT 0
	);
	INSERT INTO ua_browsers(SELECT distinct ua_browser,0,0,0 FROM tabla_sesion ORDER BY ua_browser);
	UPDATE ua_browsers SET hits = (SELECT COUNT(tabla_sesion.ua_browser) FROM tabla_sesion 
		WHERE tabla_sesion.ua_browser=ua_browsers.ua_browser);
	UPDATE ua_browsers SET visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
							wHERE tabla_sesion.ua_browser=ua_browsers.ua_browser);
	UPDATE ua_browsers SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
							WHERE tabla_sesion.ua_browser=ua_browsers.ua_browser);
	CREATE TABLE ua_crawlers
	(
		ua_crawler text,hits integer DEFAULT 0,visitantes integer DEFAULT 0,transferencia integer DEFAULT 0
	);
	INSERT INTO ua_crawlers(SELECT distinct ua_crawler,0,0,0 FROM tabla_sesion ORDER BY ua_crawler);
	UPDATE ua_crawlers SET hits = (SELECT COUNT(tabla_sesion.ua_crawler) FROM tabla_sesion 
		WHERE tabla_sesion.ua_crawler=ua_crawlers.ua_crawler);
	UPDATE ua_crawlers SET visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
		wHERE tabla_sesion.ua_crawler=ua_crawlers.ua_crawler);
	UPDATE ua_crawlers SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
		WHERE tabla_sesion.ua_crawler=ua_crawlers.ua_crawler);
	CREATE TABLE ua_links
	(
		ua_link text,hits integer DEFAULT 0,visitantes integer DEFAULT 0,transferencia integer DEFAULT 0
	);
	INSERT INTO ua_links(SELECT distinct ua_link,0,0,0 FROM tabla_sesion ORDER BY ua_link);

	UPDATE ua_links SET hits = (SELECT COUNT(tabla_sesion.ua_link) FROM tabla_sesion 
		WHERE tabla_sesion.ua_link=ua_links.ua_link);
	UPDATE ua_links SET visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
		WHERE tabla_sesion.ua_link=ua_links.ua_link);
	UPDATE ua_links SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
		WHERE tabla_sesion.ua_link=ua_links.ua_link);
	CREATE TABLE ua_spams
	(
		ua_spam text,hits integer DEFAULT 0,visitantes integer DEFAULT 0,transferencia integer DEFAULT 0
	);
	INSERT INTO ua_spams(SELECT distinct ua_spam,0,0,0 FROM tabla_sesion ORDER BY ua_spam);

	UPDATE ua_spams SET hits = (SELECT COUNT(tabla_sesion.ua_spam) FROM tabla_sesion 
		WHERE tabla_sesion.ua_spam=ua_spams.ua_spam);
	UPDATE ua_spams SET visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
							WHERE tabla_sesion.ua_spam=ua_spams.ua_spam);
	UPDATE ua_spams SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
							WHERE tabla_sesion.ua_spam=ua_spams.ua_spam);
	CREATE TABLE ua_downloads
	(
		ua_download text,hits integer DEFAULT 0,visitantes integer DEFAULT 0,transferencia integer DEFAULT 0
	);
	INSERT INTO ua_downloads(SELECT distinct ua_downloading,0,0,0 FROM tabla_sesion ORDER BY ua_downloading);
	UPDATE ua_downloads SET hits = (SELECT COUNT(tabla_sesion.ua_downloading) FROM tabla_sesion 
		WHERE tabla_sesion.ua_downloading=ua_downloads.ua_download);
	UPDATE ua_downloads SET visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
		WHERE tabla_sesion.ua_downloading=ua_downloads.ua_download);
	UPDATE ua_downloads SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
		WHERE tabla_sesion.ua_downloading=ua_downloads.ua_download);
	CREATE TABLE ua_proxys
	(
		ua_proxy text,hits integer DEFAULT 0,visitantes integer DEFAULT 0,transferencia integer DEFAULT 0
	);
	INSERT INTO ua_proxys(SELECT distinct ua_proxy,0,0,0 FROM tabla_sesion ORDER BY ua_proxy);
	UPDATE ua_proxys SET hits = (SELECT COUNT(tabla_sesion.ua_proxy) FROM tabla_sesion 
		WHERE tabla_sesion.ua_proxy=ua_proxys.ua_proxy);
	UPDATE ua_proxys SET visitantes = (SELECT COUNT(DISTINCT tabla_sesion.id_sesion) FROM tabla_sesion 
		WHERE tabla_sesion.ua_proxy=ua_proxys.ua_proxy);
	UPDATE ua_proxys SET transferencia = (SELECT SUM(tabla_sesion.transferencia) FROM tabla_sesion 
		WHERE tabla_sesion.ua_proxy=ua_proxys.ua_proxy);
	DELETE FROM ua_sistemas_operativos WHERE ua_so = 'N/A';
	DELETE FROM ua_browsers WHERE ua_browser = 'N/A';
	DELETE FROM ua_crawlers WHERE ua_crawler = 'N/A';
	DELETE FROM ua_links WHERE ua_link = 'N/A';
	DELETE FROM ua_spams WHERE ua_spam = 'N/A';
	DELETE FROM ua_downloads WHERE ua_download = 'N/A';
	DELETE FROM ua_proxys WHERE ua_proxy = 'N/A';
	DELETE FROM ua_tipos WHERE ua_tipo = 'N/A';
	DELETE FROM ua_tipos WHERE ua_tipo = 'Other';
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION crear_useragent_estadisticas() OWNER TO upolaris;
CREATE OR REPLACE FUNCTION sesionalizar_clf()
  RETURNS void AS
$BODY$
DECLARE
BEGIN
	update tabla_log_common_l_f set fecha = to_date(substring(date_time_zone from 1 for 11),'dd/Mon/yyyy');
	update tabla_log_common_l_f set hora = to_timestamp(substring(date_time_zone from 13 for 8),'hh24/mi/ss');
	update tabla_log_common_l_f set zona = substring(date_time_zone from 22 for 5);
	update tabla_log_common_l_f set bytes = '0' where bytes='-';
	DROP TABLE IF EXISTS tabla_sesion;
	CREATE TABLE tabla_sesion
	(
		id integer NOT NULL,host text NOT NULL,fecha date NOT NULL,hora time without time zone NOT NULL,id_sesion integer,date_time timestamp without time zone,
		transferencia integer,status_code text,request_original text,request text,directorio text,archivo text,
		extension text,dia integer,solo_hora integer,tipoarchivo text,user_agent text DEFAULT 'N/A',ua_tipo text DEFAULT 'N/A',
		ua_so text DEFAULT 'N/A',ua_browser text DEFAULT 'N/A',ua_crawler text DEFAULT 'N/A',ua_link text DEFAULT 'N/A',
		ua_spam text DEFAULT 'N/A',ua_downloading text DEFAULT 'N/A',ua_proxy text DEFAULT 'N/A',referente text DEFAULT '-',
		motor_busqueda text DEFAULT 'N/A',palabras_clave text DEFAULT '',sitios_referentes text DEFAULT 'N/A',dominio text DEFAULT 'N/A'
	);
	insert into tabla_sesion ((SELECT id,host,fecha,hora,0,null,to_number(bytes,'9999999999'),statuscode,recuest,null,null,null FROM tabla_log_common_l_f order by host,id));
	UPDATE tabla_sesion SET date_time=fecha+hora;
	DROP TABLE IF EXISTS sesion_tmp;
	CREATE TEMP TABLE sesion_tmp AS SELECT min(id) as id,host from tabla_log_common_l_f group by host order by id;
	UPDATE tabla_sesion SET id_sesion=sesion_tmp.id FROM sesion_tmp WHERE tabla_sesion.host=sesion_tmp.host;
	DROP TABLE sesion_tmp;
	CREATE TEMP TABLE sesion_tmp AS SELECT * FROM tabla_sesion ORDER BY id_sesion,id;
	DELETE FROM tabla_sesion;
	INSERT INTO tabla_sesion (SELECT * FROM sesion_tmp);
	DROP TABLE sesion_tmp;
	UPDATE tabla_sesion SET request=trim(both ' ' from substring(request_original from '%#" % #"%' for '#'));
	UPDATE tabla_sesion SET directorio=substring(request from '#"/%/#"%' for '#');
	UPDATE tabla_sesion SET directorio='/' where directorio IS NULL;
	UPDATE tabla_sesion SET archivo=substring(request FROM char_length(directorio)+1 for char_length(request));
	UPDATE tabla_sesion SET extension=substring(request from '%#".%#"%' for '#');
	UPDATE tabla_sesion SET dia=date_part('dow',fecha);
	UPDATE tabla_sesion SET solo_hora=date_part('hour',hora);
	UPDATE tabla_sesion SET extension='No Extension' WHERE extension IS NULL;
	UPDATE tabla_sesion SET tipoarchivo=tipo_archivo.tipo FROM tipo_archivo
		WHERE tabla_sesion.extension=tipo_archivo.extension;
	UPDATE tabla_sesion SET tipoarchivo='Other' WHERE tipoarchivo IS NULL;	 
	UPDATE tabla_sesion SET user_agent = tabla_log_common_l_f.cs_user_agent_ FROM tabla_log_common_l_f
		WHERE tabla_log_common_l_f.id = tabla_sesion.id;
	UPDATE tabla_sesion SET user_agent = replace( user_agent, '+', ' ');
	UPDATE tabla_sesion SET ua_tipo = ua_lista.desc_tipo FROM ua_lista
		WHERE tabla_sesion.user_agent like '%'||ua_lista.ua_string||'%';
	UPDATE tabla_sesion SET ua_tipo = 'Other' where ua_tipo IS NULL;
	UPDATE tabla_sesion SET ua_so = lista_so.nombre_so FROM lista_so
		WHERE tabla_sesion.user_agent like '%'||lista_so.so_string||'%';
	UPDATE tabla_sesion SET ua_so = 'N/A' where ua_so IS NULL;
	UPDATE tabla_sesion SET ua_browser = ua_lista.ua_nombre FROM ua_lista
		WHERE tabla_sesion.user_agent like '%'||ua_lista.ua_string||'%' AND ua_lista.ua_tipo = 'B';
	UPDATE tabla_sesion SET ua_browser = 'N/A' where ua_browser IS NULL;
	UPDATE tabla_sesion SET ua_crawler = ua_lista.ua_nombre FROM ua_lista
		WHERE tabla_sesion.user_agent like '%'||ua_lista.ua_string||'%' AND ua_lista.ua_tipo = 'R';
	UPDATE tabla_sesion SET ua_crawler = 'N/A' where ua_crawler IS NULL;
	UPDATE tabla_sesion SET ua_link = ua_lista.ua_nombre FROM ua_lista
		WHERE tabla_sesion.user_agent like '%'||ua_lista.ua_string||'%' AND ua_lista.ua_tipo = 'C';
	UPDATE tabla_sesion SET ua_link = 'N/A' where ua_link IS NULL;
	UPDATE tabla_sesion SET ua_spam = ua_lista.ua_nombre FROM ua_lista
		WHERE tabla_sesion.user_agent like '%'||ua_lista.ua_string||'%' AND ua_lista.ua_tipo = 'S';
	UPDATE tabla_sesion SET ua_spam = 'N/A' where ua_spam IS NULL;
	UPDATE tabla_sesion SET ua_downloading = ua_lista.ua_nombre FROM ua_lista
		WHERE tabla_sesion.user_agent like '%'||ua_lista.ua_string||'%' AND ua_lista.ua_tipo = 'D';
	UPDATE tabla_sesion SET ua_downloading = 'N/A' where ua_downloading IS NULL;
	UPDATE tabla_sesion SET ua_proxy = ua_lista.ua_nombre FROM ua_lista
		WHERE tabla_sesion.user_agent like '%'||ua_lista.ua_string||'%' AND ua_lista.ua_tipo = 'P';
	UPDATE tabla_sesion SET ua_proxy = 'N/A' where ua_proxy IS NULL;
	UPDATE tabla_sesion SET referente = tabla_log_common_l_f.cs_referer_ FROM tabla_log_common_l_f
		WHERE tabla_log_common_l_f.id = tabla_sesion.id;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sesionalizar_clf() OWNER TO upolaris;
CREATE OR REPLACE FUNCTION sesionalizar_w3c()
  RETURNS void AS
$BODY$
DECLARE
 
BEGIN
	DROP TABLE IF EXISTS tabla_sesion;
	CREATE TABLE tabla_sesion
	(
		id integer NOT NULL,host text NOT NULL,fecha date NOT NULL,hora time without time zone NOT NULL,id_sesion integer,date_time timestamp without time zone,
		transferencia integer,status_code text,request_original text,request text,directorio text,archivo text,extension text,dia integer,solo_hora integer,
		tipoarchivo text,user_agent text,ua_tipo text,ua_so text,ua_browser text,ua_crawler text,ua_link text,ua_spam text,ua_downloading text,
		ua_proxy text,referente text DEFAULT '-',motor_busqueda text DEFAULT 'N/A',palabras_clave text DEFAULT '',sitios_referentes text DEFAULT 'N/A',dominio text DEFAULT 'N/A'

	);
	insert into tabla_sesion ((SELECT id,c_ip,date,time,0,null,to_number(sc_bytes,'9999999999'),sc_status,cs_uri_stem,cs_uri_stem FROM tabla_log_w3c order by c_ip,id));
	UPDATE tabla_sesion SET date_time=fecha+hora;
	DROP TABLE IF EXISTS sesion_tmp;
	CREATE TEMP TABLE sesion_tmp AS SELECT min(id) as id,c_ip from tabla_log_w3c group by c_ip order by id;
	UPDATE tabla_sesion SET id_sesion=sesion_tmp.id FROM sesion_tmp WHERE tabla_sesion.host=sesion_tmp.c_ip;
	DROP TABLE sesion_tmp;
	CREATE TEMP TABLE sesion_tmp AS SELECT * FROM tabla_sesion ORDER BY id_sesion,id;
	DELETE FROM tabla_sesion;
	INSERT INTO tabla_sesion (SELECT * FROM sesion_tmp);
	DROP TABLE sesion_tmp;
	UPDATE tabla_sesion SET directorio=substring(request from '#"/%/#"%' for '#');
	UPDATE tabla_sesion SET directorio='/' where directorio IS NULL;
	UPDATE tabla_sesion SET archivo=substring(request FROM char_length(directorio)+1 for char_length(request));
	UPDATE tabla_sesion SET extension=substring(request from '%#".%#"%' for '#');
	UPDATE tabla_sesion SET dia=date_part('dow',fecha);
	UPDATE tabla_sesion SET solo_hora=date_part('hour',hora);
	UPDATE tabla_sesion SET extension='No Extension' WHERE extension IS NULL;
	UPDATE tabla_sesion SET tipoarchivo=tipo_archivo.tipo FROM tipo_archivo
		WHERE tabla_sesion.extension=tipo_archivo.extension;
	UPDATE tabla_sesion SET tipoarchivo='Other' WHERE tipoarchivo IS NULL;
	UPDATE tabla_sesion SET user_agent = tabla_log_w3c.cs_user_agent_ FROM tabla_log_w3c
		WHERE tabla_log_w3c.id = tabla_sesion.id;
	UPDATE tabla_sesion SET user_agent = replace( user_agent, '+', ' ');
	UPDATE tabla_sesion SET ua_tipo = ua_lista.desc_tipo FROM ua_lista
		WHERE tabla_sesion.user_agent like '%'||ua_lista.ua_string||'%';
	UPDATE tabla_sesion SET ua_tipo = 'Other' where ua_tipo IS NULL;
	UPDATE tabla_sesion SET ua_so = lista_so.nombre_so FROM lista_so
		WHERE tabla_sesion.user_agent like '%'||lista_so.so_string||'%';
	UPDATE tabla_sesion SET ua_so = 'N/A' where ua_so IS NULL;
	UPDATE tabla_sesion SET ua_browser = ua_lista.ua_nombre FROM ua_lista
		WHERE tabla_sesion.user_agent like '%'||ua_lista.ua_string||'%' AND ua_lista.ua_tipo = 'B';
	UPDATE tabla_sesion SET ua_browser = 'N/A' where ua_browser IS NULL;
	UPDATE tabla_sesion SET ua_crawler = ua_lista.ua_nombre FROM ua_lista
		WHERE tabla_sesion.user_agent like '%'||ua_lista.ua_string||'%' AND ua_lista.ua_tipo = 'R';
	UPDATE tabla_sesion SET ua_crawler = 'N/A' where ua_crawler IS NULL;
	UPDATE tabla_sesion SET ua_link = ua_lista.ua_nombre FROM ua_lista
		WHERE tabla_sesion.user_agent like '%'||ua_lista.ua_string||'%' AND ua_lista.ua_tipo = 'C';
	UPDATE tabla_sesion SET ua_link = 'N/A' where ua_link IS NULL;
	UPDATE tabla_sesion SET ua_spam = ua_lista.ua_nombre FROM ua_lista
		WHERE tabla_sesion.user_agent like '%'||ua_lista.ua_string||'%' AND ua_lista.ua_tipo = 'S';
	UPDATE tabla_sesion SET ua_spam = 'N/A' where ua_spam IS NULL;
	UPDATE tabla_sesion SET ua_downloading = ua_lista.ua_nombre FROM ua_lista
		WHERE tabla_sesion.user_agent like '%'||ua_lista.ua_string||'%' AND ua_lista.ua_tipo = 'D';
	UPDATE tabla_sesion SET ua_downloading = 'N/A' where ua_downloading IS NULL;
	UPDATE tabla_sesion SET ua_proxy = ua_lista.ua_nombre FROM ua_lista
		WHERE tabla_sesion.user_agent like '%'||ua_lista.ua_string||'%' AND ua_lista.ua_tipo = 'P';
	UPDATE tabla_sesion SET ua_proxy = 'N/A' where ua_proxy IS NULL;
	UPDATE tabla_sesion SET referente = tabla_log_w3c.cs_referer_ FROM tabla_log_w3c
		WHERE tabla_log_w3c.id = tabla_sesion.id;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sesionalizar_w3c() OWNER TO upolaris;
CREATE OR REPLACE FUNCTION sesionalizar_intervalos(rangotiempo interval)
  RETURNS void AS
$BODY$
 DECLARE
   mi_cursor  CURSOR FOR SELECT * FROM tabla_sesion ORDER BY id_sesion,id FOR UPDATE;
   mi_cursor1  CURSOR FOR SELECT * FROM tabla_sesion ORDER BY id_sesion,id FOR UPDATE;
   mi_fila1 tabla_sesion%ROWTYPE;
   mi_fila2 tabla_sesion%ROWTYPE;

   i INTEGER; 
   miIntervalo INTERVAL;
   sumaIntervalo INTERVAL;
   rangoTiempo INTERVAL; 
 BEGIN
   i=1;
   rangoTiempo = $1;
   OPEN mi_cursor;
   OPEN mi_cursor1;
   sumaIntervalo='00:00:00';
   FETCH mi_cursor1 INTO mi_fila2;
   LOOP
	FETCH  mi_cursor INTO mi_fila1;
	IF NOT FOUND THEN EXIT;
	END IF;
	FETCH mi_cursor1 INTO mi_fila2;
	     
	IF mi_fila1 IS NULL THEN 
		EXIT;
	END IF;
	miIntervalo=mi_fila2.date_time - mi_fila1.date_time;
	sumaIntervalo=sumaIntervalo+miIntervalo;
	RAISE NOTICE '% - % - % - % - %', mi_fila1.id, i,mi_fila1.date_time, miIntervalo, sumaIntervalo;
	UPDATE tabla_sesion SET id_sesion=i WHERE CURRENT OF  mi_cursor;
	
	IF mi_fila1.host <> mi_fila2.host OR sumaIntervalo > rangoTiempo THEN
		i=i+1;
		sumaIntervalo='00:00:00';
	END IF;
   END LOOP;
CLOSE mi_cursor;
CLOSE mi_cursor1;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sesionalizar_intervalos(interval) OWNER TO upolaris;
CREATE OR REPLACE FUNCTION sesionalizar_timeof()
  RETURNS void AS
$BODY$
 DECLARE
   mi_cursor  CURSOR FOR SELECT * FROM tabla_sesion ORDER BY id_sesion,id FOR UPDATE;
   mi_cursor1  CURSOR FOR SELECT * FROM tabla_sesion ORDER BY id_sesion,id FOR UPDATE;
   mi_fila1 tabla_sesion%ROWTYPE;
   mi_fila2 tabla_sesion%ROWTYPE;
   i INTEGER; 
   miIntervalo INTERVAL;
   startEnd INTEGER;
 BEGIN
   i=1;
   OPEN mi_cursor;
   OPEN mi_cursor1;
   FETCH mi_cursor1 INTO mi_fila2;
   LOOP
	FETCH  mi_cursor INTO mi_fila1;
	IF NOT FOUND THEN EXIT;
	END IF;
	FETCH mi_cursor1 INTO mi_fila2;
	     
	IF mi_fila1 IS NULL THEN 
		EXIT;
	END IF;
	miIntervalo=mi_fila2.date_time - mi_fila1.date_time;
	RAISE NOTICE '% - % - % - %', mi_fila1.id, i,mi_fila1.date_time, miIntervalo;
	UPDATE tabla_sesion SET id_sesion=i WHERE CURRENT OF  mi_cursor;
	IF mi_fila1.host <> mi_fila2.host OR miIntervalo > '30 minutes' THEN
		i=i+1;
	END IF;
   END LOOP; 
CLOSE mi_cursor;
CLOSE mi_cursor1;
END;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sesionalizar_timeof() OWNER TO upolaris;
