/**
 * Transformacion_cla.java
 *
 * Created on 24 de mayo de 2007, 03:01 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package algorithm.classification;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.Date;
import Utils.conexion;
import workspace.Prepro.intervalos;

/**
 *
 * @author Proyecto *** Polaris *** Johana
 */
public class Transformacion_cla {
    
    conexion conx;
    ResultSet rS;
    String sesionPlay;
    sesiontrans sTrans;
    int tiempoSesion;
    ArrayList datos;
    // Para Duracion
    ArrayList inDuracion= null;
    ArrayList inTamano= null;
    ArrayList inCantidad= null;
    
    /** Creates a new instance of Transformacion_cla */
    public Transformacion_cla(String sesion, int tsesion) {
        // Instanciar conx
        conx= new conexion();
        // Abrir conexion a BD logs
        conx.conectar("polaris","upolaris","ppolaris");
        // colocar sesion ha analizar
        sesionPlay= sesion;
        tiempoSesion= tsesion;
        datos= new ArrayList();
        // Predeterminar
        
    }
    
    /** poner intervalo de duracion */
    public void setIntervalDuration(ArrayList iduracion){
        inDuracion= iduracion;
    }
    
    /** poner intervalo de Cantido */
    public void setIntervalCantidad(ArrayList icantidad){
        inCantidad= icantidad;
    }
    
    /** poner intervalo de Tamano */    
    public void setIntervalTamano(ArrayList itamano){
        inTamano= itamano;
    }
    
    /** Transforma la direccion IP en el tipo IP correspondiente
     *  Si el primer numero de la IP es...
     *  de 0    -   127 :   tipoA
     *  de 128  -   191 :   tipoB
     *  de 192  -   223 :   tipoC
     *  de 224  -   239 :   tipoD
     *  de 240  -   255 :   tipoE
     *  si es un nombre :   HOST
     */
    private String transTiposIP(String campoIP){
        //
        String p="";
        int primero,fin;
        String tipo="";
        //
        if(conx!=null){
            // abrir
            fin= campoIP.indexOf('.',0);
            if(fin!=-1){ // significa que es una IP
                p= campoIP.substring(0,fin);
            } else{ // significa que es un host
                InetAddress inetAddr; // clase de direcciones
                try {
                    inetAddr = InetAddress.getByName(campoIP);
                    String str = inetAddr.toString();
                    fin= str.indexOf('.',0);
                    if(fin!=-1) p= campoIP.substring(0,fin);
                    else tipo="HOST"; // UNKOWN - DESCONOCIDO
                } catch (UnknownHostException ex) {
                    tipo="HOST"; // UNKOWN - DESCONOCIDO
                }
            }
            // una vez tenemos el primer numero de la IP
            try{
                primero= Integer.parseInt(p);
                if(primero>=0 && primero<128) tipo="type A";   // A
                if(primero>=128 && primero<192) tipo="type B"; // B
                if(primero>=192 && primero<224) tipo="type C"; // C
                if(primero>=224 && primero<240) tipo="type D"; // D
                if(primero>=240 && primero<256) tipo="type E"; // E
            }catch(Exception e){
                InetAddress inetAddr; // clase de direcciones
                try {
                    inetAddr = InetAddress.getByName(campoIP);
                    String str = inetAddr.toString();
                    fin= str.indexOf('.',0);
                    if(fin!=-1) p= campoIP.substring(0,fin);
                    else tipo="HOST"; // UNKOWN - DESCONOCIDO
                } catch (UnknownHostException ex) {
                    tipo="HOST"; // UNKOWN - DESCONOCIDO
                }
            }            
            //
        }
        //
        return tipo;
    }
    
    /** 
     * Tomamos el horario apartir de la fecha de inicio de Sesion
     * Si la hora es...
     * de   0   -   11  :   Manana
     * de   12  -   18  :   Tarde
     * de   19  -   23  :   Noche
     */
    private String transHorario(String hora1){ // Tomamos horario a partir de la fecha de inicio de sesion
        //
        String h="";
        int hora,fin;
        String horario="";
        //
        hora=0;
        fin= hora1.indexOf(':',0);
        if(fin!=-1){
            h=hora1.substring(0,fin);
            hora= Integer.parseInt(h); // Obtengo la hora
            if(hora>=0 && hora<12) horario="Morning";  // Manana
            if(hora>=12 && hora<19) horario="Afternoon"; // Tarde
            if(hora>=19 && hora<24) horario="Night"; // Noche
        }
        //
        return horario;
    }
    
    /**
     * Tomamos el Dia de Semana segun la fecha de inicio de Sesion
     * Puede ser uno de los siete dias de la semana.
     */
    private String transDiaSemana(int dia){ // Tomamos dia de semana segun la fecha de inicio de sesion
        //
        String diaSemana="";
        //
        if(dia==1) diaSemana="Monday"; // Lunes
        if(dia==2) diaSemana="Tuesday"; // Martes
        if(dia==3) diaSemana="Wednesday"; // Miercoles
        if(dia==4) diaSemana="Thursday"; // Jueves
        if(dia==5) diaSemana="Friday"; // Viernes
        if(dia==6) diaSemana="Saturday"; // Sabado
        if(dia==0) diaSemana="Sunday"; // Domingo
        //
        return diaSemana;
    }
    
    /**
     * Tomamos la duracion tomando la diferencia de la hora de inicio y la de fin de sesion
     * Si es...
     * menor a 30 min   :   Es Corta
     * de 30 - 60 min   :   Es Media
     * mayor a 60 min   :   Es Larga
     */
    private String transDuracion(Date hora1, Date hora2, int tsesion){  // Tomamos hora inicio y hora fin para
        // hacer respectiva resta
        // y tsesion
        String duracion= "";
        int totalmin= 0;
        int intervalo= tsesion/3;
        // Sacamos diferencia en minutos
        long lini = hora1.getTime();
        long lfin = hora2.getTime();
        long diferencia = lfin - lini;
        long m =  diferencia / 60000; // minutos de la sesion;
        // Calculamos        
            if(m<=intervalo)                    duracion= "Short"; // Corta
            if(m>=(intervalo+1) && m<=(intervalo*2))    duracion= "Middle"; // Intermedia
            intervalo=intervalo*2;
            if(m>=(intervalo+1) && m<=tsesion)      duracion= "Long"; // Larga        
        //
        return duracion;
    }
    
    /**
     * Utiliza la configuracion de Discretizar
     * para generar la transformacion
     *
     */
    public String transDuracion(ArrayList iduracion, Date hora1, Date hora2){
        String duracion="";
        boolean findit;
        intervalos ii;
        // Sacamos diferencia en minutos
        long lini = hora1.getTime();
        long lfin = hora2.getTime();
        long diferencia = lfin - lini;
        long m =  diferencia / 60000; // minutos de la sesion;
        // Calculamos
        findit= false;
        for(int i=0;i<iduracion.size() && findit==false;i++){
            ii= (intervalos) iduracion.get(i);
            //
            if(m>=ii.getMin() && m<=ii.getMax()){
                duracion= ii.getNom();
                findit=true;
            }
        }
        //
        return duracion;
    }    
    
    /**
     * Coloca los valores segun la cant de solicitudes
     * menos de 10  :   Pocas
     * de 10 - 40   :   Media
     * mas de 60    :   Larga
     */
    private String transCantSolicitudes(int npet){
        //
        String cant="";
        //
        if(npet<=10)  cant="Few"; // Pocas
        if(npet>=11 && npet<=40) cant="Middle"; // Intermedio
        if(npet>=41)             cant="Many"; // Muchas
        //
        return cant;
    }
    
    public String transCantSolicitudes(ArrayList icantidad, int npet){
        String cant="";
        intervalos ii;
        //
        boolean findit= false;
        for(int i=0;i<icantidad.size() && findit==false;i++){
            ii= (intervalos) icantidad.get(i);
            //
            if(npet>=ii.getMin() && npet<=ii.getMax()){
                cant= ii.getNom();
                findit=true;
            }
        }
        //
        return cant;
    }
    
    /**
     * Coloca los valores segun el tamano en bytes
     * menos de 2 mb    :   Baja
     * de 2 - 10  mb    :   Media
     * mas de 10  mb    :   Alta
     */
    private String transDescargas(int bytes){
        //
        String descarga="";
        //
        if(bytes<=2000)     descarga="Low"; // Baja
        if(bytes>=2001 && bytes<=10000)  descarga="Middle"; // Media
        if(bytes>=10001)                descarga="High"; // Alta
        //
        return descarga;
        
    }
    
    private String transDescargas(ArrayList itamano, int bytes){
        String descarga="";
        intervalos ii;
        //
        boolean findit= false;
        for(int i=0;i<itamano.size() && findit==false;i++){
            ii= (intervalos) itamano.get(i);
            //
            if(bytes>=ii.getMin() && bytes<=ii.getMax()){
                descarga= ii.getNom();
                findit=true;
            }
        }
        //
        return descarga;
    }
    
    
    /**
     * Contar la cantidad de sesiones que se generaron
     */
    private int ContarRegSesion(String sesion){
        int cont=0;
        //
        try{
            rS= conx.consulta("SELECT count(*) FROM " + sesion);
            rS.next();
            cont = rS.getInt(1);
            
        }catch(Exception e){
            System.out.println("Error: " + e.getMessage());
        }
        //
        return cont;
    }
    
    /**
     * Genera la Sesion Transformada que se usa para
     * aplicar los algoritmos de Clasificacion
     */
    public String crearSesionTransformada(){
        //
        int contSesiones=0,i;
        String msj="";
        java.util.Date fini, ffin;
        String host="", fechaini="", fechafin="", hora="";
        int numsol=0, totalb=0, ini=0, fdia=0;
        //
        //fini= new Date(); ffin= new Date();        
        contSesiones= ContarRegSesion(sesionPlay);
        if(contSesiones>0){
            // Si hay sesiones entonces transforme
            try{
                rS= conx.consulta("SELECT * FROM " + sesionPlay);
                for(i=0;i<contSesiones;i++){ // leer cada sesion
                    // ** leo reg
                    rS.next();
                    // Copio los elementos necesarios para la sesion transformada
                    host= rS.getString("hostremoto");
                    fini= rS.getTimestamp("fechahorainicio");//.getDate("fechahorainicio");                    
                    fechaini= rS.getString("fechahorainicio");                   
                    //
                    //System.out.println("hora: " + fini);
                    //
                    ffin= rS.getTimestamp("fechahorafin");//.getDate("fechahorafin");
                    fechafin= rS.getString("fechahorafin");
                    numsol= rS.getInt("numsolicitudes");
                    totalb= rS.getInt("totalbytes");
                    // ** transformacion 
                    sTrans= new sesiontrans(); // creo una clase de trans sesion                    
                    sTrans.setTipoIP(transTiposIP(host)); // colocar tipo IP
                    ini= 1 + fechaini.indexOf(' ',0); // colocar Horario
                    hora= fechaini.substring(ini);
                    sTrans.setHorario(this.transHorario(hora));
                    fdia= fini.getDay(); // colocar dia de la semana
                    sTrans.setDiaSemana(this.transDiaSemana(fdia)); 
                    //
                    if(inDuracion==null){
                        sTrans.setDuracion(this.transDuracion(fini,ffin,tiempoSesion)); // colocar cuanto dura
                    }else{
                        sTrans.setDuracion(this.transDuracion(inDuracion,fini,ffin)); // colocar cuanto dura
                    }                    
                    if(inCantidad==null){
                        sTrans.setCantPet(this.transCantSolicitudes(numsol)); // colacar cant solicitudes
                    }else{
                        sTrans.setCantPet(this.transCantSolicitudes(inCantidad, numsol)); // colacar cant solicitudes
                    }                    
                    if(inTamano==null){
                        sTrans.setTamDescarga(this.transDescargas(totalb)); // colocar tam descarga
                    }else{
                        sTrans.setTamDescarga(this.transDescargas(inTamano, totalb)); // colocar tam descarga
                    }                    
                    // ** Guardar en Algo pero en que?
                    datos.add(sTrans);
                }
                
                msj= "Transformed session";
                
            }catch(Exception e){
                //System.out.println("Error: " + e.getMessage());
                msj= "Error: " + e.getMessage();
            }
            
        } else{
            msj= "There is not transformation";
        }
        
        // FIN
        return msj;
    }
      
    /**
     * Devuelve las Sesiones de Usuario Trasnformadas
     */
    public ArrayList getDatosTrans(){
        return datos;
    }
    
    /**
     * Cierra la conexion con la base de datos Polaris
     */
    public void finalizar(){
    	conx.cerrarConexion();
    }
    
}
