/**
 * elemento.java
 *
 * Created on 2 de junio de 2007, 09:00 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package algorithm.classification;

/**
 *
 * @author Proyecto *** Polaris *** Johana
 */
public class elemento {
    
    // *** Atributos
    /** Nombre clave del elemento */
    String id;
    /** Cantidad de veces que esta el elemento */
    int frec;
    /** Entropia del elemento */
    double entropia;
    /** Cantidad de hijos que tiene */
    int nhijos;
    /** Hijos de elemento */
    public elemento[] hijos;    
    // ---    
    
    /** Creates a new instance of Attribute 
     * 
     *  @ Parameter name: It is element's name
     *  @ Parameter f: It is frecuence of element
     */
    public elemento(String name,int f) {
        this.id = name;
        frec = f;
        //
        nhijos=0;
        hijos = new elemento[7];
        for(int i=0;i<7;i++){
            hijos[i]= null;
        }
    }
    
    /** Creates a new instance of Attribute 
     *
     *  @ Parameter name: It is element's name
     *  @ Parameter e: It is entropy of element
     *  @ Parameter f: It is frecuence of element
     */
    public elemento(String name,double e, int f) {
        this.id = name;
        frec = f;
        entropia= e;
        //
        nhijos=0;
        hijos = new elemento[7];
        for(int i=0;i<7;i++){
            hijos[i]= null;
        }
    }
    
    /** Creates a new instance of Attribute 
     *
     *  @ Parameter name: It is element's name
     *  
     */
    public elemento(String name) {
        this.id = name;
        frec = 0;
        //       
        nhijos=0;
        hijos = new elemento[7];
        for(int i=0;i<7;i++){
            hijos[i]= null;
        }
    }
    
    /** Devuelve la frecuencia de elemento */
    public int getFrecuence() {
        return frec;
    }
    
    /** Devuelve la cantidad de hijos */
    public int getNumhijos() {
        return nhijos;
    }
    
    /** Asigna el nombre a elemento */
    public void setNombre(String nom){
        id= nom;
    }
           
    /** Devuelve el nombre de elemento */
    public String getNombre() {
        return id;
    }

    /** Asigna la frecuencia de elemento */
    public void setFrecuence(int f) {
        frec= f;
    }
    
    /** Asigna la cantidad de hijos */
    public void setNumhijos(int n) {
        nhijos= n;
    }
    
    /** Devuelve la entropia de elemento */
    public double getEntropia() {
        return entropia;
    }
    
    /** Asigna la entropia de elemento */
    public void setEntropia(double e) {
        entropia= e;
    }
    
    /** Incrementa frecuencia en 1 */
    public void incrementFrecuence(){
        frec++;
    }
    
    /** Incrementa el numero de hijos en 1 */
    public void incNumhijos(){
        nhijos++;
    }
        
}
