
package algorithm.hpg2;

import algorithm.classification.elemento;
import java.awt.Image;
import java.text.DecimalFormat;
import java.util.ArrayList;
import javax.swing.ImageIcon;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreePath;
import workspace.Main_Set.Main;

public class MostrarBFS extends javax.swing.JDialog { 
    
    // ***
    nodoState finalTree;
    private DefaultMutableTreeNode princ;
    
    
    /**
     * Creates new form MostrarBFS
     */
    public MostrarBFS(nodoState root, double alfa, double conf){        
        //
        princ= armarJtree(root);        
        //
        initComponents();
        this.setIconImage(this.getImage("/media/appicon.png"));        
        //        
        txt_log.setEnabled(true);
        txt_target.setEnabled(true);
        this.txt_log.setText("HPG Navigation Patterns Tree");
        this.txt_target.setText("Alfa: " + alfa + " -- Conf: " + conf);
        finalTree= root;
        lbl_proceso.setText("HPG Tree - BFS");
        this.setTitle("HPG Tree - BFS"); 
        //
        prepararArbol();
        lbl_state.setText("HPG Results");
        System.out.println("ENTRO");
    }
    
    public DefaultMutableTreeNode armarJtree(nodoState aux){
        // Variables
        DefaultMutableTreeNode nodo   = null;
        DecimalFormat df;        
        int i=0;
        //
        df = new DecimalFormat();
        df.setMaximumFractionDigits(2);
        // Proceso                
        String nom= aux.getID() + "with " + df.format(aux.getProb());
        nodo= new DefaultMutableTreeNode(nom); 
        //System.out.println(".:. ELEMENTO .:. " + aux.getNombre());
        try{
            aux= aux.hijo;
            //for(i=0;i<aux.getCountHijos();i++){
            while(aux!=null){
                nodo.add(armarJtree(aux));
                //
                aux= aux.hermano;
            }            
        }catch(Exception e){
            
        }    
        // Salida
        return nodo;
    }
    
    public void prepararArbol(){
        ImageIcon im1 = createImageIcon("/media/arbol.png");
        ImageIcon im2 = createImageIcon("/media/arbol.png");
        ImageIcon im3 = createImageIcon("/media/hoja.png");
        
        DefaultTreeCellRenderer renderer = new DefaultTreeCellRenderer();
        renderer.setLeafIcon(im3);
        renderer.setOpenIcon(im2);
        renderer.setClosedIcon(im3);
        tree_rta.setCellRenderer(renderer);
        // * - "myTreeModel" es una variable donde almacenamos el "DefaultTreeModel"        
        expandirNodo((DefaultMutableTreeNode)tree_rta.getModel().getRoot());        
    }
    
    //
    public void expandirNodo(DefaultMutableTreeNode tnodo){
        // el objeto tree_rta
        TreePath tp=new TreePath(tnodo.getPath());
        tree_rta.expandPath(tp);
        for(int i = 0; i<tnodo.getChildCount(); i++) {
            expandirNodo((DefaultMutableTreeNode)tnodo.getChildAt(i));
        }
    }
    
       
    //configuraciones iniciales de este formulario
    public MostrarBFS(java.awt.Frame parent, boolean modal) {
        super(parent, true);
        initComponents();
        this.setIconImage(this.getImage("/media/win1 (1).png"));        
    }   
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        txt_log = new javax.swing.JTextField();
        txt_target = new javax.swing.JTextField();
        lbl_sop = new javax.swing.JLabel();
        lbl_process = new javax.swing.JLabel();
        lbl_proceso = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tree_rta = new javax.swing.JTree(princ);
        lbl_state = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Classification Settings");
        setResizable(false);
        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Data")));
        jLabel1.setText("WebServerLog");

        txt_log.setBackground(new java.awt.Color(255, 255, 255));
        txt_log.setEditable(false);
        txt_log.setForeground(new java.awt.Color(0, 102, 0));

        txt_target.setBackground(new java.awt.Color(255, 255, 255));
        txt_target.setEditable(false);
        txt_target.setForeground(new java.awt.Color(0, 102, 0));

        lbl_sop.setText("Target");

        lbl_process.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lbl_process.setText("Process");

        lbl_proceso.setBackground(new java.awt.Color(255, 255, 255));
        lbl_proceso.setEditable(false);
        lbl_proceso.setForeground(new java.awt.Color(0, 102, 0));

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(34, 34, 34)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(lbl_process)
                    .addComponent(jLabel1)
                    .addComponent(lbl_sop))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(txt_target, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(txt_log, javax.swing.GroupLayout.DEFAULT_SIZE, 433, Short.MAX_VALUE)
                    .addComponent(lbl_proceso))
                .addContainerGap(47, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(txt_log, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lbl_sop)
                    .addComponent(txt_target, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lbl_process)
                    .addComponent(lbl_proceso, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(50, 50, 50))
        );

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Result Tree"));
        jScrollPane1.setViewportView(tree_rta);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 599, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 365, Short.MAX_VALUE)
                .addContainerGap())
        );

        lbl_state.setText("POLARIS WUM - VIEW: is runing...");
        lbl_state.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(lbl_state, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, 109, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lbl_state)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    //manejo de conos ********************************************************
       
    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }

    private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = Main.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }
    
//manejo de conos ********************************************************
    
  
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField lbl_proceso;
    private javax.swing.JLabel lbl_process;
    private javax.swing.JLabel lbl_sop;
    private javax.swing.JLabel lbl_state;
    private javax.swing.JTree tree_rta;
    private javax.swing.JTextField txt_log;
    private javax.swing.JTextField txt_target;
    // End of variables declaration//GEN-END:variables
    
}
