/*
 * hpgpoda.java
 *
 * Created on 20 de septiembre de 2007, 05:32 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package algorithm.hpg2;

import algorithm.hpg.produccion;
import java.util.ArrayList;

/**
 *
 * @author Proyecto *** Polaris *** Johana
 */
public class hpgpoda {
    
    double confianza, alfa, soporte, landa;
    double ts, tp;
    ArrayList prods;
    //
    int ini=0;
    
    /** Creates a new instance of hpgpoda */
    public hpgpoda(ArrayList producciones, double conf, double a, int tsesiones, int tpags) {
        //     
        prods= producciones;
        //
        confianza= conf;
        alfa= a;
        ts= Double.valueOf(String.valueOf(tsesiones));
        tp= Double.valueOf(String.valueOf(tpags));
        //
        System.out.println("////");
        System.out.println("ts: " + ts + " -- tp: " + tp + " -- alfa: " + alfa);        
        soporte= 0.5;
        if(alfa==0){
            soporte= 1/ts;
        }else if(alfa>0){
            soporte= 1/tp;
        }        
        landa= soporte * confianza;
        System.out.println("////");
        System.out.println("sop: " + soporte + " -- conf: " + confianza + " -- land: " + landa);        
        //
    }
    
    /** Obtener Lista de Producciones del Proceso de Poda */
    public ArrayList hacerPoda(){
        ArrayList newProd= new ArrayList();
        int i;
        boolean pasoSop, pasoConf;
        //
        produccion actual;
        //
        for(i=0;i<prods.size();i++){
            actual= (produccion) prods.get(i);
            //
            if(actual.getTipo()==1){
                pasoSop= this.analizarSoporte(actual);
                if(pasoSop){
                    newProd.add(actual);
                }                
            }else if(actual.getTipo()>1){
                pasoConf= this.analizarConf(actual.getProb());
                if(pasoConf){
                    newProd.add(actual);
                }
            }
        }
        //
        return newProd;
    }
    
    /** Pasar Soporte */
    public boolean analizarSoporte(produccion fuente){
        //
        boolean paso= false;
        //
        if(fuente.getProb()>=soporte){
            paso= true;
        }
        //
        return paso;
    }
    
    /** Pasar Confianza */
    public boolean analizarConf(double fuente){
        //
        boolean paso= false;
        //
        if(fuente>=landa){
            paso= true;
        }
        //
        return paso;
    }
    
    /** Obtener Arbol de Patrones de Navegacion */
    public nodoState hacerPatternsTree(){
        nodoState raiz= new nodoState(-1,0,1), aux, auxi;
        System.out.println("RAIZ");
        int i, j;
        boolean pasoSop, pasoConf, fin;
        //
        produccion actual;
        nodoState candidato;
        // -- Obtener primeros candidatos con producciones iniciales
        fin= false;
        for(i=0;i<prods.size() && fin== false;i++){
            actual= (produccion) prods.get(i);
            //
            if(actual.getId1()==-1){
                pasoSop= this.analizarSoporte(actual);
                if(pasoSop){
                    System.out.println("sig: " + actual.getId2());
                    candidato= new nodoState(actual.getId2(), actual.getProb(), actual.getTipo());
                    raiz.insertarHijo(candidato);
                }                                
            }else{
                ini= i;
                fin= true;
            }
        }
        // -- Armar siguientes siguientes candidatos con producciones transitivas
        raiz= armarRamas(raiz);
        //
        return raiz;
    }
    
    public nodoState armarRamas(nodoState ant){
        nodoState nue= null, candidato, current;
        produccion actual;
        boolean fin, pasoConf;
        int i,j,a;
        double proba;
        //Mientras alla candidatos
        current= ant.hijo;
            while(current!=null){                
                a=3;
                //
                current= buscarID1(current);
                //
                try{
                    current= armarRamas(current);
                }catch(Exception e){
                    System.out.println("ERROR: " + e.getMessage());
                }                
                //
                current= current.hermano;
            }
            //
        
        //
        nue= ant;
        return nue;
    }    
    
    public nodoState buscarID1(nodoState current){
        int j;
        produccion actual;
        double proba;
        boolean pasoConf;
        nodoState candidato;
        // Buscar como id1
        for(j=ini; j<prods.size(); j++){
            actual= (produccion) prods.get(j);
            // Si el id1 de la produccion es igual al id del hijo de i
            if(current.getID()==actual.getId1() && actual.getTipo()>1){
                proba= current.getProb() * actual.getProb();
                pasoConf= this.analizarConf(proba);
                if(actual.getId2()!=-2){
                    if(pasoConf){
                        //System.out.println("adm: " + actual.getId2());                                
                        candidato= new nodoState(actual.getId2(), proba, actual.getTipo());
                        current.insertarHijo(candidato);
                        //ant.modHijo(current,i);
                    }else{
                        //System.out.println("ina: " + actual.getId2());                                
                        candidato= new nodoState(actual.getId2(), proba, actual.getTipo(),false);
                        current.insertarHijo(candidato);
                        //ant.modHijo(current,i);
                    }
                }
                //                        
            }
            //
        }
        //
        return current;
    }
    
    //
//    public nodoState armaRamas(nodoState ant){
//        nodoState nue= null, candidato, current;
//        produccion actual;
//        boolean fin, pasoConf;
//        int i,j,a;
//        double proba;
//        //Mientras alla candidatos
//        if(ant.getCountHijos()>0){
//            // Para cada candidato
//            for(j=ini; j<prods.size(); j++){
//                actual= (produccion) prods.get(j);
//                a=3;
//                // Buscar como id1
//                //fin= false;                
//                for(i=0;i<ant.getCountHijos();i++){
//                    current= ant.getHijo(i);    
//                    // Si el id1 de la produccion es igual al id del hijo de i
//                    if(current.getID()==actual.getId1() && actual.getTipo()>1){
//                        proba= current.getProb() * actual.getProb();
//                        pasoConf= this.analizarConf(proba);
//                        if(actual.getId2()!=-2){
//                            if(pasoConf){
//                                System.out.println("adm: " + actual.getId2());                                
//                                candidato= new nodoState(actual.getId2(), proba, actual.getTipo());
//                                current.insertarHijo(candidato);
//                                ant.modHijo(current,i);
//                            }else{
//                                System.out.println("ina: " + actual.getId2());                                
//                                candidato= new nodoState(actual.getId2(), proba, actual.getTipo(),false);
//                                current.insertarHijo(candidato);
//                                ant.modHijo(current,i);
//                            }
//                        }                        
//                        //
//                    }
//                    //
//                }
//                //                
//            }
//            //
//            try{
//                for(i=0;i<ant.getCountHijos();i++){
//                    current= ant.getHijo(i);
//                    current= armaRamas(current);
//                }                
//            }catch(Exception e){
//                System.out.println("ERROR: " + e.getMessage());
//            }
//            //
//        }
//        //
//        nue= ant;
//        return nue;
//    }
    
    //
    public double getSop(){
        return soporte;
    }
    
    //
    public double getConf(){
        return confianza;
    }
    
    //
    public double getLanda(){
        return landa;
    }
    
    //
}
