/**este archivo sirve para almacenar los metodos de Nodo*/

package bfstree;

import algorithm.hpg2.nodoState;
import java.util.ArrayList;
import java.util.List;

public class NodeUtils {
    
    List<bfsNodo> nodos;
    
    public NodeUtils(){
        nodos = new ArrayList<bfsNodo>();        
    }
    
    /**metodo buscar nodo, utiliza como parametros nodos, tipo list forzado a Nodos y
    * un identificador entero*/
    public static bfsNodo searchNodo(List<bfsNodo> nodos, String id){
        /**recorre todo lo que se ha guardado en nodos, al poner como lmite en el
        * ciclo nodos.size() se garanriza este recorrido*/
        for (int i = 0; i < nodos.size(); i++) {
            /*si el valor del nodo actual coincide con el id, se retorna el nodo
            * actual*/
            if(nodos.get(i).getId() == id) return nodos.get(i);
        }
        /**de lo contrario no se retorna nada*/
        return null;
    }
    
    /**metodo obtener raiz, es sencillo... como parametro se envia un componente del
    * arreglo nodos    */
    public static bfsNodo getRoot(List<bfsNodo> nodos){
        /**igual se recorre todo el arreglo nodos*/
        for (int i = 0; i < nodos.size(); i++) {
            /**si algun nodo no tiene padre... entonces es la raiz
            * optimo y sencillo no? =)*/
            if(nodos.get(i).getPadre() == null) return nodos.get(i);
        }
        /**de lo contrario no se retorna nada*/
        return null;
    }
    
    /**metodo que lista el nivel, parametros nodos y nivel*/
    public static List<bfsNodo> listarNivel(List<bfsNodo> nodos, int nivel){
        /**res recibe un array list forzado a Nodo*/
        List<bfsNodo> res = new ArrayList<bfsNodo>();
        /**se recorre todo el arreglo*/
        for (int i = 0; i < nodos.size(); i++) {
            /**si el nivel coincide con el parametro, entonces se aade un 
            * elemento mas al arreglo*/
            if(nodos.get(i).getNivel()== nivel) res.add(nodos.get(i));
        }
         /**se retorna la lista res*/
        return res;
    }
    
    /**metodo para construir el arbol*/
    public bfsNodo constructTree(nodoState aux, int nivel, bfsNodo papa){
        /**crea un arreglo */       
        //
        int i=0;
        nodoState auxi;
        /**Proceso*/
        bfsNodo atributo, auxA;
        atributo = new bfsNodo(String.valueOf(aux.getID()),aux.getArco());
        atributo.setPadre(papa);             
        //nodo= new DefaultMutableTreeNode(aux.getNombre());         
        //
        try{
            auxA= atributo;
            auxi= aux.hijo;
            while(auxi!=null){
            //for(i=0;i<aux.getCountHijos();i++){
                //nodo.add(armarJtree(aux.hijos[i]));
                //auxA.addHijo(constructTree(aux.hijos[i],nivel + 1, atributo),0);                               
                auxA.addHijo(constructTree(auxi,nivel + 1, atributo),auxi.getProb());
                //
                nodos.add(auxA);
                //
                auxA= atributo;
                //
                auxi= auxi.hermano;
            }   
            //
            if(aux.getCountHijos()==0){
                nodos.add(auxA);
            }
            //
        }catch(Exception e){
            
        }    
        // Salida
        return atributo;
        //
//        // recorre nodosj
//        for(int x = 0; x<nodosj.size();x++){
//            //se permite acceder a los elementos
//            NodoJ nj = nodosj.get(x);
//            //id1 e id2 almacenan los atributos id1 e id2 de cada nodoj
//            int id1 = nj.getId1();
//            int id2 = nj.getId2();
//            //se crea tres nodos y se inicializan en null
//            bfsNodo n1 = null;
//            bfsNodo n2 = null;
//            bfsNodo re = null;
//            //re recibe NodeUtils de manera recursiva, y busca un nodo
//            re = NodeUtils.searchNodo(nodos,id1);
//            if(re == null){
//                //si no lo encuentra lo crea
//                n1 = new bfsNodo(id1);
//                //lo aade
//                nodos.add(n1);
//            } else{
//                //si lo encuentra lo asigna
//                n1 = re;
//            }
//            //repite el proceso para n2
//            //re actua como auxiliar, n1 como padre y n2 como hijo
//            re = NodeUtils.searchNodo(nodos,id2);
//            if(re==null){
//                n2 = new bfsNodo(id2);
//                nodos.add(n2);
//            }else{
//                n2 = re;
//            }
//            //se aade el hijo n2 a n1
//            n1.addHijo(n2, nj.getProb());
//        }
//        //se retorna la lista
//        return nodos;
    }        
    
    //
    public List<bfsNodo> getNodos(){
        return nodos;
    }
    //
    
}
