/**guarda la configuracion basica del Nodo que se llevara a arbol*/
package bfstree;

import java.util.ArrayList;
import java.util.List;


public class bfsNodo {
    /**un identificador*/
    private String id;
    /**una lista de hijos*/
    private List<bfsNodo>   hijos;
    /**un unico padre*/
    private bfsNodo padre;
    /**una unica probabilidad de ir al padre*/
    private double prob;
    boolean tipo;
    /**x y y para manejar posiciones en la parte grafica*/
    private int x = -1;
    private int y = -1;
    
    /**se maneja un id como parametro*/
    public bfsNodo(String id, boolean a) {
        this.id = id;
        //se crea la lista de hijos*/
        this.hijos = new ArrayList<bfsNodo>();
        //
        tipo= a;
    }
    
    /**metod obtener nivel*/
    public int getNivel(){
        /**un entero auxiliar res (respuesta), inicializado en cero*/
        int res = 0;
        /**se otiene el padre del nodo en cuestion*/
        bfsNodo pad = this.getPadre();
        /**mientras en haya padre, o sea, en todo caso excepto para la raiz
        *...mirar metodo getRoot en NodeUtils.java*/
        while(pad!=null){
            /**pad sera el padre*/
            pad = pad.getPadre();
            /**se incrementa res*/
            res++;
        }
        /**se retorna res*/
        return res;
    }
    
    /**
     * metodo para aadir un hijo, parametro un nodo tipo bfsNodo y una probabilidad
     * prob tipo double
     */
    public void addHijo(bfsNodo nodo, double prob){
        /**se aade un hijo*/
        this.hijos.add(nodo);
        /**el nodo actual se establece como padre*/
        nodo.setPadre(this);
        /**se le asigna su respectica probabilidad*/
        nodo.setProb(prob);
    }
    
    
    /** setters y getters para cada propiedad (encapsulacion)*/
    public String getId() {
        return id;
    }
    
    public void setId(String id) {
        this.id = id;
    }
    
    public List<bfsNodo> getHijos() {
        return hijos;
    }
    
    public void setHijos(List<bfsNodo> hijos) {
        this.hijos = hijos;
    }
    
    public double getProb() {
        return prob;
    }
    
    public void setProb(double prob) {
        this.prob = prob;
    }
    
    public bfsNodo getPadre() {
        return padre;
    }
    
    public void setPadre(bfsNodo padre) {
        this.padre = padre;
    }

    public int getY() {
        return y;
    }

    public void setY(int y) {
        this.y = y;
    }

    public int getX() {
        return x;
    }

    public void setX(int x) {
        this.x = x;
    }
    
    public boolean getTipo(){
        return tipo;
    }
    
}
