/**almacena la parte grafica de la gramatica
 esta clase se aade a la paleta swing y luego puede ser llamada como un 
 componente mas*/
package grammar;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Point;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.List;
import javax.swing.ImageIcon;

public class TreePanel extends javax.swing.JLabel{
    
    /**el arreglo que almacena los nodos y sus caracteristcas*/
    private List<Nodo> nodos;
    /**los radios de las esferas*/
    private int radio1 = 50;
    int radio2 = 6;
    /**angulos radiales*/
    double[] angs = {0,10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,180,190,200,210,220,230,240,250,260,270,280,290,300,310,320,330,340,350};
    /**los colores soportados por la aplicacion 
     el gris es para las conexiones inactivas
     el negro es para las conexiones del nodo activo
     el azul oscuro se usa para las probabilidad
     el azul claro se usa para las conexiones que salen
     el rojo define el current node
     el amarillo se usa para las conexiones que entran*/
    private Color gray      = new Color(215,215,215);
    private Color darkgray  = new Color(200,200,200);
    private Color black     = new Color(20,20,20);
    private Color darkBlue  = new Color(4,103,216);
    private Color ligthBlue = new Color(108,204,255);
    private Color darkRed   = new Color(198,4,46);
    private Color yellow    = new Color(255,211,14);
    
    /**variables tipo Point que definen puntos maximos y minimos*/
    private Point min;
    private Point max;
    /**doble buffer para mandar la imagen del fondo
     varaible tipo nodo para establecer el nodo seleccionado*/
    private BufferedImage backGround;
    private Nodo selectedNodo;
    
    public TreePanel() {
        initComponents();
        this.setBackground(new Color(255, 255, 255));
    }
    
    /**metodo setNodos  pasa como parametros una lista llamada nodos
     casteada a Nodo*/
    public void setNodos(List<Nodo> nodos){
        this.nodos = nodos;
        /**se definen las coordenadas de cada punto*/
        min = new Point(Integer.MAX_VALUE, Integer.MAX_VALUE);
        max = new Point(Integer.MIN_VALUE, Integer.MIN_VALUE);
        /**se define una lista llamada points casteada a Point, guardara
         las posiciones*/
        List<Point> points = new ArrayList<Point>();
        /**llamado de metodos internos*/
        openNode(nodos.get(0),null,points);
        getLimits(nodos.get(0),min,max);
        translate(nodos.get(0));
        /**ancho y alto*/
        int ancho = (int)((max.getX() - min.getX())+60);
        int alto  = (int)((max.getY() - min.getY())+60);
        /**se establece dim tipo Dimension en donde se maneja el alto y el 
         ancho, se establece el tamano max, min y preferido*/
        /**The Dimension class encapsulates the width and height of a component
         * (in integer precision) in a single object. The class is associated 
         * with certain properties of components. Several methods defined by 
         * the Component class and the LayoutManager interface return a 
         * Dimension object. 

         Normally the values of width and height are non-negative integers. 
         * The constructors that allow you to create a dimension do not prevent 
         * you from setting a negative value for these properties. If the value 
         * of width or height is negative, the behavior of some methods defined 
         * by other objects is undefined. */
        
        /**The BufferedImage subclass describes an Image with an accessible 
         * buffer of image data. A BufferedImage is comprised of a ColorModel 
         * and a Raster of image data. The number and types of bands in the 
         * SampleModel of the Raster must match the number and types required 
         * by the ColorModel to represent its color and alpha components. 
         * All BufferedImage objects have an upper left corner coordinate
         * of (0, 0). Any Raster used to construct a BufferedImage must 
         * therefore have minX=0 and minY=0.*/ 

        Dimension dim = new Dimension(ancho, alto);
        this.setMaximumSize(dim);
        this.setMinimumSize(dim);
        this.setPreferredSize(dim);
        /*#En informtica, un buffer es una ubicacin de la memoria en una computadora o en un instrumento digital reservada para el almacenamiento temporal de informacin digital, mientras que est esperando ser procesada. Por ejemplo, un analizador TRF tendr uno o varios bufers de entrada,donde se guardan las palabras digitales que representan las muestras de la seal de entrada.#En electrnica es un dispositivo que evita el efecto de carga en un circuito. ...
es.wikipedia.org/wiki/Buffer

memoria dedicada a almacenar temporalmente la informacin que debe procesar un dispositivo hardware para que ste pueda hacerlo sin bajar el rendimiento de la transferencia. Aparece tpicamente en discos duros y CD-ROMs.
www.conozcasuhardware.com/diccio/

memoria intermedia para el almacenamiento de datos temporales en la comunicacin entre un ordenador y un dispositivo externo (p.ej., una impresora). Cuando es un programa informtico el que hace la misin de almacenamiento intermedio para los datos que se envan a la impresora, a dicho programa se le suele llamar Spooler.
usuarios.lycos.es/Resve/diccioninform.htm

Area de almacenamiento temporal en la memoria del sistema.
www.himnariodigital.org/glossary_a-l.html

Es un rea de datos compartida por dispositivos de hardware o procesos de programas que operan a distintas velocidades o con diferenes conjuntos de prioridades. El buffer permite que cada dispositivo o proceso opere sin verse interferido por otro.
www.cafeonline.com.mx/computadores/glosario.html

Memoria intermedia que se utiliza en distintos perifricos, como es el caso de la impresora que almacena temporalmente la informacin que hay que imprimir. Es algo as como tener los datos en la recmara.
www.forounderground.com/manual.php

Una rea de almacenamiento temporal reservada para uso en las operaciones de entrada-salida, dentro de la cual los datos son ledos, o dentro de la cual los datos son escritos. 2. Memoria para almacenar temporalmente la informacin transferida de un dispositivo a otro. 3. Area o polgono que rodea un punto, lnea o rea.
sgp.cna.gob.mx/Publico/Diccionarios/Glosario.htm

Memoria intermedia destinada a aumentar la velocidad de los puertos serie.
www.obyron.com/manuint/glosario.htm*/
         
        backGround = new BufferedImage(ancho, alto, BufferedImage.TYPE_INT_RGB);
        Graphics g = backGround.getGraphics();
       
        g.setColor(new Color(255,255,255));
        g.fillRect(0,0,ancho, alto);
        g.setColor(new Color(200,200,200));
        drawArcs(nodos.get(0),g);
        drawNodes(nodos.get(0),g);
        this.putImage();
        this.repaint();
         /**las anteriores son configuraciones exclusivamente graficas de los
          * nodos y los arcos*/
    }
    
    /**retorna la distancia entre nodos utilizando una formula geometerica para
    la circunferencia dist = [(x1-x2)^2+(y1-y2)^2]^1/2*/
    public double distancia(int x1, int y1, int x2, int y2){
        return Math.sqrt(Math.pow((x1-x2),2)+Math.pow((y1-y2),2));
    }
    
    /**formulas relocas que ubican los nodos*/
    public void openNode(Nodo n, Nodo from, List<Point> points){
        if(from==null){
            n.setX(0);
            n.setY(0);
        }else{
            int minDist = Integer.MAX_VALUE;
            for (int i = 0; i < angs.length; i++) {
                double ang = angs[i];
                ang = (Math.PI/180)*ang;
                double sin = Math.sin(ang);
                double cos = Math.cos(ang);
                int d = getRadio1()*2;
                int x = 0;
                int y = 0;
                boolean clear;
                do{
                    d+=10;
                    x = (int)(from.getX()+(cos*d));
                    y = (int)(from.getY()+(sin*d));
                    clear = true;
                    for (int j = 0; j < points.size()&& clear == true; j++) {
                        double dst = distancia(x,y,(int)points.get(j).getX(),(int)points.get(j).getY());
                        if(dst<=getRadio1()*2.2)clear = false;
                    }
                }while(!clear);
                //System.out.println(d+" "+angs[i]);
                if(d<=minDist){
                    minDist = d;
                    n.setX(x);
                    n.setY(y);
                }
            }
        }
        
        Point p = new Point(n.getX(), n.getY());
        points.add(p);
        
        List<Nodo>    hijos = n.getHijos();
        List<Boolean> adela = n.getAdela();
        List<Nodo>    hijosSol = new ArrayList<Nodo>();
        
        for (int i = 0; i < hijos.size(); i++) {
            if(adela.get(i)){
                if(hijos.get(i).getContHijosAdela()>0){
                    openNode(hijos.get(i),n,points);
                }else{
                    hijosSol.add(hijos.get(i));
                }
            }
        }
        
        if(hijosSol.size()>0){
            
            double inc = 360.0d/hijosSol.size();
            inc = (Math.PI/180)*inc;
            //double start = Math.random()*360;
            double start = 20;
            for (int i = 0; i < hijosSol.size(); i++) {
                double ang = start + (inc*i);
                hijosSol.get(i).setX((int)(n.getX()+((getRadio1()-radio2)*Math.cos(ang))));
                hijosSol.get(i).setY((int)(n.getY()+((getRadio1()-radio2)*Math.sin(ang))));
            }
        }
    }
    
    /**obtener limites para ubicar un nuevo nodo*/
    public void getLimits(Nodo n, Point mins, Point maxs){
        
        if(n.getX()<mins.getX())mins.setLocation(n.getX(),mins.getY());
        if(n.getY()<mins.getY())mins.setLocation(mins.getX(),n.getY());
        
        if(n.getX()>maxs.getX())maxs.setLocation(n.getX(),maxs.getY());
        if(n.getY()>maxs.getY())maxs.setLocation(maxs.getX(),n.getY());
        
        for (int i = 0; i < n.getHijos().size(); i++) {
            if(n.getAdela().get(i)){
                getLimits(n.getHijos().get(i),mins, maxs);
            }
        }
    }
    
    /**segun la posicion del nodo, si tiene o no hijos, cual es su padre
     entonces el nodo se traduce a ubicacion grafica*/
    public void translate(Nodo n){
        
        int x1 = (int)(n.getX()-min.getX())+30;
        int y1 = (int)(n.getY()-min.getY())+30;
        
        n.setX(x1);
        n.setY(y1);
        
        for (int i = 0; i < n.getHijos().size(); i++) {
            if(n.getAdela().get(i)){
                translate(n.getHijos().get(i));
            }
        }
    }
    
    /**dibujar arcos*/
    public void drawArcs(Nodo n, Graphics g){
        g.setColor(gray);
        List<Nodo>    hijos = n.getHijos();
        List<Boolean> adela = n.getAdela();
        for (int i = 0; i < hijos.size(); i++) {
            int x1 = n.getX();
            int y1 = n.getY();
            int x2 = n.getHijos().get(i).getX();
            int y2 = n.getHijos().get(i).getY();
            //if(adela.get(i)){
                g.drawLine(x1,y1,x2,y2);
                if(hijos.get(i).getHijos().size()>0){
                    if(adela.get(i)){                      
                        drawArcs(hijos.get(i),g);
                        
                    }
                    //**se dibujan las probabilidades*/                            
                    //g.drawString(String.valueOf(n.getProbs().get(i)),n.getX()+25,n.getY()+50);
                }
            //}
        }
    }
    
    /**dibujar nodos*/
    public void drawNodes(Nodo n, Graphics g){
        g.setColor(gray);
        g.fillOval(n.getX()-radio2,n.getY()-radio2,radio2*2,radio2*2);
        g.setColor(darkgray);
        g.drawString(String.valueOf(n.getId()),n.getX()+8,n.getY()+8);
        for (int i = 0; i < n.getHijos().size(); i++) {
            if(n.getAdela().get(i)){
                drawNodes(n.getHijos().get(i),g);                
            }
        }
    }
    
    /**obtener ancestros*/
    public void getAncestors(Nodo root, Nodo son, List<Nodo> result){
        for (int i = 0; i < root.getHijos().size(); i++) {
            Nodo hijo = root.getHijos().get(i);
            if(hijo == son)result.add(root);
            if(root.getAdela().get(i)){
                getAncestors(hijo, son, result);                
            }
        }
    }

    public void putImage(){
        this.setIcon(new ImageIcon(this.getImage()));
    }
    
    public Image getImage(){
        int ancho = max.x -min.x+60;
        int alto  = max.y -min.y+60;
        BufferedImage img = new BufferedImage(ancho, alto, BufferedImage.TYPE_INT_RGB);
        Graphics2D g = (Graphics2D)img.getGraphics();
        g.setColor(new Color(255,255,255));
        g.fillRect(0,0,this.getWidth(), this.getHeight());
        g.drawImage(backGround,0,0,null);
        
        if(getSelectedNodo()!=null){
            
            for (int i = 0; i < selectedNodo.getHijos().size(); i++) {
                Nodo hijo = selectedNodo.getHijos().get(i);
                
                
                int x1 = getSelectedNodo().getX();
                int y1 = getSelectedNodo().getY();
            
                int x2 = hijo.getX();
                int y2 = hijo.getY();
                
                g.setColor(black);
                g.drawLine(x1,y1,x2,y2);
                
                g.setColor(ligthBlue);
                g.fillOval(x2-radio2,y2-radio2,radio2*2,radio2*2);
                /**el color del identificador de los nodos es darkgrew, con las
                 siguientes lineas se hace negro para las conexiones entrantes
                 del nodo*/
                g.setColor(black);
                g.drawString(String.valueOf(hijo.getId()),hijo.getX()+8,hijo.getY()+8);                                                               
            }
            
            
            ArrayList<Nodo> ancestors = new ArrayList<Nodo>();
            getAncestors(getNodos().get(0),getSelectedNodo(),ancestors);
            
            
            for (int i = 0; i < ancestors.size(); i++) {
                Nodo ancestor = ancestors.get(i);
                g.setColor(black);
                g.drawLine(ancestor.getX(), ancestor.getY(),getSelectedNodo().getX(),getSelectedNodo().getY());
                g.setColor(yellow);
                g.fillOval(ancestor.getX()-radio2,ancestor.getY()-radio2,radio2*2,radio2*2);
                /**el color del identificador de los nodos es darkgrew, con las
                 siguientes lineas se hace negro para las conexiones salientes
                 del nodo*/
                g.setColor(black);
                g.drawString(String.valueOf(ancestor.getId()),ancestor.getX()+8,ancestor.getY()+8);
                
                List hijos = ancestor.getHijos();
                double prob = -1;
                for (int j = 0; j < hijos.size(); j++) {
                    if(hijos.get(j)==this.selectedNodo){
                        prob = ancestor.getProbs().get(j);
                    }
                }
                
                //**se dibujan las probabilidades*/  
                
                double percent = 0.6;
                
                int pmx = (int)((selectedNodo.getX()*(1-percent))+(ancestor.getX()*percent));
                int pmy = (int)((selectedNodo.getY()*(1-percent))+(ancestor.getY()*percent));
                g.setColor(new Color(0,0,255));
                g.drawString(String.valueOf(prob),pmx, pmy);                               
            }
            
            
            g.setColor(darkRed);
            g.fillOval(getSelectedNodo().getX()-radio2,getSelectedNodo().getY()-radio2,radio2*2,radio2*2);
             /**el color del identificador de los nodos es darkgrew, con las
                 siguientes lineas se hace negro para el actual nodo*/
                g.setColor(black);
                g.drawString(String.valueOf(getSelectedNodo().getId()),getSelectedNodo().getX()+8,getSelectedNodo().getY()+8);                                         
                
            }
        
        return img;
    }
    
    /**encapsulacion de nodos*/
    public Nodo getSelectedNodo() {
        return selectedNodo;
    }

    public void setSelectedNodo(Nodo selectedNodo) {
        this.selectedNodo = selectedNodo;
        this.putImage();
        this.repaint();
    }

    public int getRadio1() {
        return radio1;
    }

    public void setRadio1(int radio1) {
        this.radio1 = radio1;
    }

    public List<Nodo> getNodos() {
        return nodos;
    }

    public void paint(Graphics g) {
        g.setColor(new Color(255,255,255));
        g.fillRect(0,0,this.getWidth(), this.getHeight());
        super.paint(g);
    }
    
    
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {

        setAutoscrolls(true);
        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
