/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * dijkstraViewFrame.java
 *
 * Created on 14/10/2010, 09:17:07 AM
 */

package polaris2.mining;

import polaris2.site.sitio;
import polaris2.site.enlace;
import polaris2.site.pagina;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.event.MouseEvent;
import java.awt.geom.Rectangle2D;
import java.io.IOException;
import java.util.Iterator;
import java.util.StringTokenizer;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.SwingConstants;
import prefuse.data.*;
import prefuse.Display;
import prefuse.Visualization;
import prefuse.render.*;
import prefuse.util.*;
import prefuse.action.assignment.*;
import prefuse.Constants;
import prefuse.visual.*;
import prefuse.action.*;
import prefuse.activity.*;
import prefuse.action.layout.graph.*;
import prefuse.controls.*;
import polaris2.graph.Nodo;
import prefuse.controls.Control;
import prefuse.data.tuple.TupleSet;
import prefuse.util.ui.JFastLabel;

/**
 *
 * @author santos
 */
public class dijkstraViewFrame extends javax.swing.JFrame implements Runnable  {

    public sitio sitio_web=null;
    public sitio sitio_web2=null;
    public Nodo links=null;
    public Nodo n=null;
    public pagina source=null;
    public pagina target=null;
    public VisualItem Vsource=null;
    public VisualItem Vtarget=null;
    public boolean view_hits=false;
    public boolean view_pageRank=false;
    public boolean view_webLinks=false;
    public boolean seleccionando_source=false;
    public boolean seleccionando_target=false;
    public int dataProcceshits=0;
    public int dataProccesPageRank=0;
    public int dataProccesWebLinker=0;
    private String urlAbrir="";
    private JFastLabel m_total = new JFastLabel("");
    private JFastLabel m_details;
    private Graph graph =null;
    private Visualization vis = null;
    private pagina primero_lista=null;
    private pagina ultimo_lista=null;
    private boolean calcular=false;
    private Thread h1;

    /** Creates new form dijkstraViewFrame */
    public dijkstraViewFrame() {
        initComponents();
        btn_restart.setEnabled(true);
        seleccionando_source=true;
        jTextArea1.setText("Select the source node in the graph");
        this.setIconImage(this.getImage("/media/star.png"));
    }

    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }

    public void run() {
        if(calcular==true)
        {
            if(iniciar()==1)
            {
                btn_start.setEnabled(true);
            }
            else
            {
                jTextArea1.setText("Process canceled by user  \nPress Start to begin");
                if(Vsource!=null) Vsource.setFillColor(ColorLib.rgb(0,255,0));
                if(Vtarget!=null) Vtarget.setFillColor(ColorLib.rgb(0,255,0));


                btn_start.setEnabled(false);
                btn_restart.setEnabled(true);

                seleccionando_target=false;
                seleccionando_source=true;
                Iterator iter = vis.items("graph.edges");
                while ( iter.hasNext() )
                {
                    VisualItem item = (VisualItem)iter.next();
                    item.setFillColor(ColorLib.rgb(0,0,0));
                    item.setStrokeColor(ColorLib.rgb(0,0,0));
                    item.getVisualization().repaint();
                }
                calcular=false;
            }
        }
    }

    public void crear_grafico(int tipo){
        //en tipo especifico el tipo de grafico que usar
         // TODO add your handling code here

         this.setTitle("Dijkstra");
        if(view_hits==false)
        {
            this.panel_hits.setVisible(false);
        }
        else
        {
            this.panel_hits.setVisible(true);
            this.setTitle("Dijkstra whit HITS value");
        }
        if(view_pageRank==true)
        {
            this.setTitle("Dijkstra whit PAGE RANK value");
        }
        if(view_webLinks==true)
        {   
            this.setTitle("Dijkstra whit WEB LINKER value");
        }







        jTextArea1.setText("Press Source button and select the source node in the graph");

        Table table = new Table();
        //table.addColumn("id", int.class);
        table.addColumn("nombre", String.class);
        table.addColumn("color", int.class);
        table.addColumn("id_pag", int.class);
        table.addColumn("entro", int.class);

        //Table edges=null;
        Table edges = new Table();
        edges.addColumn("id1", int.class);
        edges.addColumn("id2", int.class);
        edges.addColumn("color", int.class);

        graph = new Graph(table, edges, true, "id1", "id2");

        //creo todas las paginas de la lista
        int entro=0;
        pagina aux_pagina=sitio_web.pagina_inicial;
        while(aux_pagina!=null)
        {
            aux_pagina.no = graph.addNode();
            aux_pagina.no.set("nombre",aux_pagina.numeracion);
            aux_pagina.no.set("id_pag",aux_pagina.id_pagina);
            aux_pagina.no.set("entro",entro);
            if(aux_pagina.nivel==0) aux_pagina.no.set("color",2);
            if(aux_pagina.nivel==1) aux_pagina.no.set("color",2);
            if(aux_pagina.nivel==2) aux_pagina.no.set("color",2);
            if(aux_pagina.nivel==3) aux_pagina.no.set("color",2);
            if(aux_pagina.nivel==4) aux_pagina.no.set("color",2);
            if(aux_pagina.nivel==5) aux_pagina.no.set("color",2);
            //graph.addEdge(nu,n);
            entro++;
            aux_pagina=aux_pagina.sig_pag;
        }

        //creo todos los enlaces que conectan los nodos de la lista

        enlace aux_enlace=null;
        aux_pagina=sitio_web.pagina_inicial;
        while(aux_pagina!=null)
        {
            aux_enlace=aux_pagina.pri_salientesI;
            while(aux_enlace!=null)
            {
                //System.out.println("conectar: "+String.valueOf(aux_pagina.id_pagina)+" con " + String.valueOf(aux_enlace.destino.id_pagina) +"  salienteI");
                Edge ed=graph.addEdge(aux_pagina.no,aux_enlace.destino.no);
                ed.set("color",0);
                aux_enlace=aux_enlace.sig_enlace;
            }
            aux_enlace=aux_pagina.pri_salientesE;
            while(aux_enlace!=null)
            {
                //System.out.println("conectar: "+String.valueOf(aux_pagina.id_pagina)+" con " + String.valueOf(aux_enlace.destino.id_pagina) +"  salienteE");
                Edge ed=graph.addEdge(aux_pagina.no,aux_enlace.destino.no);
                ed.set("color",0);
                aux_enlace=aux_enlace.sig_enlace;
            }
            aux_enlace=aux_pagina.pri_entrantesI;
            while(aux_enlace!=null)
            {
                //System.out.println("conectar: "+String.valueOf(aux_pagina.id_pagina)+" con " + String.valueOf(aux_enlace.destino.id_pagina) +"  entranteI");
                //Edge ed=graph.addEdge(aux_enlace.destino.no,aux_pagina.no);
                //ed.set("color",0);
                aux_enlace=aux_enlace.sig_enlace;
            }
            aux_enlace=aux_pagina.pri_entrantesE;
            while(aux_enlace!=null)
            {
                //System.out.println("conectar: "+String.valueOf(aux_pagina.id_pagina)+" con " + String.valueOf(aux_enlace.destino.id_pagina) +"  entranteE");
                //Edge ed=graph.addEdge(aux_enlace.destino.no,aux_pagina.no);
                //ed.set("color",0);
                aux_enlace=aux_enlace.sig_enlace;
            }
            aux_pagina=aux_pagina.sig_pag;
        }
        //System.out.println("________");
        //System.out.println("________");
        vis = new Visualization();// 2. prepare the visualization
        vis.add("graph", graph);//entre comillas el nombre que identificara a el grafo
        LabelRenderer r = new LabelRenderer("nombre");
        r.setRoundedCorner(8, 8); // round the corners
        r.setRenderType(AbstractShapeRenderer.RENDER_TYPE_FILL);
        r.setHorizontalAlignment(Constants.CENTER);
        vis.setRendererFactory(new DefaultRendererFactory(r));

       // CERACION DE COLORES DE LOS ELEMENTOS
       int[] palette = new int[] { ColorLib.rgb(0,255,0),};
       int[] palette2 = new int[] { ColorLib.rgb(0,0,0),};
       DataColorAction fill = new DataColorAction("graph.nodes", "color",Constants.NOMINAL, VisualItem.FILLCOLOR, palette);
       ColorAction text = new ColorAction("graph.nodes", VisualItem.TEXTCOLOR, ColorLib.gray(0));
       DataColorAction edges1 = new DataColorAction("graph.edges","color",Constants.NOMINAL, VisualItem.STROKECOLOR, palette2);
       DataColorAction edges2 = new DataColorAction("graph.edges","color",Constants.NOMINAL, VisualItem.FILLCOLOR, palette2);

       // ASIGNACION DE COLORES DE LOS ELEMENTOS
        ActionList colour = new ActionList();//LISTADO DE TODOS LOS COLORES QUE TOMARAN LOS OBJETOS
        colour.add(fill);//ADICIONAR LA CARACTERISTICA DE COLOR DE LOS NODOS
        colour.add(text);//ADICIONAR LA CARACTERISTICA DE COLOR DEL TEXTO
        colour.add(edges1);//ADICIONAR LA CARACTERISTICA DE COLOR DE LA PUNTA DE LOS EDGES
        colour.add(edges2);//ADICIONAR LA CARACTERISTICA DE COLOR DE LOS EDGES
        vis.putAction("colour", colour);

        // CERACION DE EVENTOS DE ENTRADA Y SALIDA DEL MOUSE DE UN ITEM(SEA NODO O EDGE)
        Control hoverc = new ControlAdapter() {
           public void itemEntered(VisualItem item, MouseEvent evt)
            {
                if ( item.canGetString("nombre") )
                {
                    String nom=item.getString("nombre");
                    pagina pag_bus=sitio_web2.buscar_pagina_numeracion(nom);
                    if(pag_bus==null)m_total.setText("----");
                    else
                    {
                        //m_total.setText(pag_bus.nombre_pagina+"    ");
                        if(view_pageRank)//hay que calcular en base a page Rank
                        {
                            m_total.setText(pag_bus.nombre_pagina+"       PAGE RANK: "+pag_bus.ValuePageRank);
                        }
                        if(view_hits)//hay que calcular en base a Hits
                        {
                            if(rad_autoridad.isSelected()==true)
                            {
                                m_total.setText(pag_bus.nombre_pagina+"       HITS(Autority): "+pag_bus.ValueHitsAutority);
                            }
                            else
                            {
                                m_total.setText(pag_bus.nombre_pagina+"       HITS(HUB): "+pag_bus.ValueHitsHUB);
                            }
                        }
                        if(view_webLinks)//hay que calcular en base a linker web
                        {
                            m_total.setText(pag_bus.nombre_pagina+"       WEB LINKER: "+pag_bus.ValueVisit);
                        }
                        if(view_pageRank==false&&view_hits==false&&view_webLinks==false)//hay que calcular solo dijkstra
                        {
                            m_total.setText(pag_bus.nombre_pagina);
                        }
                    }

                }
            }
            public void itemExited(VisualItem item, MouseEvent evt) {
                 m_total.setText("-");
            }

            public void itemPressed(VisualItem item, MouseEvent e) {

                if ( item.canGetString("nombre") )
                {
                    pagina p=sitio_web.buscar_pagina(Integer.parseInt(item.getString("id_pag")));
                    pagina p2=sitio_web2.buscar_pagina(Integer.parseInt(item.getString("id_pag")));
                    if(seleccionando_source==true)
                    {
                        source=p;
                        Vsource=item;
                        item.setFillColor(ColorLib.rgb(100,100,255));
                        item.getVisualization().repaint();
                        
                        seleccionando_source=false;
                        seleccionando_target=true;
                        btn_restart.setEnabled(true);
                        jTextArea1.setText("Select the Target node in the graph");
                        //jTextArea1.setText("The source node is: "+source.url_pagina+"\n press target Button...");
                    }
                    else
                    {
                        if(seleccionando_target==true)
                        {
                            target=p;
                            if(target==source)
                            {
                             JOptionPane.showMessageDialog(null, "Source node and Target node can't be same", "Error", JOptionPane.ERROR_MESSAGE);
                            }
                            else
                            {
                                calcular=true;
                                Vtarget=item;
                                item.setFillColor(ColorLib.rgb(100,100,255));
                                item.getVisualization().repaint();
                                seleccionando_target=false;
                                empezar();                                
                                //jTextArea1.setText("The source node is: "+source.url_pagina+"\nThe trget node is: "+target.url_pagina+"\n Press start to continue..");                                
                            }
                        }
                    }
                }
            }
        };

        //ANIMAR INFINITAMENTE
        ActionList layout = new ActionList(Activity.INFINITY);

        //SELECCIONAR EL TIPO DE GRAFICO A USAR
        if (tipo==2) layout.add(new ForceDirectedLayout("graph"));
        if (tipo==1)layout.add(new RadialTreeLayout("graph"));
        layout.add(new RepaintAction());/* repaint after each movement of the graph nodes */
        vis.putAction("layout", layout);/* add the laout actions to the visualization */

        // CONTROLES INTERACTIVOS DE LA VISUALIZACION
        Display display = new Display(vis);
        display.addControlListener(hoverc);                 //AGREGAR LOS EVENTOS CREADOS EN hoverc
        display.setSize(400, 400);                          //TAMAO DEL VISOR
        display.pan(200, 200);                              // CENTRO DONDE SE DIBUJARA
        display.addControlListener(new DragControl());      //PERMITE ARRASTRAR EL GRAFO
        display.addControlListener(new PanControl());
        display.addControlListener(new ZoomControl());      //PERMITE HACER ZOOM
        display.addControlListener(new FocusControl(2));
        display.addControlListener(new WheelZoomControl());
        display.addControlListener(new ZoomToFitControl());
        display.addControlListener(new NeighborHighlightControl());


        m_details = new JFastLabel("Details:");
        m_details.setPreferredSize(new Dimension(75,20));
        m_details.setVerticalAlignment(SwingConstants.BOTTOM);
        m_total.setPreferredSize(new Dimension(500,20));
        m_total.setHorizontalAlignment(SwingConstants.RIGHT);
        m_total.setVerticalAlignment(SwingConstants.BOTTOM);

        // DETALLES DE LA PARTE SUPERIOR DEL GRAFO
        Box infoBox = new Box(BoxLayout.X_AXIS);
        infoBox.add(Box.createHorizontalStrut(5));
        infoBox.add(m_details);
        infoBox.add(Box.createHorizontalGlue());
        infoBox.add(Box.createHorizontalStrut(5));
        infoBox.add(m_total);
        infoBox.add(Box.createHorizontalStrut(5));

        this.panel_visor.setLayout(new BorderLayout());
        this.panel_visor.add(display,BorderLayout.CENTER);
        this.panel_visor.add(infoBox,BorderLayout.NORTH);
        this.panel_visor.updateUI();

        vis.run("colour");
        vis.run("layout");




        //vis.getVisualItem("graph.edges", Vtarget);
        //Tuple a=null;

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        panel_visor = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        btn_restart = new javax.swing.JButton();
        panel_hits = new javax.swing.JPanel();
        rad_autoridad = new javax.swing.JRadioButton();
        rad_hub = new javax.swing.JRadioButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea2 = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        btn_start = new javax.swing.JButton();
        jSpinner1 = new javax.swing.JSpinner();
        jLabel3 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Dijkstra");

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Dijkstra"));

        panel_visor.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));

        javax.swing.GroupLayout panel_visorLayout = new javax.swing.GroupLayout(panel_visor);
        panel_visor.setLayout(panel_visorLayout);
        panel_visorLayout.setHorizontalGroup(
            panel_visorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 792, Short.MAX_VALUE)
        );
        panel_visorLayout.setVerticalGroup(
            panel_visorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 410, Short.MAX_VALUE)
        );

        jTextArea1.setColumns(20);
        jTextArea1.setEditable(false);
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);

        btn_restart.setText("RESTART");
        btn_restart.setEnabled(false);
        btn_restart.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_restartActionPerformed(evt);
            }
        });

        panel_hits.setBorder(javax.swing.BorderFactory.createTitledBorder("Select"));

        rad_autoridad.setSelected(true);
        rad_autoridad.setText("Authoriy");
        rad_autoridad.setActionCommand("Authority");
        rad_autoridad.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rad_autoridadActionPerformed(evt);
            }
        });

        rad_hub.setText("HUB");
        rad_hub.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rad_hubActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout panel_hitsLayout = new javax.swing.GroupLayout(panel_hits);
        panel_hits.setLayout(panel_hitsLayout);
        panel_hitsLayout.setHorizontalGroup(
            panel_hitsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panel_hitsLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(panel_hitsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(rad_hub)
                    .addComponent(rad_autoridad))
                .addContainerGap(75, Short.MAX_VALUE))
        );
        panel_hitsLayout.setVerticalGroup(
            panel_hitsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, panel_hitsLayout.createSequentialGroup()
                .addComponent(rad_autoridad)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 7, Short.MAX_VALUE)
                .addComponent(rad_hub))
        );

        jTextArea2.setColumns(20);
        jTextArea2.setRows(5);
        jScrollPane2.setViewportView(jTextArea2);

        jLabel1.setText("PROCESS");

        jLabel2.setText("ROUTES FIND");

        btn_start.setText("SAVE");
        btn_start.setEnabled(false);
        btn_start.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_startActionPerformed(evt);
            }
        });

        jSpinner1.setModel(new javax.swing.SpinnerNumberModel(10, 1, 100, 1));

        jLabel3.setText("Number Of Routes");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(panel_visor, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 318, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel2)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 304, Short.MAX_VALUE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 101, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jSpinner1, javax.swing.GroupLayout.PREFERRED_SIZE, 51, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addComponent(panel_hits, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(btn_restart, javax.swing.GroupLayout.PREFERRED_SIZE, 89, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(btn_start, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))))))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addComponent(panel_visor, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jLabel1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(panel_hits, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel3)
                            .addComponent(jSpinner1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(btn_restart)
                            .addComponent(btn_start)))
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 140, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 140, Short.MAX_VALUE))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void empezar()  {
        h1 = new Thread(this);
        h1.start();
    }

    private int iniciar()    {
        pagina inicio=new pagina("s");
        String rutas="";
        //jTextArea2.setText("0");
        //adiciono los enlaces salientes a la lista
        //source.ruta=String.valueOf(source.id_pagina);
        meter_lista(source);
        pagina aux_lista=null;
        boolean continuar=true;
        int id_anterior=-1;

        while(continuar)
        {
            if(calcular==false) return 0;
            
            pagina px=primero_lista;
            //System.out.println("Estado de lista");
            while(px!=null)
            {                
                System.out.print("["+px.numeracion+"] ");
                px=px.sig_pag;
            }
            
            //System.out.println("Sacar del ultimo, tomando como id_base "+String.valueOf(id_anterior));
            
            aux_lista=sacar_siguiente(ultimo_lista,id_anterior);            //if(calcular==false) return 0;
            if(aux_lista==null)
            {
                //System.out.println("No se pudo sacar a nadie ");
                if(ultimo_lista==null)
                {
                    //System.out.println("No Hay ultimo terminar");
                    continuar=false;
                    break;
                }
                id_anterior=ultimo_lista.id_pagina;
                aux_lista=sacar_lista();
                //System.out.println("Se elimina el ultimo de la lista, el nuevo id_base es: "+String.valueOf(id_anterior));
                if(aux_lista==null)
                {
                    //System.out.println("la anterior eliminacion fue la ultima acaba el programa");
                    continuar=false;
                    break;
                }
                
                
            }
            else//tiene siguiente
            {   //verificar que no este en la lista
                //System.out.println("Quien se saco es "+aux_lista.numeracion);
                if(buscar_lista(aux_lista.id_pagina)==true)
                {
                    id_anterior=aux_lista.id_pagina;
                    //System.out.println("ya esta en la lista el nuevi id_base es: "+String.valueOf(id_anterior));
                }
                else
                {   //verificar si es el destino
                    //System.out.println("El sacado no esta en la lista verificar si es el destino");
                    if(aux_lista.id_pagina==target.id_pagina)
                    {   //se encoontro una ruta
                        //System.out.println("SE encontro destino agregar la siguiente ruta:");
                        if(rutas.length()==0)rutas=sacar_ruta();
                        else rutas=rutas+"/"+sacar_ruta();
                        //System.out.println("asi van las rutas:......"+sacar_ruta2());
                        rutas=rutas+","+String.valueOf(target.id_pagina);
                        jTextArea2.setText(jTextArea2.getText()+"\n"+sacar_ruta2());
                        id_anterior=aux_lista.id_pagina;
                    }
                    else
                    {   //metrelo en la lista
                        //System.out.println("No es el destino se lo meter en lista:"+aux_lista.numeracion+" el valor de id_base ahora es -1");
                        meter_lista(aux_lista);
                        id_anterior=-1;
                    }
                }
                if(calcular==false) return 0;
            }
        }
        if(rutas.length()==0)
        {
            jTextArea1.setText("No route between these nodes");
        }
        else
        {
            String[] grupo_rutas=tokenizar(rutas,"/");
            String[][] matriz_rutas=new String[grupo_rutas.length][3];

            //formo una matriz con las rutas y numero de paginas en c/ruta
            for(int a=0;a<grupo_rutas.length;a++)
            {
                if(calcular==false) return 0;
                String[] paginas_ruta=tokenizar(grupo_rutas[a],",");
                matriz_rutas[a][0]=grupo_rutas[a];
                matriz_rutas[a][1]=String.valueOf(paginas_ruta.length);
            }

            //ordeno la matriz de ,menor a mayor numero de enlaces hasta el destino
            jTextArea1.setText("Ordering for links number ");
            String id="";
            String rut="";
            String val="";
            for(int i=0;i<grupo_rutas.length-1;i++)
            {
                if(calcular==false) return 0;
                for(int j=i;j<grupo_rutas.length;j++)
                {
                    if(calcular==false) return 0;
                    jTextArea1.setText("Ordering for links number \nComparing: "+matriz_rutas[i][1]+" whit "+matriz_rutas[j][1]);
                    if(Integer.parseInt(matriz_rutas[i][1])>Integer.parseInt(matriz_rutas[j][1]))
                    {//cambiar datos
                      id=matriz_rutas[i][0];
                      rut=matriz_rutas[i][1];
                      matriz_rutas[i][0]=matriz_rutas[j][0];
                      matriz_rutas[i][1]=matriz_rutas[j][1];
                      matriz_rutas[j][0]=id;
                      matriz_rutas[j][1]=rut;
                    }
                }
            }

            jTextArea1.setText("calculating algorithm value");
            //calculo el resultado de la ruta respecto al algoritmo escogido
            double valor=0;
            for(int a=0;a<grupo_rutas.length;a++)
            {
                if(calcular==false) return 0;
                String[] paginas_ruta=tokenizar(matriz_rutas[a][0],",");
                valor=0;
                for(int b=1;b<paginas_ruta.length;b++)
                {
                    if(calcular==false) return 0;
                    if(view_pageRank)//hay que calcular en base a page Rank
                    {
                        n.conf.tipo_dijkstra="Page Rank";
                        pagina p=sitio_web2.buscar_pagina(Integer.parseInt(paginas_ruta[b]));
                        valor=valor+p.ValuePageRank;
                        jTextArea1.setText("calculating algorithm value \nPage Rank: "+String.valueOf(valor));
                    }
                    if(view_hits)//hay que calcular en base a Hits
                    {
                        pagina p=sitio_web2.buscar_pagina(Integer.parseInt(paginas_ruta[b]));
                        if(this.rad_autoridad.isSelected()==true)
                        {
                            n.conf.tipo_dijkstra="HITS AUTORITY";
                            valor=valor+p.ValueHitsAutority;
                            jTextArea1.setText("calculating algorithm value \n Hits Autority: "+String.valueOf(valor));
                        }
                        else
                        {
                            n.conf.tipo_dijkstra="HITS HUB";
                            valor=valor+p.ValueHitsHUB;
                            jTextArea1.setText("calculating algorithm value \nHits HUB: "+String.valueOf(valor));
                        }
                    }
                    if(view_webLinks)//hay que calcular en base a linker web
                    {
                        n.conf.tipo_dijkstra="Web Linker";
                        pagina p=sitio_web.buscar_pagina(Integer.parseInt(paginas_ruta[b]));
                        valor=valor+p.ValueVisit;
                        jTextArea1.setText("calculating algorithm value \nWeb Linker: "+String.valueOf(valor));
                    }
                    if(view_pageRank==false&&view_hits==false&&view_webLinks==false)//hay que calcular solo dijkstra
                    {
                        n.conf.tipo_dijkstra="Links";

                        valor=valor-1;
                    }
                }
                matriz_rutas[a][2]=String.valueOf(valor);
            }

            //reordeno segun el valor de la tercera columna de la matriz
            /*
            for(int i=0;i<grupo_rutas.length-1;i++)
            {
                if(calcular==false) return 0;
                for(int j=i;j<grupo_rutas.length;j++)
                {
                    if(calcular==false) return 0;
                    if(Double.parseDouble(matriz_rutas[i][2])<Double.parseDouble(matriz_rutas[j][2]))
                    {//cambiar datos
                        jTextArea1.setText("Ordering for algorithm value \n"+matriz_rutas[i][2]);
                      id=matriz_rutas[i][0];
                      rut=matriz_rutas[i][1];
                      val=matriz_rutas[i][2];
                      matriz_rutas[i][0]=matriz_rutas[j][0];
                      matriz_rutas[i][1]=matriz_rutas[j][1];
                      matriz_rutas[i][2]=matriz_rutas[j][2];
                      matriz_rutas[j][0]=id;
                      matriz_rutas[j][1]=rut;
                      matriz_rutas[j][2]=val;
                    }
                }
            }
            */

            //guardar los resultados en el nodo dijkstra
            n.conf.num_rutas_dijkstra=grupo_rutas.length;
            n.conf.rutas_dijkstra=new String[grupo_rutas.length][3];//guardo estos resultados
            n.corriendo=true;
            n.conf.source=source;
            n.conf.target=target;

            //imprimo las diferentes rutas
            String salida="Routes: \n     ";
            for(int a=0;a<grupo_rutas.length;a++)
            {
                //guardar los resultados en el nodo dijkstra
                 n.conf.rutas_dijkstra[a][0]=matriz_rutas[a][0];
                 n.conf.rutas_dijkstra[a][1]=matriz_rutas[a][1];
                 n.conf.rutas_dijkstra[a][2]=matriz_rutas[a][2];

                if(calcular==false) return 0;
                String[] paginas_ruta=tokenizar(matriz_rutas[a][0],",");
                for(int b=0;b<paginas_ruta.length;b++)
                {
                    if(calcular==false) return 0;
                     pagina p=sitio_web.buscar_pagina(Integer.parseInt(paginas_ruta[b]));
                     salida=salida+" ("+p.numeracion+")  ";
                }
                if(view_pageRank==false&&view_hits==false&&view_webLinks==false)//hay que calcular solo dijkstra
                {
                        double value=Double.parseDouble(matriz_rutas[a][2]);
                        if(value<0)salida=salida+"  value: "+String.valueOf((int)(value*-1));
                }
                else salida = salida + "  value: " + matriz_rutas[a][2];                
                salida=salida+"\n     ";
            }
            jTextArea1.setText(salida);

            






            //saco los datos y dibujo la primera en rojo

            for(int i=0;i<grupo_rutas.length;i++)
            {
                if(calcular==false) return 0;
                if(i==0)
                {
                    String[] paginas_ruta=tokenizar(matriz_rutas[i][0],",");
                    int num=paginas_ruta.length;
                    for(int j=0;j<num-1;j++)
                    {
                        if(calcular==false) return 0;
                        //cambio color enlaces
                        Iterator iter = vis.items("graph.edges");
                        Iterator iter2 = vis.items("graph.edges");
                        while ( iter.hasNext() ) {
                            if(calcular==false) return 0;
                            VisualItem item = (VisualItem)iter.next();
                            Edge eg=(Edge)iter2.next();
                            eg.getSourceNode().getInt("id_pag");

                            if(Integer.valueOf(paginas_ruta[j])==eg.getSourceNode().getInt("id_pag")&&
                               Integer.valueOf(paginas_ruta[j+1])==eg.getTargetNode().getInt("id_pag"))
                            {
                                item.setFillColor(ColorLib.rgb(255,0,0));
                                item.setStrokeColor(ColorLib.rgb(255,0,0));
                                item.getVisualization().repaint();
                            }
                        }
                    }
                }
            }
        }
        return 1;
    }

    private void btn_startActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_startActionPerformed
        
        //btn_start.setEnabled(false);
        //guardar los resultados en el nodo dijkstra
        if(n.conf.num_rutas_dijkstra>Integer.parseInt(jSpinner1.getValue().toString()))
        {
            n.conf.num_rutas_dijkstra=Integer.parseInt(jSpinner1.getValue().toString());
        }

        this.setVisible(false);
        this.dispose();
    }//GEN-LAST:event_btn_startActionPerformed

    public String[] tokenizar(String msj,String token){
    	StringTokenizer st=new StringTokenizer(msj,token);
		String[] cads = new String[ st.countTokens() ];

    	for( int i=0; i < cads.length; i++ )// Separamos los tokens de la cadena del parmetro
    	{
       		cads[i] = st.nextToken();
    	}
    	return cads;
    }

    private String sacar_ruta(){
        String r="";
        pagina aux_pag=primero_lista;
        while(aux_pag!=null)
        {
            jTextArea1.setText("Get route \n"+aux_pag.url_pagina);
            if(r.length()==0)r=String.valueOf(aux_pag.id_pagina);
            else r=r+","+String.valueOf(aux_pag.id_pagina);
            aux_pag=aux_pag.sig_pag;
        }
        return r;
    }

    private String sacar_ruta2(){
        String r="";
        pagina aux_pag=primero_lista;
        while(aux_pag!=null)
        {
            if(r.length()==0)r="["+String.valueOf(aux_pag.numeracion)+"] ";
            else r=r+"["+String.valueOf(aux_pag.numeracion)+"] ";
            aux_pag=aux_pag.sig_pag;
        }
        r=r+"["+String.valueOf(target.numeracion)+"] ";
        return r;
    }

    private pagina sacar_siguiente(pagina pag,int n){
        jTextArea1.setText("Get nex page \n");
        boolean acabo=false;
        if(n==-1)//sacar el primero que se encuentre
        {
            if(pag.pri_salientesI!=null)
            {
                return pag.pri_salientesI.destino;
            }
            else
            {
                if(pag.pri_salientesE!=null)
                {
                    return pag.pri_salientesE.destino;
                }
                else
                {
                    return null;
                }
            }
        }
        else//es una de los hijos en salientesI o en salientesE
        {
            pagina encontrada=null;
            if(pag==null) return null;
            enlace aux_enlace=pag.pri_salientesI;
            while(aux_enlace!=null)
            {
                if(aux_enlace.destino.id_pagina==n)
                {
                    if(aux_enlace.sig_enlace!=null)
                    {
                        encontrada=aux_enlace.sig_enlace.destino;
                        return encontrada;
                    }
                    else
                    {
                        acabo=true;
                    }
                }
                jTextArea1.setText("Get nex page \n"+aux_enlace.destino.url_pagina);
                aux_enlace=aux_enlace.sig_enlace;
            }
            if(acabo)//sacar el primero
            {
                if(pag.pri_salientesE!=null)
                {
                    return pag.pri_salientesE.destino;
                }
                else
                {
                    return null;
                }
            }
            else//continuar con otro
            {
                enlace aux_enlace2=pag.pri_salientesE;
                while(aux_enlace2!=null)
                {
                    if(aux_enlace2.destino.id_pagina==n)
                    {
                        if(aux_enlace2.sig_enlace!=null)
                        {
                            encontrada=aux_enlace2.sig_enlace.destino;
                            return encontrada;
                        }
                        else
                        {
                            return null;
                        }
                    }
                    //jTextArea1.setText("Get nex page \n"+aux_enlace.destino.url_pagina);
                    aux_enlace2=aux_enlace2.sig_enlace;
                }
            }
            return null;
        }
    }

    private boolean buscar_lista(int id){
        pagina aux_pag=primero_lista;
        while(aux_pag!=null)
        {
            jTextArea1.setText("Search in list \n"+aux_pag.url_pagina);
            if(aux_pag.id_pagina==id) return true;
            aux_pag=aux_pag.sig_pag;
        }
        return false;
    }

    private pagina meter_lista(pagina p){
        jTextArea1.setText("Add in list \n"+p.url_pagina);
        pagina pagina_nueva=new pagina(p.url_pagina);
        pagina_nueva.nivel=p.nivel;
        pagina_nueva.numeracion=p.numeracion;
        pagina_nueva.url_pagina=p.url_pagina;
        pagina_nueva.nombre_pagina=p.nombre_pagina;
        pagina_nueva.id_pagina=p.id_pagina;
        pagina_nueva.pri_salientesE=p.pri_salientesE;
        pagina_nueva.pri_salientesI=p.pri_salientesI;

        if(primero_lista==null)
        {
           primero_lista=pagina_nueva;
           ultimo_lista=pagina_nueva;
        }
        else
        {
            ultimo_lista.sig_pag=pagina_nueva;
            pagina_nueva.ant_pag=ultimo_lista;
            ultimo_lista=pagina_nueva;
        }
        return pagina_nueva;
    }

    private pagina sacar_lista(){
        
        pagina aux_pagina;
        jTextArea1.setText("Delete from list \n");
        if(ultimo_lista==null)
        {
           return null;
        }
        else
        {
            if(ultimo_lista.ant_pag==null)
            {
               aux_pagina=ultimo_lista;
               ultimo_lista=null;
               primero_lista=null;
               return aux_pagina;
            }
            else
            {
               aux_pagina=ultimo_lista;
               ultimo_lista=ultimo_lista.ant_pag;
               ultimo_lista.sig_pag=null;
               return aux_pagina;
            }
        }
    }

    private void btn_restartActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_restartActionPerformed
        // TODO add your handling code here:
        calcular=false;
        jTextArea1.setText("Press Source node ");
        //seleccionando_source=true;
        jTextArea2.setText("");
        n.corriendo=false;
        if(Vsource!=null) Vsource.setFillColor(ColorLib.rgb(0,255,0));
        if(Vtarget!=null) Vtarget.setFillColor(ColorLib.rgb(0,255,0));


        btn_start.setEnabled(false);
        btn_restart.setEnabled(true);
        source=null;
        target=null;
        primero_lista=null;
        ultimo_lista=null;
        seleccionando_target=false;
        seleccionando_source=true;
        Iterator iter = vis.items("graph.edges");
        while ( iter.hasNext() )
        {
            VisualItem item = (VisualItem)iter.next();
            item.setFillColor(ColorLib.rgb(0,0,0));
            item.setStrokeColor(ColorLib.rgb(0,0,0));
            item.getVisualization().repaint();
        }
    }//GEN-LAST:event_btn_restartActionPerformed

    private void rad_autoridadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rad_autoridadActionPerformed
        // TODO add your handling code here:
        this.rad_autoridad.setSelected(true);
        this.rad_hub.setSelected(false);
    }//GEN-LAST:event_rad_autoridadActionPerformed

    private void rad_hubActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rad_hubActionPerformed
        // TODO add your handling code here:
        this.rad_autoridad.setSelected(false);
        this.rad_hub.setSelected(true);
    }//GEN-LAST:event_rad_hubActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new dijkstraViewFrame().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btn_restart;
    private javax.swing.JButton btn_start;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSpinner jSpinner1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextArea jTextArea2;
    private javax.swing.JPanel panel_hits;
    private javax.swing.JPanel panel_visor;
    private javax.swing.JRadioButton rad_autoridad;
    private javax.swing.JRadioButton rad_hub;
    // End of variables declaration//GEN-END:variables

}
