/*
 * mediante esta clase se manejan todas las paginas que contenga el sitio
 *
 */

package polaris2.site;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.StringTokenizer;
import polaris2.graph.Nodo;


public class sitio {
    public String url_inicial;
    public pagina pagina_inicial;
    public pagina pagina_final;
    public pagina pagina_nueva;
    public host pri_host;
    public host ult_host;
    public host nue_host;


    public sitio()
    {
        pagina_inicial=null;
        pagina_final=null;
    }

    public void crear_lista_host()
    {
        pagina aux_pagina=null;
        aux_pagina=pagina_inicial;
        int num_host=0;
        pri_host=null;
        ult_host=null;
        while(aux_pagina!=null)
        {
            try {
                URL dir = new URL(aux_pagina.url_pagina);
                if(buscar_host(dir.getHost())==-1)
                {
                    insertar_host(dir.getHost());
                    num_host++;
                }
            }
            catch (Exception ex)
            {
            }
            aux_pagina=aux_pagina.sig_pag;
        }

        aux_pagina=pagina_inicial;
        while(aux_pagina!=null)
        {
            try {
                URL dir = new URL(aux_pagina.url_pagina);
                aux_pagina.id_host=buscar_host(dir.getHost());
            }
            catch (Exception ex)
            {
            }
            aux_pagina=aux_pagina.sig_pag;
        }
    }

    public void insertar_host(String n)
    {
        nue_host=new host();
        nue_host.nom_host=n;
        if(pri_host==null)
        {
            pri_host=nue_host;
            ult_host=nue_host;
            nue_host.id_host=0;

        }
        else
        {
            nue_host.id_host=ult_host.id_host+1;
            ult_host.sig_host=nue_host;
            nue_host.ant_host=ult_host;
            ult_host=nue_host;
        }
    }

    public int buscar_host(String n)
    {
        host aux_host=pri_host;
        while(aux_host!=null)
        {
            if(aux_host.nom_host.compareTo(n)==0) return aux_host.id_host;

            aux_host=aux_host.sig_host;
        }
        return -1;
    }

    public String[] tokenizar(String msj,String token)
    {
    	StringTokenizer st=new StringTokenizer(msj,token);
		String[] cads = new String[ st.countTokens() ];

    	for( int i=0; i < cads.length; i++ )// Separamos los tokens de la cadena del parmetro
    	{
       		cads[i] = st.nextToken();
    	}
    	return cads;
    }

    public void cargar_pagina(String info_nodo)//para cuando se carga de un txt o base de datos
    {
        String cadena_nodo[]=null;
        cadena_nodo=tokenizar(info_nodo,",");
        int caso=0;
        if(cadena_nodo[0].compareTo("P")==0) caso=1;
        if(cadena_nodo[0].compareTo("E")==0) caso=2;
        switch (caso)
        {
            case 1://se debe incertar una pagina
                //P,id,numeracion,nivel,url,enlacesSI,enlacesSE,enlacesEI,enlacesEE
                pagina_nueva=new pagina(cadena_nodo[4]);
                pagina_nueva.nivel=Integer.parseInt(cadena_nodo[3]);
                pagina_nueva.numeracion=cadena_nodo[2];
                pagina_nueva.id_pagina=Integer.parseInt(cadena_nodo[1]);
                //pagina_nueva.num_enlaces_SI=Integer.parseInt(cadena_nodo[5]);
                //pagina_nueva.num_enlaces_SE=Integer.parseInt(cadena_nodo[6]);
                //pagina_nueva.num_enlaces_EI=Integer.parseInt(cadena_nodo[7]);
                //pagina_nueva.num_enlaces_EE=Integer.parseInt(cadena_nodo[8]);
                pagina_nueva.nombre_pagina=cadena_nodo[4];
                if(pagina_final==null)
                {
                    url_inicial=cadena_nodo[4];
                    pagina_inicial=pagina_nueva;
                    pagina_final=pagina_nueva;
                }
                else
                {
                    pagina_final.sig_pag=pagina_nueva;
                    pagina_nueva.ant_pag=pagina_final;
                    pagina_final=pagina_nueva;
                }
                
            break;
            case 2:// se debe incertar un enlace
                //E,SI,id_origen,id_destino
                int id_origen=Integer.parseInt(cadena_nodo[2]);
                int id_destino=Integer.parseInt(cadena_nodo[3]);
                pagina pag_origen=this.buscar_pagina(id_origen);
                pagina pag_destino=this.buscar_pagina(id_destino);
                if(pag_origen!=null&&pag_destino!=null)
                {
                    if(cadena_nodo[1].compareTo("SI")==0)
                    {
                        pag_origen.insertar_enlace(pag_destino,"saleI");
                        pag_destino.insertar_enlace(pag_origen,"entraI");
                    }
                    if(cadena_nodo[1].compareTo("SE")==0)
                    {
                        pag_origen.insertar_enlace(pag_destino,"saleE");
                        pag_destino.insertar_enlace(pag_origen,"entraE");
                    }
                    if(cadena_nodo[1].compareTo("EI")==0)
                    {
                        pag_origen.insertar_enlace(pag_destino,"entraI");
                        pag_destino.insertar_enlace(pag_origen,"saleI");
                    }
                    if(cadena_nodo[1].compareTo("EE")==0)
                    {
                        pag_origen.insertar_enlace(pag_destino,"entraE");
                        pag_destino.insertar_enlace(pag_origen,"saleE");
                    }
                }
                else System.out.println("No valid link");

            break;
        }
    }

    public void adicionar_pagina(pagina nueva_pagina,int nivel)
    {
        pagina_nueva=new pagina(nueva_pagina.url_pagina);
        pagina_nueva.nivel=nivel;
        pagina_nueva.numeracion=nueva_pagina.numeracion;
        pagina_nueva.url_pagina=nueva_pagina.url_pagina;
        pagina_nueva.nombre_pagina=nueva_pagina.nombre_pagina;
        pagina_nueva.id_pagina=nueva_pagina.id_pagina;


        if(pagina_final==null)
        {
           pagina_inicial=pagina_nueva;
           pagina_final=pagina_nueva;
           //pagina_nueva.id_pagina=0;
        }
        else
        {
            //pagina_nueva.id_pagina=pagina_final.id_pagina+1;
            pagina_final.sig_pag=pagina_nueva;
            pagina_nueva.ant_pag=pagina_final;
            pagina_final=pagina_nueva;

        }
    }
    public void insertar_pagina(pagina nueva_pagina,int nivel)
    {
        pagina_nueva=new pagina(nueva_pagina.url_pagina);
        pagina_nueva.nivel=nivel;
        pagina_nueva.numeracion=nueva_pagina.numeracion;
        pagina_nueva.url_pagina=nueva_pagina.url_pagina;
        pagina_nueva.nombre_pagina=nueva_pagina.nombre_pagina;


        if(pagina_final==null)
        {
           pagina_inicial=pagina_nueva;
           pagina_final=pagina_nueva;
           pagina_nueva.id_pagina=0;
        }
        else
        {
            pagina_nueva.id_pagina=pagina_final.id_pagina+1;
            pagina_final.sig_pag=pagina_nueva;
            pagina_nueva.ant_pag=pagina_final;
            pagina_final=pagina_nueva;

        }
    }
    public void borrar_desconectados()
    {
        pagina aux_pagina=null;
        pagina aux_pagina2=null;
        aux_pagina=pagina_inicial;
        try
        {
            while(aux_pagina!=null)
            {
                if(aux_pagina.num_enlaces_EE==0&&
                   aux_pagina.num_enlaces_EI==0&&
                   aux_pagina.num_enlaces_SE==0&&
                   aux_pagina.num_enlaces_SI==0)
                {
                    //esta pagina no se encuentra conectada se debe eliminar
                    if(pagina_inicial!=pagina_final)//hay mas de una
                    {
                        if(aux_pagina.ant_pag==null)//es la primera
                        {
                            pagina_inicial=aux_pagina.sig_pag;
                            pagina_inicial.ant_pag.sig_pag=null;
                            pagina_inicial.ant_pag=null;
                            aux_pagina=pagina_inicial;
                        }
                        else
                        {
                            if(aux_pagina.sig_pag==null)//es la ultima
                            {
                                pagina_final=aux_pagina.ant_pag;
                                pagina_final.sig_pag.ant_pag=null;
                                pagina_final.sig_pag=null;
                                aux_pagina=pagina_final;
                            }
                            else//esta en medio
                            {
                                aux_pagina2=aux_pagina.ant_pag;
                                aux_pagina.ant_pag.sig_pag=aux_pagina.sig_pag;
                                aux_pagina.sig_pag.ant_pag=aux_pagina.ant_pag;
                                aux_pagina=aux_pagina2;

                            }
                        }
                    }
                }
                aux_pagina=aux_pagina.sig_pag;
            }
        }
        catch(Exception e)
        {
            System.out.println("Exception al eliminar paginas desconectadas "+e.toString());
        }
    }

    public String tipo_enlace(String url_actual,String url_padre)
    {
        
        try {
            URL Direccion = new URL(url_actual);
            //System.out.println( " -------------------------------------------------- ");
            //System.out.println( " Host : " + Direccion.getHost());
            //System.out.println( " Protocol : " + Direccion.getProtocol());
            //System.out.println( " -------------------------------------------------- ");
            if(pagina_inicial!=null)//verificar si es interna o externa
            {                
                URL Direccion2= new URL(url_padre);
                String host1=Direccion.getHost();
                String host2=Direccion2.getHost();
                if(host1.compareTo(host2)==0) return "interno";
                else return "externo";
            }
        }
        catch (MalformedURLException me)
        {
            return "interno";
        }
        return "interno";
    }

    public pagina buscar_pagina(int id_pag)//buscar por id
    {
        pagina aux_pagina=null;
        aux_pagina=pagina_inicial;
        while(aux_pagina!=null)
        {
            if(aux_pagina.id_pagina==id_pag) return aux_pagina;
            aux_pagina=aux_pagina.sig_pag;
        }
        return null;
    }
    public pagina buscar_pagina_numeracion(String id_pag)//buscar por id
    {
        pagina aux_pagina=null;
        aux_pagina=pagina_inicial;
        while(aux_pagina!=null)
        {
            if(aux_pagina.numeracion.compareTo(id_pag)==0) return aux_pagina;
            aux_pagina=aux_pagina.sig_pag;
        }
        return null;
    }
    public pagina buscar_pagina(String url_pag)//buscar por nombre
    {
        pagina aux_pagina=null;
        aux_pagina=pagina_inicial;
        while(aux_pagina!=null)
        {
            if(aux_pagina.url_pagina.compareTo(url_pag)==0) return aux_pagina;

            
            aux_pagina=aux_pagina.sig_pag;
        }
        return null;
    }

   
}
