package polaris2.view;

import com.itextpdf.text.Font;

import javax.swing.JFrame;
import java.awt.event.*;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import polaris2.site.sitio;
import polaris2.graph.Nodo;
import polaris2.site.enlace;
import polaris2.site.pagina;
import javax.swing.border.TitledBorder;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;

import com.lowagie.text.Document;
import com.lowagie.text.FontFactory;
import com.lowagie.text.Paragraph;
import com.lowagie.text.pdf.PdfWriter;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Image;
import java.io.PrintStream;
import java.util.StringTokenizer;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;



public class tableViewFrame extends JFrame {


    private String urlAbrir="";
    public sitio sitio_web=null;
    public sitio sitio_web2=null;
    public Nodo links=null;
    public Nodo nodo_dijkstra=null;
    public Nodo n=null;
    public boolean view_hits=false;
    public boolean view_pageRank=false;
    public boolean view_webLinks=false;
    public boolean view_Dijkstra=false;
    public int dataProcceshits=0;
    public int dataProccesPageRank=0;
    public int dataProccesWebLinker=0;
    public int numero_registros=0;
    public enlace aux_enlace=null;
    private String[] nom_columnas;
    private int numero_columnas=0;
    private String[][] datos;
    private JButton btn_pdf=new JButton("PDF");
    private JButton btn_txt=new JButton("TXT");
    private JButton btn_html=new JButton("HTML");


     public tableViewFrame() {
         
        super("Table View");
        eventos_botones();
        

        //manejamos la salida
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                //System.exit(0);
                setVisible(false);
                dispose();
            }
        });
        this.setIconImage(this.getImage("/media/star.png"));
    }

    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }

    public static void main(String[] args) {
        tableViewFrame frame = new tableViewFrame();
        frame.pack();
        frame.setVisible(true);
    }

    public String[] tokenizar(String msj,String token){
    	StringTokenizer st=new StringTokenizer(msj,token);
		String[] cads = new String[ st.countTokens() ];

    	for( int i=0; i < cads.length; i++ )// Separamos los tokens de la cadena del parmetro
    	{
       		cads[i] = st.nextToken();
    	}
    	return cads;
    }

    public void crear_tabla()
    {
        //---------------------------------------------------------------------------------------
        //----------------------------calculo de numero de registros-----------------------------------------------
        //---------------------------------------------------------------------------------------
        int numero_enlaces=0;
        pagina aux_pagina=sitio_web.pagina_inicial;
        while(aux_pagina!=null)
        {
            numero_registros++;//linea divisoria
            numero_registros++;//datos pagina
            if(links.conf.ExternalInLinks==true)
            {
                aux_enlace=aux_pagina.pri_entrantesE;
                numero_enlaces=0;
                while(aux_enlace!=null)
                {
                    numero_registros++;
                    numero_enlaces++;
                    aux_enlace=aux_enlace.sig_enlace;
                }
                aux_pagina.num_enlaces_EE2=numero_enlaces;
            }
            if(links.conf.InternalInLinks==true)
            {
                aux_enlace=aux_pagina.pri_entrantesI;
                numero_enlaces=0;
                while(aux_enlace!=null)
                {
                    numero_registros++;
                    numero_enlaces++;
                    aux_enlace=aux_enlace.sig_enlace;
                }
                aux_pagina.num_enlaces_EI2=numero_enlaces;
            }
            if(links.conf.ExternalOutLinks==true)
            {
                aux_enlace=aux_pagina.pri_salientesE;
                numero_enlaces=0;
                while(aux_enlace!=null)
                {
                    numero_registros++;
                    numero_enlaces++;
                    aux_enlace=aux_enlace.sig_enlace;
                }
                aux_pagina.num_enlaces_SE2=numero_enlaces;
            }
            if(links.conf.InternalOutLinks==true)
            {
                aux_enlace=aux_pagina.pri_salientesI;
                numero_enlaces=0;
                while(aux_enlace!=null)
                {
                    numero_registros++;
                    numero_enlaces++;
                    aux_enlace=aux_enlace.sig_enlace;
                }
                aux_pagina.num_enlaces_SI2=numero_enlaces;
            }
            aux_pagina=aux_pagina.sig_pag;
        }

        if(view_Dijkstra==false&&view_hits==false&&view_pageRank==false&&view_webLinks==false)
        {
        //---------------------------------------------------------------------------------------
        //----------------------------solo links-----------------------------------------------
        //---------------------------------------------------------------------------------------
            ////id(source),url,SI,EI,SE,EE,id(target)
            nom_columnas = new String[7];
            numero_columnas=7;
            nom_columnas[0]="Numeration(Source)"; nom_columnas[1]="URL"; nom_columnas[2]="Internal In Links";
            nom_columnas[3]="Internal Out Links"; nom_columnas[4]="External In Links";  nom_columnas[5]="External Out Links"; nom_columnas[6]="Numeration(Target)";
            datos=new String[numero_registros][7];

            aux_pagina=sitio_web.pagina_inicial;
            int pos_fila=0;
            while(aux_pagina!=null)
            {
                //-----------linea divisoria
                datos[pos_fila][0]="<html>_________________________________________________________________________________________________</html>";
                datos[pos_fila][1]="<html>_________________________________________________________________________________________________</html>";
                datos[pos_fila][2]="<html>_________________________________________________________________________________________________</html>";
                datos[pos_fila][3]="<html>_________________________________________________________________________________________________</html>";
                datos[pos_fila][4]="<html>_________________________________________________________________________________________________</html>";
                datos[pos_fila][5]="<html>_________________________________________________________________________________________________</html>";
                datos[pos_fila][6]="<html>_________________________________________________________________________________________________</html>";
                pos_fila++;
                //-----------linea divisoria

                datos[pos_fila][0]=aux_pagina.numeracion;
                datos[pos_fila][1]=aux_pagina.url_pagina;
                datos[pos_fila][2]=String.valueOf(aux_pagina.num_enlaces_EI2);
                datos[pos_fila][3]=String.valueOf(aux_pagina.num_enlaces_SI2);
                datos[pos_fila][4]=String.valueOf(aux_pagina.num_enlaces_EE2);
                datos[pos_fila][5]=String.valueOf(aux_pagina.num_enlaces_SE2);
                datos[pos_fila][6]="-";
                pos_fila++;
                if(links.conf.InternalInLinks==true)
                {
                    aux_enlace=aux_pagina.pri_entrantesI;
                    while(aux_enlace!=null)
                    {
                        datos[pos_fila][0]=aux_pagina.numeracion;
                        datos[pos_fila][1]=aux_pagina.url_pagina;
                        datos[pos_fila][2]=aux_enlace.destino.url_pagina;
                        datos[pos_fila][3]="-";
                        datos[pos_fila][4]="-";
                        datos[pos_fila][5]="-";
                        datos[pos_fila][6]=aux_enlace.destino.numeracion;
                        pos_fila++;
                        aux_enlace=aux_enlace.sig_enlace;
                    }
                }
                if(links.conf.InternalOutLinks==true)
                {
                    aux_enlace=aux_pagina.pri_salientesI;
                    while(aux_enlace!=null)
                    {
                        datos[pos_fila][0]=aux_pagina.numeracion;
                        datos[pos_fila][1]=aux_pagina.url_pagina;
                        datos[pos_fila][2]="-";
                        datos[pos_fila][3]=aux_enlace.destino.url_pagina;
                        datos[pos_fila][4]="-";
                        datos[pos_fila][5]="-";
                        datos[pos_fila][6]=aux_enlace.destino.numeracion;
                        pos_fila++;
                        aux_enlace=aux_enlace.sig_enlace;
                    }
                }
                if(links.conf.ExternalInLinks==true)
                {
                    aux_enlace=aux_pagina.pri_entrantesE;
                    while(aux_enlace!=null)
                    {
                        datos[pos_fila][0]=aux_pagina.numeracion;
                        datos[pos_fila][1]=aux_pagina.url_pagina;
                        datos[pos_fila][2]="-";
                        datos[pos_fila][3]="-";
                        datos[pos_fila][4]=aux_enlace.destino.url_pagina;
                        datos[pos_fila][5]="-";
                        datos[pos_fila][6]=aux_enlace.destino.numeracion;
                        pos_fila++;
                        aux_enlace=aux_enlace.sig_enlace;
                    }
                }                
                if(links.conf.ExternalOutLinks==true)
                {
                    aux_enlace=aux_pagina.pri_salientesE;
                    while(aux_enlace!=null)
                    {
                        datos[pos_fila][0]=aux_pagina.numeracion;
                        datos[pos_fila][1]=aux_pagina.url_pagina;
                        datos[pos_fila][2]="-";
                        datos[pos_fila][3]="-";
                        datos[pos_fila][4]="-";
                        datos[pos_fila][5]=aux_enlace.destino.url_pagina;
                        datos[pos_fila][6]=aux_enlace.destino.numeracion;
                        pos_fila++;
                        aux_enlace=aux_enlace.sig_enlace;
                    }
                }                
               aux_pagina=aux_pagina.sig_pag;
            }
        }
        //---------------------------------------------------------------------------------------
        //----------------------trabla tipo dijkstra---------------------------------------------
        //---------------------------------------------------------------------------------------
        
        else {
        if(view_Dijkstra==true)
        {
            //crear las columnas
            String tipo_dijkstra=nodo_dijkstra.conf.tipo_dijkstra;
            double valor=0;
            //String pedazo="";
            nom_columnas = new String[3];//numeration(route),url,value
            nom_columnas[0]="Numeration";
            nom_columnas[1]="URL";//aqui va la ruta (numeraciones)
            nom_columnas[2]="Value "+tipo_dijkstra;
            
            numero_registros=0;
            //determino cantidad de registros
            int numero_rutas=nodo_dijkstra.conf.num_rutas_dijkstra;



            for(int a=0;a<numero_rutas;a++)
            {
                numero_registros++;//linea de separacion
                numero_registros++;//linea para escribir la ruta y valor de dikstra
                String[] paginas_ruta=tokenizar(nodo_dijkstra.conf.rutas_dijkstra[a][0],",");
                numero_registros=numero_registros+paginas_ruta.length;
            }

            //pasar los datos de dijstra a datos de tabla
            datos=new String[numero_registros][3];
            int pos_fila=0;
            for(int a=0;a<numero_rutas;a++)
            {
                //-----linea de division
                datos[pos_fila][0]="<html>_________________________________________________________________________________________________</html>";
                datos[pos_fila][1]="<html>_________________________________________________________________________________________________</html>";
                datos[pos_fila][2]="<html>_________________________________________________________________________________________________</html>";
                pos_fila++;

                //convierto la cadena de paginas que forman una ruta en cadena de numeraciones que forman la ruta
                String salida="";
                String[] paginas_ruta=tokenizar(nodo_dijkstra.conf.rutas_dijkstra[a][0],",");
                for(int b=0;b<paginas_ruta.length;b++)
                {
                     pagina p=sitio_web.buscar_pagina(Integer.parseInt(paginas_ruta[b]));
                     salida=salida+" ["+p.numeracion+"]  ";
                }
                //a++;
                //fila que representa a la ruta
                datos[pos_fila][0]="ROUTE # "+String.valueOf(a+1);
                datos[pos_fila][1]=salida;
                if(tipo_dijkstra.compareTo("Links")==0)
                {
                    valor=Double.parseDouble(nodo_dijkstra.conf.rutas_dijkstra[a][2]);
                    valor=(valor*-1);
                    datos[pos_fila][2]=String.valueOf((int)valor);
                }
                else
                {
                    datos[pos_fila][2]=nodo_dijkstra.conf.rutas_dijkstra[a][2];
                }

                //filas que representan a cada una de las paginas de la ruta
                for(int b=0;b<paginas_ruta.length;b++)
                {
                    pos_fila++;
                    pagina p=sitio_web2.buscar_pagina(Integer.parseInt(paginas_ruta[b]));
                    datos[pos_fila][0]=p.numeracion;
                    datos[pos_fila][1]=p.url_pagina;
                    if(tipo_dijkstra.compareTo("Links")==0) datos[pos_fila][2]="1";
                    else
                    {
                        if(tipo_dijkstra.compareTo("HITS AUTORITY")==0) datos[pos_fila][2]=String.valueOf(p.ValueHitsAutority);
                        if(tipo_dijkstra.compareTo("HITS HUB")==0) datos[pos_fila][2]=String.valueOf(p.ValueHitsHUB);
                        if(tipo_dijkstra.compareTo("Web Linker")==0) datos[pos_fila][2]=String.valueOf(p.ValueVisit);
                        if(tipo_dijkstra.compareTo("Page Rank")==0) datos[pos_fila][2]=String.valueOf(p.ValuePageRank);
                    }
                }
                pos_fila++;
            }
        }
        //---------------------------------------------------------------------------------------
        //--------------------------view table con algoritmos------------------------------------
        //---------------------------------------------------------------------------------------
        else
        {            
            int pos_fila=0;
            int pos_columna=0;
            numero_columnas=numero_columnas+7;//id,url,SI,EI,SE,EE,urldestino
            ////id,url,hits autrity,hits HUB,page rank,weblinker ,SI,EI,SE,EE,idtraget,hits autrity,hits HUB,page rank,weblinker
            if (view_hits==true) numero_columnas=numero_columnas+4;
            if (view_pageRank==true) numero_columnas=numero_columnas+2;
            if (view_webLinks==true) numero_columnas=numero_columnas+2;

            nom_columnas = new String[numero_columnas];                  pos_columna=0;
            nom_columnas[pos_columna]="Numeration(source)";              pos_columna++;
            nom_columnas[pos_columna]="URL (source)";                    pos_columna++;
            if (view_hits==true)
            {
                nom_columnas[pos_columna]="HITS (Authority)(source)";   pos_columna++;
                nom_columnas[pos_columna]="HITS (HUB)(source)";         pos_columna++;
            }
            if (view_pageRank==true)
            {
                nom_columnas[pos_columna]="Page Rank(source)";   pos_columna++;
            }
            if (view_webLinks==true)
            {
                nom_columnas[pos_columna]="Web Linker(source)";   pos_columna++;
            }

            nom_columnas[pos_columna]="Internal In Links(Target)";      pos_columna++;
            nom_columnas[pos_columna]="Internal Out Links(Target)";     pos_columna++;
            nom_columnas[pos_columna]="External In Links(Target)";      pos_columna++;
            nom_columnas[pos_columna]="External Out Links(Target)";     pos_columna++;
            
           
            nom_columnas[pos_columna]="Numeration(Target)";                    pos_columna++;
            if (view_hits==true)
            {
                nom_columnas[pos_columna]="HITS (Authority)(Target)";   pos_columna++;
                nom_columnas[pos_columna]="HITS (HUB)(Target)";         pos_columna++;            
            }
            if (view_pageRank==true)
            {
                nom_columnas[pos_columna]="Page Rank (Target)";   pos_columna++;                
            }
            if (view_webLinks==true)
            {
                nom_columnas[pos_columna]="Web Linker(Target)";   pos_columna++;                
            }


            datos=new String[numero_registros][numero_columnas];

            aux_pagina=sitio_web.pagina_inicial;            
            while(aux_pagina!=null)
            {
                //-----------linea divisoria
                for(int j=0;j<numero_columnas;j++)
                {
                    datos[pos_fila][j]="<html>_________________________________________________________________________________________________</html>";
                }
                pos_fila++;
                //-----------linea divisoria

                    pos_columna=0;
                    datos[pos_fila][pos_columna]=aux_pagina.numeracion;pos_columna++;
                    datos[pos_fila][pos_columna]=aux_pagina.url_pagina;pos_columna++;
                    if (view_hits==true)
                    {
                        datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValueHitsAutority); pos_columna++;
                        datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValueHitsHUB); pos_columna++;
                    }
                    if (view_pageRank==true)
                    {
                        datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValuePageRank); pos_columna++;
                    }
                    if (view_webLinks==true)
                    {
                        datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValueVisit); pos_columna++;
                    }
                    datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.num_enlaces_EI2);pos_columna++;
                    datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.num_enlaces_SI2);pos_columna++;
                    datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.num_enlaces_EE2);pos_columna++;                    
                    datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.num_enlaces_SE2);pos_columna++;
                    
                    datos[pos_fila][pos_columna]=aux_pagina.numeracion;                     pos_columna++;
                    if (view_hits==true)
                    {
                        datos[pos_fila][pos_columna]="-"; pos_columna++;
                        datos[pos_fila][pos_columna]="-"; pos_columna++;
                    }
                    if (view_pageRank==true)
                    {
                        datos[pos_fila][pos_columna]="-"; pos_columna++;
                    }
                    if (view_webLinks==true)
                    {
                        datos[pos_fila][pos_columna]="-"; pos_columna++;
                    }
                    pos_fila++;


                if(links.conf.InternalInLinks==true)
                {
                    aux_enlace=aux_pagina.pri_entrantesI;
                    while(aux_enlace!=null)
                    {
                        pos_columna=0;
                        datos[pos_fila][pos_columna]=aux_pagina.numeracion;pos_columna++;
                        datos[pos_fila][pos_columna]=aux_pagina.url_pagina;pos_columna++;
                        if (view_hits==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValueHitsAutority); pos_columna++;
                            datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValueHitsHUB); pos_columna++;
                        }
                        if (view_pageRank==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValuePageRank); pos_columna++;
                        }
                        if (view_webLinks==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValueVisit); pos_columna++;
                        }
                        datos[pos_fila][pos_columna]=aux_enlace.destino.url_pagina;pos_columna++;
                        datos[pos_fila][pos_columna]="-";pos_columna++;
                        datos[pos_fila][pos_columna]="-";pos_columna++;
                        datos[pos_fila][pos_columna]="-";pos_columna++;
                        datos[pos_fila][pos_columna]=aux_enlace.destino.numeracion;pos_columna++;
                        if (view_hits==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_enlace.destino.ValueHitsAutority); pos_columna++;
                            datos[pos_fila][pos_columna]=String.valueOf(aux_enlace.destino.ValueHitsHUB); pos_columna++;
                        }
                        if (view_pageRank==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_enlace.destino.ValuePageRank); pos_columna++;
                        }
                        if (view_webLinks==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_enlace.destino.ValueVisit); pos_columna++;
                        }
                        pos_fila++;
                        aux_enlace=aux_enlace.sig_enlace;
                    }
                }

                    if(links.conf.InternalOutLinks==true)
                {
                    aux_enlace=aux_pagina.pri_salientesI;
                    while(aux_enlace!=null)
                    {
                        pos_columna=0;
                        datos[pos_fila][pos_columna]=aux_pagina.numeracion;pos_columna++;
                        datos[pos_fila][pos_columna]=aux_pagina.url_pagina;pos_columna++;
                        if (view_hits==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValueHitsAutority); pos_columna++;
                            datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValueHitsHUB); pos_columna++;
                        }
                        if (view_pageRank==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValuePageRank); pos_columna++;
                        }
                        if (view_webLinks==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValueVisit); pos_columna++;
                        }
                        datos[pos_fila][pos_columna]="-";pos_columna++;
                        datos[pos_fila][pos_columna]=aux_enlace.destino.url_pagina;pos_columna++;
                        datos[pos_fila][pos_columna]="-";pos_columna++;
                        datos[pos_fila][pos_columna]="-";pos_columna++;
                        datos[pos_fila][pos_columna]=aux_enlace.destino.numeracion;pos_columna++;
                        if (view_hits==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_enlace.destino.ValueHitsAutority); pos_columna++;
                            datos[pos_fila][pos_columna]=String.valueOf(aux_enlace.destino.ValueHitsHUB); pos_columna++;
                        }
                        if (view_pageRank==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_enlace.destino.ValuePageRank); pos_columna++;
                        }
                        if (view_webLinks==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_enlace.destino.ValueVisit); pos_columna++;
                        }
                        pos_fila++;
                        aux_enlace=aux_enlace.sig_enlace;
                    }
                }

                if(links.conf.ExternalInLinks==true)
                {
                    aux_enlace=aux_pagina.pri_entrantesE;
                    while(aux_enlace!=null)
                    {
                        pos_columna=0;
                        datos[pos_fila][pos_columna]=aux_pagina.numeracion;pos_columna++;
                        datos[pos_fila][pos_columna]=aux_pagina.url_pagina;pos_columna++;
                        if (view_hits==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValueHitsAutority); pos_columna++;
                            datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValueHitsHUB); pos_columna++;
                        }
                        if (view_pageRank==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValuePageRank); pos_columna++;
                        }
                        if (view_webLinks==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValueVisit); pos_columna++;
                        }
                        datos[pos_fila][pos_columna]="-";pos_columna++;
                        datos[pos_fila][pos_columna]="-";pos_columna++;
                        datos[pos_fila][pos_columna]=aux_enlace.destino.url_pagina;pos_columna++;
                        datos[pos_fila][pos_columna]="-";pos_columna++;
                        datos[pos_fila][pos_columna]=aux_enlace.destino.numeracion;pos_columna++;
                        if (view_hits==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_enlace.destino.ValueHitsAutority); pos_columna++;
                            datos[pos_fila][pos_columna]=String.valueOf(aux_enlace.destino.ValueHitsHUB); pos_columna++;
                        }
                        if (view_pageRank==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_enlace.destino.ValuePageRank); pos_columna++;
                        }
                        if (view_webLinks==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_enlace.destino.ValueVisit); pos_columna++;
                        }
                        pos_fila++;
                        aux_enlace=aux_enlace.sig_enlace;
                    }
                }
                
                if(links.conf.ExternalOutLinks==true)
                {
                    aux_enlace=aux_pagina.pri_salientesE;
                    while(aux_enlace!=null)
                    {
                        pos_columna=0;
                        datos[pos_fila][pos_columna]=aux_pagina.numeracion;;pos_columna++;
                        datos[pos_fila][pos_columna]=aux_pagina.url_pagina;pos_columna++;
                        if (view_hits==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValueHitsAutority); pos_columna++;
                            datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValueHitsHUB); pos_columna++;
                        }
                        if (view_pageRank==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValuePageRank); pos_columna++;
                        }
                        if (view_webLinks==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_pagina.ValueVisit); pos_columna++;
                        }
                        datos[pos_fila][pos_columna]="-";pos_columna++;
                        datos[pos_fila][pos_columna]="-";pos_columna++;
                        datos[pos_fila][pos_columna]="-";pos_columna++;
                        datos[pos_fila][pos_columna]=aux_enlace.destino.url_pagina;pos_columna++;
                        datos[pos_fila][pos_columna]=aux_enlace.destino.numeracion;pos_columna++;
                        if (view_hits==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_enlace.destino.ValueHitsAutority); pos_columna++;
                            datos[pos_fila][pos_columna]=String.valueOf(aux_enlace.destino.ValueHitsHUB); pos_columna++;
                        }
                        if (view_pageRank==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_enlace.destino.ValuePageRank); pos_columna++;
                        }
                        if (view_webLinks==true)
                        {
                            datos[pos_fila][pos_columna]=String.valueOf(aux_enlace.destino.ValueVisit); pos_columna++;
                        }
                        pos_fila++;
                        aux_enlace=aux_enlace.sig_enlace;
                    }
                }
                aux_pagina=aux_pagina.sig_pag;
            }
        }
        }

        JPanel principal=new JPanel(new BorderLayout(10,10));
        JPanel panel_botones=new JPanel(new BorderLayout(10,10));
        JPanel panel_tabla=new JPanel(new BorderLayout(10,10));
        JPanel grid_botones=new JPanel(new FlowLayout(FlowLayout.LEFT));
        principal.setBorder(new TitledBorder("Table View"));
        panel_tabla.setBorder(new TitledBorder("Data"));
        panel_botones.setBorder(new TitledBorder("Export to:"));
        final JTable table = new JTable(datos, nom_columnas);

        grid_botones.add(btn_txt);
        grid_botones.add(btn_pdf);
        grid_botones.add(btn_html);
        //grid_botones.set
        JScrollPane scrollPane = new JScrollPane(table);
        panel_tabla.setMinimumSize(new Dimension(2000,2000));
        panel_tabla.add(scrollPane, BorderLayout.CENTER);
        panel_botones.add(grid_botones, BorderLayout.CENTER);


        principal.add(panel_botones, BorderLayout.NORTH);
        principal.add(panel_tabla, BorderLayout.CENTER);
        getContentPane().add(principal, BorderLayout.CENTER);
    }

    private void eventos_botones() {
        // BOTON MAS /////////////////////////////////////////////////////////
        btn_pdf.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {
                JFileChooser fc = new JFileChooser();
                //fc.setCurrentDirectory(new File("."));//situarnos en el directorio actual
                fc.setDialogTitle("Save PDF file");
                boolean guardar=true;
                if(JFileChooser.APPROVE_OPTION==fc.showSaveDialog(null))
                {
                    String ruta=fc.getSelectedFile().getPath();
                    String nombre_archivo=fc.getSelectedFile().getName();
                    if(ruta.indexOf(".pdf",0)==-1)
                    {
                        ruta=ruta+".pdf";
                    }
                    File fFile=fc.getSelectedFile();
                    if(fFile.exists())
                    {
                        int confirmado = JOptionPane.showConfirmDialog(null,"This file exists, do you want replace?","CONFIRMATION",JOptionPane.YES_NO_OPTION);//tipo confirmacion
                        if (JOptionPane.OK_OPTION != confirmado) guardar=false;
                    }
                    try {
                        if(guardar)
                        {
                            OutputStream file = new FileOutputStream(new File(ruta));
                            Document document = new Document();
                            PdfWriter.getInstance(document, file);
                            document.open();
                            int entrantesI=0;
                            int salientesI=0;
                            int entrantesE=0;
                            int salientesE=0;
                            int desplazar=0;
                            String texto="";

                            if(view_Dijkstra==true)
                            {



                                texto="_____________________________________________________________________";
                                document.add(new Paragraph(texto,FontFactory.getFont("arial",12,Font.BOLD,Color.BLUE)));
                                texto="SOURCE: ";                                  document.add(new Paragraph(texto,FontFactory.getFont("arial",12,Font.BOLD,Color.RED)));
                                texto="  "+nodo_dijkstra.conf.source.numeracion;   document.add(new Paragraph(texto));
                                texto="  "+nodo_dijkstra.conf.source.url_pagina;   document.add(new Paragraph(texto));
                                texto="TARGET PAGE: ";                             document.add(new Paragraph(texto,FontFactory.getFont("arial",12,Font.BOLD,Color.RED)));
                                texto="  "+nodo_dijkstra.conf.target.numeracion;   document.add(new Paragraph(texto));
                                texto="  "+nodo_dijkstra.conf.target.url_pagina;   document.add(new Paragraph(texto));                                                                
                                texto="";                                          document.add(new Paragraph(texto));


                                for(int i=0;i<numero_registros;i++)
                                {
                                    if(datos[i][0].compareTo("<html>_________________________________________________________________________________________________</html>")==0)
                                    {
                                        texto="_____________________________________________________________________";
                                        document.add(new Paragraph(texto,FontFactory.getFont("arial",12,Font.BOLD,Color.BLUE)));
                                        //i++;
                                        //texto=datos[i][0];            document.add(new Paragraph(texto));
                                        //texto="     " + datos[i][1] + " Value "+nodo_dijkstra.conf.tipo_dijkstra+": " + datos[i][2];
                                        //document.add(new Paragraph(texto));
                                        
                                    }
 else{
                                    texto="          "+datos[i][0]+"  ";//            document.add(new Paragraph(texto));
                                    texto=texto+datos[i][1]+"  ";            //document.add(new Paragraph(texto));
                                    texto=texto+" Value "+nodo_dijkstra.conf.tipo_dijkstra+": " +datos[i][2];    document.add(new Paragraph(texto));
                                    }//i++;
                                    //
                                }
                                //        texto="ERDA "; document.add(new Paragraph(texto));
                            }
                            else
                            {
                            for(int i=0;i<numero_registros;i++)
                            {
                                if(datos[i][0].compareTo("<html>_________________________________________________________________________________________________</html>")==0)
                                {
                                    texto="_____________________________________________________________________";
                                    document.add(new Paragraph(texto,FontFactory.getFont("arial",12,Font.BOLD,Color.BLUE))); i++;
                                }
                                //imprimo datos principales
                                texto="URL SOURCE: "+datos[i][1]; document.add(new Paragraph(texto,FontFactory.getFont("arial",12,Font.BOLD,Color.GREEN)));
                                texto="NUMERATION: "+datos[i][0]; document.add(new Paragraph(texto,FontFactory.getFont("arial",12,Font.BOLD,Color.GREEN)));

                                desplazar=0;

                                if (view_hits==true)
                                {
                                    desplazar=desplazar+1;
                                    texto="HITS AUTHORITY: "+datos[i][1+desplazar]; document.add(new Paragraph(texto));
                                    desplazar=desplazar+1;
                                    texto="HITS HUB      : "+datos[i][1+desplazar]; document.add(new Paragraph(texto));
                                }

                                if (view_pageRank==true)
                                {
                                    desplazar=desplazar+1;
                                    texto="PAGE RANK     : "+datos[i][1+desplazar]; document.add(new Paragraph(texto));
                                }

                                if (view_webLinks==true)
                                {
                                    desplazar=desplazar+1;
                                    texto="WEB LINKS     : "+datos[i][1+desplazar]; document.add(new Paragraph(texto));
                                }


                                entrantesI=Integer.valueOf(datos[i][2+desplazar]);
                                salientesI=Integer.valueOf(datos[i][3+desplazar]);
                                entrantesE=Integer.valueOf(datos[i][4+desplazar]);
                                salientesE=Integer.valueOf(datos[i][5+desplazar]);
                                /////////////////////////////////////////////////////////////////////////////////////////////////
                                if(entrantesI!=0)
                                {

                                    texto="     Internal In Links:";document.add(new Paragraph(texto,FontFactory.getFont("arial",12,Font.BOLD,Color.RED)));
                                    for(int j=0;j<entrantesI;j++)
                                    {
                                        i++;
                                        texto="          "+"["+datos[i][6+desplazar]+"] "+datos[i][2+desplazar]; document.add(new Paragraph(texto));
                                        int desplazar2=0;
                                        if (view_hits==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               HITS AUTHORITY: "+datos[i][6+desplazar+desplazar2]; document.add(new Paragraph(texto));
                                            desplazar2=desplazar2+1;
                                            texto="               HITS HUB      : "+datos[i][6+desplazar+desplazar2]; document.add(new Paragraph(texto));
                                        }

                                        if (view_pageRank==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               PAGE RANK     : "+datos[i][6+desplazar+desplazar2]; document.add(new Paragraph(texto));
                                        }

                                        if (view_webLinks==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               WEB LINKS     : "+datos[i][6+desplazar+desplazar2]; document.add(new Paragraph(texto));
                                        }
                                    }
                                }
                                /////////////////////////////////////////////////////////////////////////////////////////////////
                                if(salientesI!=0)
                                {

                                    texto="     Internal Out Links:";document.add(new Paragraph(texto,FontFactory.getFont("arial",12,Font.BOLD,Color.RED)));
                                    for(int j=0;j<salientesI;j++)
                                    {
                                        i++;
                                        texto="          "+"["+datos[i][6+desplazar]+"] "+datos[i][3+desplazar]; document.add(new Paragraph(texto));
                                        int desplazar2=0;
                                        if (view_hits==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               HITS AUTHORITY: "+datos[i][6+desplazar+desplazar2]; document.add(new Paragraph(texto));
                                            desplazar2=desplazar2+1;
                                            texto="               HITS HUB      : "+datos[i][6+desplazar+desplazar2]; document.add(new Paragraph(texto));
                                        }

                                        if (view_pageRank==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               PAGE RANK     : "+datos[i][6+desplazar+desplazar2]; document.add(new Paragraph(texto));
                                        }

                                        if (view_webLinks==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               WEB LINKS     : "+datos[i][6+desplazar+desplazar2]; document.add(new Paragraph(texto));
                                        }
                                    }
                                }
                                /////////////////////////////////////////////////////////////////////////////////////////////////
                                if(entrantesE!=0)
                                {

                                    texto="     External In Links:";document.add(new Paragraph(texto,FontFactory.getFont("arial",12,Font.BOLD,Color.RED)));
                                    for(int j=0;j<entrantesE;j++)
                                    {
                                        i++;
                                        texto="          "+"["+datos[i][6+desplazar]+"] "+datos[i][4+desplazar]; document.add(new Paragraph(texto));
                                        int desplazar2=0;
                                        if (view_hits==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               HITS AUTHORITY: "+datos[i][6+desplazar+desplazar2]; document.add(new Paragraph(texto));
                                            desplazar2=desplazar2+1;
                                            texto="               HITS HUB      : "+datos[i][6+desplazar+desplazar2]; document.add(new Paragraph(texto));
                                        }

                                        if (view_pageRank==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               PAGE RANK     : "+datos[i][6+desplazar+desplazar2]; document.add(new Paragraph(texto));
                                        }

                                        if (view_webLinks==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               WEB LINKS     : "+datos[i][6+desplazar+desplazar2]; document.add(new Paragraph(texto));
                                        }
                                    }
                                }
                                /////////////////////////////////////////////////////////////////////////////////////////////////
                                if(salientesE!=0)
                                {

                                    texto="     External Out Links:";document.add(new Paragraph(texto,FontFactory.getFont("arial",12,Font.BOLD,Color.RED)));
                                    for(int j=0;j<salientesE;j++)
                                    {
                                        i++;
                                        texto="          "+"["+datos[i][6+desplazar]+"] "+datos[i][5+desplazar]; document.add(new Paragraph(texto));
                                        int desplazar2=0;
                                        if (view_hits==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               HITS AUTHORITY: "+datos[i][6+desplazar+desplazar2]; document.add(new Paragraph(texto));
                                            desplazar2=desplazar2+1;
                                            texto="               HITS HUB      : "+datos[i][6+desplazar+desplazar2]; document.add(new Paragraph(texto));
                                        }

                                        if (view_pageRank==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               PAGE RANK     : "+datos[i][6+desplazar+desplazar2]; document.add(new Paragraph(texto));
                                        }

                                        if (view_webLinks==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               WEB LINKS     : "+datos[i][6+desplazar+desplazar2]; document.add(new Paragraph(texto));
                                        }
                                    }
                                }
                            }
                            }
                            //document.add(new Paragraph(texto));
                            document.close();
                            file.close();
                        }
                    }
                    catch (Exception e3) {
                        e3.printStackTrace();
                    }
                }
            }
        });

        btn_txt.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {
                JFileChooser fc = new JFileChooser();
                fc.setDialogTitle("Save TXT file");
                //fc.setCurrentDirectory(new File("."));//situarnos en el directorio actual
                boolean guardar=true;
                if(JFileChooser.APPROVE_OPTION==fc.showSaveDialog(null))
                {
                    String ruta=fc.getSelectedFile().getPath();
                    String nombre_archivo=fc.getSelectedFile().getName();
                    if(ruta.indexOf(".txt",0)==-1)
                    {
                        ruta=ruta+".txt";
                    }
                    File fFile=fc.getSelectedFile();
                    if(fFile.exists())
                    {
                        int confirmado = JOptionPane.showConfirmDialog(null,"This file exists, do you want replace?","CONFIRMATION",JOptionPane.YES_NO_OPTION);//tipo confirmacion
                        if (JOptionPane.OK_OPTION != confirmado) guardar=false;
                    }
                    try
                    {
                        if(guardar)
                        {
                            //JOptionPane.showMessageDialog(null, "Se guardo", "Error", JOptionPane.ERROR_MESSAGE);//tipo error
                            FileOutputStream archivo;
                            String texto="";
                            PrintStream p;
                            archivo= new FileOutputStream(ruta);
                            p= new PrintStream(archivo);
                            int entrantesI=0;
                            int salientesI=0;
                            int entrantesE=0;
                            int salientesE=0;
                            int desplazar=0;

                            if(view_Dijkstra==true)
                            {
                                texto="_____________________________________________________________________";p.println(texto);
                                texto="SOURCE: ";                                   p.println(texto);
                                texto="  "+nodo_dijkstra.conf.source.numeracion;    p.println(texto);
                                texto="  "+nodo_dijkstra.conf.source.url_pagina;    p.println(texto);
                                texto="";                                           p.println(texto);
                                texto="TARGET PAGE: ";                              p.println(texto);
                                texto="  "+nodo_dijkstra.conf.target.numeracion;    p.println(texto);
                                texto="  "+nodo_dijkstra.conf.target.url_pagina;    p.println(texto);
                                texto="_____________________________________________________________________";p.println(texto);
                                texto="";                                           p.println(texto);

                                //int num_ruta=0;
                                for(int i=0;i<numero_registros;i++)
                                {

                                    if(datos[i][0].compareTo("<html>_________________________________________________________________________________________________</html>")==0)
                                    {
                                        texto="_____________________________________________________________________";
                                        p.println(texto); i++; //num_ruta++;
                                        texto=datos[i][0];            p.println(texto);
                                        texto="     " + datos[i][1] + " Value "+nodo_dijkstra.conf.tipo_dijkstra+": " + datos[i][2];
                                        i++;
                                        p.println(texto);
                                    }
                                    texto="          "+datos[i][0]+"  ";            p.print(texto);
                                    texto=datos[i][1]+"  ";            p.print(texto);
                                    texto=" Value "+nodo_dijkstra.conf.tipo_dijkstra+": " +datos[i][2];        p.print(texto);
                                    p.println("");
                                }
                            }
                            else
                            {
                            for(int i=0;i<numero_registros;i++)
                            {
                                if(datos[i][0].compareTo("<html>_________________________________________________________________________________________________</html>")==0)
                                {
                                    texto="_____________________________________________________________________";
                                    p.println(texto); i++;
                                }
                                //imprimo datos principales
                                texto="URL SOURCE: "+datos[i][1]; p.println(texto);
                                texto="NUMERATION: "+datos[i][0]; p.println(texto);
                                
                                desplazar=0;

                                if (view_hits==true)
                                {
                                    desplazar=desplazar+1;
                                    texto="HITS AUTHORITY: "+datos[i][1+desplazar]; p.println(texto);
                                    desplazar=desplazar+1;
                                    texto="HITS HUB      : "+datos[i][1+desplazar]; p.println(texto);
                                }

                                if (view_pageRank==true)
                                {
                                    desplazar=desplazar+1;
                                    texto="PAGE RANK     : "+datos[i][1+desplazar]; p.println(texto);
                                }

                                if (view_webLinks==true)
                                {
                                    desplazar=desplazar+1;
                                    texto="WEB LINKS     : "+datos[i][1+desplazar]; p.println(texto);
                                }

                                entrantesI=Integer.valueOf(datos[i][2+desplazar]);
                                salientesI=Integer.valueOf(datos[i][3+desplazar]);
                                entrantesE=Integer.valueOf(datos[i][4+desplazar]);
                                salientesE=Integer.valueOf(datos[i][5+desplazar]);
                                /////////////////////////////////////////////////////////////////////////////////////////////////
                                if(entrantesI!=0)
                                {
                                    
                                    texto="     Internal In Links:";p.println(texto);
                                    for(int j=0;j<entrantesI;j++)
                                    {
                                        i++;
                                        texto="          "+"["+datos[i][6+desplazar]+"] "+datos[i][2+desplazar]; p.println(texto);
                                        int desplazar2=0;
                                        if (view_hits==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               HITS AUTHORITY: "+datos[i][6+desplazar+desplazar2]; p.println(texto);
                                            desplazar2=desplazar2+1;
                                            texto="               HITS HUB      : "+datos[i][6+desplazar+desplazar2]; p.println(texto);
                                        }

                                        if (view_pageRank==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               PAGE RANK     : "+datos[i][6+desplazar+desplazar2]; p.println(texto);
                                        }

                                        if (view_webLinks==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               WEB LINKS     : "+datos[i][6+desplazar+desplazar2]; p.println(texto);
                                        }
                                    }
                                }
                                /////////////////////////////////////////////////////////////////////////////////////////////////
                                if(salientesI!=0)
                                {
 
                                    texto="     Internal Out Links:";p.println(texto);
                                    for(int j=0;j<salientesI;j++)
                                    {
                                        i++;
                                        texto="          "+"["+datos[i][6+desplazar]+"] "+datos[i][3+desplazar]; p.println(texto);
                                        int desplazar2=0;
                                        if (view_hits==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               HITS AUTHORITY: "+datos[i][6+desplazar+desplazar2]; p.println(texto);
                                            desplazar2=desplazar2+1;
                                            texto="               HITS HUB      : "+datos[i][6+desplazar+desplazar2]; p.println(texto);
                                        }

                                        if (view_pageRank==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               PAGE RANK     : "+datos[i][6+desplazar+desplazar2]; p.println(texto);
                                        }

                                        if (view_webLinks==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               WEB LINKS     : "+datos[i][6+desplazar+desplazar2]; p.println(texto);
                                        }
                                    }
                                }
                                /////////////////////////////////////////////////////////////////////////////////////////////////
                                if(entrantesE!=0)
                                {
 
                                    texto="     External In Links:";p.println(texto);
                                    for(int j=0;j<entrantesE;j++)
                                    {
                                        i++;
                                        texto="          "+"["+datos[i][6+desplazar]+"] "+datos[i][4+desplazar]; p.println(texto);
                                        int desplazar2=0;
                                        if (view_hits==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               HITS AUTHORITY: "+datos[i][6+desplazar+desplazar2]; p.println(texto);
                                            desplazar2=desplazar2+1;
                                            texto="               HITS HUB      : "+datos[i][6+desplazar+desplazar2]; p.println(texto);
                                        }

                                        if (view_pageRank==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               PAGE RANK     : "+datos[i][6+desplazar+desplazar2]; p.println(texto);
                                        }

                                        if (view_webLinks==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               WEB LINKS     : "+datos[i][6+desplazar+desplazar2]; p.println(texto);
                                        }
                                    }
                                }
                                /////////////////////////////////////////////////////////////////////////////////////////////////
                                if(salientesE!=0)
                                {
 
                                    texto="     External Out Links:";p.println(texto);
                                    for(int j=0;j<salientesE;j++)
                                    {
                                        i++;
                                        texto="          "+"["+datos[i][6+desplazar]+"] "+datos[i][5+desplazar]; p.println(texto);
                                        int desplazar2=0;
                                        if (view_hits==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               HITS AUTHORITY: "+datos[i][6+desplazar+desplazar2]; p.println(texto);
                                            desplazar2=desplazar2+1;
                                            texto="               HITS HUB      : "+datos[i][6+desplazar+desplazar2]; p.println(texto);
                                        }

                                        if (view_pageRank==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               PAGE RANK     : "+datos[i][6+desplazar+desplazar2]; p.println(texto);
                                        }

                                        if (view_webLinks==true)
                                        {
                                            desplazar2=desplazar2+1;
                                            texto="               WEB LINKS     : "+datos[i][6+desplazar+desplazar2]; p.println(texto);
                                        }
                                    }
                                }
                            }
                            }
                            //texto="hola todos este es el txt d prueba";
                            //p.println(texto);
                            p.close();
                        }
                        else
                        {
                          //  JOptionPane.showMessageDialog(null, "Pailas no se guardo", "Error", JOptionPane.ERROR_MESSAGE);//tipo error

                        }
                    }
                    catch(Exception ee)
                    {
                    }
                }

            }
        });

        btn_html.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {
                JFileChooser fc = new JFileChooser();
                //fc.setCurrentDirectory(new File("."));//situarnos en el directorio actual
                fc.setDialogTitle("Save HTML file");
                boolean guardar=true;
                if(JFileChooser.APPROVE_OPTION==fc.showSaveDialog(null))
                {
                    String ruta=fc.getSelectedFile().getPath();
                    String nombre_archivo=fc.getSelectedFile().getName();
                    if(ruta.indexOf(".htm",0)==-1)
                    {
                        ruta=ruta+".html";
                    }
                    File fFile=fc.getSelectedFile();
                    if(fFile.exists())
                    {
                        int confirmado = JOptionPane.showConfirmDialog(null,"This file exists, do you want replace?","CONFIRMATION",JOptionPane.YES_NO_OPTION);//tipo confirmacion
                        if (JOptionPane.OK_OPTION != confirmado) guardar=false;
                    }
                    try
                    {
                        if(guardar)
                        {
                            //JOptionPane.showMessageDialog(null, "Se guardo", "Error", JOptionPane.ERROR_MESSAGE);//tipo error
                            FileOutputStream archivo;
                            //String texto="";
                            PrintStream p;
                            archivo= new FileOutputStream(ruta);
                            p= new PrintStream(archivo);
                            
                            p.println("<html>");
                            p.println("<head>");
                            p.println("<title>");
                            p.println("PAGINA HTML");
                            p.println("</title>");
                            p.println("</head>");
                            p.println("<body>");
                            //p.println("POLARIS");
                            p.println("<table border=\"1\" align=\"center\">");


                            if(view_Dijkstra==true)
                            {
                                p.println("<tr>");
                                    p.println("<td colspan=\"4\" align=\"center\">");
                                            p.println("SOURCE: "+nodo_dijkstra.conf.source.numeracion);
                                            p.println("<br />");
                                            p.println("  "+nodo_dijkstra.conf.source.url_pagina);
                                            p.println("<br />");
                                            p.println("<br />");
                                            p.println("TARGET PAGE: "+nodo_dijkstra.conf.target.numeracion);
                                            p.println("<br />");
                                            p.println("  "+nodo_dijkstra.conf.target.url_pagina);
                                    p.println("</td>");
                                p.println("</tr>");
                                /*

                                    texto="          "+datos[i][0]+"  ";            document.add(new Paragraph(texto));
                                    texto=datos[i][1]+"  ";            document.add(new Paragraph(texto));
                                    texto=" Value "+nodo_dijkstra.conf.tipo_dijkstra+": " +datos[i][2];    document.add(new Paragraph(texto));
                                    texto=" "; document.add(new Paragraph(texto));

                                 */


                                p.println("<tr>");
                                    p.print("<td>");p.println("  Numeration ");           p.print("</td>");
                                    p.print("<td>");p.println("  URL"); p.print("</td>");
                                    p.print("<td>");p.println("  value "+nodo_dijkstra.conf.tipo_dijkstra );       p.print("</td>");
                                p.println("</tr>");
                                for(int i=0;i<numero_registros;i++)
                                {
                                    p.println("<tr>");
                                    for(int j=0;j<3;j++)
                                    {
                                        if(datos[i][j].compareTo("<html>_________________________________________________________________________________________________</html>")==0)
                                        {
                                            p.print("<td bgcolor=\"#339966\">");
                                            p.print("&nbsp;");
                                            p.println("</td>");
                                        }
                                        else
                                        {
                                            p.print("<td>");
                                            p.print(datos[i][j]);
                                            p.println("</td>");                                        
                                        }
                                    }
                                    p.println("</tr>");


                                }
                            }
                            else
                            {
                                p.println("<tr>");
                                for(int a=0;a<numero_columnas;a++)
                                {
                                    p.print("<td bgcolor=\"#FFCC66\">");
                                    p.print(nom_columnas[a]);
                                    p.println("</td>");
                                }
                                p.println("</tr>");

                                for(int i=1;i<numero_registros;i++)
                                {
                                    p.println("<tr>");

                                    for(int j=0;j<numero_columnas;j++)
                                    {
                                        if(datos[i][0].compareTo("<html>_________________________________________________________________________________________________</html>")==0)
                                        {
                                            p.print("<td bgcolor=\"#339966\">");
                                            p.print("&nbsp;");
                                            p.println("</td>");
                                        }
                                        else
                                        {
                                            p.print("<td>");
                                            p.print(datos[i][j]);
                                            p.println("</td>");
                                        }
                                    }
                                    p.println("</tr>");
                                }
                            }
                            p.println("</table>");
                            p.println("</body>");
                            p.println("</html>");
                            p.close();
                        }
                    }
                    catch(Exception ee)
                    {
                    }
                }
            }
        });
    }
}