/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * treeViewFrame.java
 *
 * Created on 9/10/2010, 12:30:33 AM
 */

package polaris2.view;


import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;

import javax.swing.AbstractAction;
import java.io.IOException;
import java.util.Iterator;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.SwingConstants;
import polaris2.site.enlace;
import polaris2.site.pagina;
import polaris2.site.sitio;
import prefuse.Constants;
import prefuse.Display;
import prefuse.Visualization;
import prefuse.action.Action;
import prefuse.action.ActionList;
import prefuse.action.ItemAction;
import prefuse.action.RepaintAction;
import prefuse.action.animate.ColorAnimator;
import prefuse.action.animate.LocationAnimator;
import prefuse.action.animate.QualityControlAnimator;
import prefuse.action.animate.VisibilityAnimator;
import prefuse.action.assignment.ColorAction;
import prefuse.action.assignment.DataColorAction;
import prefuse.action.assignment.FontAction;
import prefuse.action.filter.FisheyeTreeFilter;
import prefuse.action.layout.CollapsedSubtreeLayout;
import prefuse.action.layout.graph.NodeLinkTreeLayout;
import prefuse.activity.SlowInSlowOutPacer;
import prefuse.controls.*;
import polaris2.graph.Nodo;
import prefuse.controls.Control;
import prefuse.data.Edge;
import prefuse.data.Node;
import prefuse.data.Table;
import prefuse.data.Tree;
import prefuse.data.Tuple;
import prefuse.data.event.TupleSetListener;
import prefuse.data.search.PrefixSearchTupleSet;
import prefuse.data.tuple.TupleSet;
import prefuse.render.DefaultRendererFactory;
import prefuse.render.EdgeRenderer;
import prefuse.render.AbstractShapeRenderer;
import prefuse.render.LabelRenderer;
import prefuse.util.ColorLib;
import prefuse.util.FontLib;
import prefuse.visual.VisualItem;
import prefuse.visual.expression.InGroupPredicate;
import prefuse.visual.sort.TreeDepthItemSorter;
import prefuse.util.ui.JFastLabel;

/**
 *
 * @author santos
 */
public class treeViewFrame extends javax.swing.JFrame {

    private String urlAbrir="";
    public sitio sitio_web=null;
    public sitio sitio_web2=null;
    public Nodo links=null;
    public Nodo n=null;
    public boolean view_hits=false;
    public boolean view_pageRank=false;
    public boolean view_webLinks=false;
    public int dataProcceshits=0;
    public int dataProccesPageRank=0;
    public int dataProccesWebLinker=0;

    private static final String tree = "tree";
    private static final String treeNodes = "tree.nodes";
    private static final String treeEdges = "tree.edges";
    static final int WHEN_FOCUSED = 0;
    Visualization m_vis = new Visualization();
    private LabelRenderer m_nodeRenderer;
    private EdgeRenderer m_edgeRenderer;
    private JFastLabel m_total = new JFastLabel("");
    private JFastLabel m_details;

    private String m_label = "label";
    private int cantidad=0;
    private int m_orientation = Constants.ORIENT_LEFT_RIGHT;
    //private Visualization vis=new Visualization();
    private Display display=new Display(m_vis);

    

    /** Creates new form treeViewFrame */
    public treeViewFrame() {
        initComponents();
        this.setIconImage(this.getImage("/media/star.png"));
    }

    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        panel_visor = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Tree View");

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Node Info"));

        panel_visor.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));

        javax.swing.GroupLayout panel_visorLayout = new javax.swing.GroupLayout(panel_visor);
        panel_visor.setLayout(panel_visorLayout);
        panel_visorLayout.setHorizontalGroup(
            panel_visorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 490, Short.MAX_VALUE)
        );
        panel_visorLayout.setVerticalGroup(
            panel_visorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 486, Short.MAX_VALUE)
        );

        jTextArea1.setColumns(20);
        jTextArea1.setEditable(false);
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);

        jButton1.setText("Go to URL");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setText(">");
        jButton2.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setText("<");
        jButton3.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jButton4.setText("v");
        jButton4.setAlignmentY(0.0F);
        jButton4.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jButton5.setText("^");
        jButton5.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton5, javax.swing.GroupLayout.DEFAULT_SIZE, 29, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton2, javax.swing.GroupLayout.DEFAULT_SIZE, 29, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton1))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 223, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(panel_visor, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(panel_visor, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jButton1)
                            .addComponent(jButton3)
                            .addComponent(jButton5)
                            .addComponent(jButton2)
                            .addComponent(jButton4))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 459, Short.MAX_VALUE)))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 753, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if(urlAbrir.length()!=0)
        {
            String osName = System.getProperty("os.name");
            try {
                if (osName.startsWith("Windows")) {
                    Runtime.getRuntime().exec("rundll32 url.dll,FileProtocolHandler " + urlAbrir);
                } else if (osName.startsWith("Mac OS X")) {
                    // Runtime.getRuntime().exec("open -a safari " + url);
                    // Runtime.getRuntime().exec("open " + url + "/index.html");
                    Runtime.getRuntime().exec("open " + urlAbrir);
                } else {
                    System.out.println("Please open a browser and go to "+ urlAbrir);
                }
            }
            catch (IOException e)
            {
                System.out.println("Failed to start a browser to open the url " + urlAbrir +e.toString());
                //e.printStackTrace();
            }
        }
}//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // TODO add your handling code here:
        this.setOrientation(0);
        display.getVisualization().run("treeLayout");
        display.getVisualization().run("orient");
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // TODO add your handling code here:
        this.setOrientation(1);
        display.getVisualization().run("treeLayout");
        display.getVisualization().run("orient");
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        // TODO add your handling code here:
        //tercero
        this.setOrientation(2);
        display.getVisualization().run("treeLayout");
        display.getVisualization().run("orient");
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        // TODO add your handling code here:
        //cuarto
        this.setOrientation(3);
        display.getVisualization().run("treeLayout");
        display.getVisualization().run("orient");
    }//GEN-LAST:event_jButton5ActionPerformed

    public final void crear_grafico(){

        //Visualization m_vis = new Visualization();
        Table table = new Table();

        table.addColumn("name", String.class);
        table.addColumn("color", int.class);
        table.addColumn("id_pag", int.class);
        table.addColumn("url", String.class);

        //Table edges=null;
        Table edges = new Table();
        edges.addColumn("id1", int.class);
        edges.addColumn("id2", int.class);
        edges.addColumn("color", int.class);

        final Tree t = new Tree(table, edges, "id1", "id2");


        //creo un sitio para ir agregando paginas
        sitio sitio_temp=new sitio();
        enlace aux_enlace=null;
        Node nuevo_nodo=null;
        Edge ed=null;
        pagina aux_pagina=sitio_web.pagina_inicial;
        while(aux_pagina!=null)
        {
            //se busca si ya fue agregada
            if(sitio_temp.buscar_pagina_numeracion(aux_pagina.numeracion)==null)
            {//no esta registrada
                aux_pagina.no = t.addNode();
                aux_pagina.no.set("name",aux_pagina.numeracion);
                aux_pagina.no.set("id_pag",aux_pagina.id_pagina);
                aux_pagina.no.set("color",0);//color 0 seria blanco
                aux_pagina.no.set("url",aux_pagina.url_pagina);//color 0 seria blanco
                sitio_temp.adicionar_pagina(aux_pagina,aux_pagina.nivel);
            }
            //if(aux_pagina.numeracion.compareTo("3.15")==0)
            //{
            //   System.out.print("ss");
            //}

            for(int j=0;j<4;j++)
            {
                aux_enlace=null;
                if(j==3) aux_enlace=aux_pagina.pri_entrantesE;
                if(j==2) aux_enlace=aux_pagina.pri_entrantesI;
                if(j==1) aux_enlace=aux_pagina.pri_salientesE;
                if(j==0) aux_enlace=aux_pagina.pri_salientesI;


                while(aux_enlace!=null)
                {
                    //se busca si ya fue agregada
                    if(sitio_temp.buscar_pagina_numeracion(aux_enlace.destino.numeracion)==null)
                    {//no esta registrada
                        aux_enlace.destino.no = t.addNode();
                        aux_enlace.destino.no.set("name",aux_enlace.destino.numeracion);
                        aux_enlace.destino.no.set("id_pag",aux_enlace.destino.id_pagina);
                        aux_enlace.destino.no.set("color",0);//color 0 seria blanco
                        aux_enlace.destino.no.set("url",aux_enlace.destino.url_pagina);//color 0 seria blanco
                        sitio_temp.adicionar_pagina(aux_enlace.destino,aux_enlace.destino.nivel);

                        ed=t.addEdge(aux_pagina.no, aux_enlace.destino.no);
                        if(j==0) ed.set("color",0);
                        if(j==1) ed.set("color",1);
                        if(j==2) ed.set("color",2);
                        if(j==3) ed.set("color",3);
                    }
                    else
                    {// ya esta registrada
                        nuevo_nodo=t.addNode();
                        nuevo_nodo.set("name",aux_enlace.destino.numeracion);
                        nuevo_nodo.set("id_pag",aux_enlace.destino.id_pagina);
                        nuevo_nodo.set("color",1);//color 1 seria azul (es un nodo que ya existe no se sigue expandiendo)
                        nuevo_nodo.set("url",aux_enlace.destino.url_pagina);//color 0 seria blanco
                        ed=t.addEdge(aux_pagina.no, nuevo_nodo);
                        if(j==0) ed.set("color",0);
                        if(j==1) ed.set("color",1);
                        if(j==2) ed.set("color",2);
                        if(j==3) ed.set("color",3);
                    }
                    aux_enlace=aux_enlace.sig_enlace;
                }
            }
            aux_pagina=aux_pagina.sig_pag;
        }

        Control hoverc = new ControlAdapter() {
           public void itemEntered(VisualItem item, MouseEvent evt)
            {
                if ( item.canGetString("url") )
                {
                    String nom=item.getString("url");
                    pagina pag_bus=sitio_web.buscar_pagina(nom);
                    if(pag_bus==null)m_total.setText("----");
                    else m_total.setText(pag_bus.nombre_pagina);
                }

                //item.setFillColor(item.getStrokeColor());
                //item.setStrokeColor(ColorLib.rgb(255,255,0));
                //item.getVisualization().repaint();
            }
            public void itemExited(VisualItem item, MouseEvent evt) {
                 m_total.setText("-");
                 //item.setFillColor(item.getEndFillColor());
                 //item.setStrokeColor(item.getEndStrokeColor());
                 //item.getVisualization().repaint();
            }

            public void itemPressed(VisualItem item, MouseEvent e) {

                if ( item.canGetString("url") )
                {
                    pagina p=sitio_web.buscar_pagina(item.getString("url"));
                    pagina p2=sitio_web2.buscar_pagina(item.getString("url"));
                    String texto="";
                    String texto2="";
                    texto=texto+"URL:        \n     "+p.url_pagina+"\n";
                    urlAbrir=p.url_pagina;
                    texto=texto+"__________________________________________\n";
                    texto=texto+"Numeration: "+p.numeracion+"\n";
                    texto=texto+"Id: "+String.valueOf(p.id_pagina)+"\n";
                    int num_entrantes=p.num_enlaces_EE+p.num_enlaces_EI;
                    int num_salientes=p.num_enlaces_SE+p.num_enlaces_SI;
                    texto=texto+"In Links : "+String.valueOf(num_entrantes)+"\n";
                    texto=texto+"Out Links : "+String.valueOf(num_salientes)+"\n";
                    texto=texto+"Filter Links : "+"\n     ";
                    if(links.conf.ExternalInLinks==true)    texto2=texto2+"External In ,";
                    if(links.conf.ExternalOutLinks==true)   texto2=texto2+"External Out ,";
                    if(links.conf.InternalInLinks==true)    texto2=texto2+"Internal In ,";
                    if(links.conf.InternalOutLinks==true)   texto2=texto2+"Internal Out ";
                    texto=texto+texto2+"\n";
                    texto=texto+"__________________________________________\n";
                    texto=texto+"Internal In Links (blue)  :\n     "+String.valueOf(p.num_enlaces_EI)+"\n";
                    texto=texto+"Internal Out Links (red)  :\n     "+String.valueOf(p.num_enlaces_SI)+"\n";
                    texto=texto+"External In Links (Yellow):\n     "+String.valueOf(p.num_enlaces_EE)+"\n";
                    texto=texto+"External Out Links (green):\n     "+String.valueOf(p.num_enlaces_SE)+"\n";
                    texto=texto+"__________________________________________\n";
                    if(view_pageRank)
                    {
                        texto=texto+"Page Rank:\n     "+String.valueOf(p2.ValuePageRank)+"\n";
                        texto=texto+"     Total data procces: "+String.valueOf(dataProccesPageRank)+"\n";
                        texto=texto+"__________________________________________\n";
                    }
                    if(view_hits){
                        texto=texto+"Hits:\n";
                        texto=texto+"     Authority Score: "+String.valueOf(p2.ValueHitsAutority)+"\n";
                        texto=texto+"     HUB Score      : "+String.valueOf(p2.ValueHitsHUB)+"\n";
                        texto=texto+"     Total data procces: "+String.valueOf(dataProcceshits)+"\n";
                        texto=texto+"__________________________________________\n";
                    }
                    if(view_webLinks)
                    {
                        texto=texto+"Web Links:\n     "+String.valueOf(p.ValueVisit)+"\n";
                        texto=texto+"     maximum number links: "+String.valueOf(dataProccesWebLinker)+"\n";
                        texto=texto+"__________________________________________\n";
                    }
                    jTextArea1.setText(texto);
                }
            }
        };



        //*******************************************************************
        m_vis.add(tree, t);//adicionar arbol a la visualizacion
        m_nodeRenderer = new LabelRenderer("url");//que valor contendra la etiqueta de cada nodo
        m_nodeRenderer.setRenderType(AbstractShapeRenderer.RENDER_TYPE_FILL);
        m_nodeRenderer.setHorizontalAlignment(Constants.LEFT);
        m_nodeRenderer.setRoundedCorner(8,8);
        m_edgeRenderer = new EdgeRenderer(Constants.EDGE_TYPE_CURVE);

        DefaultRendererFactory rf = new DefaultRendererFactory(m_nodeRenderer);
        rf.add(new InGroupPredicate(treeEdges), m_edgeRenderer);
        m_vis.setRendererFactory(rf);

         // CERACION DE COLORES DE LOS ELEMENTOS
       int[] palette = new int[] { ColorLib.rgb(255,200,200), ColorLib.rgb(0,255,0), ColorLib.rgb(0,0,255), ColorLib.rgb(200,200,0), ColorLib.rgb(0,0,0), ColorLib.rgb(200,200,255) };// ColorLib.rgb converts the colour values to integers
       int[] palette2 = new int[] { ColorLib.rgb(255,0,0), ColorLib.rgb(0,255,0), ColorLib.rgb(0,0,255), ColorLib.rgb(255,255,000)};// ColorLib.rgb converts the colour values to integers
       DataColorAction fill = new DataColorAction(treeNodes, "color",Constants.NOMINAL, VisualItem.FILLCOLOR, palette);
       //ColorAction text = new ColorAction(treeNodes, VisualItem.TEXTCOLOR, ColorLib.gray(0));
       DataColorAction edges1 = new DataColorAction(treeEdges,"color",Constants.NOMINAL, VisualItem.STROKECOLOR, palette2);
       DataColorAction edges2 = new DataColorAction(treeEdges,"color",Constants.NOMINAL, VisualItem.FILLCOLOR, palette2);


        //ActionList colour = new ActionList();//LISTADO DE TODOS LOS COLORES QUE TOMARAN LOS OBJETOS
        //colour.add(fill);//ADICIONAR LA CARACTERISTICA DE COLOR DE LOS NODOS
        //colour.add(text);//ADICIONAR LA CARACTERISTICA DE COLOR DEL TEXTO
        //colour.add(edges1);//ADICIONAR LA CARACTERISTICA DE COLOR DE LA PUNTA DE LOS EDGES
        //colour.add(edges2);//ADICIONAR LA CARACTERISTICA DE COLOR DE LOS EDGES

        ItemAction nodeColor = new NodeColorAction(treeNodes);
        ItemAction textColor = new ColorAction(treeNodes,
        VisualItem.TEXTCOLOR, ColorLib.rgb(0,0,0));
        m_vis.putAction("textColor", textColor);

        //ItemAction edgeColor = new ColorAction(treeEdges,VisualItem.STROKECOLOR, ColorLib.rgb(200,200,200));

        // quick repaint
        ActionList repaint = new ActionList();
        repaint.add(nodeColor);
        repaint.add(new RepaintAction());
        m_vis.putAction("repaint", repaint);

        // full paint
        ActionList fullPaint = new ActionList();
        fullPaint.add(nodeColor);
        m_vis.putAction("fullPaint", fullPaint);

        // animate paint change
        ActionList animatePaint = new ActionList(400);
        animatePaint.add(new ColorAnimator(treeNodes));
        animatePaint.add(new RepaintAction());
        m_vis.putAction("animatePaint", animatePaint);

        // create the tree layout action
        NodeLinkTreeLayout treeLayout = new NodeLinkTreeLayout(tree,m_orientation, 50, 0, 8);
        treeLayout.setLayoutAnchor(new Point2D.Double(25,300));
        m_vis.putAction("treeLayout", treeLayout);

        CollapsedSubtreeLayout subLayout =new CollapsedSubtreeLayout(tree, m_orientation);
        m_vis.putAction("subLayout", subLayout);

        AutoPanAction autoPan = new AutoPanAction();

        // create the filtering and layout
        ActionList filter = new ActionList();
        filter.add(new FisheyeTreeFilter(tree, 2));
        filter.add(new FontAction(treeNodes, FontLib.getFont("Tahoma", 16)));
        filter.add(treeLayout);
        filter.add(subLayout);
        filter.add(textColor);
        filter.add(nodeColor);
        //filter.add(edgeColor);
        filter.add(fill);//ADICIONAR LA CARACTERISTICA DE COLOR DE LOS NODOS
        //filter.add(text);//ADICIONAR LA CARACTERISTICA DE COLOR DEL TEXTO
        filter.add(edges1);//ADICIONAR LA CARACTERISTICA DE COLOR DE LA PUNTA DE LOS EDGES
        filter.add(edges2);//ADICIONAR LA CARACTERISTICA DE COLOR DE LOS EDGES
        //filter.add(nodeColor);//mias
        //filter.add(edgeColor);
        m_vis.putAction("filter", filter);

        //REASIGNACION DE COLORES A LOS EDGES Y NODOS
        Iterator iter = m_vis.items(treeEdges);
        while ( iter.hasNext() ) {
            VisualItem item = (VisualItem)iter.next();
            int caso=item.getInt("color");
            switch (caso)
            {
                case 0://(verde) edges
                    item.setFillColor(ColorLib.rgb(0,255,0));
                    item.setStrokeColor(ColorLib.rgb(0,255,0));
                    item.getVisualization().repaint();
                break;
                case 1://(azul) edges
                    item.setFillColor(ColorLib.rgb(0,0,255));
                    item.setStrokeColor(ColorLib.rgb(0,0,255));
                    item.getVisualization().repaint();
                break;
                case 2://(rojo) edges
                    item.setFillColor(ColorLib.rgb(255,0,0));
                    item.setStrokeColor(ColorLib.rgb(255,0,0));
                    item.getVisualization().repaint();
                break;
                case 3://(negro) edges
                    item.setFillColor(ColorLib.rgb(0,0,0));
                    item.setStrokeColor(ColorLib.rgb(0,0,0));
                    item.getVisualization().repaint();
                break;


            }
        }


        // animated transition
        ActionList animate = new ActionList(1000);
        animate.setPacingFunction(new SlowInSlowOutPacer());
        animate.add(autoPan);
        animate.add(new QualityControlAnimator());
        animate.add(new VisibilityAnimator(tree));
        animate.add(new LocationAnimator(treeNodes));
        animate.add(new ColorAnimator(treeNodes));
        animate.add(new RepaintAction());
        m_vis.putAction("animate", animate);
        m_vis.alwaysRunAfter("filter", "animate");

        // create animator for orientation changes
        ActionList orient = new ActionList(2000);
        orient.setPacingFunction(new SlowInSlowOutPacer());
        orient.add(autoPan);
        orient.add(new QualityControlAnimator());
        orient.add(new LocationAnimator(treeNodes));
        orient.add(new RepaintAction());
        m_vis.putAction("orient", orient);

        setSize(700,600);
        display.addControlListener(hoverc);                 //AGREGAR LOS EVENTOS CREADOS EN hoverc
        display.setItemSorter(new TreeDepthItemSorter());
        display.addControlListener(new ZoomToFitControl());
        display.addControlListener(new ZoomControl());
        display.addControlListener(new WheelZoomControl());
        display.addControlListener(new PanControl());
        display.addControlListener(new FocusControl(1, "filter"));

        // ------------------------------------------------

        // filter graph and perform layout
        setOrientation(m_orientation);
        m_vis.run("filter");

        TupleSet search = new PrefixSearchTupleSet();
        m_vis.addFocusGroup(Visualization.SEARCH_ITEMS, search);
        search.addTupleSetListener(new TupleSetListener() {
            public void tupleSetChanged(TupleSet t, Tuple[] add, Tuple[] rem) {
                m_vis.cancel("animatePaint");
                m_vis.run("fullPaint");
                m_vis.run("animatePaint");
            }
        });

        m_details = new JFastLabel("Details:");
        m_details.setPreferredSize(new Dimension(75,20));
        m_details.setVerticalAlignment(SwingConstants.BOTTOM);
        m_total.setPreferredSize(new Dimension(500,20));
        m_total.setHorizontalAlignment(SwingConstants.RIGHT);
        m_total.setVerticalAlignment(SwingConstants.BOTTOM);

        // DETALLES DE LA PARTE SUPERIOR DEL GRAFO
        Box infoBox = new Box(BoxLayout.X_AXIS);
        infoBox.add(Box.createHorizontalStrut(5));
        infoBox.add(m_details);
        infoBox.add(Box.createHorizontalGlue());
        infoBox.add(Box.createHorizontalStrut(5));
        infoBox.add(m_total);
        infoBox.add(Box.createHorizontalStrut(5));

        this.panel_visor.setLayout(new BorderLayout());
        this.panel_visor.add(display,BorderLayout.CENTER);
        this.panel_visor.add(infoBox,BorderLayout.NORTH);
        this.panel_visor.updateUI();
        
        

    }   

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new treeViewFrame().setVisible(true);
            }
        });
    }


    public void setOrientation(int orientation) {
        NodeLinkTreeLayout rtl
            = (NodeLinkTreeLayout)m_vis.getAction("treeLayout");
        CollapsedSubtreeLayout stl
            = (CollapsedSubtreeLayout)m_vis.getAction("subLayout");
        switch ( orientation ) {
        case Constants.ORIENT_LEFT_RIGHT:
            m_nodeRenderer.setHorizontalAlignment(Constants.LEFT);
            m_edgeRenderer.setHorizontalAlignment1(Constants.RIGHT);
            m_edgeRenderer.setHorizontalAlignment2(Constants.LEFT);
            m_edgeRenderer.setVerticalAlignment1(Constants.CENTER);
            m_edgeRenderer.setVerticalAlignment2(Constants.CENTER);
            break;
        case Constants.ORIENT_RIGHT_LEFT:
            m_nodeRenderer.setHorizontalAlignment(Constants.RIGHT);
            m_edgeRenderer.setHorizontalAlignment1(Constants.LEFT);
            m_edgeRenderer.setHorizontalAlignment2(Constants.RIGHT);
            m_edgeRenderer.setVerticalAlignment1(Constants.CENTER);
            m_edgeRenderer.setVerticalAlignment2(Constants.CENTER);
            break;
        case Constants.ORIENT_TOP_BOTTOM:
            m_nodeRenderer.setHorizontalAlignment(Constants.CENTER);
            m_edgeRenderer.setHorizontalAlignment1(Constants.CENTER);
            m_edgeRenderer.setHorizontalAlignment2(Constants.CENTER);
            m_edgeRenderer.setVerticalAlignment1(Constants.BOTTOM);
            m_edgeRenderer.setVerticalAlignment2(Constants.TOP);
            break;
        case Constants.ORIENT_BOTTOM_TOP:
            m_nodeRenderer.setHorizontalAlignment(Constants.CENTER);
            m_edgeRenderer.setHorizontalAlignment1(Constants.CENTER);
            m_edgeRenderer.setHorizontalAlignment2(Constants.CENTER);
            m_edgeRenderer.setVerticalAlignment1(Constants.TOP);
            m_edgeRenderer.setVerticalAlignment2(Constants.BOTTOM);
            break;
        default:
            throw new IllegalArgumentException(
                "Unrecognized orientation value: "+orientation);
        }
        m_orientation = orientation;
        rtl.setOrientation(orientation);
        stl.setOrientation(orientation);
    }

    public int getOrientation() {
        return m_orientation;
    }   

    public class OrientAction extends AbstractAction {
        private int orientation;

        public OrientAction(int orientation) {
            this.orientation = orientation;
        }
        public void actionPerformed(ActionEvent evt) {
            setOrientation(orientation);
            display.getVisualization().cancel("orient");
            display.getVisualization().run("treeLayout");
            display.getVisualization().run("orient");
        }
    }

    public class AutoPanAction extends Action {
        private Point2D m_start = new Point2D.Double();
        private Point2D m_end   = new Point2D.Double();
        private Point2D m_cur   = new Point2D.Double();
        private int     m_bias  = 150;

        public void run(double frac) {
            TupleSet ts = m_vis.getFocusGroup(Visualization.FOCUS_ITEMS);
            if ( ts.getTupleCount() == 0 )
                return;

            if ( frac == 0.0 ) {
                int xbias=0, ybias=0;
                switch ( m_orientation ) {
                case Constants.ORIENT_LEFT_RIGHT:
                    xbias = m_bias;
                    break;
                case Constants.ORIENT_RIGHT_LEFT:
                    xbias = -m_bias;
                    break;
                case Constants.ORIENT_TOP_BOTTOM:
                    ybias = m_bias;
                    break;
                case Constants.ORIENT_BOTTOM_TOP:
                    ybias = -m_bias;
                    break;
                }

                VisualItem vi = (VisualItem)ts.tuples().next();
                m_cur.setLocation(getWidth()/2, getHeight()/2);
                display.getAbsoluteCoordinate(m_cur, m_start);
                m_end.setLocation(vi.getX()+xbias, vi.getY()+ybias);
            } else {
                m_cur.setLocation(m_start.getX() + frac*(m_end.getX()-m_start.getX()),
                                  m_start.getY() + frac*(m_end.getY()-m_start.getY()));
                //display.panToAbs(m_cur);
            }
        }
    }

    public static class NodeColorAction extends ColorAction {

        public NodeColorAction(String group) {
            super(group, VisualItem.FILLCOLOR);
        }

        public int getColor(VisualItem item) {
            if ( m_vis.isInGroup(item, Visualization.SEARCH_ITEMS) )
                return ColorLib.rgb(255,190,190);
            else if ( m_vis.isInGroup(item, Visualization.FOCUS_ITEMS) )
                return ColorLib.rgb(198,229,229);
            else if ( item.getDOI() > -1 )
                return ColorLib.rgb(164,193,193);
            else
                return ColorLib.rgba(255,255,255,0);
        }
    } // end of inner class TreeMapColorAction

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JPanel panel_visor;
    // End of variables declaration//GEN-END:variables

}
