
package polaris3.Chart;

import java.awt.Color;
import java.awt.Component;
import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Image;
import java.net.URI;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.DefaultListCellRenderer;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JTable;
import javax.swing.ListCellRenderer;
import javax.swing.ListModel;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumn;
import org.jfree.chart.ChartPanel;
import polaris2.graph.Nodo;
import polaris3.DataAcces.MiConexion;
import polaris3.Statistics.EstadisticaAccesos.ConfGraficoArchivos;
import polaris3.Statistics.EstadisticaAccesos.CrearGraficos;
import polaris3.ReadLogs.ConfDominio;

public class GraficoEstadisticaArchivos extends javax.swing.JDialog {
    
    public Nodo n=null;
    boolean nodoCorriendo;

    ConfGraficoArchivos confGraficoArchivos;
    
     //modificar ancho de columnas y centrar
    DefaultTableCellRenderer miTableCellenderer = new DefaultTableCellRenderer();
    DefaultTableModel miModelo;//tabla 
    
    //acceso a bd
    private Connection conexion=null;
    MiConexion miConexion=new MiConexion();
    ResultSet miResulSet;
    Statement miStatement;
    
    String tipoArchivo="";
    String strSerie="";//hits, visitantes o transferencia
    
    //series
    boolean serieHits=false;
    boolean serieVisitantes=false;
    boolean serieTransferencia=false;
    
    //tipos de archivo
    boolean tipoImagen=false;
    boolean tipoAudio=false;
    boolean tipoVideo=false;
    boolean tipoComprimido=false;
    boolean tipoTexto=false;
    boolean tipoInternet=false;
    boolean tipoPaginaWeb=false;
    boolean tipoOtros=false;
    
    //vectores para graficos
    Vector vectorRequest=new Vector();
    Vector vectorHits=new Vector();
    Vector vectorVisitantes=new Vector();
    Vector vectorTransferencia=new Vector();
    Vector vectorValores=new Vector();
    Vector vectorSeries=new Vector();
    //modelos par los jlist
    DefaultListModel modeloListaExtensiones=new DefaultListModel();
    DefaultListModel modeloListaNombreAchivo=new DefaultListModel();
    
    public GraficoEstadisticaArchivos(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.setLocationRelativeTo(null);
        this.setIconImage(this.getImage("/media/star.png"));
        cargaConficuacion();
        Configurar();
        CrearListas();
        CrearTabla();
        miTabla.setModel(miModelo);
        EditarTabla();
        
        nodoCorriendo=true;
    }
     public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }
    public void NodoCorriendo(){
        if(nodoCorriendo==true)
            n.corriendo=true;
    }
    
     private void CrearTabla(){
        String[] nombresColumnas = {"REQUEST", "DATE","TIME","REMOTE HOST"};
        Object[][] datos=null ;
        miModelo=null;
        
        miModelo = new DefaultTableModel(datos, nombresColumnas)//celdaas no editables
         {@Override
             public boolean isCellEditable (int fila, int columna) {
                 if (columna > 10)
                     return true;
                 return false;
             }
         };
        //__LLENAR DATOS EN LA TABLA___________________________________________
        //CargarDatosGrafico();
        //_____________________________________________________________________
        //miTabla.setModel(miModelo); 
        
        
    }
     
    private void EditarTabla(){
        //modificar ancho de columnas y centrar
        TableColumn miColumna;
        
        for (int i = 0; i < 4; i++) {
            miColumna = miTabla.getColumnModel().getColumn(i);
            if(i == 0) miColumna.setPreferredWidth(220); //COLUMNA REQUEST
	    if(i == 1) miColumna.setPreferredWidth(60); //COLUMNA DATE
            if(i == 2) miColumna.setPreferredWidth(20); //COLUMNA TIME
	    if(i == 3) miColumna.setPreferredWidth(110); //COLUMNA REMOTE HOST
        }   
        miTabla.setDefaultRenderer (Object.class, new MiRenderAF1());
    }
    
    private void CrearListas(){
        jListExtensiones.setCellRenderer(new MyCellRenderer());
        jListNombreArchivo.setCellRenderer(new MyCellRenderer());
             
        modeloListaNombreAchivo.clear();
        jListNombreArchivo.setModel(modeloListaNombreAchivo);
        
    }
    public void cargaConficuacion(){
        serieHits=confGraficoArchivos.isSerieHits();
        serieTransferencia=confGraficoArchivos.isSerieTransferencia();
        serieVisitantes=confGraficoArchivos.isSerieVisitantes();
        
        tipoImagen=confGraficoArchivos.isTipoImagen();
        tipoAudio=confGraficoArchivos.isTipoAudio();
        tipoVideo=confGraficoArchivos.isTipoVideo();
        tipoComprimido=confGraficoArchivos.isTipoComprimido();
        tipoTexto=confGraficoArchivos.isTipoTexto();
        tipoInternet=confGraficoArchivos.isTipoInternet();
        tipoPaginaWeb=confGraficoArchivos.isTipoPaginaWeb();
        tipoOtros=confGraficoArchivos.isTipoOtros();      
        ImprimirConfiguracion();
    }
    
    private void Configurar(){
             
        if(tipoImagen==true){
            tipoArchivo="Image";
        }
        if(tipoAudio==true){
            tipoArchivo="Audio";
        }
        if(tipoVideo==true){
            tipoArchivo="Video";
        }
        if(tipoComprimido==true){
            tipoArchivo="Compressed";
        }
        if(tipoTexto==true){
            tipoArchivo="Text";
        }
        if(tipoInternet==true){
            tipoArchivo="Internet";
        }
        if(tipoPaginaWeb==true){
            tipoArchivo="Web Page";
        }
        if(tipoOtros==true){
            tipoArchivo="Other";
        }
        if(serieHits==true)
            strSerie="hits";
        if(serieVisitantes==true)
            strSerie="visitantes";
        if(serieTransferencia==true)
            strSerie="transferencia";
        //titulodel panel
        panelFileType.setBorder(javax.swing.BorderFactory.createTitledBorder(null, tipoArchivo+" File", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 12))); // NOI18N
        //cargarextensiones desde la bd
        CargarExtensiones(tipoArchivo);
    }
    
    private void CargarExtensiones(String tipo_archivo){//cagar extensiones de archivo desde la bd

        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        modeloListaExtensiones.addElement("All Extensions");
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("SELECT DISTINCT extension FROM tabla_sesion WHERE tipoarchivo = '"+tipo_archivo+"' ORDER BY extension");
            while (miResulSet.next()){                   
                modeloListaExtensiones.addElement(miResulSet.getString("extension")); 
            }
            jListExtensiones.setModel(modeloListaExtensiones);
        }catch (Exception e){
            System.out.println("Problemas para cargar extensiones (clase GraficoEstadisticaArchivos.java): "+e.getMessage());
        }
        
    }
    
    private void CargarArchivos(String tipo_extension){//cagar nombres de archivos  desde la bd
        //esta funcion se ejecuata cuando se hace doble click en una de las extenciones del jListExtensiones
        modeloListaNombreAchivo.clear();
        
        String[] nombresColumnas = {"REQUEST", "DATE","TIME","REMOTE HOST"};
        Object[][] datos=null ;
        miModelo=null;
        miModelo = new DefaultTableModel(datos, nombresColumnas)//celdaas no editables
         {@Override
             public boolean isCellEditable (int fila, int columna) {
                 if (columna > 10)
                     return true;
                 return false;
             }
         };
        miTabla.setModel(miModelo);

        String miConsulta="";
        miConsulta="SELECT DISTINCT archivo FROM tabla_sesion WHERE extension = '"+tipo_extension+"' ORDER BY archivo";
        
        if(tipo_extension.compareTo("All Extensions")==0) 
            miConsulta="SELECT DISTINCT archivo FROM tabla_sesion WHERE tipoarchivo = '"+tipoArchivo+"' ORDER BY archivo";
        
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery(miConsulta);
            while (miResulSet.next()){                   
                modeloListaNombreAchivo.addElement(miResulSet.getString("archivo")); 
            }
            jListNombreArchivo.setModel(modeloListaNombreAchivo);
        }catch (Exception e){
            System.out.println("Problemas para cargar extensiones (clase GraficoEstadisticaArchivos.java): "+e.getMessage());
        }
        
    }
    private void CargarRequest(String nombre_archivo){//cagar request desde la bd
        //esta funcion se ejecuata cuando se hace doble click en una de losarchivos del jListNombreArchivo
        
        String[] nombresColumnas = {"REQUEST", "DATE","TIME","REMOTE HOST"};
        Object[][] datos=null ;
        miModelo=null;
         miModelo = new DefaultTableModel(datos, nombresColumnas)//celdaas no editables
         {@Override
             public boolean isCellEditable (int fila, int columna) {
                 if (columna > 10)
                     return true;
                 return false;
             }
         };
        
        String miConsulta="";
        //miConsulta="select  request,nombre_dia || ' ' || fecha || ' ' || hora  as fecha_dia,host from tabla_sesion,dias_semana where archivo = '"+nombre_archivo+"' and tabla_sesion.dia=dias_semana.id order by fecha,hora";
        miConsulta="select  request,nombre_dia || ' ' || fecha as fecha_dia,hora,host from tabla_sesion,dias_semana where archivo = '"+nombre_archivo+"' and tabla_sesion.dia=dias_semana.id order by fecha,hora";
     
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery(miConsulta);
            while (miResulSet.next()){     
                Object [] fila = new Object[4]; // Hay 4 columnas en la tabla
                for (int i=0;i<4;i++)//columna 0,1,2,3
                    fila[i] = miResulSet.getString(i+1);
                
                miModelo.addRow(fila);
                          
            }
            miTabla.setModel(miModelo);
            EditarTabla();
            
        }catch (Exception e){
            System.out.println("Problemas para cargar request (clase GraficoEstadisticaArchivos.java): "+e.getMessage());
        }
        
    }
    
    //graficar extensiones
    private void CargarDatosGrafico(String miExtension){//cargar datosdesde la bs
        System.out.println("mi extensiomn : "+miExtension);
        vectorRequest.removeAllElements();
        vectorHits.removeAllElements();
        vectorVisitantes.removeAllElements();
        vectorTransferencia.removeAllElements();
        vectorValores.removeAllElements();
        vectorSeries.removeAllElements();
        
        String miConsulta="";
        
        miConsulta="SELECT request,hits,visitantes,transferencia FROM acceso_estadisticas WHERE extension = '"+miExtension+"' ORDER BY "+strSerie + " desc";
        
        if(miExtension.compareTo("All Extensions")==0) 
            miConsulta="SELECT request,hits,visitantes,transferencia FROM acceso_estadisticas WHERE tipoarchivo = '"+tipoArchivo+"' ORDER BY "+strSerie + " desc";
        
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        
        try{
            int i=0;//obtener los dies requeste mas hits, visitados o transfer KB
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery(miConsulta);
            while (miResulSet.next() && i<20){
                
                double miTransfrencia=0;//para pasar a kb y redondear a 0.00
                miTransfrencia=miResulSet.getDouble("transferencia");
                miTransfrencia=miTransfrencia/1024;//pasar a kb
                miTransfrencia=Math.rint(miTransfrencia*1000)/100;//redondear
                
                vectorRequest.addElement(miResulSet.getString("request"));
                vectorHits.addElement(miResulSet.getInt("hits"));
                vectorVisitantes.addElement(miResulSet.getInt("visitantes"));
                vectorTransferencia.addElement(miTransfrencia);
                
                System.out.println(miResulSet.getString("request")+" "+miResulSet.getInt("hits")+" "+miResulSet.getInt("visitantes")+ " "+miResulSet.getInt("transferencia"));
                i++;                             
            }
            //CrearDatosGrafico();
        }catch (Exception e){
            System.out.println("Problemas para cargar datos de  grafico clase GraficoEstadisticaArchivos.java: "+e.getMessage());
        }
        CrearDatosGrafico();
    }
    
     public void CrearDatosGrafico(){//crear datos para construir grafico
        
        
        if(serieHits==true ){//grafico de una serie (hits)
            for(int i=0;i<vectorRequest.size();i++){
                vectorValores.addElement(Integer.parseInt(vectorHits.elementAt(i).toString()));//hits
                vectorSeries.addElement("Hits");
            }
            CrearGrafico("Request", "Hits Amount");
        }
               
        if(serieVisitantes==true){//grafico de una serie (visitantes)
            for(int i=0;i<vectorRequest.size();i++){
                vectorValores.addElement(Integer.parseInt(vectorVisitantes.elementAt(i).toString()));//hits
                vectorSeries.addElement("Visitors");
            }
            CrearGrafico("Request", "Visitors Amount");
        }
        
        if(serieTransferencia==true){//grafico de una serie (transferencia)
            for(int i=0;i<vectorRequest.size();i++){
                vectorValores.addElement(Float.parseFloat(vectorTransferencia.elementAt(i).toString()));//hits
                vectorSeries.addElement("Transfer");
            }
            CrearGrafico("Request", "Transfer (KB)");
        }
    }
     
     public void CrearGrafico(String tituloX, String tituloY){//crear grafico en la clase CrearGraficos.java
        
        String tipoGrafico="";
        tipoGrafico="barras";
        
        CrearGraficos migrafico = new CrearGraficos();
        //tamaño del grafico
        Dimension d = miPanel.getSize();//toma el tamaño del contenedor
        String[] datos = {"ACCESS STATISTICS",tituloX,tituloY};
        migrafico.crear_grafico_de_barras(d, vectorValores, vectorSeries, vectorRequest, datos,tipoGrafico);
        //se crea un jlabel para colocar el grafico
        miPanel.removeAll();
        ChartPanel chartPanel=new ChartPanel(migrafico.grafico,true,true,true,true,true);

        chartPanel.setBounds(0, 0, d.width, d.height);
        miPanel.add(chartPanel);

        miPanel.repaint();
        this.repaint();
    }
    
    private void ImprimirConfiguracion(){
        System.out.println("---------------------------------------------------");
        System.out.println("serieHits: "+serieHits);
        System.out.println("serieVisitantes: "+serieVisitantes);
        System.out.println("serieTansferencis: "+serieTransferencia);
        System.out.println("Tipo pagina web: "+tipoPaginaWeb);
        System.out.println("Tipo imagen: "+tipoImagen);
        System.out.println("Tipo audio: "+tipoAudio);
        System.out.println("Tipo video: "+tipoVideo);
        System.out.println("Tipo texto: "+tipoTexto);
        System.out.println("Tipo comprimido: "+tipoComprimido);
        System.out.println("Tipo internet: "+tipoInternet);
        System.out.println("Tipo otros: "+tipoOtros);
        
        System.out.println("---------------------------------------------------");
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        panelFileType = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jListExtensiones = new javax.swing.JList();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jListNombreArchivo = new javax.swing.JList();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane6 = new javax.swing.JScrollPane();
        miTabla = new javax.swing.JTable();
        miPanel = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Access Statistics");
        setAlwaysOnTop(true);
        setResizable(false);

        panelFileType.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "File Type", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 12))); // NOI18N

        jListExtensiones.setFont(new java.awt.Font("Tahoma", 1, 11));
        jListExtensiones.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jListExtensiones.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jListExtensionesMouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(jListExtensiones);

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 12));
        jLabel1.setText("Extension File");

        jListNombreArchivo.setFont(new java.awt.Font("Tahoma", 1, 11));
        jListNombreArchivo.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jListNombreArchivo.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jListNombreArchivoMouseClicked(evt);
            }
        });
        jScrollPane2.setViewportView(jListNombreArchivo);

        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 12));
        jLabel2.setText("File Name");

        miTabla.setFont(new java.awt.Font("Tahoma", 1, 11));
        miTabla.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        miTabla.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                miTablaMouseClicked(evt);
            }
        });
        jScrollPane6.setViewportView(miTabla);

        javax.swing.GroupLayout panelFileTypeLayout = new javax.swing.GroupLayout(panelFileType);
        panelFileType.setLayout(panelFileTypeLayout);
        panelFileTypeLayout.setHorizontalGroup(
            panelFileTypeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelFileTypeLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(panelFileTypeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(panelFileTypeLayout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 122, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(6, 6, 6)
                        .addComponent(jScrollPane6, javax.swing.GroupLayout.DEFAULT_SIZE, 700, Short.MAX_VALUE))
                    .addGroup(panelFileTypeLayout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel2)))
                .addContainerGap())
        );
        panelFileTypeLayout.setVerticalGroup(
            panelFileTypeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelFileTypeLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(panelFileTypeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2))
                .addGap(7, 7, 7)
                .addGroup(panelFileTypeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jScrollPane6, javax.swing.GroupLayout.Alignment.LEADING, 0, 0, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, 0, 0, Short.MAX_VALUE)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 107, Short.MAX_VALUE)))
        );

        miPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        javax.swing.GroupLayout miPanelLayout = new javax.swing.GroupLayout(miPanel);
        miPanel.setLayout(miPanelLayout);
        miPanelLayout.setHorizontalGroup(
            miPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 959, Short.MAX_VALUE)
        );
        miPanelLayout.setVerticalGroup(
            miPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 437, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(miPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(panelFileType, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(panelFileType, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(miPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void jListExtensionesMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jListExtensionesMouseClicked
    //Cuando sehace doble click sobre lista de extenciones
     if (evt.getClickCount() == 2) // Se mira si es doble click
        {
            int posicion = jListExtensiones.locationToIndex(evt.getPoint());
            ListModel auxModel = jListExtensiones.getModel();
            Object miExtension = auxModel.getElementAt(posicion);
            jListExtensiones.ensureIndexIsVisible(posicion);
            CargarArchivos(miExtension.toString());
            CargarDatosGrafico(miExtension.toString());
         }
}//GEN-LAST:event_jListExtensionesMouseClicked

private void jListNombreArchivoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jListNombreArchivoMouseClicked
    //Cuando sehace doble click sobre lista de nombres de archivos
     if (evt.getClickCount() == 2) // Se mira si es doble click
        {
            int posicion = jListNombreArchivo.locationToIndex(evt.getPoint());
            ListModel auxModel = jListNombreArchivo.getModel();
            Object miArchivo = auxModel.getElementAt(posicion);
            jListNombreArchivo.ensureIndexIsVisible(posicion);
            CargarRequest(miArchivo.toString());
            //CargarArchivos(miExtension.toString());
         }
}//GEN-LAST:event_jListNombreArchivoMouseClicked

private void miTablaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_miTablaMouseClicked
    if (evt.getClickCount() == 2){    
        String auxUrl="";
        int fila = miTabla.rowAtPoint(evt.getPoint());
        int columna = miTabla.columnAtPoint(evt.getPoint());
        if ((fila > -1) && (columna == 0)){
            auxUrl=(String)miModelo.getValueAt(fila,columna);
            AbrirURL(auxUrl);
            System.out.println(auxUrl);
        }
       
    }
}//GEN-LAST:event_miTablaMouseClicked

private void AbrirURL(String miAuxUrl){
    
    String miURL="http://";
    miURL=miURL+ConfDominio.getDominio();
    
    miURL=miURL+miAuxUrl;
    System.out.println(miURL);
    miURL=miURL.replace(" ", "+");
    try {
         Desktop.getDesktop().browse(new URI(miURL));
    } catch (Exception e) {
        System.out.println("No se puede abrir url: "+e.getMessage());
    }
    
}
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(GraficoEstadisticaArchivos.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(GraficoEstadisticaArchivos.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(GraficoEstadisticaArchivos.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(GraficoEstadisticaArchivos.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                GraficoEstadisticaArchivos dialog = new GraficoEstadisticaArchivos(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JList jListExtensiones;
    private javax.swing.JList jListNombreArchivo;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JPanel miPanel;
    private javax.swing.JTable miTabla;
    private javax.swing.JPanel panelFileType;
    // End of variables declaration//GEN-END:variables
}

class MyCellRenderer extends  DefaultListCellRenderer {
        public MyCellRenderer() {
            setOpaque(true);
        }
        Color currColor=Color.white;  
        public Component getListCellRendererComponent( JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
        super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
        if(index%2==0) {                              
            currColor=Color.LIGHT_GRAY;  
        }      
        else {  
            currColor=new Color(222,222,255);                  
        }                              
        if(isSelected) {  
            super.setForeground(list.getSelectionForeground());  
            super.setBackground(list.getSelectionBackground());  
        } else {  
            super.setForeground(Color.BLACK);     
            super.setBackground(currColor);  
        }           
        setFont(list.getFont());                                  
            return this;
        }
    }

//clase para cambiar la apariencia de las tablas
class MiRenderAF1 extends DefaultTableCellRenderer{
    
    Color currColor=Color.white;  
    
    public Component getTableCellRendererComponent(JTable table,Object value,boolean isSelected,boolean hasFocus,int row,int column)
    {
        super.getTableCellRendererComponent (table, value, isSelected, hasFocus, row, column);
        this.setOpaque(true);
        table.setShowGrid(true);
        
        //cambiar fuente de cabeseras
        JTableHeader th = table.getTableHeader(); 
        Font fuente = new Font("Verdana", Font.BOLD, 12); 
        th.setFont(fuente); 
       // th.setBackground(new Color(153,153,255));
        
        //alternar color de filas
        if(row%2==0) {                              
            currColor=Color.white;  
        }      
        else {  
            currColor=new Color(222,222,255);                  
        }                              
        if(isSelected) {  
            super.setForeground(table.getSelectionForeground());  
            super.setBackground(table.getSelectionBackground());  
        } else {  
            super.setForeground(Color.black);     
            super.setBackground(currColor);  
        }                         
        setFont(table.getFont());                                  
        setValue(value);  
        
        //alinear columnas
        super.setHorizontalAlignment(SwingConstants.LEFT);
     
        //resisables
       // table.getColumnModel().getColumn(0).setResizable(false);
        //table.getColumnModel().getColumn(1).setResizable(false);
        //table.getColumnModel().getColumn(2).setResizable(false);
        //table.getColumnModel().getColumn(3).setResizable(false);
        //table.getColumnModel().getColumn(4).setResizable(false);
        return this;
   }
}