
package polaris3.Chart;

import java.awt.Dimension;
import java.awt.Image;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import org.jfree.chart.ChartPanel;
import polaris2.graph.Nodo;
import polaris3.DataAcces.MiConexion;
import polaris3.Statistics.EstadisticaAccesos.ConfGraficoTipoArchivos;
import polaris3.Statistics.EstadisticaAccesos.CrearGraficos;

public class GraficoTipoArchivo extends javax.swing.JDialog {

    public Nodo n=null;
    boolean nodoCorriendo;
    
    ConfGraficoTipoArchivos confGraficoTipoArchivo;
    
  
     //acceso a bd
    private Connection conexion=null;
    MiConexion miConexion=new MiConexion();
    ResultSet miResulSet;
    Statement miStatement;
    
    //series
    boolean serieHits=false;
    boolean serieVisitantes=false;
    boolean serieTransferencia=false;
    String strSerie="";
    
    //vectores para piechart
    Vector vectorTipoArchivo=new Vector();
    Vector vectorHitsPieChart=new Vector();
    Vector vectorVisitantesPieChart=new Vector();
    Vector vectorTransferenciaPieChart=new Vector();
    Vector vectorValoresTipoArchivo=new Vector();
    
    //vectores para grafico de barras
    Vector vectorExtensiones=new Vector();
    Vector vectorHitsExtensiones=new Vector();
    Vector vectorVisitantesExtensiones=new Vector();
    Vector vectorTransferenciaExtensiones=new Vector();
    Vector vectorValoresExtensiones=new Vector();
    
    public GraficoTipoArchivo(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.setLocationRelativeTo(null);
        this.setIconImage(this.getImage("/media/star.png"));
        CargarConfiguracion();
        CargarDatosGraficoTipoArchivo();
        CrearDatosTipoArchivo();
        
        nodoCorriendo=true;
    }
     public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }
    public void NodoCorriendo(){
        if(nodoCorriendo==true)
            n.corriendo=true;
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanelTipoArchivo = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jPanelExtensiones = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        comboBoxExtension = new javax.swing.JComboBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("File Type");
        setAlwaysOnTop(true);

        javax.swing.GroupLayout jPanelTipoArchivoLayout = new javax.swing.GroupLayout(jPanelTipoArchivo);
        jPanelTipoArchivo.setLayout(jPanelTipoArchivoLayout);
        jPanelTipoArchivoLayout.setHorizontalGroup(
            jPanelTipoArchivoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 850, Short.MAX_VALUE)
        );
        jPanelTipoArchivoLayout.setVerticalGroup(
            jPanelTipoArchivoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 459, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("FILE TYPE", jPanelTipoArchivo);

        jPanelExtensiones.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        javax.swing.GroupLayout jPanelExtensionesLayout = new javax.swing.GroupLayout(jPanelExtensiones);
        jPanelExtensiones.setLayout(jPanelExtensionesLayout);
        jPanelExtensionesLayout.setHorizontalGroup(
            jPanelExtensionesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 828, Short.MAX_VALUE)
        );
        jPanelExtensionesLayout.setVerticalGroup(
            jPanelExtensionesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 387, Short.MAX_VALUE)
        );

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 12));
        jLabel1.setText("Extension:");

        comboBoxExtension.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        comboBoxExtension.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                comboBoxExtensionActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanelExtensiones, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addGap(18, 18, 18)
                        .addComponent(comboBoxExtension, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(21, 21, 21)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(comboBoxExtension, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(jPanelExtensiones, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        jTabbedPane1.addTab("EXTENSIONS", jPanel1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 855, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 487, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void comboBoxExtensionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_comboBoxExtensionActionPerformed
// TODO add your handling code here:
    String auxTipoArchivo="";
    
    if(evt.getSource()==comboBoxExtension){
        auxTipoArchivo=(String)comboBoxExtension.getSelectedItem();
    }
    if(auxTipoArchivo==null)
        auxTipoArchivo="Image";
    System.out.println(auxTipoArchivo);
    CargarDatosGraficoExtensiones(auxTipoArchivo);
}//GEN-LAST:event_comboBoxExtensionActionPerformed
    
    private void CargarConfiguracion(){
        serieHits=confGraficoTipoArchivo.isSerieHits();
        serieTransferencia=confGraficoTipoArchivo.isSerieTransferencia();
        serieVisitantes=confGraficoTipoArchivo.isSerieVisitantes();
        
        ImprimirConfiguracion();
    }
    
    private void ImprimirConfiguracion(){
        System.out.println("---------------------------------------------------");
        System.out.println("serieHits: "+serieHits);
        System.out.println("serieVisitantes: "+serieVisitantes);
        System.out.println("serieTransferencia: "+serieTransferencia);
        System.out.println("---------------------------------------------------");
    }
    
    private void CargarDatosGraficoTipoArchivo(){//cargar datosdesde la bs
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        comboBoxExtension.removeAllItems();//limpiar combo box
        comboBoxExtension.addItem("All Extensions");
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("SELECT tipoarchivo,hits,visitantes,transferencia FROM acceso_tipoarchivo ORDER BY tipoarchivo ");
            while (miResulSet.next()){
                
                double miTransfrencia=0;//para pasar a kb y redondear a 0.00
                miTransfrencia=miResulSet.getDouble("transferencia");
                miTransfrencia=miTransfrencia/1024;//pasar a kb
                miTransfrencia=Math.rint(miTransfrencia*1000)/100;//redondear
                
                vectorTipoArchivo.addElement(miResulSet.getString("tipoarchivo"));
                vectorHitsPieChart.addElement(miResulSet.getInt("hits"));
                vectorVisitantesPieChart.addElement(miResulSet.getInt("visitantes"));
                vectorTransferenciaPieChart.addElement(miTransfrencia);
                
                comboBoxExtension.addItem(miResulSet.getString("tipoarchivo"));
                
                //vectorTransferencia.addElement(miResulSet.getInt("transferencia"));
            }

        }catch (Exception e){
            System.out.println("Problemas para crear grafico tipo archivo: "+e.getMessage());
        }
    }
    
    public void CrearDatosTipoArchivo(){//crear datos para construir grafico tipo archivo
        
        if(serieHits==true){//grafico de una serie (hits)
            for(int i=0;i<vectorTipoArchivo.size();i++){
                //vectorTipoArchivo.setElementAt(vectorTipoArchivo.elementAt(i).toString()+" - "+vectorHitsPieChart.elementAt(i).toString()+" Hits", i);
                vectorValoresTipoArchivo.addElement(Integer.parseInt(vectorHitsPieChart.elementAt(i).toString()));//hits
            }
            strSerie="Hits";
            CrearGraficoTipoArchivo();
        }
        
        if(serieVisitantes==true){//grafico de una serie (visitantes)
            for(int i=0;i<vectorTipoArchivo.size();i++){
                //vectorTipoArchivo.setElementAt(vectorTipoArchivo.elementAt(i).toString()+" - "+vectorVisitantesPieChart.elementAt(i).toString()+" Visitors", i);
                vectorValoresTipoArchivo.addElement(Integer.parseInt(vectorVisitantesPieChart.elementAt(i).toString()));//hits
            }
            strSerie="Visitors";
            CrearGraficoTipoArchivo();
        }
        
        if(serieTransferencia==true){//grafico de una serie (transferencia)
            for(int i=0;i<vectorTipoArchivo.size();i++){
                //vectorTipoArchivo.setElementAt(vectorTipoArchivo.elementAt(i).toString()+" - "+vectorTransferenciaPieChart.elementAt(i).toString()+" KB", i);
                vectorValoresTipoArchivo.addElement(Float.parseFloat(vectorTransferenciaPieChart.elementAt(i).toString()));//hits
            }
            strSerie="KB";
            CrearGraficoTipoArchivo();
        }
    }
     
    private void CrearGraficoTipoArchivo(){//crear grafico en la clase CrearGraficos.java
        //grafico piechart
       
        CrearGraficos migrafico = new CrearGraficos();
        //tamaño del grafico
        Dimension d = jPanelTipoArchivo.getSize();//toma el tamaño del contenedor

        migrafico.crear_grafico_pieChart(d, vectorTipoArchivo, vectorValoresTipoArchivo,"File Type",strSerie);
        //se crea un jlabel para colocar el grafico
        jPanelTipoArchivo.removeAll();
        ChartPanel chartPanel=new ChartPanel(migrafico.grafico1,true,true,true,false,true);

        chartPanel.setBounds(0, 0, d.width, d.height);
        jPanelTipoArchivo.add(chartPanel);

        jPanelTipoArchivo.repaint();
        this.repaint();
    }
    
    //////////////////////////////////////////////////////////////////////////////////
    //graficar extensiones
    private void CargarDatosGraficoExtensiones(String tipo_archivo){//cargar datosdesde la bs
        
        vectorExtensiones.removeAllElements();
        vectorHitsExtensiones.removeAllElements();
        vectorVisitantesExtensiones.removeAllElements();
        vectorTransferenciaExtensiones.removeAllElements();
        vectorValoresExtensiones.removeAllElements();
        String miConsulta="";
        miConsulta="SELECT extension,hits,visitantes,transferencia FROM acceso_extensiones WHERE tipoarchivo = '"+tipo_archivo+"' ORDER BY extension";

        if(tipo_archivo.compareTo("All Extensions")==0) 
            miConsulta="SELECT extension,hits,visitantes,transferencia FROM acceso_extensiones ORDER BY extension";
          
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery(miConsulta);
            while (miResulSet.next()){
                
                double miTransfrencia=0;//para pasar a kb y redondear a 0.00
                miTransfrencia=miResulSet.getDouble("transferencia");
                miTransfrencia=miTransfrencia/1024;//pasar a kb
                miTransfrencia=Math.rint(miTransfrencia*1000)/100;//redondear
                
                vectorExtensiones.addElement(miResulSet.getString("extension"));
                vectorHitsExtensiones.addElement(miResulSet.getInt("hits"));
                vectorVisitantesExtensiones.addElement(miResulSet.getInt("visitantes"));
                vectorTransferenciaExtensiones.addElement(miTransfrencia);
                
                System.out.println(miResulSet.getString("extension"));
                                             
            }
            CrearDatosExtensiones(tipo_archivo);
        }catch (Exception e){
            System.out.println("Problemas para crear grafico tipo archivo: "+e.getMessage());
        }
    }
    
    public void CrearDatosExtensiones(String tipo_achivo){//crear datos para construir grafico extensiones
        
        if(serieHits==true){//grafico de una serie (hits)
            for(int i=0;i<vectorExtensiones.size();i++){
                //vectorExtensiones.setElementAt(vectorExtensiones.elementAt(i).toString()+" - "+vectorHitsExtensiones.elementAt(i).toString()+" Hits", i);
                vectorValoresExtensiones.addElement(Integer.parseInt(vectorHitsExtensiones.elementAt(i).toString()));//hits
            }
            strSerie="Hits";
            CrearGraficoExtensiones(tipo_achivo);
        }
        
        if(serieVisitantes==true){//grafico de una serie (visitantes)
            for(int i=0;i<vectorExtensiones.size();i++){
                //vectorExtensiones.setElementAt(vectorExtensiones.elementAt(i).toString()+" - "+vectorVisitantesExtensiones.elementAt(i).toString()+" Visitors", i);
                vectorValoresExtensiones.addElement(Integer.parseInt(vectorVisitantesExtensiones.elementAt(i).toString()));//hits
            }
            strSerie="Visitors";
            CrearGraficoExtensiones(tipo_achivo);
        }
        
        if(serieTransferencia==true){//grafico de una serie (transferencia)
            for(int i=0;i<vectorExtensiones.size();i++){
                //vectorExtensiones.setElementAt(vectorExtensiones.elementAt(i).toString()+" - "+vectorTransferenciaExtensiones.elementAt(i).toString()+" KB", i);
                vectorValoresExtensiones.addElement(Float.parseFloat(vectorTransferenciaExtensiones.elementAt(i).toString()));//hits
            }
            strSerie="KB";
            CrearGraficoExtensiones(tipo_achivo);
        }
    }
    
     private void CrearGraficoExtensiones(String tipo_archivo){//crear grafico en la clase CrearGraficos.java
        //grafico piechart
        
        CrearGraficos migrafico = new CrearGraficos();
        //tamaño del grafico
        Dimension d = jPanelExtensiones.getSize();//toma el tamaño del contenedor

        migrafico.crear_grafico_pieChart(d, vectorExtensiones, vectorValoresExtensiones,tipo_archivo+" Type",strSerie);
        //se crea un jlabel para colocar el grafico
        /*
        j2 = new JLabel();
        j2.setBounds(0, 0, d.width, d.height);
        //se carga el grafico de memoria
        migrafico.cargar_grafico1(j2);
        //se añade al contenedor
        jPanelExtensiones.removeAll();
        jPanelExtensiones.add(j2);*/
        jPanelExtensiones.removeAll();
        ChartPanel chartPanel=new ChartPanel(migrafico.grafico1,true,true,true,false,true);

        chartPanel.setBounds(0, 0, d.width, d.height);
        jPanelExtensiones.add(chartPanel);

        jPanelExtensiones.repaint();
        this.repaint();
    }  
     
    
    
    
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(GraficoTipoArchivo.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(GraficoTipoArchivo.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(GraficoTipoArchivo.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(GraficoTipoArchivo.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                GraficoTipoArchivo dialog = new GraficoTipoArchivo(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox comboBoxExtension;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    public static javax.swing.JPanel jPanelExtensiones;
    private javax.swing.JPanel jPanelTipoArchivo;
    private javax.swing.JTabbedPane jTabbedPane1;
    // End of variables declaration//GEN-END:variables
}
