
package polaris3.Chart;

import java.awt.Dimension;
import java.awt.Image;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import org.jfree.chart.ChartPanel;
import polaris2.graph.Nodo;
import polaris3.DataAcces.MiConexion;
import polaris3.Statistics.Visitantes.ConfGraficoVisitantes;
import polaris3.Statistics.Visitantes.CrearGraficos;


public class GraficoVisitantes extends javax.swing.JDialog {
    
    public Nodo n=null;
    boolean nodoCorriendo;

    ConfGraficoVisitantes confGraficoVisitantes;
    
     //modificar ancho de columnas y centrar
    DefaultTableCellRenderer miTableCellenderer = new DefaultTableCellRenderer();
    DefaultTableModel miModelo;//tabla 
    
    //acceso a bd
    private Connection conexion=null;
    MiConexion miConexion=new MiConexion();
    ResultSet miResulSet;
    Statement miStatement;
    
    String tipoArchivo="";
    String strSerie="";//hits, visitantes o transferencia
    
    //series
    boolean serieHits=false;
    boolean serieVisitantes=false;
    boolean serieTransferencia=false;
    
    
    //vectores para graficos
    Vector vectorHost=new Vector();
    Vector vectorHits=new Vector();
    Vector vectorVisitantes=new Vector();
    Vector vectorTransferencia=new Vector();
    Vector vectorValores=new Vector();
    Vector vectorSeries=new Vector();
    //modelos par los jlist
    DefaultListModel modeloListaExtensiones=new DefaultListModel();
    DefaultListModel modeloListaNombreAchivo=new DefaultListModel();
    
    public GraficoVisitantes(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.setLocationRelativeTo(null);
         this.setIconImage(this.getImage("/media/star.png"));
        cargaConfiguracion();
        Configurar();
        CargarDatosGrafico();
             
        nodoCorriendo=true;
    }
    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }
    public void NodoCorriendo(){
        if(nodoCorriendo==true)
            n.corriendo=true;
    }
    
    
    private void cargaConfiguracion(){
        serieHits=confGraficoVisitantes.isSerieHits();
        serieTransferencia=confGraficoVisitantes.isSerieTransferencia();
        serieVisitantes=confGraficoVisitantes.isSerieVisitantes();
       
        ImprimirConfiguracion();
    }
    
    private void Configurar(){
             
        if(serieHits==true)
            strSerie="hits";
        if(serieVisitantes==true)
            strSerie="visitantes";
        if(serieTransferencia==true)
            strSerie="transferencia";

    }
    
    //graficar extensiones
    private void CargarDatosGrafico(){//cargar datosdesde la bs
        
        String miConsulta="";
        
        miConsulta="SELECT host_remoto,hits,visitantes,transferencia FROM estadisticas_visitantes ORDER BY "+ strSerie + " desc";
        
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        
        try{
            int i=0;//obtener los dies requeste mas hits, visitados o transfer KB
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery(miConsulta);
            while (miResulSet.next() && i<15){
                
                double miTransfrencia=0;//para pasar a kb y redondear a 0.00
                miTransfrencia=miResulSet.getDouble("transferencia");
                miTransfrencia=miTransfrencia/1024;//pasar a kb
                miTransfrencia=Math.rint(miTransfrencia*1000)/100;//redondear
                
                vectorHost.addElement(miResulSet.getString("host_remoto"));
                vectorHits.addElement(miResulSet.getInt("hits"));
                vectorVisitantes.addElement(miResulSet.getInt("visitantes"));
                vectorTransferencia.addElement(miTransfrencia);
                i++;                 
                System.out.println(miResulSet.getString("host_remoto"));
            }
            //CrearDatosGrafico();
        }catch (Exception e){
            System.out.println("Problemas para cargar datos de  grafico clase GraficoEstadisticaArchivos.java: "+e.getMessage());
        }
        CrearDatosGrafico();
    }
    
     public void CrearDatosGrafico(){//crear datos para construir grafico
        
        
        if(serieHits==true ){//grafico de una serie (hits)
            for(int i=0;i<vectorHost.size();i++){
                vectorValores.addElement(Integer.parseInt(vectorHits.elementAt(i).toString()));//hits
                vectorSeries.addElement("Hits");
            }
            CrearGrafico("Remote Host", "Hits Amount");
        }
               
        if(serieVisitantes==true){//grafico de una serie (visitantes)
            for(int i=0;i<vectorHost.size();i++){
                vectorValores.addElement(Integer.parseInt(vectorVisitantes.elementAt(i).toString()));//hits
                vectorSeries.addElement("Visitors");
            }
            CrearGrafico("Remote Host", "Visitors Amount");
        }
        
        if(serieTransferencia==true){//grafico de una serie (transferencia)
            for(int i=0;i<vectorHost.size();i++){
                vectorValores.addElement(Float.parseFloat(vectorTransferencia.elementAt(i).toString()));//hits
                vectorSeries.addElement("Transfer");
            }
            CrearGrafico("Remote Host", "Transfer (KB)");
        }
    }
     
     public void CrearGrafico(String tituloX, String tituloY){//crear grafico en la clase CrearGraficos.java
        
        String tipoGrafico="";
        tipoGrafico="barras";
        
        CrearGraficos migrafico = new CrearGraficos();
        //tamaño del grafico
        Dimension d = miPanel.getSize();//toma el tamaño del contenedor
        String[] datos = {"REMOTE HOSTS",tituloX,tituloY};
        migrafico.crear_grafico_de_barras(d, vectorValores, vectorSeries, vectorHost, datos,tipoGrafico);
        //se crea un jlabel para colocar el grafico
        miPanel.removeAll();
        ChartPanel chartPanel=new ChartPanel(migrafico.grafico,true,true,true,true,true);

        chartPanel.setBounds(0, 0, d.width, d.height);
        miPanel.add(chartPanel);

        miPanel.repaint();
        this.repaint();
    }
    
    private void ImprimirConfiguracion(){
        System.out.println("---------------------------------------------------");
        System.out.println("serieHits: "+serieHits);
        System.out.println("serieVisitantes: "+serieVisitantes);
        System.out.println("serieTansferencis: "+serieTransferencia);
      
        System.out.println("---------------------------------------------------");
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        miPanel = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Unique IPs");
        setAlwaysOnTop(true);

        miPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        javax.swing.GroupLayout miPanelLayout = new javax.swing.GroupLayout(miPanel);
        miPanel.setLayout(miPanelLayout);
        miPanelLayout.setHorizontalGroup(
            miPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 744, Short.MAX_VALUE)
        );
        miPanelLayout.setVerticalGroup(
            miPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 486, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(miPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(miPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(GraficoVisitantes.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(GraficoVisitantes.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(GraficoVisitantes.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(GraficoVisitantes.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                GraficoVisitantes dialog = new GraficoVisitantes(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel miPanel;
    // End of variables declaration//GEN-END:variables
}
