
package polaris3.DataAcces;

import java.sql.*;
import java.util.*;

import polaris3.ReadLogs.IdentificarFormatoLog;
import polaris3.ReadLogs.AbrirLog;
import polaris3.DataAcces.MiConexion;

public class CargarArreglos {
    
    //VECTORES PARA ALMACENAR CAMPOS DE TABLA 
    static Vector vectorHost=new Vector();//ip del cliente 
    static Vector vectorDateTime=new Vector();//fecha, hora   
    static Vector vectorDate=new Vector();//fecha
    static Vector vectorTime=new Vector();//fecha
    static Vector vectorRequest=new Vector();//solicitud HTTP - "GET /apache_pb.gif HTTP/1.0"
    static Vector vectorStatusCode=new Vector();//codigo de estado HTTP
    static Vector vectorBytes=new Vector();//numero de bytes transferidos
    
    
    //____________________________________________
    
    
    private Connection conexion=null;
    MiConexion miConexion=new MiConexion();
    ResultSet miResulSet;
    Statement miStatement;
    
    static String nombreArchivo="";
    static int miIdLog;//formato del log
    static String formatoLog="";
    
    public CargarArreglos()
    {
        miIdLog=IdentificarFormatoLog.getLogFormato();
        if(miIdLog==1)
            formatoLog="W3C Extended Log";
        if(miIdLog==2)
            formatoLog="Common Log File";
        if(miIdLog==2)
            formatoLog="Combined Common Log File";
        nombreArchivo=AbrirLog.getNombreArchivo();
        //System.out.println("El formato es :" + miIdLog);
        CargarTablaLog();
    }
    
    public void CargarTablaLog()//cargar tabla lof file desde la base de datos
    {
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("SELECT * FROM tabla_sesion ORDER BY id;");
            CrearArreglos();
        }catch (Exception e){
            System.out.println("Error en resumen general. Clase CargarArreglos.java");
            System.out.println(e.getMessage());
        } 
    }
    
    public void CrearArreglos()//ALMACENAR REGISTROS DE LA BD EN ARREGLOS
    {
      try{

          while(miResulSet.next()){
              vectorHost.addElement(miResulSet.getString("host"));//host
              vectorDateTime.addElement(miResulSet.getString("date_time"));
              vectorDate.addElement(miResulSet.getString("fecha"));
              vectorTime.addElement(miResulSet.getString("hora"));
              vectorRequest.addElement(miResulSet.getString("request_original"));//requeest
              vectorStatusCode.addElement(miResulSet.getString("status_code"));
              vectorBytes.addElement(miResulSet.getString("transferencia"));                 
          }
          System.out.print("Se cargaron los registros tabla_sesion en los arreglos correctamente¡¡ (Clase CargarArreglos.java)");
      }
      catch(Exception e){
          System.out.println(e.getMessage());
      }
    }

    public static String getFormatoLog() {
        return formatoLog;
    }

    public static int getMiIdLog() {
        return miIdLog;
    }

    public static String getNombreArchivo() {
        return nombreArchivo;
    }

    public static Vector getVectorBytes() {
        return vectorBytes;
    }

    public static Vector getVectorHost() {
        return vectorHost;
    }

    public static Vector getVectorRequest() {
        return vectorRequest;
    }

    public static Vector getVectorStatusCode() {
        return vectorStatusCode;
    }

    public static Vector getVectorDateTime() {
        return vectorDateTime;
    }

    public static Vector getVectorDate() {
        return vectorDate;
    }

    public static Vector getVectorTime() {
        return vectorTime;
    }
    
    
}
