
package polaris3.DataAcces;
import java.io.*;
import java.sql.*;
import javax.swing.JOptionPane;

public class CrearTablaCommonLFExt extends Thread
{

    File miArchivoLogCommonLF;
    BufferedReader miReader;
    
    private Connection conexion=null;
    
    MiConexion miConexion=new MiConexion();
    EjecutarQuerys myQuery=new EjecutarQuerys();
    
    String columnasTabla="host,rfc_1413,username,date_time_zone,recuest,statuscode,bytes,fecha,hora,zona,cs_referer_,cs_user_agent_";//columnas de la tabla-> cadena de tipo a,b,c,d
    boolean miError=false;//par verificar errot al incertar datos
    
    private javax.swing.JProgressBar miProgresBar;//barra de progreso
    private javax.swing.JLabel miLabel;
    private javax.swing.JButton miBoton;
    int numeroLineas;
    boolean vida;//para manejar el hilo
    
    ResultSet miResulSet;
    Statement miStatement;
    
    public CrearTablaCommonLFExt(File archivo, Object in, int cantidadLineas,Object lbl,Object btn)
    {
        conexion=miConexion.getConexion();//abro la conexion a la base de datos       
        miArchivoLogCommonLF=archivo;
        
        this.miProgresBar=(javax.swing.JProgressBar)in;
        this.miLabel=(javax.swing.JLabel)lbl;
        this.miBoton=(javax.swing.JButton)btn;
        
        this.vida=true;
        numeroLineas=cantidadLineas;
        
        CrearTabla();
    }
    
    private void CrearTabla()//host text,rfc_1413 text,username text,date_time_zone text,recuest text,statuscode text,bytes text
    {
        String stringCrearTabla="host text,rfc_1413 text,username text,date_time_zone text,recuest text,statuscode text,bytes text,fecha date,hora time,zona text,cs_referer_ text,cs_user_agent_ text";
        ResultSet miResulSet = null;
        Statement miStatement = null;
        
        try
        {
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("SELECT crear_tabla_log_comonlf('"+stringCrearTabla+"')");
            System.out.println("La funcion tabla_log_common_l_f se ejecuto correctamente - se creo la tabla 'tabla_log_common_l_f' extendida");
            miResulSet.close();
            miStatement.close();
        }catch (Exception e)
        {
            System.out.println("Error al crear la tabla 'tabla_log_common_l_f' extendida");
            System.out.println(e.getMessage());
        }       
        //CargarRegistros();
    }//fin CrearTabla()
    
    public void run()
    {
        while(vida)
        {
            CargarRegistros();
        }   
    }
    
    private void CargarRegistros()//Leer todos los registros del archivo log e incertarlos en una tabla
    {
        try
        {
            // Apertura del fichero y creacion de BufferedReader para poder hacer una lectura comoda (disponer del metodo readLine()).
            miReader = new BufferedReader(new FileReader(miArchivoLogCommonLF));

            int miProgreso=0;
            // Lectura del fichero
            String miLinea="";
            
            while(miLinea!=null)
            {
                miLinea=miReader.readLine();//leer registros del log
                if(miLinea!=null)
                {
                    //manejo del progres bar
                    miProgreso++;
                    this.miProgresBar.setValue(miProgreso);
                    this.miLabel.setText(miLinea);
                    //__________________________________________________________________________________
                    //Codigo para dar formato y filtrar registros
                        String registro=miLinea;
                        String regAux="'"+miLinea+"'"+"'','','','','','','','10/Dec/2010','10:10:10','','',''";
                        
                        System.out.println(regAux);
                        //____________________________________________________________________________________________
                        //codigo para insertar registros en la tabla
                        int opcionJOptionPane;//maneje q se le da a un eventual error al incertar: Reintentar (0), Omitir (1) o Cancelar(2 0 -1)

                        String tabla="tabla_log_common_l_f";
                        String columnas=columnasTabla;
                        opcionJOptionPane=myQuery.InsertarDatos(tabla,columnas,regAux,conexion);

                        if(opcionJOptionPane==0)//reintentar
                        {
                            while(opcionJOptionPane==0)
                                opcionJOptionPane=myQuery.InsertarDatos(tabla,columnas,regAux,conexion);
                        }
                        if(opcionJOptionPane==1)//omitir
                        {
                            continue;
                        }
                        if(opcionJOptionPane==-1||opcionJOptionPane==2)//cancelar
                        {
                            miLinea=null;//para salir del ciclo while
                            myQuery.EliminarTabla("tabla_log_common_l_f", conexion);
                        }
                        //___________________________________________________________________________________________

                }
                
            }//fin while
            actualizarRegistros();
            new CargarArreglos();//cargar registros de la bd en arreglos
            vida=false;
            this.miBoton.setEnabled(true);
        }
        catch(Exception e1){ e1.printStackTrace();}
        finally
        {
            try
            {
                if(miReader!=null) miReader.close();
                conexion=miConexion.CerrarConexion();
            }
            catch(Exception e2){e2.printStackTrace();}
        }
    }//fin CargarRegistros()
    
    private void actualizarRegistros(){
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        try {
            miStatement = conexion.createStatement();
            miStatement.executeUpdate("update tabla_log_common_l_f set rfc_1413 = split_part(host,' ',2);");
            miStatement.executeUpdate("update tabla_log_common_l_f set username = split_part(host,' ',3);");
            miStatement.executeUpdate("update tabla_log_common_l_f set date_time_zone = split_part(split_part((split_part(host,'\"',1)),'[',2),']',1);");
            miStatement.executeUpdate("update tabla_log_common_l_f set recuest = '\"'||split_part(host,'\"',2)||'\"';");
            miStatement.executeUpdate("update tabla_log_common_l_f set statuscode = btrim(split_part(btrim(split_part(host,'\"',3)),' ',1));");
            miStatement.executeUpdate("update tabla_log_common_l_f set bytes = btrim(split_part(btrim(split_part(host,'\"',3)),' ',2));");
            miStatement.executeUpdate("update tabla_log_common_l_f set cs_referer_ = btrim(replace(split_part(host,'\"',4),' ','+'));");
            miStatement.executeUpdate("update tabla_log_common_l_f set cs_user_agent_ = btrim(replace(split_part(host,'\"',6),' ','+'));--cs_user_agent");
            miStatement.executeUpdate("update tabla_log_common_l_f set host = split_part(host,' ',1);");
        } catch (Exception e) {
            System.out.println(e.getMessage()+" crear tabla clf extendido.java");
        }
    }
}
