
package polaris3.DataAcces;

import java.io.*;
import java.sql.*;
import javax.swing.JOptionPane;

public class CrearTablaW3C extends Thread
{
    boolean vida;//para manejar el hilo
    
    File miArchivoLogW3C;
    BufferedReader miReader;
    
    private Connection conexion=null;
    
    MiConexion miConexion=new MiConexion();
    EjecutarQuerys myQuery=new EjecutarQuerys();
    
    String columnasTabla;//columnas de la tabla-> cadena de tipo a,b,c,d
    boolean miError=false;//par verificar errot al incertar datos
    
    private javax.swing.JProgressBar miProgresBar;//barra de progreso
    private javax.swing.JLabel miLabel;
    private javax.swing.JButton miBoton;
    int numeroLineas;
    
    public CrearTablaW3C(File archivo, Object in, int cantidadLineas,Object lbl,Object btn) 
    {
        conexion=miConexion.getConexion();//abro la conexion a la base de datos       
        miArchivoLogW3C=archivo;
        this.miProgresBar=(javax.swing.JProgressBar)in;
        this.miLabel=(javax.swing.JLabel)lbl;
        this.miBoton=(javax.swing.JButton)btn;
        
        this.vida=true;
        numeroLineas=cantidadLineas;
        
        LeerArchivo();
    }
    
    private void LeerArchivo()//leer la a fila para obtener campos
    {
        try
        {
            // Apertura del fichero y creacion de BufferedReader para poder hacer una lectura comoda (disponer del metodo readLine()).
            miReader = new BufferedReader(new FileReader(miArchivoLogW3C));

            // Lectura del fichero
            String miLinea="";
            for(int i =0;i<4;i++)
                miLinea=miReader.readLine();//leer la linea 4 del log W3C
            ObtenerCampos(miLinea);
        }
        catch(Exception e1){e1.printStackTrace();}
        finally
        {
            // En el finally cerramos el fichero, para asegurarnos que se cierra tanto si todo va bien como si salta una excepcion.
            try
            {
                if(miReader!=null)
                    miReader.close();
            }
            catch(Exception e2){e2.printStackTrace();}
        }
    }
    
    private void ObtenerCampos(String campos)//obtener campos necesarios para crear la tabla
    {
        String misCampos=campos.substring(9);
        
        misCampos=misCampos.replace("-", "_");
        misCampos=misCampos.replace("(", "_");
        misCampos=misCampos.replace(")", "_");
        
        columnasTabla=misCampos.replace(" ", ",");//para usarlo en INSERT INTO
        
        //ahora guardamos los campos en un arreglo
        String [] mis_campos=misCampos.split(" ");
        
        String stringCrearTabla="";
        
        for(int i=0;i<mis_campos.length;i++)
        {
            stringCrearTabla=stringCrearTabla+mis_campos[i]+" text";
            if(i<mis_campos.length-1)//para evitar coma (,) al final de la cadena
                stringCrearTabla=stringCrearTabla+",";
        }
        stringCrearTabla=stringCrearTabla.replace("date text", "date date");
        stringCrearTabla=stringCrearTabla.replace("time text", "time time");
        
        columnasTabla=stringCrearTabla.replace("text", "").replace("time time", "time").replace("date date", "date").replace(" ", "");
        
        CrearTabla(stringCrearTabla);
    }
//////////////////////////////////////////////////////////////////////////////////////////////////////////  
    private void CrearTabla(String campos)//crear tabla en la base de datos
    {
        String stringCrearTabla=campos;
        ResultSet miResulSet = null;
        Statement miStatement = null;
        
        try
        {
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("SELECT crear_tabla_log_w3c('"+stringCrearTabla+"')");
            System.out.println("La funcion tabla_log_w3c se ejecuto correctamente - se creo la tabla 'tabla_log_w3c'");
            miResulSet.close();
            miStatement.close();
        }catch (Exception e)
        {
            System.out.println("Error al crear la tabla 'tabla_log_w3c'");
            System.out.println(e.getMessage());
        }       
        //CargarRegistros();
    }
    
    public void run()
    {
        while(vida)
        {
            CargarRegistros();
        }
        
    }
    private void CargarRegistros()//Leer todos los registros del archivo log e incertarlos en una tabla
    {
        try
        {
            // Apertura del fichero y creacion de BufferedReader para poder hacer una lectura comoda (disponer del metodo readLine()).
            miReader = new BufferedReader(new FileReader(miArchivoLogW3C));

            // Lectura del fichero
            String miLinea="";
            int miProgreso=0;
            while(miLinea!=null)
            {
                
                miLinea=miReader.readLine();//leer registros del log
                if(miLinea!=null)
                {
                    //manejo del progres bar
                    miProgreso++;
                    this.miProgresBar.setValue(miProgreso);
                    this.miLabel.setText(miLinea);
                    //__________________________________________________________________________________
                    //Codigo para dar formato y filtrar registros
                        String registro=miLinea;
                        if(registro.startsWith("#")==false)
                        {
                            registro=registro.replace(" ", "','");//cadena de tipo a','b','c','d
                            registro="'"+registro;
                            registro=registro+"'";//cadena de tipo 'a','b','c','d' 
                            //________________________________________________________________________________________
                            //Codigo par insertar registros en la tabla
                                int opcionJOptionPane;//maneje q se le da a un eventual error al incertar: Reintentar (0), Omitir (1) o Cancelar(2 0 -1)

                                String tabla="tabla_log_w3c";
                                String columnas=columnasTabla;
                                opcionJOptionPane=myQuery.InsertarDatos(tabla,columnas,registro,conexion);

                                if(opcionJOptionPane==0)//reintentar
                                {
                                    while(opcionJOptionPane==0)
                                        opcionJOptionPane=myQuery.InsertarDatos(tabla,columnas,registro,conexion);
                                }
                                if(opcionJOptionPane==1)//omitir
                                {
                                    continue;
                                }
                                if(opcionJOptionPane==-1||opcionJOptionPane==2)//cancelar
                                {
                                    miLinea=null;//para salir del ciclo while
                                    myQuery.EliminarTabla("tabla_log_w3c", conexion);
                                }
                            //________________________________________________________________________________________
                        }
                        
                    }

            }//fin whike
            new CargarArreglos();//cargar registros de la bd en arreglos
            vida=false;
            this.miBoton.setEnabled(true);
        }
        catch(Exception e1){ e1.printStackTrace();}
        finally
        {
            try
            {
                if(miReader!=null) miReader.close();
                conexion=miConexion.CerrarConexion();
            }
            catch(Exception e2){e2.printStackTrace();}
        }
    }//fin CargarRegistros()
    
}
