
package polaris3.Filter;

import polaris3.Table.*;
import java.awt.Color;
import java.awt.Component;
import java.awt.Desktop;
import java.awt.Font;
import java.awt.Image;
import java.net.URI;
import polaris3.Statistics.RefDominios.*;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.DefaultListCellRenderer;
import javax.swing.ImageIcon;
import javax.swing.JList;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumn;
import polaris2.graph.Nodo;
import polaris3.DataAcces.CargarArreglos;
import polaris3.DataAcces.MiConexion;
import polaris3.Statistics.RefSitios.ConfGraficoSitios;
import polaris3.ReadLogs.AbrirLog;
import polaris3.ReadLogs.ConfDominio;
import polaris3.ReadLogs.IdentificarFormatoLog;

public class TablaFiltros extends javax.swing.JDialog {

    public Nodo n=null;
    boolean nodoCorriendo;

    ConfGraficoSitios onfGraficoSitios;
    
    String nombreArchivo="";//url del log
    String formatoLog="";//formato del log
    String cadenaBusqueda="";
    
     //modificar ancho de columnas y centrar
    DefaultTableCellRenderer miTableCellenderer = new DefaultTableCellRenderer();
    DefaultTableModel miModelo;//tabla 
    DefaultTableModel miModelo1;
    
    //acceso a bd
    private Connection conexion=null;
    MiConexion miConexion=new MiConexion();
    ResultSet miResulSet;
    Statement miStatement;
    
    String tipoArchivo="";
    String strSerie="";//hits, visitantes o transferencia
    int miIdLog;
    String tablaLog="";
    String campoRequest="";
    Vector filaTabla=new Vector();
    
    public TablaFiltros(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        //lblLog.setText(nombreArchivo + " - " + formatoLog);
        miIdLog=IdentificarFormatoLog.getLogFormato();
        if(miIdLog==1){
            tablaLog="tabla_log_w3c";
            campoRequest="cs_uri_stem";
        }
        if(miIdLog==2||miIdLog==3){
            tablaLog="tabla_log_common_l_f";
            campoRequest="trim(both ' ' from substring(recuest from '%#\" % #\"%' for '#'))";
        }
        CrearTabla();
        CrearTabla1();
        miTabla2.setModel(miModelo1);
        EditarTabla1();
        EditarTabla2();
        this.setLocationRelativeTo(null);
        this.setIconImage(this.getImage("/media/star.png"));    
        nodoCorriendo=true;
    }
    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }
    public void NodoCorriendo(){
        if(nodoCorriendo==true)
            n.corriendo=true;
    }
    
     private void CrearTabla(){
        String[] nombresColumnas = {"#","Request"};
        Object[][] datos=null ;
        miModelo=null;
        miModelo = new DefaultTableModel(datos, nombresColumnas)//celdaas no editables
         {@Override
             public boolean isCellEditable (int fila, int columna) {
                 if (columna > 10)
                     return true;
                 return false;
             }
         };
        //__LLENAR DATOS EN LA TABLA___________________________________________
        CargarDatosTabla();
        //_____________________________________________________________________
        miTabla1.setModel(miModelo); 
        EditarTabla1();;     
    }
    
     private void CrearTabla1(){
        String[] nombresColumnas = {"#", "Request"};
        Object[][] datos=null ;
        miModelo1=null;       
        miModelo1 = new DefaultTableModel(datos, nombresColumnas)//celdaas no editables
         {@Override
             public boolean isCellEditable (int fila, int columna) {
                 if (columna > 10)
                     return true;
                 return false;
             }
         };        
    }
     
    private void Configurar(){
        nombreArchivo=AbrirLog.getNombreArchivo();
        formatoLog=CargarArreglos.getFormatoLog();
    }
    
    //graficar extensiones
    private void CargarDatosTabla(){//cargar datosdesde la bs
        
        String[] nombresColumnas = {"#", "Reques"};
        Object[][] datos=null ;
        miModelo=null;
        miModelo = new DefaultTableModel(datos, nombresColumnas)//celdaas no editables
        {@Override
             public boolean isCellEditable (int fila, int columna) {
                 if (columna > 10)
                     return true;
                 return false;
             }
        };
         
        String miConsulta="";
        miConsulta="SELECT "+campoRequest+" FROM "+tablaLog+" ORDER BY id";
        System.out.println(miConsulta);
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery(miConsulta);
            int i=0;
            while (miResulSet.next()){
                Object [] fila = new Object[2]; // Hay 5 columnas en la tabla 
                i++;
                fila[0] =i;
                fila[1] = miResulSet.getString(1);
                miModelo.addRow(fila);                      
            }
            miTabla1.setModel(miModelo);
            EditarTabla1();       
        }catch (Exception e){
            System.out.println("Problemas para cargar datos de  tabla log"+e.getMessage());
        }
    }
    
    private void CargarTablaBusqueda(String auxBusqueda){//cagar request desde la bd
        //esta funcion se ejecuata cuando se hace doble click en una de losarchivos del jListNombreArchivo
        
        String[] nombresColumnas = {"#", "Request"};
        Object[][] datos=null ;
        miModelo1=null;
         miModelo1 = new DefaultTableModel(datos, nombresColumnas)//celdaas no editables
         {@Override
             public boolean isCellEditable (int fila, int columna) {
                 if (columna > 10)
                     return true;
                 return false;
             }
         };
        
        String miConsulta="";
        //miConsulta="select  request,nombre_dia || ' ' || fecha || ' ' || hora  as fecha_dia,host from tabla_sesion,dias_semana where archivo = '"+nombre_archivo+"' and tabla_sesion.dia=dias_semana.id order by fecha,hora";
        miConsulta="SELECT "+campoRequest+" FROM "+tablaLog+" WHERE "+campoRequest+ " ILIKE '%"+auxBusqueda+"%';";
     
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery(miConsulta);
            int i=0;
            while (miResulSet.next()){     
                Object [] fila = new Object[2]; // Hay 5 columnas en la tabla 
                i++;
                fila[0] =i;
                fila[1] = miResulSet.getString(1);
                miModelo1.addRow(fila);        
            }
            miTabla2.setModel(miModelo1);
            EditarTabla1();
            
        }catch (Exception e){
            System.out.println("Problemas para cargar request (clase GraficoEstadisticaArchivos.java): "+e.getMessage());
        }
        
    }
    
    private void EditarTabla1(){
        //modificar ancho de columnas y centrar
        TableColumn miColumna;
        
        for (int i = 0; i < 2; i++) {
            miColumna = miTabla1.getColumnModel().getColumn(i);
            if(i == 0) miColumna.setPreferredWidth(20); //COLUMNA REQUEST
	    if(i == 1) miColumna.setPreferredWidth(500); //COLUMNA DATE
        }   
        miTabla1.setDefaultRenderer (Object.class, new MiRenderAF5());
    }
    private void EditarTabla2(){
        //modificar ancho de columnas y centrar
        TableColumn miColumna;
        
        for (int i = 0; i < 2; i++) {
            miColumna = miTabla2.getColumnModel().getColumn(i);
            if(i == 0) miColumna.setPreferredWidth(20); //COLUMNA REQUEST
	    if(i == 1) miColumna.setPreferredWidth(500); //COLUMNA DATE
        }   
        miTabla2.setDefaultRenderer (Object.class, new MiRenderAF5());
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        miTabla1 = new javax.swing.JTable();
        btnRefrescar = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        miTabla2 = new javax.swing.JTable();
        jLabel1 = new javax.swing.JLabel();
        txtBuscar = new javax.swing.JTextField();
        botonBuscar = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Filter");
        setAlwaysOnTop(true);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Table", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 12))); // NOI18N

        miTabla1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        miTabla1.setCellSelectionEnabled(true);
        miTabla1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                miTabla1MouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(miTabla1);
        miTabla1.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_INTERVAL_SELECTION);

        btnRefrescar.setText("Refresh");
        btnRefrescar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRefrescarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 699, Short.MAX_VALUE)
                    .addComponent(btnRefrescar))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 190, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnRefrescar))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Find", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N

        miTabla2.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        miTabla2.setCellSelectionEnabled(true);
        miTabla2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                miTabla2MouseClicked(evt);
            }
        });
        jScrollPane2.setViewportView(miTabla2);

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel1.setText("Find:");

        botonBuscar.setText("Find");
        botonBuscar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonBuscarActionPerformed(evt);
            }
        });

        jButton1.setText("Delete Lines");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 691, Short.MAX_VALUE)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(txtBuscar, javax.swing.GroupLayout.PREFERRED_SIZE, 262, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(botonBuscar))
                    .addComponent(jButton1, javax.swing.GroupLayout.Alignment.TRAILING))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(txtBuscar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(botonBuscar))
                .addGap(18, 18, 18)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 160, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 7, Short.MAX_VALUE)
                .addComponent(jButton1))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void miTabla1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_miTabla1MouseClicked
   if (evt.getClickCount() == 2){    
        String auxUrl="";
        int fila = miTabla1.rowAtPoint(evt.getPoint());
        int columna = miTabla1.columnAtPoint(evt.getPoint());
        if ((fila > -1) && (columna == 1)){
            auxUrl=(String)miModelo.getValueAt(fila,columna);
            AbrirURL(auxUrl);
            System.out.println(auxUrl);
        }
       
    }
}//GEN-LAST:event_miTabla1MouseClicked

private void miTabla2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_miTabla2MouseClicked
    if (evt.getClickCount() == 2){    
        String auxUrl="";
        int fila = miTabla2.rowAtPoint(evt.getPoint());
        int columna = miTabla2.columnAtPoint(evt.getPoint());
        if ((fila > -1) && (columna == 1)){
            auxUrl=(String)miModelo1.getValueAt(fila,columna);
            AbrirURL(auxUrl);
            System.out.println(auxUrl);
        }
       
    }
}//GEN-LAST:event_miTabla2MouseClicked

private void btnRefrescarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRefrescarActionPerformed
//refrescar datos de la tabla log
    CargarDatosTabla();
}//GEN-LAST:event_btnRefrescarActionPerformed

private void botonBuscarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonBuscarActionPerformed
    String strBuscar=txtBuscar.getText();
    cadenaBusqueda=strBuscar;
    if(strBuscar.compareTo("")!=0)
        CargarTablaBusqueda(strBuscar);
}//GEN-LAST:event_botonBuscarActionPerformed

private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
    //borrar lineaas encontradas
    conexion=miConexion.getConexion();//abro la conexion a la base de datos 
    miResulSet = null;
    miStatement = null;
    try {
        miStatement = conexion.createStatement();
        miStatement.executeUpdate("DELETE FROM "+tablaLog+" WHERE "+campoRequest+" ILIKE '%"+cadenaBusqueda+"%'; ");
    } catch (Exception e) {
        System.out.println(e.getMessage()+" crear tabla clf extendido.java");
    }
    CargarTablaBusqueda(cadenaBusqueda);
}//GEN-LAST:event_jButton1ActionPerformed

private void AbrirURL(String miAuxUrl){
    
    String miURL="http://";
    miURL=miURL+ConfDominio.getDominio();
    
    miURL=miURL+miAuxUrl;
    System.out.println(miURL);
    miURL=miURL.replace(" ", "+");
    try {
         Desktop.getDesktop().browse(new URI(miURL));
    } catch (Exception e) {
        System.out.println("No se puede abrir url: "+e.getMessage());
    }
    
}
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(TablaFiltros.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(TablaFiltros.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(TablaFiltros.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(TablaFiltros.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                TablaFiltros dialog = new TablaFiltros(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonBuscar;
    private javax.swing.JButton btnRefrescar;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTable miTabla1;
    private javax.swing.JTable miTabla2;
    private javax.swing.JTextField txtBuscar;
    // End of variables declaration//GEN-END:variables
}
class MyCellRenderer5 extends  DefaultListCellRenderer {
        public MyCellRenderer5() {
            setOpaque(true);
        }
        Color currColor=Color.white;  
        public Component getListCellRendererComponent( JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
        super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
        if(index%2==0) {                              
            currColor=Color.LIGHT_GRAY;  
        }      
        else {  
            currColor=new Color(222,222,255);                  
        }                              
        if(isSelected) {  
            super.setForeground(list.getSelectionForeground());  
            super.setBackground(list.getSelectionBackground());  
        } else {  
            super.setForeground(Color.BLACK);     
            super.setBackground(currColor);  
        }           
        setFont(list.getFont());                                  
            return this;
        }
    }

//clase para cambiar la apariencia de las tablas
class MiRenderAF5 extends DefaultTableCellRenderer{
    
    Color currColor=Color.white;  
    
    public Component getTableCellRendererComponent(JTable table,Object value,boolean isSelected,boolean hasFocus,int row,int column)
    {
        super.getTableCellRendererComponent (table, value, isSelected, hasFocus, row, column);
        this.setOpaque(true);
        table.setShowGrid(true);
        
        //cambiar fuente de cabeseras
        JTableHeader th = table.getTableHeader(); 
        Font fuente = new Font("Verdana", Font.BOLD, 12); 
        th.setFont(fuente); 
       // th.setBackground(new Color(153,153,255));
        
        //alternar color de filas
        if(row%2==0) {                              
            currColor=Color.white;  
        }      
        else {  
            currColor=new Color(222,222,255);                  
        }                              
        if(isSelected) {  
            super.setForeground(table.getSelectionForeground());  
            super.setBackground(table.getSelectionBackground());  
        } else {  
            super.setForeground(Color.black);     
            super.setBackground(currColor);  
        }                         
        setFont(table.getFont());                                  
        setValue(value);  
        
        //alinear columnas
        super.setHorizontalAlignment(SwingConstants.LEFT);
     
        //resisables
       // table.getColumnModel().getColumn(0).setResizable(false);
        //table.getColumnModel().getColumn(1).setResizable(false);
        //table.getColumnModel().getColumn(2).setResizable(false);
        //table.getColumnModel().getColumn(3).setResizable(false);
        //table.getColumnModel().getColumn(4).setResizable(false);
        return this;
   }
}