//crear sesiones y guardarlas en una nueva tabla con los siguientes campos
    //id
    //host
    //fecha
    //hora
    //id_sesion -> sesion1,sesion2....
package polaris3.Session;
import polaris3.DataAcces.EjecutarQuerys;
import polaris3.DataAcces.MiConexion;
import java.sql.*;
import java.util.*;
import polaris3.ReadLogs.IdentificarFormatoLog;
import polaris3.ReadLogs.AbrirLog;
import javax.swing.JOptionPane;
import polaris2.graph.Nodo;

public class CrearSesiones {
    
    public Nodo n=null;
    boolean nodoCorriendo = false;
    
    //VECTORES PARA ALMACENAR CAMPOS DE TABLA 
    static Vector vectorId=new Vector();//id del registro
    Vector auxVectorId=new Vector();
    static Vector vectorHost=new Vector();//ip del cliente
    static Vector vectorDate=new Vector();//fecha
    static Vector vectorTime=new Vector();//hora
    //____________________________________________
    
    EjecutarQuerys myQuery=new EjecutarQuerys();
    private Connection conexion=null;
    MiConexion miConexion=new MiConexion();
    ResultSet miResulSet;
    Statement miStatement;
    Statement miStatementUpdate; //para realizar update
    
    static String nombreArchivo="";
    static int miIdLog;//formato del log
    static String formatoLog="";
    static int intervaloSesion=0;
    boolean estadoRangoSesion=false;
    boolean opcIntervalo=false;
    boolean opcTimeof=false;
    
    public CrearSesiones(){
        miIdLog=IdentificarFormatoLog.getLogFormato();
        nombreArchivo=AbrirLog.getNombreArchivo();
        intervaloSesion=RangoSesion.getRango_sesion();//obtener el intervalo de tiepo de la sesion 10,15,20..
        estadoRangoSesion=RangoSesion.isEstadoRangoSesion();
        opcIntervalo=RangoSesion.isOpcIntervalo();
        opcTimeof=RangoSesion.isOpcTimeof();
                
        //System.out.println("El formato es :" + miIdLog);
        if(estadoRangoSesion==true){//Si ya se configuro el tiempo de cada sesion   
            if(miIdLog==1){
                CrearTablaSesiones();
                formatoLog="W3C Extended Log File Format";
            }
            if(miIdLog==2){
                CrearTablaSesiones();
                formatoLog="Common Log Format (CLF)";
            } 
            if(miIdLog==3){
                CrearTablaSesiones();
                formatoLog="Combined Common Log Format";
            } 
        }else{
            //Mensaje: primero configurar intervalo
            JOptionPane.showMessageDialog(null, "Configurar el tiempo de sesion", "Sesion",JOptionPane.ERROR_MESSAGE);
        }   
    }
    
    public void NodoCorriendo(){
        if(nodoCorriendo==true)
            n.corriendo=true;
    }
    
    public void CrearTablaSesiones()//crear la tabla sesion con las funciones sql
    {
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        try {
            miStatement = conexion.createStatement();
            miStatement.executeUpdate("alter table tabla_log_w3c add column sc_bytes text");
        } catch (Exception e) {
            System.out.println(e.getMessage()+" CrearSesiones.java");
        }
        miResulSet = null;
        miStatement = null;
        try {
            miStatement = conexion.createStatement();
            miStatement.executeUpdate("alter table tabla_log_w3c add column cs_referer_ text");
        } catch (Exception e) {
            System.out.println(e.getMessage()+" CrearSesiones.java");
        }
        
        miResulSet = null;
        miStatement = null;
        try {
            miStatement = conexion.createStatement();
            miStatement.executeUpdate("alter table tabla_log_w3c add column cs_user_agent_ text");
        } catch (Exception e) {
            System.out.println(e.getMessage()+" CrearSesiones.java");
        }
        
        miResulSet = null;
        miStatement = null;
        try{
            miStatement = conexion.createStatement();
            if(miIdLog==1){//W3C
                
                miResulSet = miStatement.executeQuery("SELECT sesionalizar_w3c()");
                System.out.println("Se creo tabla_sesion para w3c - clase CrearSesiones.java'");  
                
                //cargar en un resulset la tabla
                
            }
            if(miIdLog==2){//CLF
                miResulSet = miStatement.executeQuery("SELECT sesionalizar_clf()");
                System.out.println("Se creo tabla_sesion para clf - clase CrearSesiones.java'"); 
                
                //cargar en un resulset la tabla
            }
            if(miIdLog==3){//CLF
                miResulSet = miStatement.executeQuery("SELECT sesionalizar_clf()");
                System.out.println("Se creo tabla_sesion para clf extendido - clase CrearSesiones.java'"); 
                
                //cargar en un resulset la tabla
            }
            miResulSet.close();
            miStatement.close();
            if(opcIntervalo==true)
                SesioinalizarIntervalo();
            if(opcTimeof==true)
                SesionalizarTimeOf();
        }
        catch (Exception e){
            System.out.println("Error al crear sesiones. CrearSesiones.java");
            System.out.println(e.getMessage());
            JOptionPane.showMessageDialog(null, "Error Session: "+e.getMessage(), 
                    "Error", JOptionPane.ERROR_MESSAGE);
        } 
        
        
    }
    
    public void SesionalizarTimeOf(){//sesinalizar utilizando timeof de 30 minutos
        miResulSet = null;
        miStatement = null;
        try {
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("SELECT sesionalizar_timeof()");
            System.out.println("Se ejecuto funcion SQL sesionalizar_timeof()");
            CrearTablaResumen();
        } catch (Exception e) {
            System.out.println("Error al ejecutar funcion SQL sesionalizar_timeof()");
        }  
    }
    
    public void SesioinalizarIntervalo(){//sesionalizar utilizando intervalos de tiempo
        
        String rangoIntervalo=String.valueOf(intervaloSesion);
        
        miResulSet = null;
        miStatement = null;
        try {
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("SELECT sesionalizar_intervalos('"+rangoIntervalo+" minutes')");
            System.out.println("Se ejecuto funcion sesionalizar_intervalos('"+rangoIntervalo+" minutes')");
            CrearTablaResumen();
        } catch (Exception e) {
            System.out.println("Error al ejecutar funcion SQL sesionalizar_intervalos(rangoSesin interval)");
        }  
        
    }
    
    public void CrearTablaResumen(){
        //crear tabla de resumene de sesiones con los campos id, host, start_date , final_date
        miResulSet = null;
        miStatement = null;
        try {
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("SELECT crear_resumen_sesion()");
            System.out.println("Se ejecuto funcion SQL crear_resumen_sesion()");
        } catch (Exception e) {
            System.out.println("Error al ejecutar funcion SQL crear_resumen_sesion()");
        }  
        
        nodoCorriendo=true;
        
    }
            
   //---------------------------------------------------------------------------------------------
    public static String getFormatoLog() {
        return formatoLog;
    }

    public static int getMiIdLog() {
        return miIdLog;
    }

    public static String getNombreArchivo() {
        return nombreArchivo;
    }

    public static Vector getVectorDate() {
        return vectorDate;
    }

    public static Vector getVectorHost() {
        return vectorHost;
    }

    public static Vector getVectorId() {
        return vectorId;
    }

    public static Vector getVectorTime() {
        return vectorTime;
    }
}
