
package polaris3.Session;

import polaris3.Table.VerTablaSesion;
import polaris3.DataAcces.MiConexion;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.math.RoundingMode;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;

public class DetallesSesion extends javax.swing.JDialog {
    
    //_____________________________________________________
    MiConexion miConexion=new MiConexion();
    ResultSet miResulSet;
    Statement miStatement;
    private Connection conexion=null;
    //_____________________________________________________
    
    DefaultTableModel miModelo1;//tabla download pages
    DefaultTableModel miModelo2;//tabla download extensiins
    DefaultTableModel miModelo3;//tabla http codes
    
    //modificar ancho de columnas y centrar
    DefaultTableCellRenderer miTableCellenderer = new DefaultTableCellRenderer();
    
    String idSesion="0";//lo obtengo desde el boton "Details" de la clase VerTablaSesion
    String remoteHost="";
    String requestAmount="";
    String downloadSize="";

    public DetallesSesion(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.setLocationRelativeTo(null);
        conexion=miConexion.getConexion();//abrir conexion a bd
        MostrarDatosGenerales();
        CrearTablaDownloadPages();
        CrearTablaDownloadExtension();
        CrearTablaHttpCode();
    }
    
    private void MostrarDatosGenerales(){
        //mostrar request amount, download size, remte host
        idSesion=VerTablaSesion.getIdSesion();
        this.setTitle("Details Session");
        miPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Session " + idSesion, javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 12))); // NOI18N

        //btener campos de la tabla resumen_sesion segun idSesion
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;

        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("select host,cantidad_peticiones,transferencia from resumen_sesion where id = " + idSesion);
            while (miResulSet.next()){
                remoteHost=miResulSet.getString("host");
                requestAmount=miResulSet.getString("cantidad_peticiones");
                downloadSize=miResulSet.getString("transferencia");
            }

        }catch (Exception e){
            System.out.println("Problemas al crear detalles de Sesion: "+e.getMessage());
        }
        
        //redondear
        double auxDS=0;
        auxDS=Float.parseFloat(downloadSize);
        auxDS=auxDS/1024;//pasar a KB
        auxDS=Math.rint(auxDS*1000)/1000;//redondear
        
        downloadSize=String.valueOf(auxDS + " KB");
        
        lblRemoteHost.setText(remoteHost);
        lblRequestAmount.setText(requestAmount);
        lblDownloadSize.setText(downloadSize);
        
    }
    
    private void CrearTablaDownloadPages(){
        String[] nombresColumnas = {"#", "DWNLOAD PAGE"};
        Object[][] datos=null ;
        miModelo1 = new DefaultTableModel(datos, nombresColumnas);
        //__LLENAR DATOS EN LA TABLA___________________________________________
        LlenarTablaDownloadPages();
        //_____________________________________________________________________
        tablaDownloadPages.setModel(miModelo1); 
        
        //modificar ancho de columnas y centrar
        TableColumn miColumna;
        miTableCellenderer.setHorizontalAlignment(SwingConstants.CENTER);//centrar
        tablaDownloadPages.getColumnModel().getColumn(0).setCellRenderer(miTableCellenderer);//centrar columna #
        for (int i = 0; i < 2; i++) {
            miColumna = tablaDownloadPages.getColumnModel().getColumn(i);
            if(i == 0) miColumna.setPreferredWidth(10); //COLUMNA #
	    if(i == 1) miColumna.setPreferredWidth(380); //COLUMNA DOWNLOAD PAGE     
        }   
    }

    private void CrearTablaDownloadExtension(){
        String[] nombresColumnas = {"#", "DWNLOAD EXTENSION"};
        Object[][] datos=null ;
        miModelo2 = new DefaultTableModel(datos,nombresColumnas);
        //__LLENAR DATOS EN LA TABLA___________________________________________
        LlenarTablaDownloadExtension();
        //_____________________________________________________________________
        tablaDownloadExtension.setModel(miModelo2); 
        
        //modificar ancho de columnas y centrar
        TableColumn miColumna;
        miTableCellenderer.setHorizontalAlignment(SwingConstants.CENTER);//centrar
        tablaDownloadExtension.getColumnModel().getColumn(0).setCellRenderer(miTableCellenderer);//centrar columna #
        for (int i = 0; i < 2; i++) {
            miColumna = tablaDownloadExtension.getColumnModel().getColumn(i);
            if(i == 0) miColumna.setPreferredWidth(10); //COLUMNA #
	    if(i == 1) miColumna.setPreferredWidth(380); //COLUMNA DOWNLOAD EXTENSION     
        } 
    }
    
    private void CrearTablaHttpCode(){
        String[] nombresColumnas = {"#", "CODE","DESCRIPTION"};
        Object[][] datos=null ;
        miModelo3 = new DefaultTableModel(datos, nombresColumnas);
        //__LLENAR DATOS EN LA TABLA___________________________________________
        LlenarTablaHttpCodes();
        //_____________________________________________________________________
        tablaHttpCodes.setModel(miModelo3);
        
        //modificar ancho de columnas y centrar
        TableColumn miColumna;
        miTableCellenderer.setHorizontalAlignment(SwingConstants.CENTER);//centrar
        tablaHttpCodes.getColumnModel().getColumn(0).setCellRenderer(miTableCellenderer);//centrar columna #
        tablaHttpCodes.getColumnModel().getColumn(1).setCellRenderer(miTableCellenderer);//centrar columna #
        for (int i = 0; i < 3; i++) {
            miColumna = tablaHttpCodes.getColumnModel().getColumn(i);
            if(i == 0) miColumna.setPreferredWidth(10); //COLUMNA #
	    if(i == 1) miColumna.setPreferredWidth(60); //COLUMNA HTTP CODE
            if(i == 2) miColumna.setPreferredWidth(350); //COLUMNA HTTP CODE
        } 
    }
    
    public void LlenarTablaDownloadPages(){
        miResulSet = null;
        miStatement = null;
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("select distinct request from tabla_sesion where id_sesion = "+idSesion+" and request IS NOT NULL;");
            int i=0;//variable para enumerar losregistros
            while (miResulSet.next()){
                Object [] fila = new Object[2]; // Hay 2 columnas en la tabla
                i=i+1;
                // Se rellena cada posición del array con una de las columnas de la tabla en base de datos.
                fila[0]=i;
                fila[1] = miResulSet.getString(1); // El primer indice en rs es el 1, no el cero, por eso se suma 1.
                // Se añade al modelo la fila completa.
                miModelo1.addRow(fila);
            }
        }catch (Exception e){
            System.out.println("Problemas para cargar detalles de sesion(download extensions): "+e.getMessage());
        }
        
    }
    
    public void LlenarTablaDownloadExtension(){
        miResulSet = null;
        miStatement = null;
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("select distinct extension from tabla_sesion where id_sesion = "+idSesion+" and extension IS NOT NULL;");
            int i=0;//variable para enumerar losregistros
            while (miResulSet.next()){
                Object [] fila = new Object[2]; // Hay 2 columnas en la tabla
                i=i+1;
                // Se rellena cada posición del array con una de las columnas de la tabla en base de datos.
                fila[0]=i;
                fila[1] = miResulSet.getString(1); // El primer indice en rs es el 1, no el cero, por eso se suma 1.
                // Se añade al modelo la fila completa.
                miModelo2.addRow(fila);
            }
        }catch (Exception e){
            System.out.println("Problemas para cargar detalles de sesion(download extensions): "+e.getMessage());
        }
    }
    
    public void LlenarTablaHttpCodes(){
        miResulSet = null;
        miStatement = null;
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("select  distinct status_code,descripcion from tabla_sesion,codigo_http where id_sesion = "+idSesion+" and tabla_sesion.status_code=codigo_http.codigo");
            int i=0;//variable para enumerar losregistros
            while (miResulSet.next()){
                Object [] fila = new Object[3]; // Hay 3 columnas en la tabla
                i=i+1;
                // Se rellena cada posición del array con una de las columnas de la tabla en base de datos.
                fila[0]=i;
                fila[1] = miResulSet.getString(1); // El primer indice en rs es el 1, no el cero, por eso se suma 1.
                fila[2] = miResulSet.getString(2);
                // Se añade al modelo la fila completa.
                miModelo3.addRow(fila);
            }
        }catch (Exception e){
            System.out.println("Problemas para cargar detalles de sesion(httpstatus code): "+e.getMessage());
        }   
    }
    
    
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tablaDownloadPages = new javax.swing.JTable();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        tablaDownloadExtension = new javax.swing.JTable();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        tablaHttpCodes = new javax.swing.JTable();
        miPanel = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        lblRemoteHost = new javax.swing.JLabel();
        lblRequestAmount = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        lblDownloadSize = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setAlwaysOnTop(true);

        jTabbedPane1.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jTabbedPane1.setOpaque(true);

        tablaDownloadPages.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(tablaDownloadPages);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 525, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 151, Short.MAX_VALUE)
                .addContainerGap())
        );

        jTabbedPane1.addTab("DOWNLOAD FILE", jPanel1);

        tablaDownloadExtension.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane2.setViewportView(tablaDownloadExtension);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 525, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 153, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(32, 32, 32))
        );

        jTabbedPane1.addTab("DOWNLOAD EXTENSION", jPanel2);

        tablaHttpCodes.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane3.setViewportView(tablaHttpCodes);

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 525, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 151, Short.MAX_VALUE)
                .addContainerGap())
        );

        jTabbedPane1.addTab("HTTP STATUS CODES", jPanel3);

        miPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Session id", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 12))); // NOI18N

        jLabel3.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel3.setText("Remote Host");

        lblRemoteHost.setText("aa");
        lblRemoteHost.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        lblRequestAmount.setText("00");
        lblRequestAmount.setAutoscrolls(true);
        lblRequestAmount.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel4.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel4.setText("Request Amount ");

        jLabel5.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel5.setText("Download Size");

        lblDownloadSize.setText("00");
        lblDownloadSize.setAutoscrolls(true);
        lblDownloadSize.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        javax.swing.GroupLayout miPanelLayout = new javax.swing.GroupLayout(miPanel);
        miPanel.setLayout(miPanelLayout);
        miPanelLayout.setHorizontalGroup(
            miPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, miPanelLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(miPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(miPanelLayout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(lblRemoteHost, javax.swing.GroupLayout.PREFERRED_SIZE, 369, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(4, 4, 4))
                    .addGroup(miPanelLayout.createSequentialGroup()
                        .addGroup(miPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(miPanelLayout.createSequentialGroup()
                                .addComponent(jLabel5)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(lblDownloadSize, javax.swing.GroupLayout.PREFERRED_SIZE, 74, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(miPanelLayout.createSequentialGroup()
                                .addComponent(jLabel4)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(lblRequestAmount, javax.swing.GroupLayout.PREFERRED_SIZE, 74, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(299, 299, 299)))
                .addGap(29, 29, 29))
        );
        miPanelLayout.setVerticalGroup(
            miPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(miPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(miPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3)
                    .addComponent(lblRemoteHost))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(miPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblRequestAmount)
                    .addComponent(jLabel4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(miPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblDownloadSize)
                    .addComponent(jLabel5))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTabbedPane1, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(miPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(miPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 202, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(DetallesSesion.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(DetallesSesion.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(DetallesSesion.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(DetallesSesion.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                DetallesSesion dialog = new DetallesSesion(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JLabel lblDownloadSize;
    private javax.swing.JLabel lblRemoteHost;
    private javax.swing.JLabel lblRequestAmount;
    private javax.swing.JPanel miPanel;
    private javax.swing.JTable tablaDownloadExtension;
    private javax.swing.JTable tablaDownloadPages;
    private javax.swing.JTable tablaHttpCodes;
    // End of variables declaration//GEN-END:variables
}
