
package polaris3.Statistics;
import java.awt.Image;
import javax.swing.ImageIcon;
import polaris3.Statistics.CrearResumenGeneral;

public class LanzarResumenGeneral extends javax.swing.JDialog {

    int miIdLog;
    String formatoLog="";
    String nombreArchivo=".log";
    float numeroDiferenteDias=0;//numero de dias diferentes
    float totalPeticiones=0;//numero de peticiones totales
    float peticionesExitosas=0;//numero de Peticiones exitosas http 2xx
    float peticionesRedireccionadas=0;//numero de peticiones redireccionadas
    float peticionesFallidasCliente=0;//numero de peticiones fallidas por herror del cliente
    float peticionesFallidasServidor=0;//numero de peticiones fallidas por herror del Servidor
    double transferenciaTotal=0;//transferencia total de bytes de datos
    float totalPaginasVistas=0;//total paginas vistas
    
    double promedioPeticionesDia=0;//promedio de visitas por dia
    double promedioTransferenciaDia=0;//promedio transferencia de bytes de datos por dia
    double promedioTransferenciaPeticion=0;//promedio transferencia de bytes de datos por peticion
    double promedioPaginasVistasDia=0;//promerdio de paginas vistas por dia
    float numeroVisitantes=0;//numero de visitantes (ips unicas)
    
    String fechaInicio="";
    String fechaFin="";
    String horaInicio="";
    String horaFin="";
    String intervaloTiempo="";
    
    public LanzarResumenGeneral(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.setLocationRelativeTo(null);
        this.setIconImage(this.getImage("/media/star.png"));
        GetDatos();
        SetDatos();
    }
    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }
    public void GetDatos()//Cargar valores en las variables
    {
        this.miIdLog=CrearResumenGeneral.getMiIdLog();
        this.formatoLog=CrearResumenGeneral.getFormatoLog();
        this.nombreArchivo=CrearResumenGeneral.getNombreArchivo();
        this.numeroDiferenteDias=CrearResumenGeneral.getNumeroDiferenteDias();
        this.totalPeticiones=CrearResumenGeneral.getTotalPeticiones();
        this.peticionesExitosas=CrearResumenGeneral.getPeticionesExitosas();
        this.peticionesRedireccionadas=CrearResumenGeneral.getPeticionesRedireccionadas();
        this.peticionesFallidasCliente=CrearResumenGeneral.getPeticionesFallidasCliente();
        this.peticionesFallidasServidor=CrearResumenGeneral.getPeticionesFallidasServidor();
        this.transferenciaTotal=CrearResumenGeneral.getTransferenciaTotal();
        this.totalPaginasVistas=CrearResumenGeneral.getTotalPaginasVistas();
        this.promedioPeticionesDia=CrearResumenGeneral.getPromedioPeticionesDia();
        this.promedioTransferenciaDia=CrearResumenGeneral.getPromedioTransferenciaDia();
        this.promedioTransferenciaPeticion=CrearResumenGeneral.getPromedioTransferenciaPeticion();
        this.promedioPaginasVistasDia=CrearResumenGeneral.getPromedioPaginasVistasDia();
        this.numeroVisitantes=CrearResumenGeneral.getNumeroVisitantes();
        
        this.fechaInicio=CrearResumenGeneral.getFechaInicio();
        this.fechaFin=CrearResumenGeneral.getFechaFin();
        this.horaInicio=CrearResumenGeneral.getHoraInicio();
        this.horaFin=CrearResumenGeneral.getHoraFin();
        this.intervaloTiempo=CrearResumenGeneral.getIntervaloTiempo();          
        
    }

    public void SetDatos()//colocar valores en el formulario frame
    {
        //DATOS CABECERA
        this.lblNombreArchivo.setText(nombreArchivo);
        this.lblFormatoLog.setText(formatoLog);
        System.out.println(formatoLog + "xx");
        this.lblIntervaloTiempo.setText(intervaloTiempo);
        //SOLICITUDES
        this.lblSolicitudesTotales.setText(String.valueOf(this.totalPeticiones));
        this.lblSolicitudesExitosas.setText(String.valueOf(this.peticionesExitosas));
        this.lblSolicitudesRedirecc.setText(String.valueOf(this.peticionesRedireccionadas));
        this.lblSolicitudesFallaCliente.setText(String.valueOf(this.peticionesFallidasCliente));
        this.lblSolicitudesFallaServidor.setText(String.valueOf(this.peticionesFallidasServidor));
        this.lblPromedioSoliDia.setText(String.valueOf(this.promedioPeticionesDia));
        
        //VISITAS
        this.lblPaginasVistas.setText(String.valueOf(this.totalPaginasVistas));
        this.lblPromPagVistasDia.setText(String.valueOf(this.promedioPaginasVistasDia));
        this.lblTotalVisitantes.setText(String.valueOf(this.numeroVisitantes));
        
        //TRANSFERENCA DE DATOS
        this.lblTransfTotal.setText(String.valueOf(this.transferenciaTotal));
        this.lblPromTransTotalDia.setText(String.valueOf(this.promedioTransferenciaDia));
        this.lblPromTransfSolicitud.setText(String.valueOf(this.promedioTransferenciaPeticion));    
    }
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jPanel1 = new javax.swing.JPanel();
        panelTitulo = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        lblFormatoLog = new javax.swing.JLabel();
        lblNombreArchivo = new javax.swing.JLabel();
        lblIntervaloTiempo = new javax.swing.JLabel();
        panelTitulo1 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        lblSolicitudesTotales = new javax.swing.JLabel();
        lblSolicitudesExitosas = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        lblSolicitudesRedirecc = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        jLabel17 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        lblSolicitudesFallaCliente = new javax.swing.JLabel();
        lblSolicitudesFallaServidor = new javax.swing.JLabel();
        lblPromedioSoliDia = new javax.swing.JLabel();
        jLabel22 = new javax.swing.JLabel();
        jLabel23 = new javax.swing.JLabel();
        jLabel24 = new javax.swing.JLabel();
        lblPaginasVistas = new javax.swing.JLabel();
        lblPromPagVistasDia = new javax.swing.JLabel();
        lblTotalVisitantes = new javax.swing.JLabel();
        jLabel28 = new javax.swing.JLabel();
        jLabel29 = new javax.swing.JLabel();
        jLabel30 = new javax.swing.JLabel();
        lblTransfTotal = new javax.swing.JLabel();
        lblPromTransTotalDia = new javax.swing.JLabel();
        lblPromTransfSolicitud = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Summary");
        setAlwaysOnTop(true);

        jPanel1.setAutoscrolls(true);

        panelTitulo.setBackground(new java.awt.Color(0, 102, 153));

        jPanel2.setBackground(new java.awt.Color(0, 102, 153));
        jPanel2.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel1.setFont(new java.awt.Font("SansSerif", 1, 14)); // NOI18N
        jLabel1.setForeground(new java.awt.Color(255, 255, 255));
        jLabel1.setText("File:");

        jLabel2.setFont(new java.awt.Font("SansSerif", 1, 14)); // NOI18N
        jLabel2.setForeground(new java.awt.Color(255, 255, 255));
        jLabel2.setText("Log Format:");

        jLabel5.setFont(new java.awt.Font("SansSerif", 1, 14)); // NOI18N
        jLabel5.setForeground(new java.awt.Color(255, 255, 255));
        jLabel5.setText("Time Range:");

        lblFormatoLog.setFont(new java.awt.Font("SansSerif", 0, 14)); // NOI18N
        lblFormatoLog.setForeground(new java.awt.Color(255, 255, 255));
        lblFormatoLog.setText("formatoLog");

        lblNombreArchivo.setFont(new java.awt.Font("SansSerif", 0, 14)); // NOI18N
        lblNombreArchivo.setForeground(new java.awt.Color(255, 255, 255));
        lblNombreArchivo.setText("nombreArchivo");

        lblIntervaloTiempo.setFont(new java.awt.Font("SansSerif", 0, 14)); // NOI18N
        lblIntervaloTiempo.setForeground(new java.awt.Color(255, 255, 255));
        lblIntervaloTiempo.setText("intervaloTiempo");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 105, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(lblIntervaloTiempo, javax.swing.GroupLayout.PREFERRED_SIZE, 438, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel2Layout.createSequentialGroup()
                            .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 105, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                            .addComponent(lblNombreArchivo, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel2Layout.createSequentialGroup()
                            .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 105, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                            .addComponent(lblFormatoLog, javax.swing.GroupLayout.PREFERRED_SIZE, 333, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(111, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(lblNombreArchivo))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(lblFormatoLog))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(lblIntervaloTiempo))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout panelTituloLayout = new javax.swing.GroupLayout(panelTitulo);
        panelTitulo.setLayout(panelTituloLayout);
        panelTituloLayout.setHorizontalGroup(
            panelTituloLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelTituloLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        panelTituloLayout.setVerticalGroup(
            panelTituloLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelTituloLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        panelTitulo1.setBackground(new java.awt.Color(0, 102, 153));

        jLabel3.setFont(new java.awt.Font("Arial", 1, 36)); // NOI18N
        jLabel3.setForeground(new java.awt.Color(255, 255, 255));
        jLabel3.setText("POLARIS 3.0");

        javax.swing.GroupLayout panelTitulo1Layout = new javax.swing.GroupLayout(panelTitulo1);
        panelTitulo1.setLayout(panelTitulo1Layout);
        panelTitulo1Layout.setHorizontalGroup(
            panelTitulo1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelTitulo1Layout.createSequentialGroup()
                .addGap(51, 51, 51)
                .addComponent(jLabel3)
                .addContainerGap(472, Short.MAX_VALUE))
        );
        panelTitulo1Layout.setVerticalGroup(
            panelTitulo1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelTitulo1Layout.createSequentialGroup()
                .addGap(22, 22, 22)
                .addComponent(jLabel3)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel3.setBackground(new java.awt.Color(212, 224, 224));
        jPanel3.setBorder(javax.swing.BorderFactory.createEtchedBorder(java.awt.Color.white, java.awt.Color.white));

        jLabel6.setBackground(new java.awt.Color(0, 153, 153));
        jLabel6.setFont(new java.awt.Font("Aharoni", 1, 20)); // NOI18N
        jLabel6.setForeground(new java.awt.Color(255, 255, 255));
        jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel6.setText("OVERVIEW");
        jLabel6.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jLabel6.setOpaque(true);

        jLabel7.setBackground(new java.awt.Color(0, 153, 153));
        jLabel7.setFont(new java.awt.Font("Arial Black", 0, 13)); // NOI18N
        jLabel7.setForeground(new java.awt.Color(255, 255, 255));
        jLabel7.setText("  HITS");
        jLabel7.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jLabel7.setOpaque(true);

        jLabel8.setBackground(new java.awt.Color(0, 153, 153));
        jLabel8.setFont(new java.awt.Font("Arial Black", 0, 13)); // NOI18N
        jLabel8.setForeground(new java.awt.Color(255, 255, 255));
        jLabel8.setText("   DATA TRANSFER");
        jLabel8.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jLabel8.setOpaque(true);

        jLabel9.setBackground(new java.awt.Color(0, 153, 153));
        jLabel9.setFont(new java.awt.Font("Arial Black", 0, 13)); // NOI18N
        jLabel9.setForeground(new java.awt.Color(255, 255, 255));
        jLabel9.setText("  VISITS");
        jLabel9.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jLabel9.setOpaque(true);

        jLabel10.setBackground(new java.awt.Color(212, 224, 224));
        jLabel10.setFont(new java.awt.Font("Arial Black", 1, 12)); // NOI18N
        jLabel10.setForeground(new java.awt.Color(0, 102, 102));
        jLabel10.setText("   Successful Hits");
        jLabel10.setToolTipText("Codigo de estado HTTP 2xx: Peticiones recibidas correctamente");
        jLabel10.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        jLabel10.setOpaque(true);

        jLabel11.setBackground(new java.awt.Color(195, 210, 210));
        jLabel11.setFont(new java.awt.Font("Arial Black", 1, 12)); // NOI18N
        jLabel11.setForeground(new java.awt.Color(0, 102, 102));
        jLabel11.setText("   Total Hits");
        jLabel11.setToolTipText("Cantidad total de peticiones recibidas por el servidor.");
        jLabel11.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        jLabel11.setOpaque(true);

        lblSolicitudesTotales.setBackground(new java.awt.Color(195, 210, 210));
        lblSolicitudesTotales.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        lblSolicitudesTotales.setForeground(new java.awt.Color(0, 102, 102));
        lblSolicitudesTotales.setText("   jLabel10");
        lblSolicitudesTotales.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        lblSolicitudesTotales.setOpaque(true);

        lblSolicitudesExitosas.setBackground(new java.awt.Color(212, 224, 224));
        lblSolicitudesExitosas.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        lblSolicitudesExitosas.setForeground(new java.awt.Color(0, 102, 102));
        lblSolicitudesExitosas.setText("   jLabel10");
        lblSolicitudesExitosas.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        lblSolicitudesExitosas.setOpaque(true);

        jLabel14.setBackground(new java.awt.Color(212, 224, 224));
        jLabel14.setFont(new java.awt.Font("Arial Black", 1, 12)); // NOI18N
        jLabel14.setForeground(new java.awt.Color(0, 102, 102));
        jLabel14.setText("   Redirected Hits");
        jLabel14.setToolTipText("Codigo de estado HTTP 3xx: El cliente debe tomar una accin adicional para completar la peticin.");
        jLabel14.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        jLabel14.setOpaque(true);

        lblSolicitudesRedirecc.setBackground(new java.awt.Color(212, 224, 224));
        lblSolicitudesRedirecc.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        lblSolicitudesRedirecc.setForeground(new java.awt.Color(0, 102, 102));
        lblSolicitudesRedirecc.setText("   jLabel10");
        lblSolicitudesRedirecc.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        lblSolicitudesRedirecc.setOpaque(true);

        jLabel16.setBackground(new java.awt.Color(195, 210, 210));
        jLabel16.setFont(new java.awt.Font("Arial Black", 1, 12)); // NOI18N
        jLabel16.setForeground(new java.awt.Color(0, 102, 102));
        jLabel16.setText("   Failed Hits (Client Error)");
        jLabel16.setToolTipText("Codigo de estado HTTP 4xx: Errores del cliente, la solicitud contiene sintaxis incorrecta o no puede procesarse.");
        jLabel16.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        jLabel16.setOpaque(true);

        jLabel17.setBackground(new java.awt.Color(212, 224, 224));
        jLabel17.setFont(new java.awt.Font("Arial Black", 1, 12)); // NOI18N
        jLabel17.setForeground(new java.awt.Color(0, 102, 102));
        jLabel17.setText("   Failed Hits (Server Error)");
        jLabel17.setToolTipText("Codigo de estado HTTP 5xx: Errores de servidor, el servidor es incapaz de completar una solicitud.");
        jLabel17.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        jLabel17.setOpaque(true);

        jLabel18.setBackground(new java.awt.Color(212, 224, 224));
        jLabel18.setFont(new java.awt.Font("Arial Black", 1, 12)); // NOI18N
        jLabel18.setForeground(new java.awt.Color(0, 102, 102));
        jLabel18.setText("   Average Hits per Day");
        jLabel18.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        jLabel18.setOpaque(true);

        lblSolicitudesFallaCliente.setBackground(new java.awt.Color(195, 210, 210));
        lblSolicitudesFallaCliente.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        lblSolicitudesFallaCliente.setForeground(new java.awt.Color(0, 102, 102));
        lblSolicitudesFallaCliente.setText("   jLabel10");
        lblSolicitudesFallaCliente.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        lblSolicitudesFallaCliente.setOpaque(true);

        lblSolicitudesFallaServidor.setBackground(new java.awt.Color(212, 224, 224));
        lblSolicitudesFallaServidor.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        lblSolicitudesFallaServidor.setForeground(new java.awt.Color(0, 102, 102));
        lblSolicitudesFallaServidor.setText("   jLabel10");
        lblSolicitudesFallaServidor.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        lblSolicitudesFallaServidor.setOpaque(true);

        lblPromedioSoliDia.setBackground(new java.awt.Color(212, 224, 224));
        lblPromedioSoliDia.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        lblPromedioSoliDia.setForeground(new java.awt.Color(0, 102, 102));
        lblPromedioSoliDia.setText("   jLabel10");
        lblPromedioSoliDia.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        lblPromedioSoliDia.setOpaque(true);

        jLabel22.setBackground(new java.awt.Color(195, 210, 210));
        jLabel22.setFont(new java.awt.Font("Arial Black", 1, 12)); // NOI18N
        jLabel22.setForeground(new java.awt.Color(0, 102, 102));
        jLabel22.setText("   Page View");
        jLabel22.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        jLabel22.setOpaque(true);

        jLabel23.setBackground(new java.awt.Color(212, 224, 224));
        jLabel23.setFont(new java.awt.Font("Arial Black", 1, 12)); // NOI18N
        jLabel23.setForeground(new java.awt.Color(0, 102, 102));
        jLabel23.setText("   Average Page Views per Day");
        jLabel23.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        jLabel23.setOpaque(true);

        jLabel24.setBackground(new java.awt.Color(212, 224, 224));
        jLabel24.setFont(new java.awt.Font("Arial Black", 1, 12)); // NOI18N
        jLabel24.setForeground(new java.awt.Color(0, 102, 102));
        jLabel24.setText("   Total Visitors");
        jLabel24.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        jLabel24.setOpaque(true);

        lblPaginasVistas.setBackground(new java.awt.Color(195, 210, 210));
        lblPaginasVistas.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        lblPaginasVistas.setForeground(new java.awt.Color(0, 102, 102));
        lblPaginasVistas.setText("   jLabel10");
        lblPaginasVistas.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        lblPaginasVistas.setOpaque(true);

        lblPromPagVistasDia.setBackground(new java.awt.Color(212, 224, 224));
        lblPromPagVistasDia.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        lblPromPagVistasDia.setForeground(new java.awt.Color(0, 102, 102));
        lblPromPagVistasDia.setText("   jLabel10");
        lblPromPagVistasDia.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        lblPromPagVistasDia.setOpaque(true);

        lblTotalVisitantes.setBackground(new java.awt.Color(212, 224, 224));
        lblTotalVisitantes.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        lblTotalVisitantes.setForeground(new java.awt.Color(0, 102, 102));
        lblTotalVisitantes.setText("   jLabel10");
        lblTotalVisitantes.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        lblTotalVisitantes.setOpaque(true);

        jLabel28.setBackground(new java.awt.Color(195, 210, 210));
        jLabel28.setFont(new java.awt.Font("Arial Black", 1, 12)); // NOI18N
        jLabel28.setForeground(new java.awt.Color(0, 102, 102));
        jLabel28.setText("   Total Transfer (Kilobytes)");
        jLabel28.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        jLabel28.setOpaque(true);

        jLabel29.setBackground(new java.awt.Color(212, 224, 224));
        jLabel29.setFont(new java.awt.Font("Arial Black", 1, 12)); // NOI18N
        jLabel29.setForeground(new java.awt.Color(0, 102, 102));
        jLabel29.setText("   Average Transfer per Day (Kilobytes)");
        jLabel29.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        jLabel29.setOpaque(true);

        jLabel30.setBackground(new java.awt.Color(212, 224, 224));
        jLabel30.setFont(new java.awt.Font("Arial Black", 1, 12)); // NOI18N
        jLabel30.setForeground(new java.awt.Color(0, 102, 102));
        jLabel30.setText("   Average Transfer per Hit (Kilobytes)");
        jLabel30.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        jLabel30.setOpaque(true);

        lblTransfTotal.setBackground(new java.awt.Color(195, 210, 210));
        lblTransfTotal.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        lblTransfTotal.setForeground(new java.awt.Color(0, 102, 102));
        lblTransfTotal.setText("   jLabel10");
        lblTransfTotal.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        lblTransfTotal.setOpaque(true);

        lblPromTransTotalDia.setBackground(new java.awt.Color(212, 224, 224));
        lblPromTransTotalDia.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        lblPromTransTotalDia.setForeground(new java.awt.Color(0, 102, 102));
        lblPromTransTotalDia.setText("   jLabel10");
        lblPromTransTotalDia.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        lblPromTransTotalDia.setOpaque(true);

        lblPromTransfSolicitud.setBackground(new java.awt.Color(212, 224, 224));
        lblPromTransfSolicitud.setFont(new java.awt.Font("Arial", 1, 12)); // NOI18N
        lblPromTransfSolicitud.setForeground(new java.awt.Color(0, 102, 102));
        lblPromTransfSolicitud.setText("   jLabel10");
        lblPromTransfSolicitud.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153)));
        lblPromTransfSolicitud.setOpaque(true);

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel7, javax.swing.GroupLayout.DEFAULT_SIZE, 674, Short.MAX_VALUE)
                    .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, 674, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jLabel14, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel10, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 464, Short.MAX_VALUE)
                            .addComponent(jLabel11, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(0, 0, 0)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblSolicitudesRedirecc, javax.swing.GroupLayout.DEFAULT_SIZE, 210, Short.MAX_VALUE)
                            .addComponent(lblSolicitudesExitosas, javax.swing.GroupLayout.DEFAULT_SIZE, 210, Short.MAX_VALUE)
                            .addComponent(lblSolicitudesTotales, javax.swing.GroupLayout.DEFAULT_SIZE, 210, Short.MAX_VALUE)))
                    .addComponent(jLabel9, javax.swing.GroupLayout.DEFAULT_SIZE, 674, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jLabel18, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel17, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 464, Short.MAX_VALUE)
                            .addComponent(jLabel16, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(0, 0, 0)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblSolicitudesFallaCliente, javax.swing.GroupLayout.DEFAULT_SIZE, 210, Short.MAX_VALUE)
                            .addComponent(lblSolicitudesFallaServidor, javax.swing.GroupLayout.DEFAULT_SIZE, 210, Short.MAX_VALUE)
                            .addComponent(lblPromedioSoliDia, javax.swing.GroupLayout.DEFAULT_SIZE, 210, Short.MAX_VALUE)))
                    .addComponent(jLabel8, javax.swing.GroupLayout.DEFAULT_SIZE, 674, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jLabel24, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel23, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 464, Short.MAX_VALUE)
                            .addComponent(jLabel22, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(0, 0, 0)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblTotalVisitantes, javax.swing.GroupLayout.DEFAULT_SIZE, 210, Short.MAX_VALUE)
                            .addComponent(lblPromPagVistasDia, javax.swing.GroupLayout.DEFAULT_SIZE, 210, Short.MAX_VALUE)
                            .addComponent(lblPaginasVistas, javax.swing.GroupLayout.DEFAULT_SIZE, 210, Short.MAX_VALUE)))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jLabel30, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 464, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel29, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel28, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(0, 0, 0)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblPromTransfSolicitud, javax.swing.GroupLayout.DEFAULT_SIZE, 210, Short.MAX_VALUE)
                            .addComponent(lblPromTransTotalDia, javax.swing.GroupLayout.DEFAULT_SIZE, 210, Short.MAX_VALUE)
                            .addComponent(lblTransfTotal, javax.swing.GroupLayout.DEFAULT_SIZE, 210, Short.MAX_VALUE))))
                .addContainerGap())
        );

        jPanel3Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jLabel10, jLabel11, jLabel14, jLabel16, jLabel17, jLabel18, jLabel22, jLabel23, jLabel24, jLabel28, jLabel29, jLabel30});

        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, 0)
                        .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(lblSolicitudesTotales, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(0, 0, 0)
                        .addComponent(lblSolicitudesExitosas, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addGap(0, 0, 0)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel14, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblSolicitudesRedirecc, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(0, 0, 0)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel16, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, 0)
                        .addComponent(jLabel17, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(lblSolicitudesFallaCliente, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(0, 0, 0)
                        .addComponent(lblSolicitudesFallaServidor, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addGap(0, 0, 0)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel18, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblPromedioSoliDia, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(0, 0, 0)
                .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel22, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, 0)
                        .addComponent(jLabel23, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(lblPaginasVistas, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(0, 0, 0)
                        .addComponent(lblPromPagVistasDia, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addGap(0, 0, 0)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel24, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblTotalVisitantes, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(0, 0, 0)
                .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel28, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, 0)
                        .addComponent(jLabel29, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(lblTransfTotal, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(0, 0, 0)
                        .addComponent(lblPromTransTotalDia, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addGap(0, 0, 0)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel30, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblPromTransfSolicitud, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );

        jPanel3Layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jLabel10, jLabel11, jLabel14, jLabel16, jLabel17, jLabel18, jLabel22, jLabel23, jLabel24, jLabel28, jLabel29, jLabel30});

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(panelTitulo1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(panelTitulo, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(panelTitulo1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(40, 40, 40)
                .addComponent(panelTitulo, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jScrollPane1.setViewportView(jPanel1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 760, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 567, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(LanzarResumenGeneral.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(LanzarResumenGeneral.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(LanzarResumenGeneral.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(LanzarResumenGeneral.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                LanzarResumenGeneral dialog = new LanzarResumenGeneral(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel28;
    private javax.swing.JLabel jLabel29;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel30;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel lblFormatoLog;
    private javax.swing.JLabel lblIntervaloTiempo;
    private javax.swing.JLabel lblNombreArchivo;
    private javax.swing.JLabel lblPaginasVistas;
    private javax.swing.JLabel lblPromPagVistasDia;
    private javax.swing.JLabel lblPromTransTotalDia;
    private javax.swing.JLabel lblPromTransfSolicitud;
    private javax.swing.JLabel lblPromedioSoliDia;
    private javax.swing.JLabel lblSolicitudesExitosas;
    private javax.swing.JLabel lblSolicitudesFallaCliente;
    private javax.swing.JLabel lblSolicitudesFallaServidor;
    private javax.swing.JLabel lblSolicitudesRedirecc;
    private javax.swing.JLabel lblSolicitudesTotales;
    private javax.swing.JLabel lblTotalVisitantes;
    private javax.swing.JLabel lblTransfTotal;
    private javax.swing.JPanel panelTitulo;
    private javax.swing.JPanel panelTitulo1;
    // End of variables declaration//GEN-END:variables
}
