
package polaris3.Table;

import java.awt.Color;
import java.awt.Component;
import java.awt.Desktop;
import java.awt.Font;
import java.awt.Image;
import java.net.URI;
import polaris3.Statistics.RefDominios.*;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.DefaultListCellRenderer;
import javax.swing.ImageIcon;
import javax.swing.JList;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumn;
import polaris2.graph.Nodo;
import polaris3.DataAcces.CargarArreglos;
import polaris3.DataAcces.MiConexion;
import polaris3.Statistics.RefSitios.ConfGraficoSitios;
import polaris3.ReadLogs.AbrirLog;
import polaris3.ReadLogs.ConfDominio;

public class TablaSitios extends javax.swing.JDialog {

    public Nodo n=null;
    boolean nodoCorriendo;

    ConfGraficoSitios onfGraficoSitios;
    
    String nombreArchivo="";//url del log
    String formatoLog="";//formato del log
    
     //modificar ancho de columnas y centrar
    DefaultTableCellRenderer miTableCellenderer = new DefaultTableCellRenderer();
    DefaultTableModel miModelo;//tabla 
    DefaultTableModel miModelo1;
    
    //acceso a bd
    private Connection conexion=null;
    MiConexion miConexion=new MiConexion();
    ResultSet miResulSet;
    Statement miStatement;
    
    String tipoArchivo="";
    String strSerie="";//hits, visitantes o transferencia
    
    //series
    boolean serieHits=false;
    boolean serieVisitantes=false;
    boolean serieTransferencia=false;
    
    Vector filaTabla=new Vector();
    
    public TablaSitios(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        cargaConficuacion();
        Configurar();
        lblLog.setText(nombreArchivo + " - " + formatoLog);  
        CrearTabla();
        CrearTabla1();
        miTabla2.setModel(miModelo1);
        EditarTabla();
        this.setLocationRelativeTo(null);
        this.setIconImage(this.getImage("/media/star.png"));
        
        
        nodoCorriendo=true;
    }
    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }
    public void NodoCorriendo(){
        if(nodoCorriendo==true)
            n.corriendo=true;
    }
    
     private void CrearTabla(){
        String strColumnaCantidad="";
        if(strSerie.compareTo("hits")==0) strColumnaCantidad="HITS";
        if(strSerie.compareTo("visitantes")==0) strColumnaCantidad="VISITORS";
        if(strSerie.compareTo("transferencia")==0) strColumnaCantidad="DATA TRANSFER (KB)";

        String[] nombresColumnas = {"REFERRING SITES",strColumnaCantidad};
        Object[][] datos=null ;
        miModelo=null;
        miModelo = new DefaultTableModel(datos, nombresColumnas)//celdaas no editables
         {@Override
             public boolean isCellEditable (int fila, int columna) {
                 if (columna > 10)
                     return true;
                 return false;
             }
         };
        //__LLENAR DATOS EN LA TABLA___________________________________________
        CargarDatosTabla();
        //_____________________________________________________________________
        miTabla1.setModel(miModelo); 
        
        TableColumn miColumna;
        
        for (int i = 0; i < 2; i++) {
            miColumna = miTabla1.getColumnModel().getColumn(i);
            if(i == 0) miColumna.setPreferredWidth(250); //COLUMNA HOST
	    if(i == 1) miColumna.setPreferredWidth(30); //COLUMNA CANTIDAD

        }   
        miTabla1.setDefaultRenderer (Object.class, new MiRenderAF5());
        
        
    }
     
    public void cargaConficuacion(){
        serieHits=onfGraficoSitios.isSerieHits();
        serieTransferencia=onfGraficoSitios.isSerieTransferencia();
        serieVisitantes=onfGraficoSitios.isSerieVisitantes();
    }
    
    private void Configurar(){
             
        if(serieHits==true)
            strSerie="hits";
        if(serieVisitantes==true)
            strSerie="visitantes";
        if(serieTransferencia==true)
            strSerie="transferencia";
        
        nombreArchivo=AbrirLog.getNombreArchivo();
        formatoLog=CargarArreglos.getFormatoLog();

    }
    
    //graficar extensiones
    private void CargarDatosTabla(){//cargar datosdesde la bs
        System.out.println(strSerie);
      
        String miConsulta="";
        
        miConsulta="SELECT sitio,"+strSerie+" FROM est_sitios_referentes ORDER BY "+ strSerie + " desc";
        System.out.println(miConsulta);
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        try{
            
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery(miConsulta);
            while (miResulSet.next()){
                Object [] fila = new Object[2]; // Hay 5 columnas en la tabla
                
                if(strSerie.compareTo("transferencia")==0){
                    
                    double miTransfrencia=0;//para pasar a kb y redondear a 0.00
                    miTransfrencia=miResulSet.getDouble("transferencia");
                    miTransfrencia=miTransfrencia/1024;//pasar a kb
                    miTransfrencia=Math.rint(miTransfrencia*1000)/100;//redondear
                
                    //Se rellena cada posición del array con una de las columnas de la tabla en base de datos.
                    for (int i=0;i<1;i++)//columna 0,1,2,3
                        fila[i] = miResulSet.getString(i+1); // El primer indice en rs es el 1, no el cero, por eso se suma 1.
                    fila[1]=miTransfrencia;//columna 4: transferncia en kb
                }else{
                    for (int i=0;i<2;i++)//columna 0,1,2,3
                        fila[i] = miResulSet.getString(i+1); // El primer indice en rs es el 1, no el cero, por eso se suma 1.                   
                }
 
                miModelo.addRow(fila);                      
            }
            
        }catch (Exception e){
            System.out.println("Problemas para cargar datos de  tabla clase TablaEstadisticasSitios.java: "+e.getMessage());
        }
 
    }
    
    private void CargarRequest(String nombre_sitio){//cagar request desde la bd
        //esta funcion se ejecuata cuando se hace doble click en una de losarchivos del jListNombreArchivo
        
        String[] nombresColumnas = {"REQUEST", "DATE","TIME","REMOTE HOST"};
        Object[][] datos=null ;
        miModelo1=null;
         miModelo1 = new DefaultTableModel(datos, nombresColumnas)//celdaas no editables
         {@Override
             public boolean isCellEditable (int fila, int columna) {
                 if (columna > 10)
                     return true;
                 return false;
             }
         };
        
        String miConsulta="";
        //miConsulta="select  request,nombre_dia || ' ' || fecha || ' ' || hora  as fecha_dia,host from tabla_sesion,dias_semana where archivo = '"+nombre_archivo+"' and tabla_sesion.dia=dias_semana.id order by fecha,hora";
        miConsulta="select  request,nombre_dia || ' ' || fecha as fecha_dia,hora,host from tabla_sesion,dias_semana where sitios_referentes = '"+nombre_sitio+"' and tabla_sesion.dia=dias_semana.id order by fecha,hora";
     
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery(miConsulta);
            while (miResulSet.next()){     
                Object [] fila = new Object[4]; // Hay 4 columnas en la tabla
                for (int i=0;i<4;i++)//columna 0,1,2,3
                    fila[i] = miResulSet.getString(i+1);
                
                miModelo1.addRow(fila);
                          
            }
            miTabla2.setModel(miModelo1);
            EditarTabla();
            
        }catch (Exception e){
            System.out.println("Problemas para cargar request (clase GraficoEstadisticaArchivos.java): "+e.getMessage());
        }
        
    }
    private void CrearTabla1(){
        String[] nombresColumnas = {"REQUEST", "DATE","TIME","REMOTE HOST"};
        Object[][] datos=null ;
        miModelo1=null;
        
        miModelo1 = new DefaultTableModel(datos, nombresColumnas)//celdaas no editables
         {@Override
             public boolean isCellEditable (int fila, int columna) {
                 if (columna > 10)
                     return true;
                 return false;
             }
         };
        //__LLENAR DATOS EN LA TABLA___________________________________________
        //CargarDatosGrafico();
        //_____________________________________________________________________
        //miTabla.setModel(miModelo); 
        
        
    }
    private void EditarTabla(){
        //modificar ancho de columnas y centrar
        TableColumn miColumna;
        
        for (int i = 0; i < 4; i++) {
            miColumna = miTabla2.getColumnModel().getColumn(i);
            if(i == 0) miColumna.setPreferredWidth(220); //COLUMNA REQUEST
	    if(i == 1) miColumna.setPreferredWidth(60); //COLUMNA DATE
            if(i == 2) miColumna.setPreferredWidth(20); //COLUMNA TIME
	    if(i == 3) miColumna.setPreferredWidth(110); //COLUMNA REMOTE HOST
        }   
        miTabla2.setDefaultRenderer (Object.class, new MiRenderAF5());
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        miTabla1 = new javax.swing.JTable();
        jScrollPane2 = new javax.swing.JScrollPane();
        miTabla2 = new javax.swing.JTable();
        jPanel2 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        lblProcess1 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        lblLog = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Referring Sites");
        setAlwaysOnTop(true);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Result", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 12))); // NOI18N

        miTabla1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        miTabla1.setCellSelectionEnabled(true);
        miTabla1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                miTabla1MouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(miTabla1);

        miTabla2.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        miTabla2.setCellSelectionEnabled(true);
        miTabla2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                miTabla2MouseClicked(evt);
            }
        });
        jScrollPane2.setViewportView(miTabla2);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 706, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 706, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 169, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Data", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 12))); // NOI18N

        jLabel4.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel4.setText("Process");

        lblProcess1.setFont(new java.awt.Font("Tahoma", 1, 11));
        lblProcess1.setText("Referring Sites Statistics");
        lblProcess1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel5.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel5.setText("Web Server Log");

        lblLog.setFont(new java.awt.Font("Tahoma", 1, 11));
        lblLog.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(47, 47, 47)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel5)
                    .addComponent(jLabel4))
                .addGap(18, 18, 18)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(lblLog, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(lblProcess1, javax.swing.GroupLayout.DEFAULT_SIZE, 358, Short.MAX_VALUE))
                .addContainerGap(214, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel5)
                    .addComponent(lblLog, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblProcess1, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void miTabla1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_miTabla1MouseClicked
   if (evt.getClickCount() == 2){    
        String auxCad="";
        int fila = miTabla1.rowAtPoint(evt.getPoint());
        int columna = miTabla1.columnAtPoint(evt.getPoint());
        if ((fila > -1) && (columna == 0)){
            auxCad=(String)miModelo.getValueAt(fila,columna);
            CargarRequest(auxCad);
        }
       
    }
}//GEN-LAST:event_miTabla1MouseClicked

private void miTabla2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_miTabla2MouseClicked
    if (evt.getClickCount() == 2){    
        String auxUrl="";
        int fila = miTabla2.rowAtPoint(evt.getPoint());
        int columna = miTabla2.columnAtPoint(evt.getPoint());
        if ((fila > -1) && (columna == 0)){
            auxUrl=(String)miModelo1.getValueAt(fila,columna);
            AbrirURL(auxUrl);
            System.out.println(auxUrl);
        }
       
    }
}//GEN-LAST:event_miTabla2MouseClicked

private void AbrirURL(String miAuxUrl){
    
    String miURL="http://";
    miURL=miURL+ConfDominio.getDominio();
    
    miURL=miURL+miAuxUrl;
    System.out.println(miURL);
    miURL=miURL.replace(" ", "+");
    try {
         Desktop.getDesktop().browse(new URI(miURL));
    } catch (Exception e) {
        System.out.println("No se puede abrir url: "+e.getMessage());
    }
    
}
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(TablaSitios.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(TablaSitios.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(TablaSitios.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(TablaSitios.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                TablaSitios dialog = new TablaSitios(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JLabel lblLog;
    private javax.swing.JLabel lblProcess1;
    private javax.swing.JTable miTabla1;
    private javax.swing.JTable miTabla2;
    // End of variables declaration//GEN-END:variables
}
class MyCellRenderer5 extends  DefaultListCellRenderer {
        public MyCellRenderer5() {
            setOpaque(true);
        }
        Color currColor=Color.white;  
        public Component getListCellRendererComponent( JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
        super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
        if(index%2==0) {                              
            currColor=Color.LIGHT_GRAY;  
        }      
        else {  
            currColor=new Color(222,222,255);                  
        }                              
        if(isSelected) {  
            super.setForeground(list.getSelectionForeground());  
            super.setBackground(list.getSelectionBackground());  
        } else {  
            super.setForeground(Color.BLACK);     
            super.setBackground(currColor);  
        }           
        setFont(list.getFont());                                  
            return this;
        }
    }

//clase para cambiar la apariencia de las tablas
class MiRenderAF5 extends DefaultTableCellRenderer{
    
    Color currColor=Color.white;  
    
    public Component getTableCellRendererComponent(JTable table,Object value,boolean isSelected,boolean hasFocus,int row,int column)
    {
        super.getTableCellRendererComponent (table, value, isSelected, hasFocus, row, column);
        this.setOpaque(true);
        table.setShowGrid(true);
        
        //cambiar fuente de cabeseras
        JTableHeader th = table.getTableHeader(); 
        Font fuente = new Font("Verdana", Font.BOLD, 12); 
        th.setFont(fuente); 
       // th.setBackground(new Color(153,153,255));
        
        //alternar color de filas
        if(row%2==0) {                              
            currColor=Color.white;  
        }      
        else {  
            currColor=new Color(222,222,255);                  
        }                              
        if(isSelected) {  
            super.setForeground(table.getSelectionForeground());  
            super.setBackground(table.getSelectionBackground());  
        } else {  
            super.setForeground(Color.black);     
            super.setBackground(currColor);  
        }                         
        setFont(table.getFont());                                  
        setValue(value);  
        
        //alinear columnas
        super.setHorizontalAlignment(SwingConstants.LEFT);
     
        //resisables
       // table.getColumnModel().getColumn(0).setResizable(false);
        //table.getColumnModel().getColumn(1).setResizable(false);
        //table.getColumnModel().getColumn(2).setResizable(false);
        //table.getColumnModel().getColumn(3).setResizable(false);
        //table.getColumnModel().getColumn(4).setResizable(false);
        return this;
   }
}