/**
 * ClassificationTableModel.java
 *
 * Created on 26 de mayo de 2007, 03:19 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package prePro;

import java.util.ArrayList;
import java.util.Vector;
import javax.swing.JButton;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;

/**
 *
 * @author Proyecto *** Polaris *** Johana
 */
public class SesionTableModel extends AbstractTableModel {
    
     String[] columnNames = {   "#",
                                "HOSTREMOTO",
                                "START DATE",
                                "FINALE DATE", // Duracion
                                "REQUEST AMOUNT",
                                "DOWNLOAD SIZE", // Duracion
                                "DOWNLOAD EXTENSION",
                                "DOWNLOAD PAGES"
                            };
        private ArrayList sesiones;
        protected TableModel model;
        int tipoS;
        JButton boton;
        /**
         * Crea una nueva instancia de la clase ClassificationTableModel.
         *
         * @param sesiones La estructura que sera utilizada para crear el modelo de
         *        la tabla de datos.
         */

        /**
     * Creates a new instance of regLogTableModel
     */
        public SesionTableModel(ArrayList ses) {
            sesiones= ses;
            fireTableChanged(null);
        }
        
        /** nicamente retornamos el numero de elementos del
         * array de los nombres de las columnas
         *
         */
        public int getColumnCount() {
            return columnNames.length;
        }

        /** retormanos el numero de elementos
         * del array de datos
         */
        public int getRowCount() {
            return sesiones.size();
        }

        /** retornamos el nombre de la columna de indice col
         */
        public String getColumnName(int col) {
            return columnNames[col];
        }
        
        /** retornamos el indice de tal nombre de la columna
         */
        public int getColumnIndex(String colname){
            int i, indice=0;
            String aux;
            boolean salir=false;
            //
            for(i=0;i<6 && salir==false;i++){
                aux= columnNames[i];
                if(colname.equals(aux)){
                    salir=true; 
                    i--;
                }
            }
            indice=i;
            //
            return indice;
        }

        /*** Devuelve el objeto en tal fila tal columna
         */
        public Object getValueAt(int row, int col) {
            Object obj = sesiones.get(row);
            String dato="";
            switch(col){
                case 0:
                    dato= String.valueOf(row + 1);
                    break;
                case 1:
                    dato= ((sesionview) obj).getHostremoto();
                    break;
                case 2:
                    if(tipoS==1) dato= ((sesionview) obj).getFechainicio().toString();
                    if(tipoS==2) dato= ((sesionview) obj).getAgenteuser();
                    break;
                case 3:
                    if(tipoS==1) dato= ((sesionview) obj).getFechafin().toString();                    
                    if(tipoS==2) dato= ((sesionview) obj).getFechainicio().toString();
                    break;
                case 4:
                    if(tipoS==1) dato= String.valueOf(((sesionview) obj).getNumSolicitudes());
                    if(tipoS==2) dato= ((sesionview) obj).getFechafin().toString();                    
                    break;
                case 5:
                    if(tipoS==1) dato= String.valueOf(((sesionview) obj).getTotalbytes());
                    if(tipoS==2) dato= String.valueOf(((sesionview) obj).getNumSolicitudes());                    
                    break;
                case 6:
                    if(tipoS==1) dato= "Extensions";
                    if(tipoS==2) dato= String.valueOf(((sesionview) obj).getTotalbytes());                    
                    break;
                case 7:
                    if(tipoS==1) dato= "Pages";
                    if(tipoS==2) dato= "Extensions";
                    break;                
                case 8:                    
                    if(tipoS==2) dato= "Pages";
                    break;                    
            }
            return dato;
        }
        
        /** Devuelve la sesion completa de tal fila
         */
        public SesionExtendida getSesionAt(int row){
            return (SesionExtendida) sesiones.get(row);
        }
        
        /** Devuelve los valores de toda una columna en un Vector 
         */
        public Vector getValuesColumn(int col){            
            String dato="";
            Vector aux=new Vector();
            //
            for(int i=0; i<sesiones.size();i++){
                Object obj = sesiones.get(i);
                switch(col){
                case 0:
                    dato= String.valueOf(i + 1);
                    break;
                case 1:
                    dato= ((sesionview) obj).getHostremoto();
                    break;
                case 2:
                    if(tipoS==1) dato= ((sesionview) obj).getFechainicio().toString();
                    if(tipoS==2) dato= ((sesionview) obj).getAgenteuser();
                    break;
                case 3:
                    if(tipoS==1) dato= ((sesionview) obj).getFechafin().toString();                    
                    if(tipoS==2) dato= ((sesionview) obj).getFechainicio().toString();
                    break;
                case 4:
                    if(tipoS==1) dato= String.valueOf(((sesionview) obj).getNumSolicitudes());
                    if(tipoS==2) dato= ((sesionview) obj).getFechafin().toString();                    
                    break;
                case 5:
                    if(tipoS==1) dato= String.valueOf(((sesionview) obj).getTotalbytes());
                    if(tipoS==2) dato= String.valueOf(((sesionview) obj).getNumSolicitudes());                    
                    break;
                case 6:
                    if(tipoS==1) dato= "Extensions";
                    if(tipoS==2) dato= String.valueOf(((sesionview) obj).getTotalbytes());                    
                    break;
                case 7:
                    if(tipoS==1) dato= "Pages";
                    if(tipoS==2) dato= "Extensions";
                    break;                
                case 8:                    
                    if(tipoS==2) dato= "Pages";
                    break;                    
            }
                aux.addElement(dato);
            }
            //
            return aux;
        }

        /**
         * Este metodo sirve para determinar el editor predeterminado
         * para cada columna de celdas
         */
        public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }

        /*
         * No tienes que implementar este mtodo a menos que
         * las celdas de tu tabla sean Editables
         */
        public boolean isCellEditable(int row, int col) {
                return true;
        }

        /*
         * No tienes que implementar este mtodo a menos que
         * los datos de tu tabla cambien
         */        
        
        public void setDatos(ArrayList datosnuevos) {
            this.sesiones = datosnuevos;
            
        }
        
        /** Coloca nuevos nombres a las columnas si es necesario
         */
    public void setNomcol(String[] nomcol) {
        this.columnNames = nomcol;
    }
        
    public void setColExt(){
        String[] columnN = {    "#",
                                "HOSTREMOTO",
                                "USER AGENT",
                                "START DATE",
                                "FINALE DATE", // Duracion
                                "REQUEST AMOUNT",
                                "DOWNLOAD SIZE", // Duracion
                                "DOWNLOAD EXTENSION",
                                "DOWNLOAD PAGES"
                            };
        //
        columnNames= columnN;
    }    
    
    public void setTipoS(int t){
        tipoS= t;
    }
    
}
