/**almacena la parte grafica de la gramatica*/
package treeA;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.util.List;

public class TreePanel extends javax.swing.JPanel {    
    
    private List<Nodo> nodos;
    public TreePanel() {
        initComponents();
    }
    
    /**se establece la lista y se repinta*/
    public void setNodos(List<Nodo> nodos){
        this.nodos = nodos;
        this.repaint();
    }
    
    /**la super funcion que dibuja*/
    public void paint(Graphics g) {
        /**color de fondo*/
        g.setColor(new Color(255,255,255));               
        g.fillRect(0,0,this.getWidth(), this.getHeight());
        /**color de fondo*/
        g.setColor(new Color(0,0,0));
        
         /**si nodos tiene componentes*/ 
        if(this.nodos!=null){
             /**se establece la separacion horizontal y vertical, y el radio
             * de cada bolita*/
            int sepHz = 100;
            int sepVr = 150;
            int radio = 15;
            //se 
            List<Nodo> nivel;
            int n = 0;
            int bigLevel = 0;
            do{
                /**nivel recibe el metodo listar nivel desde NodeUtils*/
                nivel = NodeUtils.listarNivel(nodos, n);
                /**establece limites*/
                /**si el nivel contiene mas nodos que el entero biglevel
                * se*/
                if(nivel.size() > bigLevel) bigLevel = nivel.size();
                n ++;
                for (int i = 0; i < nivel.size(); i++) {
                    int x = ((i+1)*sepHz)+radio;
                    int y = ((n-1)*sepVr)+radio+50;
                    nivel.get(i).setX(x);
                    nivel.get(i).setY(y);
                }
            }while(nivel.size()>0);
            
            
            Graphics2D g2 = (Graphics2D)g;
            float[] dash = new float[2];
            dash[0] = 2;
            dash[1] = 4;
            
            g2.setStroke(new BasicStroke(2,1,0,1,dash,0));
            g.setFont(new Font(Font.SANS_SERIF,Font.BOLD,12));
            
            for (int i = 0; i < nodos.size(); i++) {
                if(nodos.get(i).getPadre()!=null){
                    int x1 = nodos.get(i).getX();
                    int y1 = nodos.get(i).getY();
                    
                    int x2 = nodos.get(i).getPadre().getX();
                    int y2 = nodos.get(i).getPadre().getY();
                    g.setColor(new Color(2,70,138));
                    g.drawLine(x1+25,y1,x2+25,y2);

//las lineas bloqueadas hacen referencia a mostrar la probabilidad                    
//                    String ps = String.valueOf(nodos.get(i).getProb());
//                    int ancho = (int)g.getFontMetrics().getStringBounds(ps,g).getWidth();
                    
//                    int pmx = ((x1+x2)/2)-(ancho/2);
//                    int pmy = (y1+y2)/2;
//                    
//                    g.setColor(new Color(200,200,200));
//                    g.drawString(ps, pmx+2, pmy+2);
//                    
//                    g.setColor(new Color(0,0,0));
//                    g.drawString(ps, pmx, pmy);                
                }                
            }
            
            for (int i = 0; i < nodos.size(); i++) {
                if(nodos.get(i).getHijos().size()==0){
                    g.setColor(new Color(171,213,254));                                   
                }else if(nodos.get(i).getPadre()==null){
                    g.setColor(new Color(233,146,9));
                }else{
                    g.setColor(new Color(3,128,252));
                }
                g.fillRoundRect(nodos.get(i).getX()-radio, nodos.get(i).getY()-radio, radio*6, radio*2,10,10);                
                
                /**se muestra el id de cada nodo*/
                 int x1 = nodos.get(i).getX();
                 int y1 = nodos.get(i).getY()+3;
                String cs =  String.valueOf(nodos.get(i).getId());
                if(cs == "Request amount"){
                    cs = "Req.Am";
                }
                g.setColor(new Color(0,0,0));
                g.drawString(cs, x1, y1);
            }
            
            Dimension dim = new Dimension((bigLevel-1)*sepVr, ((n-1)*sepVr));
            this.setMaximumSize(dim);
            this.setMinimumSize(dim);
            this.setPreferredSize(dim);
            //this.setBounds(0,0,640,);
        }
    }
    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
