/** el archivo contiene las configuraciones correspondientes a la seleccion EquipAsso
 * desde asociacion*/

package workspace.Association.algorithms;

import Utils.AssocRules;
import Utils.AvlTree;
import Utils.DataSet;
import Utils.fillDataSet;
import algorithm.association.EquipAsso.EquipAsso;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Point;
import java.util.ArrayList;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import workspace.Association.settings.FrmAssociation;
import workspace.Association.settings.SimpleAssociationNode;
import workspace.Main_Set.SimpleNode;
import workspace.Prepro.IntervalNode;
import workspace.Prepro.UmbralNode;
import workspace.Source.SelectSourceNode;

public class EquipAssoNode extends SimpleAssociationNode{
    // ***
    Vector trees;
    DataSet dataset;
    // ***
    /**se esta forzando a variable*/
    private Class<?>[] clases;
    private ArrayList<SimpleNode> nodos;
    /**las siguientes banderas establecen si el objeto ya fue configurado     */
    public boolean configured = false;
    public boolean executed   = false;
    
    public EquipAssoNode(Point center) {
        /**se establece centro, dimension*/
        this.setCenter(center);
        this.setDimension(new Dimension(80,60));
        /**se valida el nodo antecesor, 2 nodos le pueden anteceder*/
        this.clases = new Class<?>[2];
        this.clases[0] = IntervalNode.class;
        this.clases[1] = UmbralNode.class;
        /**se instancia un ArrayList en nodos*/
        this.nodos = new ArrayList();
    }
    
    public Class<?>[] getValidInputClasses(){
        /**retorna los antecesores... umbral e interval en este caso*/
        return this.clases;
    }
    
    public ArrayList<SimpleNode> getInputNodes(){
        /**verifica si YA hay nodos de entrada*/
        /**se devuelven los valores de los nodos en un array forzado a tipo
         * SimpleNode*/
        return this.nodos;
    }
    
    public Image getImage(){
        /**el icono*/
        return new ImageIcon(System.class.getResource("/media/asoc.png")).getImage();
    }
    
    public String getString(){
        /**retorna una cadena que lo identifica*/
        return "EquipAsso";
    }
    
    /**si el nodo puede ser conectado, entonces se anade un nodo*/
    public void connect(SimpleNode n){
        if(this.canConnect(n)){
            this.nodos.add(n);
        }
    }
    
    /**al desconectar el nodo se elimina la linea punteada y se coloca el color
    * de borde por defecto */
    public void disconnect(SimpleNode n){
        this.nodos.remove(n);
        this.setBorderColor(null);
    }
    
    /**retorna verdadero porque puede ser configurado */
    public boolean canConfigure(){
        return true;
    }
    
     /**llama al formulario de configuracion de equipasso */
    public void configure() {
        FrmAssociation an = new FrmAssociation(null,(EquipAssoNode)getSelf());
         /** centrar */
        an.setLocationRelativeTo(an.getParent());
        an.setVisible(true);
        getParent().repaint();
    }
    
    /**retorna verdadero porque puede ser ejecutado */
    public boolean canExecute() {
        return true;
    }
    
    public void execute() {
        // *** Polaris *** Johana ***
        // *** Para Association Rules
        double soporte,confianza;
        String algorithm;        
        double  support;        
        fillDataSet llenarDataSet;        
        boolean hacerLift;
        // *** Finished ***
        if(this.getInputNodes().size()==1){
            String sourceClassName = this.getInputNodes().get(0).getClass().getCanonicalName();
            if(sourceClassName.equals(IntervalNode.class.getCanonicalName())){
                
                IntervalNode in = (IntervalNode)this.getInputNodes().get(0);
                //***********************************************************
                /*aqui se instancia interval y a su vez del web server*/
                //***********************************************************
                /**pasa la ruta desde el select source*/
                this.setPathLogServer(in.getPathLogServer());
                System.out.println(" From EquipAsso: " + this.getPathLogServer());
                /**paso el valor de mfr desde prepro*/
                System.out.println(" From EquipAsso: is interval mfr "+in.isMfr());
                 /**paso del tiempo de sesion desde prepro*/
                this.setTsesion(Integer.parseInt(in.getTsesion()));
                System.out.println(" From EquipAsso: session time "+this.getTsesion());
                
                if(!in.isConfigured()){
                    this.getParent().showError("The Interval Session must be configured first");
                     /**validacion para las baderas ejecucion, configuracion y el color del borde*/
                    this.setExecuted(false);
                    if(this.isConfigured() == false){
                        this.setConfigured(false);
                        setBorderColor(null);
                    } else{
                        this.setConfigured(true);
                        setBorderColor(new Color(0,0,255));
                    }
                } else if(!in.isExecuted()){
                    this.getParent().showError("The Interval Session must be executed first");
                    /**validacion para las baderas ejecucion, configuracion y el color del borde*/
                    this.setExecuted(false);
                    if(this.isConfigured() == false){
                        this.setConfigured(false);
                        setBorderColor(null);
                    } else{
                        this.setConfigured(true);
                        setBorderColor(new Color(0,0,255));
                    }
                } else if(!this.isConfigured()){
                    this.getParent().showError("First configure after execute");
                    /**cuando no esta configurado*/
                    this.setExecuted(false);
                    this.setConfigured(false);
                    setBorderColor(null);
                } else{
                    // *** Polaris *** Johana ***
                    long time = System.currentTimeMillis();
                    // *** Configurar soporte y Confianza y Algoritmo
                    soporte= this.getSupport();
                    confianza= this.getConfidence();
                    algorithm= "EquipAsso";
                    hacerLift= this.isLift();
                    // *** Llenar Data Set
                    llenarDataSet= new fillDataSet(in.getTipoL()); //(tipo de Sesion) deberia ir tipoL
                    dataset= new DataSet();
                    dataset= llenarDataSet.loadDataSet(); // cargar datos en el DataSet
                    // *** Configurar soporte
                    int s_int = (int) ( (soporte * (double)dataset.getNtransactions()) / (double)100 );
                    System.out.println("dataset.getNtransactions " + dataset.getNtransactions() + " for " + algorithm);
                    System.out.println("s " + soporte + " for " + algorithm);
                    //
                    short s;
                    if(s_int > Short.MAX_VALUE){
                        s = Short.MAX_VALUE;
                    } else {
                        s = (short) s_int;
                    }
                    if(s==0)s=1;
                    System.out.println("Sop: " + s);
                    // *** Algoritmo
                    AvlTree frequentsOne = new AvlTree();
                    dataset.pruneCandidatesOne(s, frequentsOne);
                    // *** Para EquipAsso
                    if(frequentsOne.howMany() > 0){
                        EquipAsso equipasso = new EquipAsso(dataset, s);
                        equipasso.start();
                        trees = equipasso.getFrequents();
                        if(trees!=null) {
                                this.setMsg("EQUIPASSO NODE EXECUTED: " + "Frequents Items had been created - Total: " + trees.size());
                            }else{
                                this.setMsg("EQUIPASSO NODE EXECUTED: " + "Error: Frequents Items hadn't been created...");
                            }
                    }else{
                        this.setMsg("EQUIPASSO NODE EXECUTED: " + "Error: There aren't exist Frequents Items One...");
                    }
                    long executionTime = System.currentTimeMillis() - time;                       
                    System.out.println("Equipasso tiempo: " + executionTime + " milisegundos");
                    // *** Finished ***
                    this.setExecuted(true);
                    /**pinta de verde si el nodo ya se ejecuto*/
                    setBorderColor(new Color(0,255,0));
                    getParent().repaint();
                    
                }
            }else if(sourceClassName.equals(UmbralNode.class.getCanonicalName())){
                
                UmbralNode   un = (UmbralNode)this.getInputNodes().get(0);
                //***********************************************************
                /*aqui se instancia umbral y a su vez del web server*/
                //***********************************************************
                this.setPathLogServer(un.getPathLogServer());
                System.out.println(" From EquipAsso: " + this.getPathLogServer());
                System.out.println(" From EquipAsso: is umbral mfr " + un.isMfr());
                /**paso del tiempo de sesion desde prepro*/
                this.setTsesion(Integer.parseInt(un.getTsesion()));
                System.out.println(" From Equipasso: session time "+this.getTsesion());
                
                if(!un.isConfigured()){
                    this.getParent().showError("The Umbral Session must be configured first");
                    /**validacion para las baderas ejecucion, configuracion y el color del borde*/
                    this.setExecuted(false);
                    if(this.isConfigured() == false){
                        this.setConfigured(false);
                        setBorderColor(null);
                    } else{
                        this.setConfigured(true);
                        setBorderColor(new Color(0,0,255));
                    }
                    
                } else if(!un.isExecuted()){
                    this.getParent().showError("The Umbral Session must be executed first");
                   /**validacion para las baderas ejecucion, configuracion y el color del borde*/
                    this.setExecuted(false);
                    if(this.isConfigured() == false){
                        this.setConfigured(false);
                        setBorderColor(null);
                    } else{
                        this.setConfigured(true);
                        setBorderColor(new Color(0,0,255));
                    }
                    
                } else if(!this.isConfigured()){
                    this.getParent().showError("First configure after execute");
                    /**cuando no esta configurado*/
                    this.setExecuted(false);
                    this.setConfigured(false);
                    setBorderColor(null);
                } else{
                    //EXECUTION CODE GOES HERE
                    // *** Polaris *** Johana ***
                    long time = System.currentTimeMillis();
                    // *** Configurar soporte y Confianza y Algoritmo
                    soporte= this.getSupport();
                    confianza= this.getConfidence();
                    algorithm= "EquipAsso";
                    hacerLift= this.isLift();
                    // *** Llenar Data Set
                    llenarDataSet= new fillDataSet(un.getTipoL()); //(tipo de Sesion) deberia ir tipoL
                    dataset= new DataSet();
                    dataset= llenarDataSet.loadDataSet(); // cargar datos en el DataSet
                    // *** Configurar soporte
                    int s_int = (int) ( (soporte * (double)dataset.getNtransactions()) / (double)100 );
                    System.out.println("dataset.getNtransactions " + dataset.getNtransactions() + " for " + algorithm);
                    System.out.println("s " + soporte + " for " + algorithm);
                    //
                    short s;
                    if(s_int > Short.MAX_VALUE){
                        s = Short.MAX_VALUE;
                    } else {
                        s = (short) s_int;
                    }
                    if(s==0)s=1;
                    System.out.println("Sop: " + s);
                    // *** Algoritmo
                    AvlTree frequentsOne = new AvlTree();
                    dataset.pruneCandidatesOne(s, frequentsOne);
                    // *** Para EquipAsso
                    if(frequentsOne.howMany() > 0){
                        EquipAsso equipasso = new EquipAsso(dataset, s);
                        equipasso.start();
                        trees = equipasso.getFrequents();
                        if(trees!=null) {
                                this.setMsg("EQUIPASSO NODE EXECUTED: " + "Frequents Items had been created - Total: " + trees.size());
                            }else{
                                this.setMsg("EQUIPASSO NODE EXECUTED: " + "Error: Frequents Items hadn't been created...");
                            }
                    }else{
                        this.setMsg("EQUIPASSO NODE EXECUTED: " + "Error: There aren't exist Frequents Items One...");
                    }
                    //
                    long executionTime = System.currentTimeMillis() - time;                       
                    System.out.println("Equipasso tiempo: " + executionTime + " milisegundos");
                    // *** Finished ***
                    /**cambia el valor de la bandera executed*/
                    this.setExecuted(true);
                    /**si el nodo fue configurado, el borde se torna verde*/
                    setBorderColor(new Color(0,255,0));
                    /**obtiene el contenedor y lo redibuja... si no se redibuja entonces
                    /**al mostrarse graficamente presenta pixeles defectuosos*/
                    getParent().repaint();
                    System.out.println(" From EquipAsso, is umbral mfr " + un.isMfr());
                }
            }
        }else{
            this.getParent().showError("First add a connection");
            /**cuando no esta configurado*/
            this.setExecuted(false);
            if(this.isConfigured() == false){
                this.setConfigured(false);
                setBorderColor(null);
            } else{
                this.setConfigured(true);
                setBorderColor(new Color(0,0,255));
            }
            getParent().repaint();
        }
    }
    /**aplicacion de encapsulacion*/
    public boolean isConfigured() {
        return configured;
    }
    
    public void setConfigured(boolean configured) {
        this.configured = configured;
    }
    
    public Vector getArbolFrec(){
        return this.trees;
    }
    
    public DataSet getDataSet(){
        return this.dataset;
    }
    
}
