package workspace.Association.settings;

import java.awt.Color;
import java.awt.Image;
import javax.swing.ImageIcon;
import javax.swing.SpinnerNumberModel;
import workspace.Main_Set.Main;

public class FrmAssociation extends javax.swing.JDialog {    
   /**se instancia el AprioriNode, archivo que contiene todas las configuraciones
   /** respectivas a Apriori y que a su vez hereda de SimpleNode*/
   private SimpleAssociationNode an;  
   /**se define un modelo particular para el spinner; un modelo que no acepta 
   * valores negativos, cuyo max valor es 100 y que incrementa en 0.5*/
   private SpinnerNumberModel spnModel1;
   private SpinnerNumberModel spnModel2;
   public boolean LIFT = false;
   /**configuraciones iniciales de este formulario*/
    public FrmAssociation(java.awt.Frame parent, SimpleAssociationNode nodo) {
        super(parent, true);
        initComponents();
        this.setIconImage(this.getImage("/media/star.png"));
        /**la instanciacion recibe un nodo */
        this.an = nodo;
        /**se aplica el modelo al spinner*/
        spnModel1 = new SpinnerNumberModel(this.an.getSupport(), 0.0, 100.0, 0.5);
        spnModel2 = new SpinnerNumberModel(this.an.getConfidence(), 0.0, 100.0, 0.5);
        /**se aplica en los dos spinner que contiene este formulario*/
        this.spnSupport.setModel(spnModel1);        
        this.spnConfidence.setModel(spnModel2);
        /**validacion para que el lift aparezca marcado o no*/
        if (this.an.isLift() == true){
            this.chkLift.setSelected(true);
        } else {
            this.chkLift.setSelected(false);
        }
    }       
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        spnSupport = new javax.swing.JSpinner();
        spnConfidence = new javax.swing.JSpinner();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        btnAccept = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();
        chkLift = new javax.swing.JCheckBox();
        jLabel1 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();

        setTitle("Apriori Settings");

        jLabel2.setText("Support");

        jLabel3.setText("Confidence");

        btnAccept.setText("Accept");
        btnAccept.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAcceptActionPerformed(evt);
            }
        });

        btnCancel.setText("Cancel");
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        chkLift.setText("Lift");
        chkLift.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        chkLift.setMargin(new java.awt.Insets(0, 0, 0, 0));
        chkLift.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkLiftActionPerformed(evt);
            }
        });

        jLabel1.setText("%");

        jLabel4.setText("%");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(61, 61, 61)
                        .addComponent(chkLift))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel2)
                                    .addComponent(jLabel3))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 17, Short.MAX_VALUE)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addComponent(spnConfidence)
                                    .addComponent(spnSupport, javax.swing.GroupLayout.PREFERRED_SIZE, 51, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel1)
                                    .addComponent(jLabel4))
                                .addGap(12, 12, 12))
                            .addGroup(layout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(btnAccept)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(btnCancel)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(spnSupport, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2)
                    .addComponent(jLabel1))
                .addGap(16, 16, 16)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(spnConfidence, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3)
                    .addComponent(jLabel4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 15, Short.MAX_VALUE)
                .addComponent(chkLift)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnCancel)
                    .addComponent(btnAccept))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    /**manejo de iconos ********************************************************/
       
    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }

    private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = Main.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }
    
    /**manejo de iconos ********************************************************/

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        /**boton cancelar*/                
        this.setVisible(false);   
        /**validacion para no cambiar los la configuracion cuando el nodo esta 
        * configurado o ejecutado y se oprime el boton cancelar*/
        if (this.an.isConfigured() == true) {
            this.an.setConfigured(true);
            this.an.setBorderColor(new Color(0,0,255));
            if (this.an.isExecuted() == true){
                this.an.setExecuted(true);
                this.an.setBorderColor(new Color(0,255,0));
            }
        }                   
    }//GEN-LAST:event_btnCancelActionPerformed

    private void btnAcceptActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAcceptActionPerformed
        /**boton aceptar*/
        this.an.setExecuted(false);
        this.an.setConfigured(true);
        /**a traves del paso de parametros de la instanciacion de an se envia el
        * soporte y la confianza y se visualizan*/
        this.an.setSupport((Double)this.spnSupport.getValue());         
        System.out.println(" Assoc form, Support: " + this.an.getSupport());        
        this.an.setConfidence((Double)this.spnConfidence.getValue());          
        System.out.println(" Assoc form, Confidence: " + this.an.getConfidence());        
        /**Al configurar el color del borde es azul y la badera de configured
        * se torna verdadera */       
        this.an.setBorderColor(new Color(0,0,255));
        this.an.setConfigured(true);
        this.setVisible(false);
        
        /**se asigna el valor de lift a AprioriNode y se visauliza rusticamente*/     
         if (this.LIFT == true){
             this.an.setLift(true); 
             System.out.println(" Assoc form, Lift value " + this.an.isLift());
        } else {
            this.an.setLift(false);  
             System.out.println(" Assoc form, Lift value " + this.an.isLift());
        }       
    }//GEN-LAST:event_btnAcceptActionPerformed

    private void chkLiftActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkLiftActionPerformed
        /**se asigna el valor de lift a AprioriNode*/    
         if(this.chkLift.isSelected() == true){ 
            this.LIFT = true;                                      
        } else {
            this.LIFT = false;                                
        }        
    }//GEN-LAST:event_chkLiftActionPerformed
                
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAccept;
    private javax.swing.JButton btnCancel;
    private javax.swing.JCheckBox chkLift;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JSpinner spnConfidence;
    private javax.swing.JSpinner spnSupport;
    // End of variables declaration//GEN-END:variables
    
}
