/**el archivo contiene las configuraciones correspondientes a la seleccion c 4.5
 *desde clasificacion*/

package workspace.Classification.algorithms;

import algorithm.classification.Transformacion_cla;
import algorithm.classification.c45_1.c45;
import algorithm.classification.elemento;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Point;
import java.util.ArrayList;
import javax.swing.ImageIcon;
import workspace.Classification.settings.FrmClassification;
import workspace.Classification.settings.SimpleClassificationNode;
import workspace.Main_Set.SimpleNode;
import workspace.Prepro.FilterNode;
import workspace.Prepro.IntervalNode;
import workspace.Prepro.UmbralNode;

public class C45Node extends SimpleClassificationNode{
    /**se esta forzando a variable*/
    private Class<?>[] clases;
    private ArrayList<SimpleNode> nodos;
    public boolean configured = false;
    public boolean executed   = false;
    // ***
    c45 algorithmC45;
    /** Estos parametros se guardan */
    ArrayList inDuracion;
    ArrayList inTamano;
    ArrayList inCantidad;
    // ***
    
    public C45Node(Point center) {
        /**se establece centro, dimension*/
        this.setCenter(center);
        this.setDimension(new Dimension(80,60));
        /**se valida el nodo antecesor, 2 nodos le pueden anteceder*/
        this.clases = new Class<?>[1];
        this.clases[0] = FilterNode.class;
        /**se instancia un ArrayList en nodos*/
        this.nodos = new ArrayList();
    }
    
    public Class<?>[] getValidInputClasses(){
        /**retorna los antecesores... umbral e interval en este caso*/
        return this.clases;
    }
    
    public ArrayList<SimpleNode> getInputNodes(){
        /**se devuelven los valores de los nodos en un array forzado a tipo
         *SimpleNode*/
        return this.nodos;
    }
    
    public Image getImage(){
        /**el icono*/
        return new ImageIcon(System.class.getResource("/media/c45.png")).getImage();
    }
    
    public String getString(){
        /**retorna una cadena que lo identifica*/
        return "C 4.5";
    }
    
    /**si el nodo puede ser conectado, entonces se anade un nodo*/
    public void connect(SimpleNode n){
        if(this.canConnect(n)){
            this.nodos.add(n);
        }
    }
    
    /**al desconectar el nodo se elimina la linea punteada y se coloca el color
     *de borde por defecto*/
    public void disconnect(SimpleNode n){
        this.nodos.remove(n);
        this.setBorderColor(null);
    }
    
    /**retorna verdadero porque puede ser configurado*/
    public boolean canConfigure(){
        return true;
    }
    
    /**llama al formulario de configuracion de c 4.5*/
    public void configure() {
        FrmClassification cn = new FrmClassification(null,(C45Node)getSelf());
        /**centrar*/
        cn.setLocationRelativeTo(cn.getParent());
        cn.setVisible(true);
        getParent().repaint();
    }
    
    /**retorna verdadero porque puede ser ejecutado*/
    public boolean canExecute() {
        return true;
    }
    
    public void execute() {
        // *** Polaris *** Johana
        ArrayList filtroCla;
        String claseTarget;
        String msj;
        // ***
        if(this.getInputNodes().size()==1){
            String sourceClassName = this.getInputNodes().get(0).getClass().getCanonicalName();
            if(sourceClassName.equals(FilterNode.class.getCanonicalName())){
                
                FilterNode   fn = (FilterNode)this.getInputNodes().get(0);
                //***********************************************************
                /*aqui se instancia filter*/
                //***********************************************************
                this.setPathLogServer(fn.getPathLogServer());
                //
                this.inCantidad= fn.getIcantidad();
                this.inDuracion= fn.getIduracion();
                this.inTamano= fn.getItamano();
                //
                System.out.println(" From filter: " + this.getPathLogServer());
                
                if(!fn.isExecuted()){
                    this.getParent().showError("The filter Session must be executed first");
                    /**validacion para las baderas ejecucion, configuracion y el color del borde*/
                    this.setExecuted(false);
                    if(this.isConfigured() == false){
                        this.setConfigured(false);
                        setBorderColor(null);
                    } else{
                        this.setConfigured(true);
                        setBorderColor(new Color(0,0,255));
                    }
                } else if(!this.isConfigured()){
                    this.getParent().showError("First configure after execute");
                    this.setExecuted(false);
                    this.setConfigured(false);
                    /**pinta de azul si el nodo ya no se ha configurado*/
                    setBorderColor(new Color(0,0,0));
                    getParent().repaint();
                } else{
                    
                    /**EXECUTION CODE GOES HERE*/
                    filtroCla= fn.getTransCla();
                    // - Algoritmo
                    String algoCla="C4.5";
                    claseTarget= this.getTarget();
                    String algorithm= algoCla;
                    //
                    if(algoCla.equals("C4.5") && filtroCla!=null){
                        msj= "C4.5 NODE EXECUTED: " + "Runing Algorithm...";
                        this.setMsg(msj);
                        algorithmC45= new c45(filtroCla,claseTarget);
                        algorithmC45.colocarValores(fn.getIduracion(),fn.getIcantidad(),fn.getItamano());
                        algorithmC45.start();                        
                    }else{
                        msj= "C4.5 NODE EXECUTED: " + "Error: It's posible than Discretize Node faild.";
                        this.setMsg(msj);
                    }
                    // *** Finished ***
                    /**cambia el valor de la bandera executed*/
                    this.setExecuted(true);
                    /**si el nodo fue configurado, el borde se torna verde*/
                    setBorderColor(new Color(0,255,0));
                    /**obtiene el contenedor y lo redibuja... si no se redibuja entonces
                     *al mostrarse graficamente presenta pixeles defectuosos*/
                    getParent().repaint();
                }
            }
            /**filternode close*/
        }else{
            this.getParent().showError("First add a connection");
            this.setExecuted(false);
            if(this.isConfigured() == false){
                this.setConfigured(false);
                setBorderColor(null);
            } else{
                this.setConfigured(true);
                setBorderColor(new Color(0,0,255));
            }
            getParent().repaint();
        }
    }
    
// *** Polaris *** Johana ***
    public elemento getArbol(){
        return algorithmC45.getArbolDecision();
    }
// *** F ***
    
    public boolean isConfigured() {
        return configured;
    }
    
    public void setConfigured(boolean configured) {
        this.configured = configured;
    }
    
    //
    
    public ArrayList getIduracion(){
        return inDuracion;
    }
    
    public ArrayList getItamano(){
        return inTamano;
    }
    
    public ArrayList getIcantidad(){
        return inCantidad;
    }
    
    // 
    
}
