package workspace.HPG;

import java.awt.Color;
import java.awt.Image;
import javax.swing.ImageIcon;
import javax.swing.SpinnerNumberModel;
import workspace.Main_Set.Main;

public class FrmHPG extends javax.swing.JDialog {    
   /**se instancia el HPGNode, archivo que contiene todas las configuraciones
   * respectivas a HPG y que a su vez hereda de SimpleNode*/
   private HPGNode hn;  
  /**se define un modelo particular para el spinner*/
   private SpinnerNumberModel spnModel1;
   private SpinnerNumberModel spnModel2;
   /**configuraciones iniciales de este formulario*/
    public FrmHPG(java.awt.Frame parent, HPGNode nodo) {
        super(parent, true);
        initComponents();
        this.setIconImage(this.getImage("/media/star.png"));
        /**la instanciacion recibe un nodo*/ 
        this.hn = nodo;
        /**se aplica el modelo al spinner*/
        spnModel1 = new SpinnerNumberModel(this.hn.getAlfa(), 0, 1, 0.1);
        spnModel2 = new SpinnerNumberModel(this.hn.getN(), 1, 100, 1);
        /**se aplica en los dos spinner que contiene este formulario*/
        this.spnAlfa.setModel(spnModel1);        
        this.spnN.setModel(spnModel2);            
    }       
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        spnAlfa = new javax.swing.JSpinner();
        spnN = new javax.swing.JSpinner();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        btnAccept = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();

        setTitle("HPG Settings");

        jLabel2.setText("Alfa");

        jLabel3.setText("N");

        btnAccept.setText("Accept");
        btnAccept.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAcceptActionPerformed(evt);
            }
        });

        btnCancel.setText("Cancel");
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(50, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel2)
                    .addComponent(jLabel3))
                .addGap(33, 33, 33)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(spnN, javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(spnAlfa, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 51, Short.MAX_VALUE))
                .addGap(16, 16, 16))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(btnAccept)
                .addGap(15, 15, 15)
                .addComponent(btnCancel)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(spnAlfa, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addGap(16, 16, 16)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(spnN, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnAccept)
                    .addComponent(btnCancel))
                .addContainerGap(25, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    /**manejo de iconos ********************************************************/
       
    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }

    private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = Main.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }
    
    /**manejo de iconos ********************************************************/

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
         /**boton cancelar */               
        this.setVisible(false);   
        /**validacion para no cambiar los la configuracion cuando el nodo esta 
        * configurado o ejecutado y se oprime el boton cancelar*/
        if (this.hn.isConfigured() == true) {
            this.hn.setConfigured(true);
            this.hn.setBorderColor(new Color(0,0,255));
            if (this.hn.isExecuted() == true){
                this.hn.setExecuted(true);
                this.hn.setBorderColor(new Color(0,255,0));
            }
        }                   
    }//GEN-LAST:event_btnCancelActionPerformed

    private void btnAcceptActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAcceptActionPerformed
        /**boton aceptar        
        * a traves del paso de parametros de la instanciacion de hn se envian el
        * los parametros de HPG y se visualizan */
        this.hn.setExecuted(false);       
        this.hn.setAlfa((Double)this.spnAlfa.getValue());
        System.out.println(" HPG form, Alfa: " + this.hn.getAlfa());        
        this.hn.setN((Integer)this.spnN.getValue());          
        System.out.println(" HPG form, N: " + this.hn.getN());        
        /**Al configurar el color del borde es azul y la badera de configured
        * se torna verdadera */       
        this.hn.setBorderColor(new Color(0,0,255));
        this.hn.setConfigured(true);
        this.setVisible(false);                    
    }//GEN-LAST:event_btnAcceptActionPerformed
                
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAccept;
    private javax.swing.JButton btnCancel;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JSpinner spnAlfa;
    private javax.swing.JSpinner spnN;
    // End of variables declaration//GEN-END:variables
    
}
