/**este archivo contiene todas las configuraciones rezpectivas al panel izq del
 * area de trabajo,
 * el trabajo con iconos y presentacion; es una clase que extiende de jPanel
 * se encarga de dibujar los nodos y de la comunicacion interna*/

package workspace.Main_Set;

//import com.itextpdf.text.Font;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.geom.Rectangle2D;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JSeparator;
import javax.swing.SwingUtilities;
import org.jdom.Attribute;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;
import workspace.Association.algorithms.AprioriNode;
import workspace.Prepro.intervalos;

public class Area extends JPanel{
    /**ArrayList es un objeto que representa un vector de tamao
     * variable para albergar distintos objetos, la anotacion <tipo> disponible
     * desde java 5.0 indica que esta coleccin o
     * vector unicamente almacena objetos de tipo <tipo> para este caso
     * SimpleNode <> actua como restriccion*/
    private List<SimpleNode> nodos;
    /**el objeto curNode obedece al nodo actual o al seleccionado y es tipo
     * SimpleNode tambien*/
    
    private SimpleNode curNode = null;
    private SimpleNode curNode2 = null;
    private int  curMode  = 1;
    /**valores constantes de estados posibles para el nodo
     * contantes del estado del rea de trabajo, su funcion principal es
     * impedir que al extender la clase sobre escriba estas constantes*/
    private final int SELECTNODE    = 1;
    private final int MOVEMODE      = 2;
    private final int ADDSOURCEMODE = 3;
    
    private String path;
    private boolean saved;
    
    public JLabel lbl_state;
    
    /**bandera que valida el arrastre del selectsource*/
    private boolean banArrastre = false;
    
    /**esta instanciacion se hace para el mensaje de la barra de estado*/
    private AprioriNode an;
    public String statusMsg;
    private boolean moviendo=true;
    private int pos_x=0;
    private int pos_y=0;
    private int pos_mouse_x=0;
    private int pos_mouse_y=0;

    //
    public String userbd="polaris";
    public String userbdpassword="polaris";
    //
    
    public void reset(){
        setNodos(new ArrayList<SimpleNode>());
        this.repaint();
        this.setPath(null);
        this.setSaved(true);
    }
    
    public Area() {
        reset();
        
        /**se anade un escuchador de eventos para mouse*/
        this.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                //ifCursor.CROSSHAIR_CURSOR
                pos_mouse_x=evt.getX();
                pos_mouse_y=evt.getY();
                repaint();




            }
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                //System.out.println("arrastre"+String.valueOf(evt.getX()));
                if(moviendo)
                {
                    try
                    {
                        int x = (int)getMousePosition().getX();
                        int y = (int)getMousePosition().getY();
                        if(curNode2!=null)curNode2.setCenter(new Point(x,y));
                        repaint();
                    }
                    catch(Exception o)
                    {
                    }
                    

                }


            }
        });

        this.addMouseListener(new MouseListener(){
            /**clic de mouse*/
            public void mouseClicked(MouseEvent e){
                mouseClick();
            }
            /**mouse entra*/
            public void mouseEntered(MouseEvent e){}
            /**mouse sale*/
            public void mouseExited(MouseEvent e){
                if(moviendo)
                {
                    if(curNode2!=null) curNode2.setCenter(new Point(pos_x,pos_y));
                    repaint();
                }

            }
            /**codigo para obtener el menu de clic derecho como popup
             * mouse presionado*/

            public void mousePressed(MouseEvent e){


                if(SwingUtilities.isLeftMouseButton(e))
                {
                    curNode2 = testPoint();
                    moviendo=true;
                    pos_x=e.getX();
                    pos_y=e.getY();
                }

                /**si se esta desplegando el menu contextual...*/
                if (e.isPopupTrigger()) {
                    /**al nodo actual se le asigna testPoint()*/
                    curNode = testPoint();
                    /**se repinta porque de lo contrario no se muestra bien en
                     * pantalla*/
                    repaint();
                    /**muestra del menu contextual*/
                    if(curNode!=null)mostrarPopup();
                }
            }
            /**se levanta el mouse*/
            public void mouseReleased(MouseEvent e){
                moviendo=false;
                //comprobar que no haya salido sino cambiar



                /**si se esta desplegando el menu contextual...*/
                if (e.isPopupTrigger()) {
                    /**el nodo actual recibe un testPoint*/
                    curNode = testPoint();
                    /**se repinta porque de lo contrario no se muestra bien en*/
                    /**pantalla*/
                    repaint();
                    /**muestra el menu*/
                    if(curNode!=null)mostrarPopup();
                }
            }
        });
    }
    
    /**se muestra un cuadro de dialogo que solicita una confirmacion*/
    public boolean showConfirm(String msg){
        if(JOptionPane.showConfirmDialog(this.getRootPane(),msg,"Question",JOptionPane.YES_NO_OPTION)==JOptionPane.YES_OPTION)
            return true;
        return false;
    }
    /**se muestra un cuadro de dialogo que reporta un error*/
    public void showError(String msg){
        JOptionPane.showMessageDialog(this.getRootPane(),msg,"Error",JOptionPane.ERROR_MESSAGE);
    }
    /**parametros del cursor del mouse*/
    public void setCursor(int cursorType){
        this.setCursor(new Cursor(cursorType));
    }
    /**eventos del clic del mouse*/
    public void mouseClick(){
        /**si curNode esta seleccionado*/
        if(curMode == SELECTNODE){
            /**se le asigna un testpoint()*/
            curNode = testPoint();
            /**y repinta*/
            repaint();
        }
        /**si el nodo actual se mueve*/
        if(curMode == MOVEMODE){
            /**las coordenadas son asignadas despues de obtener la posicion del
             * mouse*/
            int x = (int)getMousePosition().getX();
            int y = (int)getMousePosition().getY();
            /**se establece el centro*/
            curNode.setCenter(new Point(x,y));
            /**SELECTNODE es el cdigo 1*/
            curMode = SELECTNODE;
            /**cursor por defecto*/
            this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            /**se repinta*/
            repaint();
        }
        /**si el modo del cursor es anadir*/
        if(curMode == ADDSOURCEMODE){
            /**el nodo fuente es el nodo que permite seleccionar la fuente*/
            SimpleNode fuente = testPoint();
            /**si la fuente tiene un valor diferente de null*/
            if(fuente!=null){
                /**se procede a evaluar la conexion*/
                if(curNode.canConnect(fuente)){
                    /**si no hay fuente y si el nodo actual esta habilitado
                     * para ser
                     * conectado a la fuente, se conecta*/
                    curNode.connect(fuente);
                    /**se repinta*/
                    repaint();
                }else{
                    /**mensaje de error por seleccion de fuente indebida*/
                    JOptionPane.showMessageDialog(this,"The selected node is not a valid source","Error",JOptionPane.ERROR_MESSAGE);
                }
            }else{
                /*error por inexistencia de fuente*/
                JOptionPane.showMessageDialog(this,"Please, select a source node","Error",JOptionPane.ERROR_MESSAGE);
            }
            /*y el estado actual cambia a seleccion*/
            curMode = SELECTNODE;
            /*cursor por defecto*/
            this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        }
    }
    
    /** evento testPoint: su funcion es saber si un clic se encuentra dentro del
     * area de un nodo*/
    public SimpleNode testPoint(){
        /** por defecto res = null;*/
        SimpleNode res = null;
        /** se toman las coordenadas actuales del mouse*/
        int x = (int)getMousePosition().getX();
        int y = (int)getMousePosition().getY();
        for (int i = 0; i < getNodos().size(); i++) {
            SimpleNode n = getNodos().get(i);
            if(n.testPoint(new Point(x,y))){
                res = n;
            }
        }
        /** retorna el nodo que est en la coordena x y o null si en x y
         * no hay ningn nodo*/
        return res;
    }
    
    /** en esta funcion se construye y muestran un menu popup con las opciones
     * disponibles del nodo seleccionadomen de clic derecho*/
    public void mostrarPopup(){
        JPopupMenu jp = new JPopupMenu();
        JMenuItem  jm;
        /*
        jm = new JMenuItem("Move");
        jm.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                setSaved(false);
                setCursor(Cursor.CROSSHAIR_CURSOR);
                curMode = MOVEMODE;
            }
        });
        
        jp.add(jm);*/
        /** cuando se elimina el nodo se realizan tambien la desconexion*/
        jm = new JMenuItem("Delete");
        jm.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                if(showConfirm("Are you sure to delete this node?")){
                    setSaved(false);
                    for (int i = 0; i < getNodos().size(); i++) {
                        SimpleNode n = getNodos().get(i);
                        n.disconnect(curNode);
                    }
                    getNodos().remove(curNode);
                }
                /** se repinta*/
                repaint();
            }
        });
        jp.add(jm);
        
        /** validaciones para anadir/remover conexion y adicion de sus respectivos
         * separadores*/
        if(this.curNode.getValidInputClasses().length>0){
            jp.add(new JSeparator());
            if(this.curNode.getInputNodes().size()==0){
                jm = new JMenuItem("Add Connection");
                jm.addActionListener(new ActionListener(){
                    public void actionPerformed(ActionEvent e){
                        setSaved(false);
                        curMode = ADDSOURCEMODE;
                        setCursor(Cursor.CROSSHAIR_CURSOR);
                    }
                });
                jp.add(jm);
                jm = new JMenuItem("Remove Connection");
                jm.setEnabled(false);
                jp.add(jm);
            }else{
                jm = new JMenuItem("Add Connection");
                jm.setEnabled(false);
                jp.add(jm);
                jm = new JMenuItem("Remove Connection");
                jm.addActionListener(new ActionListener(){
                    public void actionPerformed(ActionEvent e){
                        setSaved(false);
                        curNode.disconnect(curNode.getInputNodes().get(0));
                        repaint();
                    }
                });
                jp.add(jm);
            }
            
        }
        
        /** si el nodo actual se puede configurar o ejecutar; se aade un separador
         * al menu contextual*/
        if(this.curNode.canConfigure()||this.curNode.canExecute()){
            jp.add(new JSeparator());
        }
        
        /** configuracion*/
        if(this.curNode.canConfigure()){
            jm = new JMenuItem("Settings");
            jm.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent a){
                    setSaved(false);
                    curNode.configure();
                }
            });
            jp.add(jm);
        }
        
        /** ejecucion*/
        if(this.curNode.canExecute()){
            /**los escuchadores fueron removidos en el metodo execute y son
             * sobre escritos pos metodos action performed que indican que
             * acciones se realizaran*/            
            jm = new JMenuItem("Run");
            jm.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent a){
                    setSaved(false);
                    curNode.setLogin(userbd);
                    curNode.setPWLogin(userbdpassword);
                    curNode.execute();
                    statusMsg = curNode.getMsg();
                    System.out.println("msj: " + curNode.getMsg());
                    lbl_state.setText(curNode.getMsg());
                }
            });
            jp.add(jm);
        }
        
        /** ver*/
        if(this.curNode.canView()){
            jm = new JMenuItem("View");
            jm.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent a){
                    curNode.view();
                }
            });
            jp.add(jm);
        }
        
        /**ayuda*/
        if(this.curNode.canView()||this.curNode.canGetHelp()){
            jp.add(new JSeparator());
        }
        if(this.curNode.canGetHelp()){
            jm = new JMenuItem("Help");
            jm.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent a){
                    curNode.help();
                }
            });
            jp.add(jm);
        }
        jp.show(this,(int)this.getMousePosition().getX(),(int)this.getMousePosition().getY());
    }
    
    /**adicion de nodos*/
    public void addNodo(SimpleNode n){
        
        this.getNodos().add(n);
        n.setParent(this);
        setSaved(false);
        
    }
    
    /**dibujo de cajas y conexiones*/
    public void paint(Graphics g) {

        Image btnNorm = null;

        Graphics2D g2 = (Graphics2D)g;

        /**dibujando las conexiones*/
        g.setColor(new Color(150,150,150));
        g.fillRect(0,0,this.getWidth(), this.getHeight());


        g.setColor(new Color(255,255,255));
        //float[] pat = new float[2];
        //pat[0] = 3;
        //pat[1] = 3;
        //g2.setStroke(new BasicStroke(2,0,0,1,pat,0));
        for (int i = 0; i < this.getNodos().size(); i++) {
            SimpleNode n = this.getNodos().get(i);
            ArrayList<SimpleNode> nodosI = n.getInputNodes();
            for (int j = 0; j < nodosI.size(); j++) {
                SimpleNode in = nodosI.get(j);
                g.drawLine((int)n.getCenter().getX(),(int)n.getCenter().getY(),(int)in.getCenter().getX(),(int)in.getCenter().getY());
            }
        }

         if(curMode==ADDSOURCEMODE)
         {
            g.drawLine((int)curNode.getCenter().getX(),(int)curNode.getCenter().getY(),pos_mouse_x,pos_mouse_y);
         }


        
        for (int i = 0; i < this.getNodos().size(); i++) {
            /**dibujando el borde*/
            SimpleNode n = this.getNodos().get(i);

            if(n.getBorderColor()!=null){
                
                g.setColor(n.getBorderColor());
            }else{
                
                g.setColor(new Color(38,64,102));
            }


            if(g.getColor().getGreen()==255)
            {
                //btnNorm = new ImageIcon(System.class.getResource("/media/btnVerde.png")).getImage();
                if(n.getString().compareTo("Web Server")==0) btnNorm = new ImageIcon(System.class.getResource("/media/webserver1.png")).getImage();
                if(n.getString().compareTo("Inter.Session")==0) btnNorm = new ImageIcon(System.class.getResource("/media/prepro1a1.png")).getImage();
                if(n.getString().compareTo("GAP Session")==0) btnNorm = new ImageIcon(System.class.getResource("/media/prepro1gapa1.png")).getImage();
                if(n.getString().compareTo("Discretize")==0) btnNorm = new ImageIcon(System.class.getResource("/media/filter1.png")).getImage();
                if(n.getString().compareTo("Apriori")==0) btnNorm = new ImageIcon(System.class.getResource("/media/asocapriori1.png")).getImage();
                if(n.getString().compareTo("FpTree")==0) btnNorm = new ImageIcon(System.class.getResource("/media/asocafptri1.png")).getImage();
                if(n.getString().compareTo("EquipAsso")==0) btnNorm = new ImageIcon(System.class.getResource("/media/asocequipasso1.png")).getImage();
                if(n.getString().compareTo("C 4.5")==0) btnNorm = new ImageIcon(System.class.getResource("/media/c451.png")).getImage();
                if(n.getString().compareTo("MateTree")==0) btnNorm = new ImageIcon(System.class.getResource("/media/matetree1.png")).getImage();
                if(n.getString().compareTo("HPG")==0) btnNorm = new ImageIcon(System.class.getResource("/media/hpg1.png")).getImage();
                if(n.getString().compareTo("Table")==0) btnNorm = new ImageIcon(System.class.getResource("/media/table1.png")).getImage();
                if(n.getString().compareTo("Stat")==0) btnNorm = new ImageIcon(System.class.getResource("/media/stat1.png")).getImage();
                if(n.getString().compareTo("Rules")==0) btnNorm = new ImageIcon(System.class.getResource("/media/rules1.png")).getImage();
                if(n.getString().compareTo("JTree")==0) btnNorm = new ImageIcon(System.class.getResource("/media/jtree1.png")).getImage();
                if(n.getString().compareTo("Tree")==0) btnNorm = new ImageIcon(System.class.getResource("/media/treeview1.png")).getImage();
                if(n.getString().compareTo("HPG Table")==0) btnNorm = new ImageIcon(System.class.getResource("/media/hpgtable1.png")).getImage();
                if(n.getString().compareTo("Grammar")==0) btnNorm = new ImageIcon(System.class.getResource("/media/grammar1.png")).getImage();
                if(n.getString().compareTo("BFSTree")==0) btnNorm = new ImageIcon(System.class.getResource("/media/bfs1.png")).getImage();
            }
            if(g.getColor().getGreen()==64)
            {
                //btnNorm = new ImageIcon(System.class.getResource("/media/btnRojo.png")).getImage();
                if(n.getString().compareTo("Web Server")==0) btnNorm = new ImageIcon(System.class.getResource("/media/webserver.png")).getImage();
                if(n.getString().compareTo("Inter.Session")==0) btnNorm = new ImageIcon(System.class.getResource("/media/prepro1a.png")).getImage();
                if(n.getString().compareTo("GAP Session")==0) btnNorm = new ImageIcon(System.class.getResource("/media/prepro1gapa.png")).getImage();
                if(n.getString().compareTo("Discretize")==0) btnNorm = new ImageIcon(System.class.getResource("/media/filter.png")).getImage();
                if(n.getString().compareTo("Apriori")==0) btnNorm = new ImageIcon(System.class.getResource("/media/asocapriori.png")).getImage();
                if(n.getString().compareTo("FpTree")==0) btnNorm = new ImageIcon(System.class.getResource("/media/asocafptri.png")).getImage();
                if(n.getString().compareTo("EquipAsso")==0) btnNorm = new ImageIcon(System.class.getResource("/media/asocequipasso.png")).getImage();
                if(n.getString().compareTo("C 4.5")==0) btnNorm = new ImageIcon(System.class.getResource("/media/c45.png")).getImage();
                if(n.getString().compareTo("MateTree")==0) btnNorm = new ImageIcon(System.class.getResource("/media/matetree.png")).getImage();
                if(n.getString().compareTo("HPG")==0) btnNorm = new ImageIcon(System.class.getResource("/media/hpg.png")).getImage();
                if(n.getString().compareTo("Table")==0) btnNorm = new ImageIcon(System.class.getResource("/media/table.png")).getImage();
                if(n.getString().compareTo("Stat")==0) btnNorm = new ImageIcon(System.class.getResource("/media/stat.png")).getImage();
                if(n.getString().compareTo("Rules")==0) btnNorm = new ImageIcon(System.class.getResource("/media/rules.png")).getImage();
                if(n.getString().compareTo("JTree")==0) btnNorm = new ImageIcon(System.class.getResource("/media/jtree.png")).getImage();
                if(n.getString().compareTo("Tree")==0) btnNorm = new ImageIcon(System.class.getResource("/media/treeview.png")).getImage();
                if(n.getString().compareTo("HPG Table")==0) btnNorm = new ImageIcon(System.class.getResource("/media/hpgtable.png")).getImage();
                if(n.getString().compareTo("Grammar")==0) btnNorm = new ImageIcon(System.class.getResource("/media/grammar.png")).getImage();
                if(n.getString().compareTo("BFSTree")==0) btnNorm = new ImageIcon(System.class.getResource("/media/bfs.png")).getImage();
            }
            if(g.getColor().getGreen()==0)
            {
                //btnNorm = new ImageIcon(System.class.getResource("/media/btnAmarillo.png")).getImage();
                if(n.getString().compareTo("Web Server")==0) btnNorm = new ImageIcon(System.class.getResource("/media/webserver2.png")).getImage();
                if(n.getString().compareTo("Inter.Session")==0) btnNorm = new ImageIcon(System.class.getResource("/media/prepro1a2.png")).getImage();
                if(n.getString().compareTo("GAP Session")==0) btnNorm = new ImageIcon(System.class.getResource("/media/prepro1gapa2.png")).getImage();
                if(n.getString().compareTo("Discretize")==0) btnNorm = new ImageIcon(System.class.getResource("/media/filter2.png")).getImage();
                if(n.getString().compareTo("Apriori")==0) btnNorm = new ImageIcon(System.class.getResource("/media/asocapriori2.png")).getImage();
                if(n.getString().compareTo("FpTree")==0) btnNorm = new ImageIcon(System.class.getResource("/media/asocafptri2.png")).getImage();
                if(n.getString().compareTo("EquipAsso")==0) btnNorm = new ImageIcon(System.class.getResource("/media/asocequipasso2.png")).getImage();
                if(n.getString().compareTo("C 4.5")==0) btnNorm = new ImageIcon(System.class.getResource("/media/c452.png")).getImage();
                if(n.getString().compareTo("MateTree")==0) btnNorm = new ImageIcon(System.class.getResource("/media/matetree2.png")).getImage();
                if(n.getString().compareTo("HPG")==0) btnNorm = new ImageIcon(System.class.getResource("/media/hpg2.png")).getImage();
                if(n.getString().compareTo("Table")==0) btnNorm = new ImageIcon(System.class.getResource("/media/table2.png")).getImage();
                if(n.getString().compareTo("Stat")==0) btnNorm = new ImageIcon(System.class.getResource("/media/stat2.png")).getImage();
                if(n.getString().compareTo("Rules")==0) btnNorm = new ImageIcon(System.class.getResource("/media/rules2.png")).getImage();
                if(n.getString().compareTo("JTree")==0) btnNorm = new ImageIcon(System.class.getResource("/media/jtree2.png")).getImage();
                if(n.getString().compareTo("Tree")==0) btnNorm = new ImageIcon(System.class.getResource("/media/treeview2.png")).getImage();
                if(n.getString().compareTo("HPG Table")==0) btnNorm = new ImageIcon(System.class.getResource("/media/hpgtable2.png")).getImage();
                if(n.getString().compareTo("Grammar")==0) btnNorm = new ImageIcon(System.class.getResource("/media/grammar2.png")).getImage();
                if(n.getString().compareTo("BFSTree")==0) btnNorm = new ImageIcon(System.class.getResource("/media/bfs2.png")).getImage();
            }



            g.drawImage(btnNorm,(int)(n.getCenter().getX()-45),(int)(n.getCenter().getY()-33),null);
            //g.setColor(new Color(0,0,255));
            //Rectangle2D r = g.getFontMetrics().getStringBounds(n.getString(),g);
            //int offX = (int)(r.getWidth()/2);
            //int offY = 0;
            //Font font = new Font( "Serif", Font.BOLD, 15 );
            //g.setFont( font );
            //g.drawString(n.getString(),(int)n.getCenter().getX()-offX,(int)n.getCenter().getY()-offY);

        }
    }
    
    /**envio de nodos como parametros*/
    public List<SimpleNode> getNodos() {
        return nodos;
    }
    
    public void setNodos(List<SimpleNode> nodos) {
        this.nodos = nodos;
    }
    
    public String getPath() {
        return path;
    }
    
    public void setPath(String path) {
        this.path = path;
    }
    
    public boolean isSaved() {
        return saved;
    }
    
    public void setSaved(boolean saved) {
        this.saved = saved;
    }
    
    /**para abrir y guardar el esquema se uriliza jdom.jar - www.jdom.org - Jason
     * Hunter - jhunter@servlets.com
     * se encarga de representar estructuras xml de modo sencillo y natural
     * es una evolucion del dom*/
    
    /**el temible... abrir =o*/
    public void loadFromFile(){
        String path = this.getPath();
        /**el proceso de abrir es aparentemente sencillo, el elemento quue fue
         * creado en save, se llama aqui y se obtienen los valores que fueron
         * grabados*/
        List<SimpleNode> nodos = new ArrayList<SimpleNode>();
        SAXBuilder builder = new SAXBuilder();
        try {
            Document doc   = builder.build(new File(path));
            Element  root  = doc.getRootElement();
            Element  nodes = root.getChild("nodes");
            for (int i = 0; i < nodes.getChildren().size(); i++) {
                Element nodo = (Element)nodes.getChildren().get(i);
                String className = nodo.getAttribute("class").getValue();
                Element point = nodo.getChild("point");
                int x = Integer.parseInt(point.getAttribute("x").getValue());
                int y = Integer.parseInt(point.getAttribute("y").getValue());
                int code = Integer.parseInt(nodo.getAttribute("code").getValue());
                /**si es selectsource*/
                if(className.equals(workspace.Source.SelectSourceNode.class.getCanonicalName())){
                    workspace.Source.SelectSourceNode node = new workspace.Source.SelectSourceNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    node.setConfigured(Boolean.valueOf(nodo.getChild("configure").getValue()));
                    /**valida si el nodo se guarda en estado configurado*/
                    if (node.isConfigured()== true) {
                        node.setBorderColor(new Color(0,0,255));
                    }
                    /**guarda la ruta*/
                    node.setPath(nodo.getChild("path").getValue());
                    
                    Element exts = nodo.getChild("extensions");
                    node.setTam(exts.getChildren().size());
                    
                    Vector vct = new Vector();
                    
                    for (int j = 0; j < exts.getChildren().size(); j++) {
                        vct.add(((Element)exts.getChildren().get(j)).getText());
                    }
                    
                    node.setVectorExt(vct);
                    
                    int aux = node.getTam();
                    nodos.add(node);
                }
                /**abre sesion y mfr*/
                if(className.equals(workspace.Prepro.IntervalNode.class.getCanonicalName())){
                    workspace.Prepro.IntervalNode node = new workspace.Prepro.IntervalNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    node.setConfigured(Boolean.valueOf(nodo.getChild("configure").getValue()));
                    if (node.isConfigured()== true) {
                        node.setBorderColor(new Color(0,0,255));
                    }
                    node.setTsesion(nodo.getChild("session").getValue());
                    node.setMfr(Boolean.valueOf(nodo.getChild("mfr").getValue()));
                    nodos.add(node);
                }
                if(className.equals(workspace.Prepro.UmbralNode.class.getCanonicalName())){
                    workspace.Prepro.UmbralNode node = new workspace.Prepro.UmbralNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    node.setConfigured(Boolean.valueOf(nodo.getChild("configure").getValue()));
                    if (node.isConfigured()== true) {
                        node.setBorderColor(new Color(0,0,255));
                    }
                    node.setTsesion(nodo.getChild("session").getValue());
                    node.setMfr(Boolean.valueOf(nodo.getChild("mfr").getValue()));
                    nodos.add(node);
                }
                if(className.equals(workspace.Prepro.FilterNode.class.getCanonicalName())){
                    workspace.Prepro.FilterNode node = new workspace.Prepro.FilterNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    
                    ////////////////////////////////////////////////////////
                    
                    Element cant = nodo.getChild("cantidades");
                    Element dura = nodo.getChild("duracion");
                    Element tama = nodo.getChild("tamano");
                    
                    if(cant!=null){
                        if(cant.getChildren().size()>0){
                            node.inCantidad = new ArrayList();
                            for (int j = 0; j < cant.getChildren().size(); j++) {
                                Element interval = (Element)cant.getChildren().get(j);
                                String des = interval.getAttribute("Description").getValue();
                                String nam = interval.getAttribute("Name").getValue();
                                long   max = Long.valueOf(interval.getAttribute("Max").getValue());
                                long   min = Long.valueOf(interval.getAttribute("Min").getValue());
                                intervalos inte = new intervalos(nam, min, max);
                                inte.setDescripcion(des);
                                node.inCantidad.add(inte);
                            }
                        }
                    }
                    
                    if(dura!=null){
                        if(dura.getChildren().size()>0){
                            node.inDuracion = new ArrayList();
                            for (int j = 0; j < dura.getChildren().size(); j++) {
                                Element interval = (Element)dura.getChildren().get(j);
                                String des = interval.getAttribute("Description").getValue();
                                String nam = interval.getAttribute("Name").getValue();
                                long   max = Long.valueOf(interval.getAttribute("Max").getValue());
                                long   min = Long.valueOf(interval.getAttribute("Min").getValue());
                                intervalos inte = new intervalos(nam, min, max);
                                inte.setDescripcion(des);
                                node.inDuracion.add(inte);
                            }
                        }
                    }
                    
                    if(tama!=null){
                        if(tama.getChildren().size()>0){
                            node.inTamano = new ArrayList();
                            for (int j = 0; j < tama.getChildren().size(); j++) {
                                Element interval = (Element)tama.getChildren().get(j);
                                String des = interval.getAttribute("Description").getValue();
                                String nam = interval.getAttribute("Name").getValue();
                                long   max = Long.valueOf(interval.getAttribute("Max").getValue());
                                long   min = Long.valueOf(interval.getAttribute("Min").getValue());
                                intervalos inte = new intervalos(nam, min, max);
                                inte.setDescripcion(des);
                                node.inTamano.add(inte);
                            }
                        }
                    }
                    
                    ////////////////////////////////////////////////////////
                    
                    nodos.add(node);
                }
                /**parametros de apriori y todos los algoritmos de asoc*/
                if(className.equals(workspace.Association.algorithms.AprioriNode.class.getCanonicalName())){
                    workspace.Association.algorithms.AprioriNode node = new workspace.Association.algorithms.AprioriNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    node.setConfigured(Boolean.valueOf(nodo.getChild("configure").getValue()));
                    if (node.isConfigured()== true) {
                        node.setBorderColor(new Color(0,0,255));
                    }
                    node.setSupport(Double.valueOf(nodo.getChild("support").getValue()));
                    node.setConfidence(Double.valueOf(nodo.getChild("confidence").getValue()));
                    node.setLift(Boolean.valueOf(nodo.getChild("lift").getValue()));
                    nodos.add(node);
                }
                if(className.equals(workspace.Association.algorithms.EquipAssoNode.class.getCanonicalName())){
                    workspace.Association.algorithms.EquipAssoNode node = new workspace.Association.algorithms.EquipAssoNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    node.setConfigured(Boolean.valueOf(nodo.getChild("configure").getValue()));
                    if (node.isConfigured()== true) {
                        node.setBorderColor(new Color(0,0,255));
                    }
                    node.setSupport(Double.valueOf(nodo.getChild("support").getValue()));
                    node.setConfidence(Double.valueOf(nodo.getChild("confidence").getValue()));
                    node.setLift(Boolean.valueOf(nodo.getChild("lift").getValue()));
                    nodos.add(node);
                }
                if(className.equals(workspace.Association.algorithms.FpTreeNode.class.getCanonicalName())){
                    workspace.Association.algorithms.FpTreeNode node = new workspace.Association.algorithms.FpTreeNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    node.setConfigured(Boolean.valueOf(nodo.getChild("configure").getValue()));
                    if (node.isConfigured()== true) {
                        node.setBorderColor(new Color(0,0,255));
                    }
                    node.setSupport(Double.valueOf(nodo.getChild("support").getValue()));
                    node.setConfidence(Double.valueOf(nodo.getChild("confidence").getValue()));
                    node.setLift(Boolean.valueOf(nodo.getChild("lift").getValue()));
                    nodos.add(node);
                }/**algoritmos de clasificacion*/
                if(className.equals(workspace.Classification.algorithms.C45Node.class.getCanonicalName())){
                    workspace.Classification.algorithms.C45Node node = new workspace.Classification.algorithms.C45Node(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    node.setConfigured(Boolean.valueOf(nodo.getChild("configure").getValue()));
                    if (node.isConfigured()== true) {
                        node.setBorderColor(new Color(0,0,255));
                    }
                    node.setTarget(nodo.getChild("target").getValue());
                    nodos.add(node);
                }
                if(className.equals(workspace.Classification.algorithms.CBANode.class.getCanonicalName())){
                    workspace.Classification.algorithms.CBANode node = new workspace.Classification.algorithms.CBANode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    node.setConfigured(Boolean.valueOf(nodo.getChild("configure").getValue()));
                    if (node.isConfigured()== true) {
                        node.setBorderColor(new Color(0,0,255));
                    }
                    node.setTarget(nodo.getChild("target").getValue());
                    nodos.add(node);
                }
                if(className.equals(workspace.Classification.algorithms.MateTreeNode.class.getCanonicalName())){
                    workspace.Classification.algorithms.MateTreeNode node = new workspace.Classification.algorithms.MateTreeNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    node.setConfigured(Boolean.valueOf(nodo.getChild("configure").getValue()));
                    if (node.isConfigured()== true) {
                        node.setBorderColor(new Color(0,0,255));
                    }
                    node.setTarget(nodo.getChild("target").getValue());
                    nodos.add(node);
                }//k medias
                if(className.equals(workspace.Clustering.ClusteringNode.class.getCanonicalName())){
                    workspace.Clustering.ClusteringNode node = new workspace.Clustering.ClusteringNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    nodos.add(node);
                }/**hpg*/
                if(className.equals(workspace.HPG.HPGNode.class.getCanonicalName())){
                    workspace.HPG.HPGNode node = new workspace.HPG.HPGNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    node.setConfigured(Boolean.valueOf(nodo.getChild("configure").getValue()));
                    if (node.isConfigured()== true) {
                        node.setBorderColor(new Color(0,0,255));
                    }
                    node.setAlfa(Double.valueOf(nodo.getChild("alfa").getValue()));
                    node.setN(Integer.valueOf(nodo.getChild("n").getValue()));
                    nodos.add(node);
                }/**algoritmos de vistas*/
                if(className.equals(workspace.Views.GrammarViewNode.class.getCanonicalName())){
                    workspace.Views.GrammarViewNode node = new workspace.Views.GrammarViewNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    nodos.add(node);
                }
                if(className.equals(workspace.Views.StatViewNode.class.getCanonicalName())){
                    workspace.Views.StatViewNode node = new workspace.Views.StatViewNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    nodos.add(node);
                }
                if(className.equals(workspace.Views.TableViewNode.class.getCanonicalName())){
                    workspace.Views.TableViewNode node = new workspace.Views.TableViewNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    nodos.add(node);
                }
                if(className.equals(workspace.Views.TreeViewNode.class.getCanonicalName())){
                    workspace.Views.TreeViewNode node = new workspace.Views.TreeViewNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    nodos.add(node);
                }
                if(className.equals(workspace.Views.WekaViewNode.class.getCanonicalName())){
                    workspace.Views.WekaViewNode node = new workspace.Views.WekaViewNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    nodos.add(node);
                }
                if(className.equals(workspace.Views.JTreeViewNode.class.getCanonicalName())){
                    workspace.Views.JTreeViewNode node = new workspace.Views.JTreeViewNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    nodos.add(node);
                }
                if(className.equals(workspace.Views.RulesViewNode.class.getCanonicalName())){
                    workspace.Views.RulesViewNode node = new workspace.Views.RulesViewNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    nodos.add(node);
                }
                if(className.equals(workspace.Views.HPGTableNode.class.getCanonicalName())){
                    workspace.Views.HPGTableNode node = new workspace.Views.HPGTableNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    nodos.add(node);
                }
                 if(className.equals(workspace.Views.BFSTreeNode.class.getCanonicalName())){
                    workspace.Views.BFSTreeNode node = new workspace.Views.BFSTreeNode(new Point(x,y));
                    node.setCode(code);
                    node.setParent(this);
                    nodos.add(node);
                }
            }
            setNodos(nodos);
            /**Guarda relaciones*/
            Element rels = root.getChild("relations");
            List    rel  = rels.getChildren();
            for (int i = 0; i < rel.size(); i++) {
                int from = Integer.parseInt(((Element)rel.get(i)).getAttributeValue("from"));
                int to   = Integer.parseInt(((Element)rel.get(i)).getAttributeValue("to"));
                SimpleNode fromNode = getElementById(nodos,from);
                SimpleNode toNode   = getElementById(nodos,to);
                fromNode.connect(toNode);
            }
            
            repaint();
            
        } catch (IOException ex) {
            ex.printStackTrace();
        } catch (JDOMException ex) {
            ex.printStackTrace();
        }
    }
    
    /**guardar =o*/
    public void saveToFile(){
        Area area = this;
        List<SimpleNode> nodos = area.getNodos();
        
        Document doc = new Document();
        Element e;
        /**toma el workspace como elemento*/
        Element workspace = new Element("workspace");
        workspace.getAttributes().add(new Attribute("name","project x"));
        Element nodes = new Element("nodes");
        //las relaciones tambien son elementos*/
        Element relations = new Element("relations");
        workspace.getChildren().add(nodes);
        workspace.getChildren().add(relations);
        doc.addContent(workspace);
        /**recorre los nodos estableciendoles un codigo, independiente del tipo
         * de nodo*/
        for (int i = 0; i < nodos.size(); i++) {
            nodos.get(i).setCode(i);
        }
        /**para cada nodo se abre su respectiva configuracion ya almacenada*/
        for (int i = 0; i < nodos.size(); i++) {
            Element node = new Element("node");
            Element punto = new Element("point");
            String className = nodos.get(i).getClass().getCanonicalName();
            try {
                node.setAttribute("code",String.valueOf(nodos.get(i).getCode()));
            } finally {
            }
            node.setAttribute("class",className);
            punto.setAttribute("x",String.valueOf((int)nodos.get(i).getCenter().getX()));
            punto.setAttribute("y",String.valueOf((int)nodos.get(i).getCenter().getY()));
            node.addContent(punto);
            /**guarda la ruta del web server*/
            if(className.equals(workspace.Source.SelectSourceNode.class.getCanonicalName())){
                workspace.Source.SelectSourceNode ssn =  (workspace.Source.SelectSourceNode)nodos.get(i);
                Element path = new Element("path");
                path.setText(ssn.getPath());
                node.addContent(path);
                
                /**guarda el vector de extenisones... casi no!!*/
                Element vec = new Element("extensions");
                for (int j = 0; j < ssn.getVectorExt().size(); j++) {
                    Element ext = new Element("Extension");
                    ext.setText(ssn.getVectorExt().elementAt(j).toString());
                    vec.getChildren().add(ext);
                    System.out.println(ssn.getVectorExt().elementAt(j).toString());
                }
                node.getChildren().add(vec);
                
                Element conf = new Element("configure");
                conf.setText(String.valueOf(ssn.isConfigured()));
                node.addContent(conf);
            }
            
            /**guarda la sesion y el mfr del preproceso*/
            if(className.equals(workspace.Prepro.IntervalNode.class.getCanonicalName())){
                workspace.Prepro.IntervalNode ivn =  (workspace.Prepro.IntervalNode)nodos.get(i);
                Element el;
                el = new Element("session");
                el.setText(ivn.getTsesion());
                node.addContent(el);
                
                Element elMfr;
                elMfr = new Element("mfr");
                elMfr.setText(String.valueOf(ivn.isMfr()));
                node.addContent(elMfr);
                
                Element conf = new Element("configure");
                conf.setText(String.valueOf(ivn.isConfigured()));
                node.addContent(conf);
            }
            
            if(className.equals(workspace.Prepro.UmbralNode.class.getCanonicalName())){
                workspace.Prepro.UmbralNode un =  (workspace.Prepro.UmbralNode)nodos.get(i);
                Element el;
                el = new Element("session");
                el.setText(un.getTsesion());
                node.addContent(el);
                
                el = new Element("mfr");
                el.setText(String.valueOf(un.isMfr()));
                node.addContent(el);
                
                Element conf = new Element("configure");
                conf.setText(String.valueOf(un.isConfigured()));
                node.addContent(conf);
            }
            if(className.equals(workspace.Prepro.FilterNode.class.getCanonicalName())){
                workspace.Prepro.FilterNode fn =  (workspace.Prepro.FilterNode)nodos.get(i);
                Element cant = new Element("cantidades");
                node.getChildren().add(cant);
                
                Element dura = new Element("duracion");
                node.getChildren().add(dura);
                
                Element tama = new Element("tamano");
                node.getChildren().add(tama);
                
                if(fn.getIcantidad()!=null){
                    for (int j = 0; j < fn.getIcantidad().size(); j++) {
                        intervalos in = (intervalos)fn.getIcantidad().get(j);
                        Element interval = new Element("intervalos");
                        cant.getChildren().add(interval);
                        interval.setAttribute("Description",in.getDescripcion());
                        interval.setAttribute("Max",String.valueOf(in.getMax()));
                        interval.setAttribute("Min",String.valueOf(in.getMin()));
                        interval.setAttribute("Name",in.getNom());
                    }
                    
                } else {
                    System.out.println("getIcant null");
                }
                
                if(fn.getIduracion()!=null){
                    for (int j = 0; j < fn.getIduracion().size(); j++) {
                        intervalos in = (intervalos)fn.getIduracion().get(j);
                        Element interval = new Element("intervalos");
                        dura.getChildren().add(interval);
                        interval.setAttribute("Description",in.getDescripcion());
                        interval.setAttribute("Max",String.valueOf(in.getMax()));
                        interval.setAttribute("Min",String.valueOf(in.getMin()));
                        interval.setAttribute("Name",in.getNom());
                    }
                } else {
                    System.out.println("getIdur null");
                }
                
                if(fn.getItamano()!=null){
                    for (int j = 0; j < fn.getItamano().size(); j++) {
                        intervalos in = (intervalos)fn.getItamano().get(j);
                        Element interval = new Element("intervalos");
                        tama.getChildren().add(interval);
                        interval.setAttribute("Description",in.getDescripcion());
                        interval.setAttribute("Max",String.valueOf(in.getMax()));
                        interval.setAttribute("Min",String.valueOf(in.getMin()));
                        interval.setAttribute("Name",in.getNom());
                    }
                } else {
                    System.out.println("getItam null");
                }
                
                Element conf = new Element("execute");
                conf.setText(String.valueOf(fn.isExecuted()));
                node.getChildren().add(conf);
            }
            
            /**guarda los parametros de los algoritmos de asoc*/
            if(className.equals(workspace.Association.algorithms.AprioriNode.class.getCanonicalName())){
                workspace.Association.algorithms.AprioriNode an =  (workspace.Association.algorithms.AprioriNode)nodos.get(i);
                Element el;
                el = new Element("support");
                el.setText(String.valueOf(an.getSupport()));
                node.addContent(el);
                
                el = new Element("confidence");
                el.setText(String.valueOf(an.getConfidence()));
                node.addContent(el);
                
                el = new Element("lift");
                el.setText(String.valueOf(an.isLift()));
                node.addContent(el);
                
                Element conf = new Element("configure");
                conf.setText(String.valueOf(an.isConfigured()));
                node.addContent(conf);
            }
            
            if(className.equals(workspace.Association.algorithms.EquipAssoNode.class.getCanonicalName())){
                workspace.Association.algorithms.EquipAssoNode en =  (workspace.Association.algorithms.EquipAssoNode)nodos.get(i);
                Element el;
                el = new Element("support");
                el.setText(String.valueOf(en.getSupport()));
                node.addContent(el);
                
                el = new Element("confidence");
                el.setText(String.valueOf(en.getConfidence()));
                node.addContent(el);
                
                el = new Element("lift");
                el.setText(String.valueOf(en.isLift()));
                node.addContent(el);
                
                Element conf = new Element("configure");
                conf.setText(String.valueOf(en.isConfigured()));
                node.addContent(conf);
            }
            
            if(className.equals(workspace.Association.algorithms.FpTreeNode.class.getCanonicalName())){
                workspace.Association.algorithms.FpTreeNode fn =  (workspace.Association.algorithms.FpTreeNode)nodos.get(i);
                Element el;
                el = new Element("support");
                el.setText(String.valueOf(fn.getSupport()));
                node.addContent(el);
                
                el = new Element("confidence");
                el.setText(String.valueOf(fn.getConfidence()));
                node.addContent(el);
                
                el = new Element("lift");
                el.setText(String.valueOf(fn.isLift()));
                node.addContent(el);
                
                Element conf = new Element("configure");
                conf.setText(String.valueOf(fn.isConfigured()));
                node.addContent(conf);
            }
            /**guarda los parametros de clasif*/
            if(className.equals(workspace.Classification.algorithms.C45Node.class.getCanonicalName())){
                workspace.Classification.algorithms.C45Node cn =  (workspace.Classification.algorithms.C45Node)nodos.get(i);
                Element el;
                el = new Element("target");
                el.setText(cn.getTarget());
                node.addContent(el);
                
                Element conf = new Element("configure");
                conf.setText(String.valueOf(cn.isConfigured()));
                node.addContent(conf);
            }
            
            if(className.equals(workspace.Classification.algorithms.CBANode.class.getCanonicalName())){
                workspace.Classification.algorithms.CBANode cn =  (workspace.Classification.algorithms.CBANode)nodos.get(i);
                Element el;
                el = new Element("target");
                el.setText(cn.getTarget());
                node.addContent(el);
                
                Element conf = new Element("configure");
                conf.setText(String.valueOf(cn.isConfigured()));
                node.addContent(conf);
            }
            
            if(className.equals(workspace.Classification.algorithms.MateTreeNode.class.getCanonicalName())){
                workspace.Classification.algorithms.MateTreeNode mn =  (workspace.Classification.algorithms.MateTreeNode)nodos.get(i);
                Element el;
                el = new Element("target");
                el.setText(String.valueOf(mn.getTarget()));
                node.addContent(el);
                
                Element conf = new Element("configure");
                conf.setText(String.valueOf(mn.isConfigured()));
                node.addContent(conf);
            }/**guarda params y settings de hpg*/
            if(className.equals(workspace.HPG.HPGNode.class.getCanonicalName())){
                workspace.HPG.HPGNode hn =  (workspace.HPG.HPGNode)nodos.get(i);
                Element el;
                el = new Element("alfa");
                el.setText(String.valueOf(hn.getAlfa()));
                node.addContent(el);
                
                el = new Element("n");
                el.setText(String.valueOf(hn.getN()));
                node.addContent(el);
                
                Element conf = new Element("configure");
                conf.setText(String.valueOf(hn.isConfigured()));
                node.addContent(conf);
            }
            
            /**parametros y conf de las vistas*/
            if(className.equals(workspace.Views.TableViewNode.class.getCanonicalName())){
                workspace.Views.TableViewNode tv =  (workspace.Views.TableViewNode)nodos.get(i);
                Element conf = new Element("execute");
                conf.setText(String.valueOf(tv.isExecuted()));
                node.addContent(conf);
            }
            if(className.equals(workspace.Views.TreeViewNode.class.getCanonicalName())){
                workspace.Views.TreeViewNode trv =  (workspace.Views.TreeViewNode)nodos.get(i);
                Element conf = new Element("execute");
                conf.setText(String.valueOf(trv.isExecuted()));
                node.addContent(conf);
            }
            if(className.equals(workspace.Views.StatViewNode.class.getCanonicalName())){
                workspace.Views.StatViewNode sv =  (workspace.Views.StatViewNode)nodos.get(i);
                Element conf = new Element("execute");
                conf.setText(String.valueOf(sv.isExecuted()));
                node.addContent(conf);
            }
            if(className.equals(workspace.Views.GrammarViewNode.class.getCanonicalName())){
                workspace.Views.GrammarViewNode gv =  (workspace.Views.GrammarViewNode)nodos.get(i);
                Element conf = new Element("execute");
                conf.setText(String.valueOf(gv.isExecuted()));
                node.addContent(conf);
            }
            if(className.equals(workspace.Views.JTreeViewNode.class.getCanonicalName())){
                workspace.Views.JTreeViewNode jv =  (workspace.Views.JTreeViewNode)nodos.get(i);
                Element conf = new Element("execute");
                conf.setText(String.valueOf(jv.isExecuted()));
                node.addContent(conf);
            }
            if(className.equals(workspace.Views.RulesViewNode.class.getCanonicalName())){
                workspace.Views.RulesViewNode rv =  (workspace.Views.RulesViewNode)nodos.get(i);
                Element conf = new Element("execute");
                conf.setText(String.valueOf(rv.isExecuted()));
                node.addContent(conf);
            }
            if(className.equals(workspace.Views.HPGTableNode.class.getCanonicalName())){
                workspace.Views.HPGTableNode hv =  (workspace.Views.HPGTableNode)nodos.get(i);
                Element conf = new Element("execute");
                conf.setText(String.valueOf(hv.isExecuted()));
                node.addContent(conf);
            }
            if(className.equals(workspace.Views.BFSTreeNode.class.getCanonicalName())){
                workspace.Views.BFSTreeNode bv =  (workspace.Views.BFSTreeNode)nodos.get(i);
                Element conf = new Element("execute");
                conf.setText(String.valueOf(bv.isExecuted()));
                node.addContent(conf);
            }
            
            /**final vistas*/
            nodes.addContent(node);
        }
        /**establece las relaciones exixtentes*/
        for (int i = 0; i < nodos.size(); i++) {
            if(nodos.get(i).getInputNodes().size()==1){
                /**el archivo de xml contiene elementos, los cuales contienen
                 * otros elementos y a su vez contienen atributos, pero solo
                 * cuenta con un UNICO root*/
                Element rel = new Element("relation");
                rel.setAttribute("from",String.valueOf(nodos.get(i).getCode()));
                SimpleNode to = nodos.get(i).getInputNodes().get(0);
                rel.setAttribute("to"  ,String.valueOf(to.getCode()));
                relations.addContent(rel);
            }
        }
        /**muestra la salida contenida en un archivo xml*/
        XMLOutputter outp = new XMLOutputter();
        outp.setFormat(Format.getPrettyFormat());
        File f = new File(this.getPath());
        try {
            FileOutputStream fos = new FileOutputStream(f);
            outp.output(doc,fos);
            fos.close();
            setSaved(true);
        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    
    /**distribuye cada elemento del SimpleNode (clase padre) por ID*/
    private SimpleNode getElementById(List<SimpleNode> nodos, int id){
        System.out.println("Looking for "+id);
        SimpleNode res = null;
        for (int i = 0; i < nodos.size()&&res==null; i++) {
            System.out.println("code "+nodos.get(i).getCode());
            if(nodos.get(i).getCode()==id){
                res = nodos.get(i);
            }
        }
        return res;
    }
    
    public boolean isBanArrastre() {
        return banArrastre;
    }
    
    public void setBanArrastre(boolean banArrastre) {
        this.banArrastre = banArrastre;
    }
    
    public String getStatusMsg() {
        return statusMsg;
    }
    
    public void setBarra(JLabel lbl_stat){
        lbl_state= lbl_stat;
    }
    
    public void setStatusMsg(String statusMsg) {
        this.statusMsg = statusMsg;
    }
}
