 /**ejecuta los ? archivos anteriores y muestra la ventana definida inicialmente
 *como contenido, contiene la definicion del arbol jTree y el area que soporta
 *d&d*/
package workspace.Main_Set;

import about.about;
import dnd.AreaTransferHandler;
import java.awt.Desktop;
import java.awt.GraphicsEnvironment;
import java.awt.Image;
import java.io.File;
import java.io.IOException;
//import java.net.URI;
//import java.net.URISyntaxException;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JTree;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.WindowConstants;
import javax.swing.filechooser.FileFilter;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreePath;
//import org.jvnet.substance.SubstanceLookAndFeel;
import polaris2.ventana;
//import org.jvnet.substance.theme.SubstanceEbonyTheme;


public final class Main extends javax.swing.JFrame{
    private DefaultMutableTreeNode top;
    public String name;
    public String password;
    public SimpleNode simpleN;
    //
    
    @SuppressWarnings("static-access")
    public Main() {
        
        initComponents();
        
        /**se valida para que al cerrar por primera vez se lanza el evento*/
        /**yes-no-cancel para confirmar cambios*/        
        area.setSaved(false);
        area.setBarra(this.lbl_state);
        //this.lbl_state.setText("Polaris project is running...");
        this.lbl_state.setText(area.getStatusMsg());
        this.prepareTree();
        area.setTransferHandler(new AreaTransferHandler());
        this.setIconImage(this.getImage("/media/star_blue.png"));
        GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment();
        this.setExtendedState(this.getExtendedState() | this.MAXIMIZED_BOTH);
    }
    
    public Main(String msj) {
        
        initComponents();
        
        /**se valida para que al cerrar por primera vez se lanza el evento*/
        /**yes-no-cancel para confirmar cambios*/        
        area.setSaved(false);
        area.setBarra(this.lbl_state);
        //this.lbl_state.setText("Polaris project is running...");
        this.lbl_state.setText(area.getStatusMsg());
        this.prepareTree();
        area.setTransferHandler(new AreaTransferHandler());
        this.setIconImage(this.getImage("/media/star_blue.png"));
        GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment();
        this.setExtendedState(this.getExtendedState() | this.MAXIMIZED_BOTH);
        //
        if(msj.startsWith("ERROR")){
            JOptionPane.showMessageDialog(this, msj + "\nVERIFY: Polaris database is loaded one? but going to the setting option.", 
                    "Database Connection", JOptionPane.ERROR_MESSAGE);
        }        
    }
    
    public Image getImage(String classpath){
        /**se asigna la imagen respectiva*/
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }
    
    /**funcion mostrar pregunta: en salir-> guarda o no cambios?*/
    public boolean showQuestion(String msg){
        this.lbl_state.setText("Question launched...");
        JOptionPane op = new JOptionPane();
        int res = op.showConfirmDialog(null,msg,"Question",JOptionPane.YES_NO_CANCEL_OPTION,JOptionPane.WARNING_MESSAGE);
        if(res == op.YES_OPTION)return true;
        return false;
    }
    
    /**se abre el archivo .pol o .xml*/
    public String getOpenPath(){
        this.lbl_state.setText("Open Project...");
        JFileChooser file = new JFileChooser();
        //file.setFileSelectionMode(JFileChooser.FILES_ONLY);
        file.setAcceptAllFileFilterUsed(false);
        file.addChoosableFileFilter(new FileFilter(){
            public String getDescription(){
                return "XML File";
            }
            public boolean accept(File f){
                return (!f.isDirectory())&&(f.getAbsolutePath().endsWith("xml"));
            }
        });
        file.addChoosableFileFilter(new FileFilter(){
            public String getDescription(){
                return "Polaris Project";
            }
            public boolean accept(File f){
                return (!f.isDirectory())&&(f.getAbsolutePath().endsWith("pol"));
            }
        });
        int res = file.showOpenDialog(this);
        if(res==JFileChooser.APPROVE_OPTION){
            return file.getSelectedFile().getAbsolutePath();
        }
        this.lbl_state.setText("Polaris project is running...");
        return null;
    }
    
    /**se guarda*/
    public String getSavePath(){
        this.lbl_state.setText("Save launched...");
        JFileChooser file = new JFileChooser();
        //file.setFileSelectionMode(JFileChooser.FILES_ONLY);
        file.setAcceptAllFileFilterUsed(false);
        file.setFileFilter(new FileFilter(){
            public String getDescription(){
                return "Polaris Project";
            }
            public boolean accept(File f){
                return (!f.isDirectory())&&(f.getAbsolutePath().endsWith("pol"));
            }
        });
        int res = file.showSaveDialog(this);
        if(res==JFileChooser.APPROVE_OPTION){
            String r = file.getSelectedFile().getAbsolutePath();
            r = r.toLowerCase();
            if(!r.endsWith(".pol")){
                r = r + ".pol";
            }
            return r;
        }
        this.lbl_state.setText("Polaris project is running...");
        return null;
    }
    
    /**manejo de icono para win*/
    private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = Main.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }
    
    
    private void prepareTree(){
        /**definicion y creacion del arbol*/
        this.lbl_state.setText("Working on tree...");
        ImageIcon im1 = createImageIcon("/media/tree1.png");
        ImageIcon im2 = createImageIcon("/media/tree2.png");
        ImageIcon im3 = createImageIcon("/media/tree3.png");
        
        DefaultTreeCellRenderer renderer = new DefaultTreeCellRenderer();
        renderer.setLeafIcon(im1);
        renderer.setOpenIcon(im2);
        renderer.setClosedIcon(im3);
        jTree1.setCellRenderer(renderer);
        
        /**start JTree*/
        DefaultMutableTreeNode category   = null;
        DefaultMutableTreeNode category2  = null;
        DefaultMutableTreeNode branch     = null;
        DefaultMutableTreeNode branch1    = null;
        DefaultMutableTreeNode branch2    = null;
        DefaultMutableTreeNode branch3    = null;
        DefaultMutableTreeNode branch4    = null;
        DefaultMutableTreeNode branch5    = null;
        DefaultMutableTreeNode branch6    = null;
        DefaultMutableTreeNode branch7    = null;
        /**definicion de nodos y hojas del jTree*/
        category2  = new DefaultMutableTreeNode("WEB DATA SOURCE");
        branch      = new DefaultMutableTreeNode("Web Server");
        category2.add(branch);
        top.add(category2);
        
        category2 = new DefaultMutableTreeNode("PREPROCESS");
        branch    = new DefaultMutableTreeNode("Inter.Session");
        branch1   = new DefaultMutableTreeNode("GAP Session");
        branch2   = new DefaultMutableTreeNode("Discretize");
        category2.add(branch);
        category2.add(branch1);
        category2.add(branch2);
        top.add(category2);
        
        category2 = new DefaultMutableTreeNode("DATA MINING");
        category  = new DefaultMutableTreeNode("ASSOCIATION RULES");
        branch    = new DefaultMutableTreeNode("Apriori");
        branch1   = new DefaultMutableTreeNode("FpTree");
        branch2   = new DefaultMutableTreeNode("EquipAsso");
        category.add(branch);
        category.add(branch1);
        category.add(branch2);
        category2.add(category);
        category = new DefaultMutableTreeNode("CLASIFICATION");
        branch   = new DefaultMutableTreeNode("C 4.5");
        branch1  = new DefaultMutableTreeNode("MateTree");
        //branch2 = new DefaultMutableTreeNode("CBA");
        category.add(branch);
        category.add(branch1);
        //category.add(branch2);
        category2.add(category);
        top.add(category2);
        
        category2 = new DefaultMutableTreeNode("WEB USAGE MINING");
        branch    = new DefaultMutableTreeNode("HPG");
        category2.add(branch);
        top.add(category2);
        
        category2 = new DefaultMutableTreeNode("VIEWS");
        branch    = new DefaultMutableTreeNode("Table");
        branch1   = new DefaultMutableTreeNode("Stat");
        branch2   = new DefaultMutableTreeNode("Rules");
        branch3   = new DefaultMutableTreeNode("JTree");
        branch4   = new DefaultMutableTreeNode("Tree");        
        branch5   = new DefaultMutableTreeNode("HPG Table");
        branch6   = new DefaultMutableTreeNode("Grammar");        
        branch7   = new DefaultMutableTreeNode("BFSTree");
        
        category2.add(branch);
        category2.add(branch1);
        category2.add(branch2);
        category2.add(branch3);
        category2.add(branch4);
        category2.add(branch5);
        category2.add(branch6);
        category2.add(branch7);
        top.add(category2);
        // *** Termina arbol, ahora lo expandimos
        // * - "myTreeModel" es una variable donde almacenamos el "DefaultTreeModel"
        expandirNodo((DefaultMutableTreeNode)jTree1.getModel().getRoot());
    }
    
    /**expande arbol*/
    public void expandirNodo(DefaultMutableTreeNode tnodo){
        /**el objeto tree_rta*/
        TreePath tp=new TreePath(tnodo.getPath());
        jTree1.expandPath(tp);
        for(int i = 0; i<tnodo.getChildCount(); i++) {
            expandirNodo((DefaultMutableTreeNode)tnodo.getChildAt(i));
        }
    }
    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        top = new DefaultMutableTreeNode("POLARIS");
        jTree1 = new JTree(top);
        jScrollPane2 = new javax.swing.JScrollPane();
        area = new workspace.Main_Set.Area();
        jToolBar1 = new javax.swing.JToolBar();
        btnNew = new javax.swing.JButton();
        btnLoad = new javax.swing.JButton();
        btnSave = new javax.swing.JButton();
        btnSaveAs = new javax.swing.JButton();
        btnHelp = new javax.swing.JButton();
        btnAbout = new javax.swing.JButton();
        btnSettings = new javax.swing.JButton();
        lbl_state = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Polaris UWM Tool");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jSplitPane1.setDividerLocation(250);

        jTree1.setToolTipText("Tools");
        jTree1.setDragEnabled(true);
        jScrollPane1.setViewportView(jTree1);

        jSplitPane1.setLeftComponent(jScrollPane1);

        area.setToolTipText("Work Area");

        javax.swing.GroupLayout areaLayout = new javax.swing.GroupLayout(area);
        area.setLayout(areaLayout);
        areaLayout.setHorizontalGroup(
            areaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 743, Short.MAX_VALUE)
        );
        areaLayout.setVerticalGroup(
            areaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 345, Short.MAX_VALUE)
        );

        jScrollPane2.setViewportView(area);

        jSplitPane1.setRightComponent(jScrollPane2);

        btnNew.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/new.png"))); // NOI18N
        btnNew.setToolTipText("New Project");
        btnNew.setInheritsPopupMenu(true);
        btnNew.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                btnNewMouseEntered(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btnNewMouseReleased(evt);
            }
        });
        btnNew.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnNewActionPerformed(evt);
            }
        });
        jToolBar1.add(btnNew);

        btnLoad.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/open.png"))); // NOI18N
        btnLoad.setToolTipText("Open Project");
        btnLoad.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnLoadActionPerformed(evt);
            }
        });
        jToolBar1.add(btnLoad);

        btnSave.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/save.png"))); // NOI18N
        btnSave.setToolTipText("Save Project");
        btnSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveActionPerformed(evt);
            }
        });
        jToolBar1.add(btnSave);

        btnSaveAs.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/saveas.png"))); // NOI18N
        btnSaveAs.setToolTipText("Save as...");
        btnSaveAs.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveAsActionPerformed(evt);
            }
        });
        jToolBar1.add(btnSaveAs);

        btnHelp.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/help.png"))); // NOI18N
        btnHelp.setToolTipText("Help");
        btnHelp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnHelpActionPerformed(evt);
            }
        });
        jToolBar1.add(btnHelp);

        btnAbout.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/about.png"))); // NOI18N
        btnAbout.setToolTipText("About us...");
        btnAbout.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAboutActionPerformed(evt);
            }
        });
        jToolBar1.add(btnAbout);

        btnSettings.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/settings.png"))); // NOI18N
        btnSettings.setToolTipText("BD Settings");
        btnSettings.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSettingsActionPerformed(evt);
            }
        });
        jToolBar1.add(btnSettings);

        lbl_state.setBackground(new java.awt.Color(255, 255, 255));
        lbl_state.setFont(new java.awt.Font("Arial", 0, 12));
        lbl_state.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 820, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lbl_state, javax.swing.GroupLayout.DEFAULT_SIZE, 820, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addComponent(jToolBar1, javax.swing.GroupLayout.DEFAULT_SIZE, 820, Short.MAX_VALUE)
                .addGap(20, 20, 20))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(jToolBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 349, Short.MAX_VALUE)
                .addGap(7, 7, 7)
                .addComponent(lbl_state, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void btnSettingsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSettingsActionPerformed

        //esto esta comentariado por que hace parte de polaris 2
        /*

        frmSettings fs = new frmSettings(null,(ventana)getSelf());
        
        fs.setLocationRelativeTo(fs.getParent());
        fs.setVisible(true);
        getParent().repaint();
        
        System.out.println("Nombre " + this.getName());
        System.out.println("Passw  " + this.getPassword());
        //
        area.userbd= this.getName();
        area.userbdpassword= this.getPassword();
        */
        
        //simpleN.setLogin(this.getName());
    }//GEN-LAST:event_btnSettingsActionPerformed
    
    private void btnNewMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnNewMouseReleased
        
    }//GEN-LAST:event_btnNewMouseReleased
    
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        
    }//GEN-LAST:event_formWindowClosed
    
    private void btnSaveAsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveAsActionPerformed
        this.lbl_state.setText("Save as launched...");
        String r = this.getSavePath();
        if(r!=null){
            this.area.setPath(r);
            this.area.saveToFile();
        }
        this.lbl_state.setText("Polaris project is running...");
    }//GEN-LAST:event_btnSaveAsActionPerformed
    
    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        if(area.isSaved() == false){
            this.lbl_state.setText("God Bye...");
            JOptionPane op = new JOptionPane();
            int res = op.showConfirmDialog(null,"Exit saving changes?","Question",JOptionPane.YES_NO_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE);
            if (res == op.YES_OPTION) {
                String r = this.getSavePath();
                if(r!=null){
                    this.area.setPath(r);
                    this.area.saveToFile();
                }
                System.exit(0);
            } else if (res == op.NO_OPTION) {
                System.exit(0);
            } else if (res == op.CANCEL_OPTION) {
                setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
                this.lbl_state.setText("Polaris project is running...");
            }
        } else if(area.isSaved() == true) {
            this.lbl_state.setText("God Bye...");
            setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
            
        }
    }//GEN-LAST:event_formWindowClosing
    
    private void btnHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnHelpActionPerformed
        /**se muestra el formulario de selectsource*/
//        JOptionPane.showMessageDialog(null," THE GLORY IS FOR OUR LORD");
//        this.lbl_state.setText("Polaris project is running...");
        this.lbl_state.setText("Help launched...");
        // *** Polaris *** Johana
        Desktop desktop = null;
        //URI uri = null;        
        // Before more Desktop API is used, first check 
        // whether the API is supported by this particular 
        // virtual machine (VM) on this particular host.
        if (Desktop.isDesktopSupported()) {
            desktop = Desktop.getDesktop();
            String url= System.getProperty("user.dir")+System.getProperty("file.separator")+"ayuda"+System.getProperty("file.separator")+"index.html";
            //String url= "http://polaris.berlios.de";
            System.out.println("url: " + url);
            File file = new File(url);
            try {
                //uri = new URI(url);
                //desktop.browse(uri);
                desktop.open(file);
                lbl_state.setText("Help is loaded in Browser...");
            }
            catch(IOException ioe) {
                ioe.printStackTrace();
                lbl_state.setText("ERROR: " + ioe.getMessage());
            }
//            catch(URISyntaxException use) {
//                use.printStackTrace();
//                lbl_state.setText("ERROR: " + use.getMessage());
//            }            
        }
        //
//        helpp a= new helpp();
//        // centrar
//        a.setLocationRelativeTo(a.getParent());
//        //a.set
//        // Visible
//        a.setVisible(true);        
        // *** Finished ***
    }//GEN-LAST:event_btnHelpActionPerformed
    
    private void btnAboutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAboutActionPerformed
        this.lbl_state.setText("About launched...");
        // *** Polaris *** Johana
        about a= new about(this,false);
        // centrar
        a.setLocationRelativeTo(a.getParent());
        // Visible
        a.setVisible(true);
        // *** Finished ***
        this.lbl_state.setText("Polaris project is running...");
    }//GEN-LAST:event_btnAboutActionPerformed
    
    private void btnNewActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnNewActionPerformed
        this.lbl_state.setText("New launched...");
        area.setBanArrastre(false);
        boolean ban;
        if(area.isSaved()){
            ban = true;
        }else{
            ban = showQuestion("With this action, you will lost all changes in the current project.\nDo you want to continue?");
        }
        if(ban){
            area.reset();
            this.lbl_state.setText("Polaris project is running...");
        }
    }//GEN-LAST:event_btnNewActionPerformed
    
    private void btnNewMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnNewMouseEntered
        
    }//GEN-LAST:event_btnNewMouseEntered
    
    /**acciones del boton load para manejo de archivos*/
    private void btnLoadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnLoadActionPerformed
        this.lbl_state.setText("Load launched...");
        area.setBanArrastre(true);
        boolean ban;
        if(area.isSaved()){
            ban = true;
        }else{
            ban = showQuestion("With this action, you will lost all changes in the current project.\nDo you want to continue?");
        }
        if(ban){
            String path = getOpenPath();
            System.out.println(path);
            if(path!=null){
                area.setPath(path);
                area.loadFromFile();
            }
        }
        this.lbl_state.setText("Polaris project is running...");
    }//GEN-LAST:event_btnLoadActionPerformed
    
    /*
    List<SimpleNode> nodos
    SimpleNode[]     nodos
     
    List         nodos
    Object[]     nodos
     */
    
    
    /**boton guardar para esquema*/
    private void btnSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveActionPerformed
        this.lbl_state.setText("Save launched...");
        if(area.getPath() == null){
            area.setPath(getSavePath());
        }
        if(area.getPath() != null){
            area.saveToFile();
        }
        this.lbl_state.setText("Polaris project is running...");
    }//GEN-LAST:event_btnSaveActionPerformed
    
    
    public static void main(String[] args) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Main().setVisible(true);
                
                /**OJO OPCION 1 PARA CAMBIAR APARIENCIA CON SUBSTACE*/
                /**se escoje del selector*/
//                try {
//                    UIManager.setLookAndFeel(new org.jvnet.substance.skin.SubstanceModerateLookAndFeel());
//                } catch (UnsupportedLookAndFeelException ulafe) {
//                    System.out.println("Substance failed to set");
//                }
                /**OJO OPCION 2 PARA CAMBIAR APARIENCIA CON SUBSTACE*/
                /**azul clarito de muestra*/
                //try {
                    //UIManager.setLookAndFeel(new SubstanceLookAndFeel());
                //} catch (UnsupportedLookAndFeelException ulafe) {
                //    System.out.println("Substance failed to set");
                //}
                /**OJO OPCION 3 PARA CAMBIAR APARIENCIA CON SUBSTACE*/
                /**azul clarito de muestra*/
//                try {
//                    UIManager
//                            .setLookAndFeel("org.jvnet.substance.SubstanceLookAndFeel");
//                } catch (UnsupportedLookAndFeelException ulafe) {
//                    System.out.println("Substance failed to set");
//                } catch (ClassNotFoundException cnfe) {
//                    System.out.println("Substance not found");
//                } catch (InstantiationException ie) {
//                    System.out.println("Substance failed to instantiate");
//                } catch (IllegalAccessException iae) {
//                    System.out.println("Access denied");
//                }
                /**OJO OPCION  PARA CAMBIAR APARIENCIA CON SUBSTACE*/
                /**negro como feito*/
//                try {
//                    UIManager.setLookAndFeel(new SubstanceLookAndFeel());
//                    SubstanceLookAndFeel.setCurrentTheme(new SubstanceEbonyTheme());
//                    UIManager.setLookAndFeel(new SubstanceLookAndFeel());
//                } catch (UnsupportedLookAndFeelException ulafe) {
//                    System.out.println("Substance failed to set");
//                }
                
            }//RUN
        });
        
        
        
        
    }
    
    public String getName() {
        return name;
    }
    
    public void setName(String name) {
        this.name = name;
    }
    
    public String getPassword() {
        return password;
    }
    
    public void setPassword(String password) {
        this.password = password;
    }
    
    private Main getSelf() {
        return this;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private workspace.Main_Set.Area area;
    private javax.swing.JButton btnAbout;
    private javax.swing.JButton btnHelp;
    private javax.swing.JButton btnLoad;
    private javax.swing.JButton btnNew;
    private javax.swing.JButton btnSave;
    private javax.swing.JButton btnSaveAs;
    private javax.swing.JButton btnSettings;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JTree jTree1;
    private javax.swing.JLabel lbl_state;
    // End of variables declaration//GEN-END:variables
    
}

