/*
 * SplashScreen.java
 *
 * Created on 9 de agosto de 2007, 02:11 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 *
 * 
 *
 */

package workspace.Main_Set;

import java.awt.*;
import java.net.URL;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
//import org.jvnet.substance.SubstanceLookAndFeel;
import Utils.conexion;
import polaris2.ventana;

/**
* Present a simple graphic to the user upon launch of the application, to 
* provide a faster initial response than is possible with the main window.
* 
* <P>Adapted from an 
* <a href=http://developer.java.sun.com/developer/qow/archive/24/index.html>item</a> 
* on Sun's Java Developer Connection.
*
* <P>This splash screen appears within about 2.5 seconds on a development 
* machine. The main screen takes about 6.0 seconds to load, so use of a splash 
* screen cuts down the initial display delay by about 55 percent. 
*
* @used.By {@link stocksmonitor.Launcher}
* @to.do Can the performance be improved to 1.0 second?
* @author <a href="http://www.javapractices.com/">javapractices.com</a>
 *@author2 Proyecto *** Polaris *** Johana ***
*/
public final class SplashScreen extends Frame {

    
    boolean usarDobleBuffer;
    Graphics contextoDobleBuffer;
    //
  /**
  * @param aImageId must have content, and is used by  
  * <code>Class.getResource</code> to retrieve the splash screen image.
  */
  public SplashScreen(String aImageId) {
    /* Implementation Note
    * Args.checkForContent is not called here, in an attempt to minimize 
    * class loading.
    */
    if ( aImageId == null || aImageId.trim().length() == 0 ){
      throw new IllegalArgumentException("Image Id does not have content.");
    }
    fImageId = aImageId;
  }
   
  /**
  * Show the splash screen to the end user.
  *
  * <P>Once this method returns, the splash screen is realized, which means 
  * that almost all work on the splash screen should proceed through the event 
  * dispatch thread. In particular, any call to <code>dispose</code> for the 
  * splash screen must be performed in the event dispatch thread.
  */
  public void splash(){
    initImageAndTracker();
    setSize(fImage.getWidth(null), fImage.getHeight(null));
    center();
    
    fMediaTracker.addImage(fImage, 0);
    try {
      fMediaTracker.waitForID(0);
    }
    catch(InterruptedException ie){
      System.out.println("Cannot track image load.");
    }

    SplashWindow splashWindow = new SplashWindow(this,fImage);
  }
  
  
  // PRIVATE//
  private final String fImageId;
  private MediaTracker fMediaTracker;
  private Image fImage;
  private Image bImage;

  private void initImageAndTracker(){
    fMediaTracker = new MediaTracker(this);
    URL imageURL = SplashScreen.class.getResource(fImageId);
    fImage = Toolkit.getDefaultToolkit().getImage(imageURL);    
    //
  }

  /**
  * Centers the frame on the screen.
  *
  * This centering service is more or less in {@link UiUtil}; this duplication 
  * is justified only because the use of {@link UiUtil} would entail more 
  * class loading, which is not desirable for a splash screen.
  */
  private void center(){
    Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
    Rectangle frame = getBounds();
    setLocation((screen.width - frame.width)/2, (screen.height - frame.height)/2);
  }
   
  private class SplashWindow extends Window {
    SplashWindow(Frame aParent, Image aImage) {
       super(aParent);
       fImage = aImage;
       setSize(fImage.getWidth(null), fImage.getHeight(null));
       Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
       Rectangle window = getBounds();
       setLocation((screen.width - window.width) / 2, (screen.height - window.height) / 2);
       //setBackground(Color.black);
       setVisible(true);
    }
    
    //
    public void update( Graphics g ) {
        paint( g );  
    }
    //    
    public void paint(Graphics graphics) {
      if (fImage != null) {
        graphics.drawImage(fImage,0,0,this);        
      }
      //
    }
    //
    private Image fImage;
  }//
      
  /**
  * Developer test harness shows the splash screen for a fixed length of 
  * time, without launching the full application.
  */
  public static void main(String[] args){
      //
    SplashScreen splashScreen = new SplashScreen("/media/bluelogo.gif");
    splashScreen.usarDobleBuffer= true;
    splashScreen.splash();
    try {
      Thread.sleep(4000);
    }
    catch(InterruptedException ex) {
      System.out.println(ex);
    }
    //
    // Instanciar conx
    conexion conx= new conexion();
    // Abrir conexion a BD logs
    conx.conectar("polaris","upolaris","ppolaris");
    final String mensaje= conx.getMensaje();
    conx.cerrarConexion();
    //
    splashScreen.setVisible(false);
    splashScreen.dispose();
    //System.exit(0);
    java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                //new Main(mensaje).setVisible(true);


                //si les pone problema con la base de datos comentareen la linea 73 que contiene menssaje
                //y activen la linea 74 que no lleva mensaje

                new ventana(mensaje).setVisible(true);
                //new ventana().setVisible(true);
         
                
                try
                {
                        UIManager.setLookAndFeel(new com.nilo.plaf.nimrod.NimRODLookAndFeel());
                }
                catch(Exception e)
                {
                    System.out.println("no se cargo interfaz del sistema");
                }
         //     
            }//RUN
        });
    //
  }
}