/**el archivo contiene las configuraciones correspondientes a la seleccion filter
*desde prepro*/

package workspace.Prepro;

import algorithm.classification.Transformacion_cla;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Point;
import java.util.ArrayList;
import javax.swing.ImageIcon;
import workspace.Main_Set.SimpleNode;

public class FilterNode extends SimpleNode{
    /**se esta forzando a variable*/
    private Class<?>[] clases;
    private ArrayList<SimpleNode> nodos;
    /**las siguientes banderas establecen si el objeto ya fue configurado 
    *o ejecutado*/
    public boolean configured = false;
    public boolean executed   = false;
    public String pathLogServer = "";
    public int tipoL;
    public long tiempoS;
        
    /** Estos parametros se guardan */
    /************************************************************************************/
    //fue necesario establecerlos como publicos para implementar guardar/cargar
    public ArrayList inDuracion;
    public ArrayList inTamano;
    public ArrayList inCantidad;
    /************************************************************************************/
    //
    frm_cla fd;
    
    // ***
    Transformacion_cla filtroCla;    
        
    public FilterNode(Point center) {
        /**se establece centro, dimension*/
        this.setCenter(center);
        this.setDimension(new Dimension(80,60));
        /**se valida el nodo antecesor, 2 nodos le pueden anteceder*/
        this.clases = new Class<?>[2];        
        this.clases[0] = IntervalNode.class;
        this.clases[1] = UmbralNode.class;        
        /**se instancia un ArrayList en nodos*/
        this.nodos = new ArrayList();
    }
        
    public Class<?>[] getValidInputClasses(){
        /**retorna los antecesores...*/
        return this.clases;
    }
    
    public ArrayList<SimpleNode> getInputNodes(){
        /**se devuelven los valores de los nodos en un array forzado a tipo
        SimpleNode*/
        return this.nodos;
    }
    
    public Image getImage(){
        /**el icono*/
        return new ImageIcon(System.class.getResource("/media/filter.png")).getImage();
    }
    
    public String getString(){
        /**retorna una cadena que lo identifica*/
        return "Discretize";
    }
    
    /**si el nodo puede ser conectado, entonces se anade un nodo*/
    public void connect(SimpleNode n){
        if(this.canConnect(n)){
            this.nodos.add(n);
        }
    }
    
    /**al desconectar el nodo se elimina la linea punteada y se coloca el color*/
    /**de borde por defecto*/
    public void disconnect(SimpleNode n){
        this.nodos.remove(n);
        this.setBorderColor(null);
    }
    
      /**puede ser configurado*/
     public boolean canConfigure(){
        return true;
    }
     
     public void configure() {
         
        String sourceClassName = this.getInputNodes().get(0).getClass().getCanonicalName();
        if(sourceClassName.equals(IntervalNode.class.getCanonicalName())){
            IntervalNode in = (IntervalNode)this.getInputNodes().get(0);
            tiempoS= Long.parseLong(in.getTsesion());
        }else if(sourceClassName.equals(UmbralNode.class.getCanonicalName())){
            UmbralNode   un = (UmbralNode)this.getInputNodes().get(0);
            tiempoS= Long.parseLong(un.getTsesion());
        }
         
        /**en la configuracion muestra el formulario*/
        fd = new frm_cla(null,(FilterNode)getSelf(),tiempoS);
        /**se coloca en el centro */
        fd.setLocationRelativeTo(fd.getParent());
        /**lo hace visible */
        fd.setVisible(true);        
        //
        setBorderColor(new Color(0,0,255));
        /**repinta el icono en la ventana contenedora*/
        getParent().repaint();
    }
     
    /**retorna verdadero porque puede ser ejecutado*/
    public boolean canExecute() {
        return true;
    }
        
   public void execute() {         
       // *** Polaris *** Johana                  
        boolean transhecha;
        int tiempoS;
        //
        if(fd!=null){
            inDuracion= fd.getIduracion();
            inCantidad= fd.getIcantidad();
            inTamano= fd.getItamano();
            fd.dispose();
        }
       // *** Finished ***   
       
            if(this.getInputNodes().size()==1){
                String sourceClassName = this.getInputNodes().get(0).getClass().getCanonicalName();
                if(sourceClassName.equals(IntervalNode.class.getCanonicalName())){                                        
                    IntervalNode in = (IntervalNode)this.getInputNodes().get(0);
                    //***********************************************************
                    /*aqui se instancia interval y a su vez del web server*/
                   
                    //***********************************************************
                    this.setPathLogServer(in.getPathLogServer());
                    System.out.println(" From filter: " + this.getPathLogServer());                                     
                    
                    if(!in.isConfigured()){
                        this.getParent().showError("The Interval Session must be configured first");
                        /**validacion para la badera ejecucion y el color del borde*/
                        this.setExecuted(false);  
                        setBorderColor(null);
                    } else if(!in.isExecuted()){
                        this.getParent().showError("The Interval Session must be executed first");                    
                        /**validacion para la badera ejecucion y el color del borde*/
                        this.setExecuted(false);  
                        setBorderColor(null);                        
                    } else {                    
                        this.setExecuted(true);
                        //
                        // *** Polaris *** Johana
                        long time = System.currentTimeMillis();
                        // - Transformacion
                        String sesion="sesioncomun", msj;     
                        transhecha= false;
                        if(in.getTipoL()==2) sesion= "sesionextendida";
                        tiempoS= Integer.parseInt(in.getTsesion());
                        filtroCla= new Transformacion_cla(sesion,tiempoS);
                        //
                        if(fd!=null){
                            filtroCla.setIntervalCantidad(inCantidad);
                            filtroCla.setIntervalDuration(inDuracion);
                            filtroCla.setIntervalTamano(inTamano);
                        }
                        //
                        msj= filtroCla.crearSesionTransformada();
                        if(msj.equals("Transformed session")) transhecha=true;
                        this.setMsg("DISCRETIZE NODE EXECUTED: " + msj);
                        filtroCla.finalizar();
                        //
                        long executionTime = System.currentTimeMillis() - time;                       
                        System.out.println("Filter tiempo: " + executionTime + " milisegundos");
                        // *** Finished ***
                        /**pinta de verde si el nodo ya se ejecuto*/
                        setBorderColor(new Color(0,255,0));
                        getParent().repaint();                                                
                    }
                    
                }else if(sourceClassName.equals(UmbralNode.class.getCanonicalName())){                    
                    UmbralNode   un = (UmbralNode)this.getInputNodes().get(0);
                     //***********************************************************
                    /*aqui se instancia umbral y a su vez del web server*/
                    //***********************************************************
                    this.setPathLogServer(un.getPathLogServer());
                    System.out.println(" From filter: " + this.getPathLogServer());                                        
                    
                    if(!un.isConfigured()){
                        this.getParent().showError("The Umbral Session must be configured first");
                        /**validacion para la badera ejecucion y el color del borde*/
                        this.setExecuted(false);  
                        setBorderColor(null);
                    } else if(!un.isExecuted()){
                        this.getParent().showError("The Umbral Session must be executed first");
                        /**validacion para la badera ejecucion y el color del borde*/
                        this.setExecuted(false);  
                        setBorderColor(null);
                    } 
                    else{
                        //EXECUTION CODE GOES HERE     
                        // *** Polaris *** Johana
                        long time = System.currentTimeMillis();
                        // - Transformacion
                        String sesion="sesioncomun", msj;     
                        transhecha= false;
                        if(un.getTipoL()==2) sesion= "sesionextendida";
                        tiempoS= Integer.parseInt(un.getTsesion());
                        filtroCla= new Transformacion_cla(sesion,tiempoS);
                        msj= filtroCla.crearSesionTransformada();
                        if(msj.equals("Sesion transformada")) transhecha=true;
                        this.setMsg("DISCRETIZE NODE EXECUTED: " + msj);
                        filtroCla.finalizar();
                        //
                        long executionTime = System.currentTimeMillis() - time;                       
                        System.out.println("Filter tiempo: " + executionTime + " milisegundos");
                        // *** Finished ***
                        /**cambia el valor de la bandera executed*/
                        this.setExecuted(true);
                        /**si el nodo fue configurado, el borde se torna verde*/
                        setBorderColor(new Color(0,255,0));
                        /**obtiene el contenedor y lo redibuja... si no se redibuja entonces
                        *al mostrarse graficamente presenta pixeles defectuosos*/
                        getParent().repaint();                               
                    }
                }/**UmbralNode*/
            }else{
                
                this.getParent().showError("First add a connection");
                /**validacion para las baderas ejecucion, configuracion y el color del borde*/
                this.setExecuted(false);
                if(this.isConfigured() == false){
                    this.setConfigured(false);
                    setBorderColor(null);
                } else{
                    this.setConfigured(true);
                    setBorderColor(new Color(0,0,255));
                }
                 getParent().repaint();  
            }       
        
    }   /**execution*/
        
    public String getPathLogServer() {
        return pathLogServer;
    }
    
    public void setPathLogServer(String pathLogServer) {
        this.pathLogServer = pathLogServer;
    }
    
    public int getTipoL() {
        return tipoL;
    }
    
    public void setTipoL(int tipoL) {
        this.tipoL = tipoL;
    }

    public boolean isConfigured() {
        return configured;
    }

    public void setConfigured(boolean configured) {
        this.configured = configured;
    }
    
    public ArrayList getTransCla(){
        if(this.filtroCla==null) return null;
        return filtroCla.getDatosTrans();
    }
 
    //
    
    public ArrayList getIduracion(){
        return inDuracion;
    }
    
    public ArrayList getItamano(){
        return inTamano;
    }
    
    public ArrayList getIcantidad(){
        return inCantidad;
    }
    
    // 
    
    public long getTiempoS(){
        return tiempoS;
    }
    
    public void setTiempoS(long t){
        tiempoS= t;
    }
    
}
