/**el archivo contiene las configuraciones correspondientes a la seleccion 
*intervalo desde preprocesamiento; igual documentacion para umbral*/

package workspace.Prepro;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Point;
import java.util.ArrayList;
import javax.swing.ImageIcon;
import prePro.ejecutarPrepro;
import workspace.Main_Set.SimpleNode;
import workspace.Source.SelectSourceNode;

public class IntervalNode extends SimpleNode{
    
    private Class<?>[] clases;
    private ArrayList<SimpleNode> nodos;       
    public boolean mfr      = false;
    public String minutes = "Select a value";
    public String pathLogServer = "";
    public int tipoL;
    public boolean configured = false;
    public boolean executed   = false;
    //
    
    public IntervalNode(Point center) {
      
        /**establece centro y dimension*/
        this.setCenter(center);
        this.setDimension(new Dimension(80,60));
        this.clases = new Class<?>[1];
        /**solo acepta un selectsource antes de el*/
        this.clases[0] = SelectSourceNode.class;
        this.nodos = new ArrayList();
    }
            
    /**define las clases validas*/
    public Class<?>[] getValidInputClasses(){
        return this.clases;
    }
    
    /**define los nodos validos*/
    public ArrayList<SimpleNode> getInputNodes(){
        return this.nodos;
    }
    
    /**retorna el icono*/
    public Image getImage(){
        return new ImageIcon(System.class.getResource("/media/prepro1.png")).getImage();
    }
    
    /**retorna la cadena que lo identifica*/
    public String getString(){
        return "Inter.Session";
    }
    
    /**si el nodo puede ser conectado, entonces se anade un nodo*/
    public void connect(SimpleNode n){
        if(this.canConnect(n)){
            this.nodos.add(n);
        }
    }
    
    /**al desconectar se elimina la linea punteada que hace referencia grafica
    *a la conexion*/
    public void disconnect(SimpleNode n){
        this.nodos.remove(n);
        this.setBorderColor(null);
    }
    
    /**puede ser configurado*/
     public boolean canConfigure(){
        return true;
    }
     
     public void configure() {
        /**en la configuracion muestra el formulario*/
        FrmInterval iv = new FrmInterval(null,(IntervalNode)getSelf());
        /**se coloca en el centro */
        iv.setLocationRelativeTo(iv.getParent());
        /**lo hace visible */
        iv.setVisible(true);
        /**repinta el icono en la ventana contenedora*/
        getParent().repaint();
    }
    
    /**puede ser ejecutado*/
    public boolean canExecute() {
        return true;
    }
    
    public void execute() {
        // ***
        ejecutarPrepro runPrepro;
        // ***
        //primero debe estar configurado para ser ejecutado
        if (this.isConfigured() == true){          
            /**valida que primero este conectado a una fuente*/
            if(getInputNodes().size( )== 0){                
                getParent().showError("Please, select a source");
                /**validacion para las baderas ejecucion, configuracion y el color del borde*/
                this.setExecuted(false);                        
                return;
            }
            
            SelectSourceNode ss = (SelectSourceNode)getInputNodes().get(0);
            //*******************************************************************
            /*aqui se instancia el select source y se puede acceder a sus
             metodos y propiedades*/
            //*******************************************************************            
            this.setPathLogServer(ss.getPath());
            System.out.println(" From Interval, the path ; " + this.getPathLogServer());
            this.setTipoL(ss.getTipoL());
            System.out.println(" From Interval, the tipoL ; " + this.getTipoL());            
            
            if(ss.isExecuted() == false){
                getParent().showError("Please, excute the Web Server first");                  
                /**validacion para las baderas ejecucion, configuracion y el color del borde*/
                this.setExecuted(false);
                if(this.isConfigured() == false){
                    this.setConfigured(false);
                    setBorderColor(null);
                } else{
                    this.setConfigured(true);
                    setBorderColor(new Color(0,0,255));
                }
                return;
            }
            
            /**la bandera es true*/
            // *** Polaris *** Johana ***
            long time = System.currentTimeMillis();
            //
            int tiempoS= Integer.parseInt(this.getTsesion());
            runPrepro= new ejecutarPrepro(this.getPathLogServer(),ss.getIndicesExt(ss.getVectorExt()),ss.getCuantos(),tiempoS);
            runPrepro.hacerTransfor(); // Hacer transformacion
            if(this.getTipoL()==1 || this.getTipoL()==3) runPrepro.hacerSesionComun(1); // Hacer Sesion Comun pa todos
            if(this.getTipoL()==2){
                runPrepro.setMFR(this.isMfr());
                runPrepro.hacerSesionExt(1); // Hacer Sesion Extendida solo para extendida
            }
            this.setMsg("INTERVAL NODE EXECUTED: " + runPrepro.getMensaje());
            // MANDAR MENSAJE
            long executionTime = System.currentTimeMillis() - time;                       
            System.out.println("Interval tiempo: " + executionTime);
            // *** Finished ***
            this.setExecuted(true);
            /**pinta de verde si el nodo ya se ejecuto*/
            setBorderColor(new Color(0,255,0));
            getParent().repaint();
        } else {
            /**en caso contrario muestra advertencia*/
            this.getParent().showError("First configure, after execute");           
            this.setExecuted(false);
            if(this.isConfigured() == false){
                this.setConfigured(false);
                setBorderColor(null);
            } else{
                this.setConfigured(true);
                setBorderColor(new Color(0,0,255));
            }
            getParent().repaint();
        }
    }         
    
    /**comprobacion MFR, el valor se pasa como parametro*/
    public boolean isMfr() {
        return mfr;
    }    
    public void setMfr(boolean mfr) {
        this.mfr = mfr;
    } 
    
    /**se pasa el valor de la sesion en minutos como parametro*/
    public String getTsesion() {
        return minutes;
    }    
    public void setTsesion(String minutes) {
        this.minutes = minutes;
    }
  
    /**paso de parametros del select source*/
    public int getTipoL() {
        return tipoL;
    }

    public void setTipoL(int tipoL) {
        this.tipoL = tipoL;
    }

    public String getPathLogServer() {
        return pathLogServer;
    }

    public void setPathLogServer(String pathLogServer) {
        this.pathLogServer = pathLogServer;
    }

    public boolean isConfigured() {
        return configured;
    }

    public void setConfigured(boolean configured) {
        this.configured = configured;
    }
           
}//
