/*
 * ClassificationRulesTableModel.java
 *
 * Created on 17 de agosto de 2007, 10:14 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package workspace.Views;

import algorithm.classification.sesiontrans;
import java.util.ArrayList;
import java.util.Vector;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;
import workspace.Prepro.intervalos;

/**
 *
 * @author Proyecto *** Polaris *** Johana
 */
public class ClassificationRulesTableModel extends AbstractTableModel {
    
     String[] columnNames = {   "Ip type",
                                "Schedule",
                                "Week day",
                                "Duration", // Duracion
                                "Request amount",
                                "Download size"};
        private ArrayList sesiones;
        protected TableModel model;
        
        /** Estos parametros se guardan */
        ArrayList inDuracion;
        ArrayList inTamano;
        ArrayList inCantidad;

        /**
         * Crea una nueva instancia de la clase ClassificationTableModel.
         *
         * @param sesiones La estructura que sera utilizada para crear el modelo de
         *        la tabla de datos.
         */

        /** Creates a new instance of ClassificationTableModel */
        public ClassificationRulesTableModel(ArrayList sesions) {
            sesiones= sesions;
            fireTableChanged(null);
        }
        
        /** nicamente retornamos el numero de elementos del
         * array de los nombres de las columnas
         *
         */
        public int getColumnCount() {
            return columnNames.length;
        }

        /** retormanos el numero de elementos
         * del array de datos
         */
        public int getRowCount() {
            return sesiones.size();
        }

        /** retornamos el nombre de la columna de indice col
         */
        public String getColumnName(int col) {
            return columnNames[col];
        }
        
        /** retornamos el indice de tal nombre de la columna
         */
        public int getColumnIndex(String colname){
            int i, indice=0;
            String aux;
            boolean salir=false;
            //
            for(i=0;i<6 && salir==false;i++){
                aux= columnNames[i];
                if(colname.equals(aux)){
                    salir=true; 
                    i--;
                }
            }
            indice=i;
            //
            return indice;
        }

        /*** Devuelve el objeto en tal fila tal columna
         */
        public Object getValueAt(int row, int col) {
            Object obj = sesiones.get(row);
            String dato="";
            switch(col){
                case 0:
                    dato= ((sesiontrans) obj).getTipoIP();
                    break;
                case 1:
                    dato= ((sesiontrans) obj).getHorario();
                    break;
                case 2:
                    dato= ((sesiontrans) obj).getDiaSemana();
                    break;
                case 3:
                    dato= ((sesiontrans) obj).getDuracion();
                    dato= queDuracion(dato);
                    break;
                case 4:
                    dato= ((sesiontrans) obj).getCantPet();
                    dato= queCantidad(dato);
                    break;
                case 5:
                    dato= ((sesiontrans) obj).getTamDescarga();
                    dato= queTamano(dato);
                    break;
            }
            return dato;
        }
        
        private String queDuracion(String cad){
            String duracion="";
            boolean findit;
            intervalos ii;
            //
            if(inDuracion!=null){
                findit=false;
                for(int i=0;i<inDuracion.size() && findit==false;i++){
                    ii= (intervalos) inDuracion.get(i);
                    if(cad.equals(ii.getNom())){
                        duracion= ii.getDescripcion();
                        findit= true;
                    }
                }
                duracion= duracion + " minutes conected";
                
            }else{
                if(cad.equals("Short")) duracion="Connected less than 1/3 of the time of session ";
                if(cad.equals("Middle")) duracion="Connected between 1/3 and 2/3 of the time of session ";
                if(cad.equals("Long")) duracion="Connected more than 2/3 of the time of session ";
            }
            //
            return duracion;
        }
        
        private String queCantidad(String cad){
            String cantidad="";
            boolean findit;
            intervalos ii;
            //
            if(inCantidad!=null){
                findit=false;
                for(int i=0;i<inCantidad.size() && findit==false;i++){
                    ii= (intervalos) inCantidad.get(i);
                    if(cad.equals(ii.getNom())){
                        cantidad= ii.getDescripcion();
                        findit= true;
                    }
                }
                cantidad= cantidad + " requests";
                
            }else{
                if(cad.equals("Few")) cantidad="Less than 10 requests ";
                if(cad.equals("Middle")) cantidad="Between 11 and 40 requests ";
                if(cad.equals("Many")) cantidad="More than 41 requests ";
            }
            //
            return cantidad;
        }
        
        private String queTamano(String cad){
            String tamano="";
            boolean findit;
            intervalos ii;
            //
            if(inTamano!=null){
                findit=false;
                for(int i=0;i<inTamano.size() && findit==false;i++){
                    ii= (intervalos) inTamano.get(i);
                    if(cad.equals(ii.getNom())){
                        tamano= ii.getDescripcion();
                        findit= true;
                    }
                }
                tamano= tamano + " bytes Download";
                
            }else{
                if(cad.equals("Low")) tamano="Download Less than 2000 bytes ";
                if(cad.equals("Middle")) tamano="Download Between 2001 and 10000 bytes ";
                if(cad.equals("High")) tamano="Download More than 10001 bytes ";
            }
            //
            return tamano;
        }
        
        /** Devuelve la sesion completa de tal fila
         */
        public sesiontrans getSesionAt(int row){
            return (sesiontrans) sesiones.get(row);
        }
        
        /** Devuelve los valores de toda una columna en un Vector 
         */
        public Vector getValuesColumn(int col){            
            String dato="";
            Vector aux=new Vector();
            //
            for(int i=0; i<sesiones.size();i++){
                Object obj = sesiones.get(i);
                switch(col){
                    case 0:
                        dato= ((sesiontrans) obj).getTipoIP();
                        break;
                    case 1:
                        dato= ((sesiontrans) obj).getHorario();
                        break;
                    case 2:
                        dato= ((sesiontrans) obj).getDiaSemana();
                        break;
                    case 3:
                        dato= ((sesiontrans) obj).getDuracion();
                        break;
                    case 4:
                        dato= ((sesiontrans) obj).getCantPet();
                        break;
                    case 5:
                        dato= ((sesiontrans) obj).getTamDescarga();
                        break;
                }                
                aux.addElement(dato);
            }
            //
            return aux;
        }

        /**
         * Este metodo sirve para determinar el editor predeterminado
         * para cada columna de celdas
         */
        public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }

        /*
         * No tienes que implementar este mtodo a menos que
         * las celdas de tu tabla sean Editables
         */
        public boolean isCellEditable(int row, int col) {
                return true;
        }

        /*
         * No tienes que implementar este mtodo a menos que
         * los datos de tu tabla cambien
         */        
        
        public void setDatos(ArrayList datosnuevos) {
            this.sesiones = datosnuevos;
            
        }
        
        /** Coloca nuevos nombres a las columnas si es necesario
         */
    public void setNomcol(String[] nomcol) {
        this.columnNames = nomcol;
    }
        
        
   public void setIDuracion(ArrayList indatos){
       inDuracion= indatos;
   }
   
   public void setICantidad(ArrayList indatos){
       inCantidad= indatos;
   }
   
   public void setITamano(ArrayList indatos){
       inTamano= indatos;
   }
    
}//
