
package workspace.Views;

import Utils.AssocRules;
import Utils.TableOptimalWidth;
import algorithm.classification.ClassificationTableModel;
import algorithm.classification.mate.MateTableModel;
import algorithm.classification.sesiontrans;
import algorithm.hpg.HPGTableModel;
import algorithm.hpg.produccion;
import grammar.colocarnom;
import javax.swing.JCheckBox;
import prePro.sesionview;
import workspace.Views.RulesTableModel;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Image;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumnModel;
import prePro.SesionTableModel;
import prePro.regLog;
import prePro.regLogTableModel;
import workspace.Main_Set.Main;

public class MostrarTabla extends javax.swing.JDialog { 
    
   private javax.swing.JFileChooser Save;
    
    /** Fuente */
    private ArrayList datosRta;
    /** Reglas de Asociacion */
    private AssocRules rules;    
    /** Tabla analizada. */
    private String fileLog;    
    /** Soporte minimo del sistema. */
    private String support;    
    /** Confianza. */
    private String confidence;
    /** Proceso */
    private String Process;
    /** Clase Target */
    private String cT="";
    //
    ArrayList npags;
    private DefaultListModel model;
    
    /** Creates new form MostrarTabla */
    public MostrarTabla(AssocRules rules, String fileLog, String support, String confidence, String proceso, String Algoritmo) {
        //** Llenar propiedades
        this.rules = rules;
        this.fileLog = fileLog;
        this.support = support;
        this.confidence = confidence;
        this.Process= proceso;
        //
        initComponents();        
        jp_list.setVisible(false);
        lstNodos.setVisible(false);
   
        this.setIconImage(this.getImage("/media/appicon.png"));        
        //
        if(proceso.equals("Association Rules")){
            if(rules.getRules().size() != 0) {

                RulesTableModel model = new RulesTableModel(rules.getRules());
                tbl_rta.setModel(model);
                tbl_rta.setAutoResizeMode(tbl_rta.AUTO_RESIZE_OFF);
                TableOptimalWidth.setOptimalColumnWidth(tbl_rta);
                tbl_rta.setVisible(true);
                lbl_state.setText("Generate " + tbl_rta.getRowCount() + " rules with confidence "
                        + confidence + "%");
                /**edicion*/
                //tbl_rta.setForeground(Color.BLUE);
                //
            } else {
                /**No hay resultados */
                lbl_state.setText("Upps... No hay resultados");
            }
            //
            txt_sop.setText(support + "%"); txt_sop.setEnabled(true);
            txt_conf.setText(confidence + "%"); txt_conf.setEnabled(true);
            
        }
        
        // *** Datos
        txt_log.setText(fileLog);        
        lbl_proceso.setText(proceso + " - " + Algoritmo);
        this.setTitle(proceso + " - " + Algoritmo);
        this.addJTableHeaderListener();
    }
    
    public MostrarTabla(ArrayList datos, String fileLog, String proceso, ArrayList ind, ArrayList inc, ArrayList ins){
        //** Llenar propiedades        
        this.fileLog = fileLog;        
        this.Process= proceso;
        this.datosRta= datos;
        //
        initComponents();        
        jp_list.setVisible(false);
        lstNodos.setVisible(false);
        //
        this.setIconImage(this.getImage("/media/appicon.png"));        
        //
        if(proceso.equals("Discretize Filter")){
            if(datos.size()>0) {
                //RulesTableModel model = new RulesTableModel(rules.getRules());
                ClassificationTableModel model= new ClassificationTableModel(datos);
                model.setIDuracion(ind); model.setICantidad(inc); model.setITamano(ins);
                model.setTraducir(true);
                tbl_rta.setModel(model);
                tbl_rta.setAutoResizeMode(tbl_rta.AUTO_RESIZE_OFF);
                TableOptimalWidth.setOptimalColumnWidth(tbl_rta);
                tbl_rta.setVisible(true);
                lbl_state.setText("Generate " + tbl_rta.getRowCount() + " sesions ");
                //
                
            } else {
                /** No hay resultados */
                lbl_state.setText("Upps... No hay resultados");
            }
            //
            //lbl_sop.setText("Target: "); lbl_sop.setEnabled(true);
            //txt_sop.setText(Target); txt_sop.setEnabled(true);
            lbl_sop.setVisible(false); lbl_conf.setVisible(false);
            txt_sop.setVisible(false); txt_conf.setVisible(false);
            txt_conf.setEnabled(false); lbl_conf.setEnabled(false);
            
        }
        // *** Datos
        txt_log.setText(fileLog);        
        lbl_proceso.setText(proceso);
        this.setTitle(proceso);
        this.addJTableHeaderListener();
    }
    
    public MostrarTabla(ArrayList datos, String fileLog, String proceso, String algorithm, String ctarget,
            ArrayList ind, ArrayList inc, ArrayList ins){
        
        //
        int ctind;
        //** Llenar propiedades        
        this.fileLog = fileLog;        
        this.Process= proceso;
        this.datosRta= datos;
        //
        initComponents();        
        jp_list.setVisible(false);
        lstNodos.setVisible(false);
        cT= ctarget;
        //
        this.setIconImage(this.getImage("/media/appicon.png"));        
        //
        if(proceso.equals("Classification Rules")){
            if(datos.size()>0) {                
                ClassificationRulesTableModel model= new ClassificationRulesTableModel(datos);
                model.setIDuracion(ind); model.setICantidad(inc); model.setITamano(ins);
                ctind= model.getColumnIndex(ctarget);
                //
                tbl_rta.setModel(model);
                tbl_rta.getTableHeader().setReorderingAllowed(false);
                tbl_rta.moveColumn(ctind,tbl_rta.getColumnCount()-1);
                //
                tbl_rta.setAutoResizeMode(tbl_rta.AUTO_RESIZE_OFF);
                TableOptimalWidth.setOptimalColumnWidth(tbl_rta);
                tbl_rta.setVisible(true);
                lbl_state.setText("Generate " + tbl_rta.getRowCount() + " classification rules. ");
                //
                
            } else {
                /** No hay resultados */
                lbl_state.setText("Upps... No hay resultados");
            }
            //
            lbl_sop.setText("Target: "); lbl_sop.setEnabled(true);
            txt_sop.setText(ctarget); txt_sop.setEnabled(true);
            //lbl_sop.setVisible(false); txt_sop.setVisible(false);
            lbl_conf.setVisible(false); txt_conf.setVisible(false);
            txt_conf.setEnabled(false); lbl_conf.setEnabled(false);
            
        }
        // *** Datos
        txt_log.setText(fileLog);        
        lbl_proceso.setText(proceso + " .:. " + algorithm);
        this.setTitle(proceso);
        this.addJTableHeaderListener();
    }
    
    public MostrarTabla(ArrayList datos, String fileLog, String proceso){
        //** Llenar propiedades        
        this.fileLog = fileLog;        
        this.Process= proceso;
        this.datosRta= datos;
        //
        initComponents();        
        jp_list.setVisible(false);
        lstNodos.setVisible(false);
        //
        this.setIconImage(this.getImage("/media/appicon.png"));        
        //
        if(proceso.equals("Source")){
            if(datos.size()>0) {
                regLogTableModel model= new regLogTableModel(datos);
                //
                tbl_rta.setModel(model);
                tbl_rta.setAutoResizeMode(tbl_rta.AUTO_RESIZE_OFF);
                TableOptimalWidth.setOptimalColumnWidth(tbl_rta);
                tbl_rta.setVisible(true);
                lbl_state.setText("Generate " + tbl_rta.getRowCount() + " records ");
                //
                lbl_sop.setVisible(false); lbl_conf.setVisible(false);
                txt_sop.setVisible(false); txt_conf.setVisible(false);
                //
                
            }else{
                /**No hay resultados*/
                lbl_state.setText("Upps... No hay resultados");
            }
        }
        // *** Datos
        txt_log.setText(fileLog);        
        lbl_proceso.setText(proceso);
        this.setTitle(proceso);
        this.addJTableHeaderListener();
    }
    
    public MostrarTabla(ArrayList datos, String fileLog, String proceso, int tipoS, boolean mfr){
        //** Llenar propiedades        
        this.fileLog = fileLog;        
        this.Process= proceso;
        this.datosRta= datos;
        //
        initComponents();        
        jp_list.setVisible(false);
        lstNodos.setVisible(false);
        //
        this.setIconImage(this.getImage("/media/appicon.png"));        
        //
        if(proceso.equals("Sessions")){
            if(datos.size()>0) {
                SesionTableModel model= new SesionTableModel(datos);
                if(tipoS==2) model.setColExt();
                model.setTipoS(tipoS);
                //
                tbl_rta.setModel(model);
                tbl_rta.setAutoResizeMode(tbl_rta.AUTO_RESIZE_OFF);
                TableOptimalWidth.setOptimalColumnWidth(tbl_rta);
                npags= this.nomPaginas();
                //
                tbl_rta.getColumn("DOWNLOAD EXTENSION").setCellRenderer(new ButtonRenderer());
                tbl_rta.getColumn("DOWNLOAD EXTENSION").setCellEditor(new ButtonEditor(new JCheckBox(),datos,tipoS,npags));
                //
                tbl_rta.getColumn("DOWNLOAD PAGES").setCellRenderer(new ButtonRenderer());
                tbl_rta.getColumn("DOWNLOAD PAGES").setCellEditor(new ButtonEditor(new JCheckBox(),datos,tipoS,npags));
                //
                tbl_rta.setVisible(true);
                lbl_state.setText("Generate " + tbl_rta.getRowCount() + " sesions ");
                //
                lbl_sop.setVisible(false); lbl_conf.setVisible(false);
                txt_sop.setVisible(false); txt_conf.setVisible(false);
            }else{
                /**No hay resultados*/
                lbl_state.setText("Upps... No hay resultados");
            }
        }
        // *** Datos
        txt_log.setText(fileLog);        
        lbl_proceso.setText(proceso);
        this.setTitle(proceso);
        if(mfr) this.setTitle(proceso + " with MFR active");
        this.addJTableHeaderListener();
    }
    
    // *- Tabla de Mate
    public MostrarTabla(MateTableModel mateT, String fileLog, String proceso){
        //** Llenar propiedades        
        this.fileLog = fileLog;        
        this.Process= proceso;
        //
        initComponents();
        jp_list.setVisible(false);
        jp_list.setVisible(false);
        lstNodos.setVisible(false);
        this.setIconImage(this.getImage("/media/appicon.png"));        
        //
        if(proceso.equals("Mate Tabla")){
            if(mateT.getRowCount()>0) {                
                tbl_rta.setModel(mateT);
                tbl_rta.setAutoResizeMode(tbl_rta.AUTO_RESIZE_OFF);
                TableOptimalWidth.setOptimalColumnWidth(tbl_rta);
                tbl_rta.setVisible(true);
                lbl_state.setText("Generate " + tbl_rta.getRowCount() + " rows ");
            } else {
                /**No hay resultados*/
                lbl_state.setText("Upps... Something faild");
            }
            //
            txt_conf.setEnabled(false); lbl_conf.setEnabled(false);
            
        }
        // *** Datos
        txt_log.setText(fileLog);        
        lbl_proceso.setText(proceso);
        this.setTitle(proceso);
        this.addJTableHeaderListener();
    }
    
    // * HPG
    public MostrarTabla(ArrayList datos, String fileLog, String proceso, double a, int N){
        //** Llenar propiedades        
        this.fileLog = fileLog;        
        this.Process= proceso;
        this.datosRta= datos;
        //
        String nodito;
        //
        initComponents();
        jp_list.setVisible(true);
        lstNodos.setVisible(true);
        this.setIconImage(this.getImage("/media/appicon.png"));         
        //
        if(proceso.equals("HPG")){
            if(datos.size()>0){
                HPGTableModel hmodel= new HPGTableModel(datos);
                tbl_rta.setModel(hmodel);
                tbl_rta.setAutoResizeMode(tbl_rta.AUTO_RESIZE_OFF);
                TableOptimalWidth.setOptimalColumnWidth(tbl_rta);
                tbl_rta.setVisible(true);
                lbl_state.setText("Generate " + tbl_rta.getRowCount() + " Relationship Productions");
                //
                lbl_sop.setText("Alfa: ");  lbl_conf.setText("N-Gramm: ");
                lbl_sop.setEnabled(true); lbl_conf.setEnabled(true);
                txt_sop.setText(String.valueOf(a)); txt_sop.setEnabled(true);
                txt_conf.setText(String.valueOf(N)); txt_conf.setEnabled(true);
                // edicion
                //tbl_rta.setForeground(Color.BLUE);
                jp_rta.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Result Productions"));
                /**centrar*/
                /**get the render for Strings*/
                TableCellRenderer tcr = tbl_rta.getDefaultRenderer(String.class);
                /**For Strings with no changes made to the table, the render is a DefaultTableCellRender.*/
                DefaultTableCellRenderer dtcr = (DefaultTableCellRenderer) tcr;
                /**set the alignment to center*/
                dtcr.setHorizontalAlignment(DefaultTableCellRenderer.CENTER);
                //
                tbl_rta.setDefaultRenderer(String.class,dtcr);
                //
                /** modelo del JList lstNodos*/
                model = new DefaultListModel();
                npags= this.nomPaginas();
                /** el identificador de cada nodo es anadido */
                model.addElement("ID .:. PAGE NAME");
                model.addElement(" ");
                model.addElement("-1 .:. START");
                for (int i = 0; i < npags.size(); i++) {
                    if(i<10){ nodito= String.valueOf(i) + "   :: " + npags.get(i).toString(); }
                    else{ nodito= String.valueOf(i) + "  :: " + npags.get(i).toString(); }
                    model.addElement(nodito);
                    //model.addElement(nodos.get(i));
                }
                model.addElement("-2 .:. FINALE");
                this.lstNodos.setModel(model);
                //
            } else {
                /**No hay resultados*/
                lbl_state.setText("Upps... No hay resultados");
            }
        }
        
        // *** Datos
        txt_log.setText(fileLog);        
        lbl_proceso.setText(proceso);
        this.setTitle(proceso);
        this.addJTableHeaderListener();
    }
    
    public ArrayList nomPaginas(){
        colocarnom cnom= new colocarnom();
        return cnom.getLisPags();
    }
    
    //
    public void addJTableHeaderListener() {
        MouseAdapter mouseListener = new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                TableColumnModel columnModel = tbl_rta.getColumnModel();
                int viewColumn = columnModel.getColumnIndexAtX(e.getX());
                //System.out.println("column model " + viewColumn);
                int column = tbl_rta.convertColumnIndexToModel(viewColumn);
                //System.out.println("column " + column);
                /**Ordenar elementos de la columna de la tabla*/
                if(e.getClickCount() == 1 && column != -1) {
                    /**Ordenar por confianza.*/
                    if(column == 1) {
                        rules.sortByGoldStone(0);
                        rules.sortByGoldStone(1);
                        tbl_rta.updateUI();
                    } else if(column == 2) {
                        rules.sortByConfidence();
                        tbl_rta.updateUI();
                    } else if(column == 3) {
//                        rules.sortByGoldStone(0);
//                        rules.sortByGoldStone(1);                        
//                        rules.sortByGoldStone(3);                        
//                        tbl_rta.updateUI();
                    }
                }
            }
        };
        JTableHeader header = tbl_rta.getTableHeader();
        header.addMouseListener(mouseListener);
    }
    
    /**configuraciones iniciales de este formulario*/
    public MostrarTabla(java.awt.Frame parent, boolean modal) {
        super(parent, true);
        initComponents();
        this.setIconImage(this.getImage("/media/win1 (1).png"));        
    }   
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        txt_log = new javax.swing.JTextField();
        txt_sop = new javax.swing.JTextField();
        lbl_sop = new javax.swing.JLabel();
        txt_conf = new javax.swing.JTextField();
        lbl_conf = new javax.swing.JLabel();
        lbl_p = new javax.swing.JLabel();
        lbl_proceso = new javax.swing.JTextField();
        btnSave = new javax.swing.JButton();
        jp_rta = new javax.swing.JScrollPane();
        tbl_rta = new javax.swing.JTable();
        jp_list = new javax.swing.JScrollPane();
        lstNodos = new javax.swing.JList();
        lbl_state = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Table View");
        setResizable(false);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Data"));

        jLabel1.setText("WebServerLog");

        txt_log.setEditable(false);

        txt_sop.setEditable(false);
        txt_sop.setEnabled(false);

        lbl_sop.setText("Support");

        txt_conf.setEditable(false);
        txt_conf.setEnabled(false);

        lbl_conf.setText("Confidence");

        lbl_p.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lbl_p.setText("Process");

        lbl_proceso.setEditable(false);

        btnSave.setIcon(new javax.swing.ImageIcon(getClass().getResource("/media/save_all.png"))); // NOI18N
        btnSave.setText("Save Report");
        btnSave.setToolTipText("Save this report");
        btnSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(55, 55, 55)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(lbl_p)
                    .addComponent(jLabel1)
                    .addComponent(lbl_sop))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(txt_sop, javax.swing.GroupLayout.PREFERRED_SIZE, 106, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(lbl_conf)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(txt_conf, javax.swing.GroupLayout.PREFERRED_SIZE, 102, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(txt_log, javax.swing.GroupLayout.DEFAULT_SIZE, 433, Short.MAX_VALUE)
                    .addComponent(lbl_proceso))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 197, Short.MAX_VALUE)
                .addComponent(btnSave)
                .addGap(18, 18, 18))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(txt_log, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lbl_sop)
                    .addComponent(btnSave)
                    .addComponent(lbl_conf)
                    .addComponent(txt_sop, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(txt_conf, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lbl_p)
                    .addComponent(lbl_proceso, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jp_rta.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), "Result"));

        tbl_rta.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jp_rta.setViewportView(tbl_rta);

        lstNodos.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        lstNodos.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                lstNodosValueChanged(evt);
            }
        });
        jp_list.setViewportView(lstNodos);

        lbl_state.setText("POLARIS WUM - VIEW: is runing...");
        lbl_state.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(lbl_state, javax.swing.GroupLayout.DEFAULT_SIZE, 905, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(jp_rta, javax.swing.GroupLayout.DEFAULT_SIZE, 709, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jp_list, javax.swing.GroupLayout.PREFERRED_SIZE, 190, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jp_rta, javax.swing.GroupLayout.DEFAULT_SIZE, 341, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(14, 14, 14)
                        .addComponent(jp_list, javax.swing.GroupLayout.PREFERRED_SIZE, 324, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lbl_state, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void lstNodosValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_lstNodosValueChanged

    }//GEN-LAST:event_lstNodosValueChanged

    private void btnSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveActionPerformed
       String path;
        //
        Save= new JFileChooser();
        Save.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
        Save.addChoosableFileFilter(new FileFilter(){
            public String getDescription(){
                return "*.html";
            }
            public boolean accept(File f){
                return (!f.isDirectory())&&(f.getAbsolutePath().endsWith("html"));
            }
        });
        //
        int saveOK = Save.showSaveDialog(this);
        if(saveOK == Save.APPROVE_OPTION) {
            
         try {
             path= Save.getSelectedFile().getAbsolutePath(); 
             if(!path.endsWith("html")) path += ".html";
            FileWriter fw = new FileWriter(path);
            BufferedWriter bw = new BufferedWriter(fw);
            PrintWriter salida = new PrintWriter(bw);
            salida.print(getEscribir());
            //salida.println("esto escribe una linea en el archivo");
            salida.close();
            //
            lbl_state.setText("Rules Report is save...");
        }
        catch(java.io.IOException ioex) {
          //System.out.println("se presento el error: "+ioex.toString());
          lbl_state.setText("This error happend: "+ioex.toString());
        }
         
        }
    }//GEN-LAST:event_btnSaveActionPerformed
    
    String getEscribir(){
        String archivo="<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>";
        //
        archivo += "\n   <html xmlns='http://www.w3.org/1999/xhtml'>";
        archivo += "\n    <head>";
        archivo += "\n    <meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1' />";
        archivo += "\n    <title>.:. Polaris Association Rules .:.</title>";
        archivo += "\n    <style type='text/css'>";
        archivo += "\n    <!--";
        archivo += "\n    body,td,th {";
        archivo += "\n            font-family: Geneva, Arial, Helvetica, sans-serif;";
        archivo += "\n            color: #993300;";
        archivo += "\n    }";
        archivo += "\n    body {";
        archivo += "\n            background-color: #000000;";
        archivo += "\n    }";
        archivo += "\n    .Estilo3 {color: #CC6600}";
        archivo += "\n    .Estilo4 {color: #EFE33B}";
        archivo += "\n    .Estilo5 {color: #EFE54E}";
        archivo += "\n    .Estilo6 {font-size: 36px; color: #CC6600;}";        
        archivo += "\n    -->";
        archivo += "\n    </style></head>";
        archivo += "\n    <body> <center>";
        archivo += "\n      <br> <span class='Estilo6'>";
        archivo += "\n        .:. POLARIS RESULT .:. <br>";
        archivo += "\n      </span> <br>";
        archivo += "\n        LogFile: " + this.fileLog + " <br>";
        archivo += "\n        Process: " + this.Process;
        archivo += "\n      <br> <br>";        
        archivo += "\n    <table width='600' border='1'>";        
//        archivo += "\n      <tr>";
//        archivo += "\n        <td><div align='center'></div></td>";
//        archivo += "\n      </tr>";
        if(Process.equals("Association Rules")){
            archivo += rules.toString();
        }
        else if(Process.equals("Source")){
            archivo += escribirReg();
        }else if(Process.equals("HPG")){
            archivo += escribirReg();
        }else if(Process.equals("Discretize Filter") || Process.equals("Classification Rules")){
            archivo += escribirCla();
        }else if(Process.equals("Sessions")){
            archivo += escribirReg();
        }
        //
        archivo += "\n    </table>";
        if(Process.equals("HPG")){
            archivo += "\n      <br> <br>";        
            archivo += "\n    <table width='600' border='1'>";        
            archivo += escribirPags();
            archivo += "\n    </table>";
        }
        archivo += "\n    </center> </body>";
        //
        archivo += "\n    </html>";                        
        return archivo;
    }
    
    String escribirReg(){
        String registros="";
        //
        if(datosRta.size()>0 && this.Process.equals("Source")){
            registros += "\n      <tr>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "#";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "HOSTREMOTE";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "AUTH-USER";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "DATE";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "HOUR";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "TYPE REQUEST";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "REQUEST";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "PROTOCOL";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "STATE CODE";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "BYTES";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n      </tr>";
        }
        if(datosRta.size()>0 && this.Process.equals("HPG")){
            registros += "\n      <tr>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "#";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "ORIGEN NODE";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "DESTINE NODE";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "PROBABILITY";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n      </tr>";
        }
        if(datosRta.size()>0 && this.Process.equals("Sessions")){
            registros += "\n      <tr>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "#";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "HOSTREMOTE";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "AUTH-USER";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "START DATE";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "FINAL DATE";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "REQUEST AMOUNT";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "TOTAL BYTES";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "EXTENSIONS";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "PAGES";
            registros += "\n         </span>";
            registros += "\n         </div></td>";            
            registros += "\n      </tr>";
        }
        //
        for(int i=0; i<datosRta.size(); i++) {
            registros += "\n      <tr>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros = registros + (i+1) + ". ";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <div align='center'>";
            registros += "\n         <span class='Estilo5'>";
            //registros +=  ((Rules) rules.get(i)).toString() + "\n";
            if(Process.equals("Source")){
                registros += ((regLog) datosRta.get(i)).toString();
            }else if(Process.equals("HPG")){
                registros += ((produccion) datosRta.get(i)).toString();
            }else if(Process.equals("Sessions")){
                registros += ((sesionview) datosRta.get(i)).toString(npags);
            }
            //
            registros += "\n         </span>";
            registros += "\n </div>";
            registros += "\n      </tr>";
        }
        //
        return registros;
    }
    
    String escribirCla(){
        String registros="";
        //
        if(datosRta.size()>0){
            registros += "\n      <tr>";            
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "#";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            if(!cT.equals("Ip type"))  {
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "IP TYPE";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            }
            if(!cT.equals("Schedule"))  {
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "SCHEDULE";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            }
            if(!cT.equals("Week day"))  {
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "WEEK DAY";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            }
            if(!cT.equals("Duration"))  {
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "DURATION";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            }
            if(!cT.equals("Request amount"))  {
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "REQUEST AMOUNT";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            }
            if(!cT.equals("Download size"))  {
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros += "DOWNLOAD SIZE";
            registros += "\n         </span>";
            registros += "\n         </div></td>";            
            }
            if(!cT.equals("")){
                registros += "\n        <td><div align='center'>";
                registros += "\n         <span class='Estilo3'>";
                if(cT.equals("Ip type"))        registros += "IP TYPE";
                if(cT.equals("Schedule"))       registros += "SCHEDULE";
                if(cT.equals("Week day"))       registros += "WEEK DAY";
                if(cT.equals("Duration"))       registros += "DURATION";
                if(cT.equals("Request amount")) registros += "REQUEST AMOUNT";
                if(cT.equals("Download size"))  registros += "DOWNLOAD SIZE";                
                registros += "\n         </span>";
                registros += "\n         </div></td>";            
            }            
            registros += "\n      </tr>";
        }
        //
        for(int i=0; i<datosRta.size(); i++) {
            registros += "\n      <tr>";
            registros += "\n        <td><div align='center'>";
            registros += "\n         <span class='Estilo3'>";
            registros = registros + (i+1) + ". ";
            registros += "\n         </span>";
            registros += "\n         </div></td>";
            registros += "\n        <div align='center'>";
            registros += "\n         <span class='Estilo5'>";
            //registros +=  ((Rules) rules.get(i)).toString() + "\n";            
                registros += ((sesiontrans) datosRta.get(i)).toString(cT);
            //
            registros += "\n         </span>";
            registros += "\n </div>";
            registros += "\n      </tr>";
        }
        //
        return registros;
    }
    
    String escribirPags(){
        String salida="";
        //
        salida += "\n      <tr>";
        salida += "\n        <td><div align='center'>";
        salida += "\n         <span class='Estilo3'>";
        salida += "\n           ID NODE";
        salida += "\n         </span>";
        salida += "\n       </div></td>";
        salida += "\n        <td><div align='center'>";
        salida += "\n         <span class='Estilo3'>";
        salida += "\n           PAGE NAME";
        salida += "\n         </span>";
        salida += "\n       </div></td>";
        salida += "\n      </tr>";
        //
        for (int i = 0; i < npags.size(); i++) {
            //nodito= String.valueOf(i) + "  :: " + npags.get(i).toString(); 
            salida += "\n      <tr>";
            salida += "\n        <td><div align='center'>";
            salida += "\n         <span class='Estilo3'>";
            salida = salida + i + ". ";
            salida += "\n         </span>";
            salida += "\n         </div></td>";
            //
            salida += "\n           <td>";
            salida += "\n        <div align='center'>";
            salida += "\n         <span class='Estilo5'>";
            salida += "\n           " + npags.get(i).toString();
            salida += "\n         </span>";
            salida += "\n       </div>";
            salida += "\n           </td>";            
            //
            salida += "\n         </span>";
            salida += "\n </div>";
            salida += "\n      </tr>";
            //
        }
        //
        return salida;
    }

    /**manejo de conos ********************************************************/
       
    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }

    private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = Main.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }
    
/**manejo de conos ********************************************************/
    
  
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnSave;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jp_list;
    private javax.swing.JScrollPane jp_rta;
    private javax.swing.JLabel lbl_conf;
    private javax.swing.JLabel lbl_p;
    private javax.swing.JTextField lbl_proceso;
    private javax.swing.JLabel lbl_sop;
    private javax.swing.JLabel lbl_state;
    private javax.swing.JList lstNodos;
    private javax.swing.JTable tbl_rta;
    private javax.swing.JTextField txt_conf;
    private javax.swing.JTextField txt_log;
    private javax.swing.JTextField txt_sop;
    // End of variables declaration//GEN-END:variables
    
}
