/*
 * RulesTableModel.java
 *
 * Created on 1 de junio de 2006, 20:23
 *
 * Proyecto Tariy
 */

package workspace.Views;

import Utils.Rules;
import java.text.DecimalFormat;
import java.util.ArrayList;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;

/**
 *
 * @author Proyecto Tariy - Polaris
 */
public class RulesTableModel extends AbstractTableModel {
    /** Las reglas de asociación. */
    private ArrayList rules;
    /** Decimal format to confidence */
    private DecimalFormat df;
    /** Los nombres de las columnas. */
    String[] columnNames = new String[7];
    
    /** */
    protected TableModel model;
    
    /**
     * Crea una nueva instancia de la clase RulesTableModel.
     *
     * @param rules La estructura que sera utilizada para crear el modelo de
     *        la tabla de datos.
     */
    public RulesTableModel(ArrayList rules) {
        this.rules = rules;
        this.columnNames[0] = "#";
        this.columnNames[1] = "CONFIDENCE";
        this.columnNames[2] = "RULE";
        this.columnNames[3] = "";
        this.columnNames[4] = "";
        this.columnNames[5] = "";
        this.columnNames[6] = "Lift";
        fireTableChanged(null);
        df = new DecimalFormat();
        df.setMaximumFractionDigits(2);
    }
    
    public String getColumnName(int column) {
        if (columnNames[column] != null) {
            return columnNames[column];
        } else {
            return "";
        }
    }
    
    //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
    //||||||||||||||| AbstractTableModel implemented methods |||||||||||||||||
    //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
    
    /**
     * Retorna el numero de reglas a traves del tamano del ArrayList que las
     * contiene.
     */
    public int getRowCount() {
        return rules.size();
    }
    
    public int getColumnCount() {
        return columnNames.length;
    }
    
    /** Devuelve las reglas en formato web mining rules */
    public Object getValueAt(int rowIndex, int columnIndex) {
        Object obj = rules.get(rowIndex);
        if(columnIndex == 0) {
            return rowIndex+1;
        } else if(columnIndex == 1) {
            float confidence = 0;
            confidence = ((Rules) obj).getConfidence();
            return df.format(confidence) + "%";
        } else if(columnIndex == 2) {
            String rule = new String();
            rule = "OF VISITORS WHO ACCESSED URLs ";
            return rule;
        }else if(columnIndex == 3) {
            String rule = new String();
            rule = ((Rules) obj).getAntecedent().replaceAll("~", "AND");
            return rule;
        }else if(columnIndex == 4) {
            String rule = new String();
            rule = " ALSO VISTED ";
            return rule;
        }else if(columnIndex == 5) {
            String rule = new String();
            rule = ((Rules) obj).getConcecuent().replaceAll("~", "AND");
            return rule;
        } else{
            float lift = 0;
            lift = ((Rules) obj).getMlift();
            return df.format(lift);
        }
    }
}
