/**el archivo contiene las configuraciones correspondientes a la seleccion stat
*desde View**/

package workspace.Views;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Point;
import java.util.ArrayList;
import javax.swing.ImageIcon;
import statistical.estadisticas;
import workspace.Source.SelectSourceNode;
import workspace.Main_Set.SimpleNode;

public class StatViewNode extends SimpleNode{
    /**se esta forzando a variable*/
    private Class<?>[] clases;
    private ArrayList<SimpleNode> nodos;
    /**las siguientes banderas establecen si el objeto ya fue configurado
    *o ejecutado*/
    public boolean configured = true;
    public boolean executed   = false;
    /**path desde el select source*/
    public String pathLogServer = "";
    /**tipoL desde el select source*/
    public int tipoL;
    /**tiempo de sesion desde prepro*/
    public int tSesion;
    
    public StatViewNode(Point center) {
        /**se establece centro, dimension*/
        this.setCenter(center);
        this.setDimension(new Dimension(80,60));
        /**se valida el nodo antecesor, 2 nodos le pueden anteceder*/
        this.clases = new Class<?>[1];
        this.clases[0] = SelectSourceNode.class;
        /*se instancia un ArrayList en nodos*/
        this.nodos = new ArrayList();
    }
    
    public Class<?>[] getValidInputClasses(){
        /**retorna los antecesores...*/
        return this.clases;
    }
    
    public ArrayList<SimpleNode> getInputNodes(){
        /**se devuelven los valores de los nodos en un array forzado a tipo
        *SimpleNode*/
        return this.nodos;
    }
    
    public Image getImage(){
        /**el icono*/
        return new ImageIcon(System.class.getResource("/media/stat.png")).getImage();
    }
    
    public String getString(){
        /**retorna una cadena que lo identifica*/
        return "Stat";
    }
    
    /**si el nodo puede ser conectado, entonces se aade un nodo*/
    public void connect(SimpleNode n){
        if(this.canConnect(n)){
            this.nodos.add(n);
        }
    }
    
    /**al desconectar el nodo se elimina la linea punteada y se coloca el color
    *de borde por defecto*/
    public void disconnect(SimpleNode n){
        this.nodos.remove(n);
        this.setBorderColor(null);
    }

    /**retorna verdadero porque puede ser ejecutado*/
    public boolean canExecute() {
        return true;
    }
    
    public void execute() {
        if(this.getInputNodes().size()==1){
            String sourceClassName = this.getInputNodes().get(0).getClass().getCanonicalName();
            if (sourceClassName.equals(SelectSourceNode.class.getCanonicalName())){
                SelectSourceNode sn = (SelectSourceNode)this.getInputNodes().get(0);
                //***********************************************************
                /*aqui se instancia SS*/
                //***********************************************************               
                
                if(!sn.isConfigured()){
                    this.getParent().showError("The SS must be configured first");
                    //validacion para la badera ejecucion y el color del borde
                    this.setExecuted(false);
                    setBorderColor(null);
                } else if(!sn.isExecuted()){
                    this.getParent().showError("The SS must be executed first");
                    //validacion para la badera ejecucion y el color del borde
                    this.setExecuted(false);
                    setBorderColor(null);
                }  else{                    
                    this.setExecuted(true);
                    // *** Polaris *** Johana ***
                    long time = System.currentTimeMillis();
            //
                    if(sn.getPath()==null){
                        this.setMsg("Log File don't load...");
                    }else{
                    estadisticas mt= new estadisticas(sn.getPath());
                    // centrar
                    mt.setLocationRelativeTo(mt.getParent());
                    // Visible
                    mt.setVisible(true);                    
                    }
                //
                    long executionTime = System.currentTimeMillis() - time;                       
            System.out.println("Stat tiempo: " + executionTime + " milisegundos");
                    // *** Finished ***
                    //pinta de verde si el nodo ya se ejecuto
                    setBorderColor(new Color(0,255,0));
                    getParent().repaint();
                }
            }//else if
        }else{
            this.getParent().showError("First add a connection");
            //validacion para la badera ejecucion y el color del borde
            this.setExecuted(false);
            setBorderColor(null);
            getParent().repaint();
        }
   }
       
    public String getPathLogServer() {
        return pathLogServer;
    }
    
    public void setPathLogServer(String pathLogServer) {
        this.pathLogServer = pathLogServer;
    }
    
    public int getTipoL() {
        return tipoL;
    }
    
    public void setTipoL(int tipoL) {
        this.tipoL = tipoL;
    }
    
    public int getTsesion() {
        return getTsesion();
    }
    
    public void setTsesion(int tSesion) {
        this.setTsesion(getTsesion());
    }        
}
